﻿Public Class AdminTool

    Private Sub AcceptButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Abrir el formulario dependiendo del elemento seleccionado en el combobox
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Try
            Dim salida As String = "------Entrada en Admintool------"
            Dim seleccionado As Integer = PrincipalComboBox.SelectedIndex
            'Para cada uno de los 4 elementos se abrirá un formulario
            Me.Cursor = Cursors.WaitCursor
            If seleccionado = 0 Then
                Dim A As New Arbol
                Arbol.ShowDialog()
            ElseIf seleccionado = 1 Then
                recursosCompartidosArbol.ShowDialog()
            ElseIf seleccionado = 2 Then
                IExplorer.ShowDialog()
            ElseIf seleccionado = 3 Then
                RenombrarPerfil.ShowDialog()
            Else
                MsgBox("Seleccione una de las opciones")
            End If
            Me.Cursor = Cursors.Default
            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)

        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub CancelButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        '==========================================================================
        ' Name:     CancelButton_Click
        ' Purpose:  Cerrar la ventana sin reliazar ningún cambio
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Me.Close()

    End Sub

    Private Sub AdminTool_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     AdminTool_Load
        ' Purpose:  Obtiene los datos de configuración de un archivo de configuración
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    Desencripta de EncriptClass
        '==========================================================================
        Dim servicesConf
        Dim ParametrosArray() As String
        Dim usuario, password, server, domain, userdomain, adroot, external, usu_encripta, pwd_encripta, server_encripta, domain_encripta, userdomain_encripta, adroot_encripta, external_encripta As String
        Dim ParamFile, NomParam, ValorParam, ReadLineTextFile, objFSO
        Const ForReading = 1
        PrincipalComboBox.SelectedIndex = 0
        'Acceder al archivo de configuración
        servicesConf = My.Application.Info.DirectoryPath & "\Conf\Conf.txt"
        'servicesConf = "C:\Prueba Conf\Conf.txt"

        'Utilizando WMI
        objFSO = CreateObject("Scripting.FileSystemObject")

        'Leer los datos del archivo
        ParamFile = objFSO.OpenTextFile(servicesConf, ForReading)
        Do While ParamFile.AtEndOfStream <> True
            ReadLineTextFile = ParamFile.ReadLine
            ParametrosArray = Split(ReadLineTextFile, ":")
            NomParam = ParametrosArray(0)
            ValorParam = ParametrosArray(1)

            'Desencriptar los datos leidos y asignárselos a nuestras variables 
            Select Case UCase(NomParam)
                Case "USUARIO"
                    usuario = ValorParam
                    usu_encripta = EncriptClass.DesEncripta(usuario)
                    Settings.adminLogon = usu_encripta
                Case "PASSWORD"
                    password = ValorParam
                    pwd_encripta = EncriptClass.DesEncripta(password)
                    Settings.adminPassword = pwd_encripta
                Case "SERVERNAME"
                    server = ValorParam
                    server_encripta = EncriptClass.DesEncripta(server)
                    Settings.ldapServerName = server_encripta
                Case "DNSDOMAIN"
                    domain = ValorParam
                    domain_encripta = EncriptClass.DesEncripta(domain)
                    Settings.userDNSDomain = domain_encripta
                Case "USERDOMAIN"
                    userdomain = ValorParam
                    userdomain_encripta = EncriptClass.DesEncripta(userdomain)
                    Settings.userDomain = userdomain_encripta
                Case "ADROOT"
                    adroot = ValorParam
                    adroot_encripta = EncriptClass.DesEncripta(adroot)
                    Settings.ADRoot = adroot_encripta
                Case "EXTERNALADDRESSSUFIX"
                    external = ValorParam
                    external_encripta = EncriptClass.DesEncripta(external)
                    Settings.ExternalAddressSufix = external_encripta
            End Select
        Loop
        ParamFile.Close()
    End Sub
End Class