﻿Imports System.DirectoryServices
Imports System.Text
Imports System.ComponentModel
Imports System.Text.RegularExpressions

Public Class Arbol

    Private WithEvents Movement As New ToolStripMenuItem()
    Private WithEvents Rename As New ToolStripMenuItem()
    Private WithEvents Delete As New ToolStripMenuItem()
    Private WithEvents Properties As New ToolStripMenuItem()
    Private WithEvents Enable As New ToolStripMenuItem()
    Private WithEvents Disable As New ToolStripMenuItem()
    Private WithEvents Unlock As New ToolStripMenuItem()
    Private WithEvents PasswordChange As New ToolStripMenuItem()
    Private WithEvents ExchangeTasks As New ToolStripMenuItem()
    Private WithEvents Copy As New ToolStripMenuItem()
    Dim formscerradas As Boolean = False
    Dim ConExchange As Boolean
    Private strip As ContextMenuStrip

    Private Actual_OU As String

    Dim nombre As String

    Friend Sub loadNewName(ByVal name As String)
        '==========================================================================
        ' Name:     loadName
        ' Purpose:  Obtener el nombre del objeto a utilizar más adelante
        ' Input:    1 string: el nombre del objeto 'name'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        nombre = name
    End Sub

    Friend Sub PropertiesClosed()
        '==========================================================================
        ' Name:     PropertiesClosed
        ' Purpose:  Que se actualice el contenedor actual al cambiar las propiedades de un objeto
        ' Input:    None
        ' Return:   None
        ' Calls:    ActualizarContenedor
        '==========================================================================
        ActualizarContenedor(Actual_OU)
    End Sub

    Private Sub crearArbol(ByVal dn As String, ByRef NodoPadre As TreeNode)

        '==========================================================================
        ' Name:     crearArbol
        ' Purpose:  Obtener el nombre de login de un objeto a utilizar más adelante
        ' Input:    1 string: La dirección de donde obtner los datos del árbol'dn'
        '           1 TreeNode: El nodo padre 'NodoPadre'
        ' Return:   None
        ' Calls:    none
        '==========================================================================

        ''Obtener los contenedores que no son de las vistas avanzadas del directorioActivo
        Dim elementos As List(Of String) = GenericClass.ElementosNodo(dn)
        Dim dname, clave, nombre As String
        'Insertar los resultados obtenidos y volver a llamar recursivamente a la función hasta llegar a las hojas del árbol
        If Not elementos Is Nothing Then
            For i = 0 To elementos.Count - 1
                dname = elementos(i)
                nombre = GenericClass.GetName(elementos(i))
                clave = dname
                NodoPadre.Nodes.Add(clave, nombre, 1)
                'crearArbol(dname, NodoPadre.Nodes(clave))
            Next
        End If

    End Sub

    Private Sub Arbol_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        '==========================================================================
        ' Name:     Arbol_FormClosing
        ' Purpose:  Que no permita cerrar el formulario general de admintool si hay un subformulario abierto
        ' Input:    None
        ' Return:   None
        ' Calls:    ActualizarContenedor
        '==========================================================================
        Dim frm As Form
        For Each frm In Me.OwnedForms
            If frm.Visible Then
                e.Cancel = True
                'Exit For
            End If
        Next


        'If Me.OwnedForms > 0 Then
        '    e.Cancel = True
        'End If

    End Sub

    Private Sub Arbol_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        '==========================================================================
        ' Name:     Arbol_KeyDown
        ' Purpose:  Actualiza el árbol si se pulsa la tecla F5
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If e.KeyValue = Keys.F5 Then

            Dim auxnode As TreeNode = New TreeNode()
            auxnode = TreeView1.SelectedNode

            If TreeView1.SelectedNode.Text = Settings.userDNSDomain Then
                'Borrar Arbol
                TreeView1.Nodes.Clear()
                'Nuevo Arbol

                TreeView1.Nodes.Add(Settings.ADRoot, Settings.userDNSDomain)
                crearArbol(Settings.ADRoot, TreeView1.Nodes(Settings.ADRoot))
                TreeView1.SelectedNode = TreeView1.Nodes(Settings.ADRoot)
                'TreeView1.SelectedNode = TreeView1.TopNode
            Else
                TreeView1.SelectedNode = auxnode
                Dim dn As String
                dn = auxnode.Name
                ActualizarContenedor(dn)
                ActualizarInformacion(dn)
            End If
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '==========================================================================
        ' Name:     Form1_Load
        ' Purpose:  Crear el primer Nodo del árbol y llamar a la función que lo crea.
        '           Además inicializa el datagrid que mostrará el contenido de la carpeta seleccionada en el árbol
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    crearArbol
        '==========================================================================
        Dim lEx As List(Of String)
        lEx = GenericClass.CargarServidoresExch
        If lEx.Count > 0 Then
            ConExchange = True
        Else
            ConExchange = False
        End If

        TreeView1.Nodes.Clear()
        DataGridView1.Columns.Clear()
        TreeView1.Nodes.Add(Settings.ADRoot, Settings.userDNSDomain)
        crearArbol(Settings.ADRoot, TreeView1.Nodes(Settings.ADRoot))
        Dim col As New DataGridViewRolloverCellColumn()
        DataGridView1.Columns.Add(col)
        TreeView1.SelectedNode = TreeView1.Nodes(Settings.ADRoot)
        ActualizarContenedor(Settings.ADRoot)
        ActualizarInformacion(Settings.ADRoot)
    End Sub

    Private Sub TreeView1_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeView1.AfterSelect
        '==========================================================================
        ' Name:     TreeView1_AfterSelect
        ' Purpose:  Actualiza la variable en la que se guarda el contenedor actual y se muestra el contenido del contenedor en el dataGrid 
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    ActualizarContenedor, ActualizarInformacion
        '==========================================================================

        Dim dn As String
        Me.Cursor = Cursors.WaitCursor
        dn = e.Node.Name
        ActualizarContenedor(dn)
        ActualizarInformacion(dn)

        Actual_OU = dn

        'Si es un nodo hoja, Añadir subOUs
        If e.Node.Nodes.Count = 0 Then
            crearArbol(dn, e.Node)
        End If
        Me.Cursor = Cursors.Default


    End Sub

    Private Sub ActualizarToolStripMenuItem_ClickByVal(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActualizarToolStripMenuItem.Click
        '==========================================================================
        ' Name:     ActualizarToolStripMenuItem_ClickByVal
        ' Purpose:  Actualiza el árbol
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim auxnode As TreeNode = New TreeNode()
        auxnode = TreeView1.SelectedNode

        If TreeView1.SelectedNode.Text = Settings.userDNSDomain Then
            'Borrar Arbol
            TreeView1.Nodes.Clear()
            'Nuevo Arbol
            TreeView1.Nodes.Add(Settings.ADRoot, Settings.userDNSDomain)
            crearArbol(Settings.ADRoot, TreeView1.Nodes(Settings.ADRoot))
            TreeView1.SelectedNode = TreeView1.Nodes(Settings.ADRoot)
            'TreeView1.SelectedNode = TreeView1.TopNode
        Else
            TreeView1.SelectedNode = auxnode
            Dim dn As String
            dn = auxnode.Name
            ActualizarContenedor(dn)
            ActualizarInformacion(dn)
        End If

    End Sub

    Private Sub ActualizarContenedor(ByVal dname As String)
        '==========================================================================
        ' Name:     ActualizarContenedor
        ' Purpose:  Actualiza el contenido del DataGrid
        ' Input:    1 string: dirección del contenedor 'dname'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        DataGridView1.DataSource = GenericClass.ContenedorDataTable(dname) ', GetobjectCategory(oResult.GetDirectoryEntry.Properties("objectCategory").Value.ToString))

        DataGridView1.Columns("HiddenName").Visible = False

        DataGridView1.Refresh()

    End Sub

    Private Sub ActualizarInformacion(ByVal dname As String)
        '==========================================================================
        ' Name:     Actualizarinformacion
        ' Purpose:  Actualiza el label con el número de elementos del contenedor
        ' Input:    1 string: dirección del contenedor 'dname'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Label1.Text = dname & " " & GenericClass.InfoContenedor(dname)

    End Sub

    Public Function GetobjectCategory(ByVal cadena As String) As String
        '==========================================================================
        ' Name:     GetobjectCategory
        ' Purpose:  Obtener el tipo de objeto
        ' Input:    1 string: atributo objectCategory de un objeto 'cadena'
        ' Return:   1 string: el tipo de objeto
        ' Calls:    None
        '==========================================================================

        Dim poscoma As Integer = cadena.IndexOf(",")
        Dim longitud As Integer = cadena.Length
        'Se manipula la cadena para quedarse solo con la parte que indica el tipo de objeto
        cadena = cadena.ToUpper
        cadena = cadena.Substring(0, poscoma)
        cadena = cadena.Replace("CN=", "")

        Return cadena

    End Function

    Private Sub DataGridView1_CellContextMenuStripNeeded(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellContextMenuStripNeededEventArgs) Handles DataGridView1.CellContextMenuStripNeeded
        '==========================================================================
        ' Name:     DataGridView1_CellContextMenuStripNeeded
        ' Purpose:  Establecer el menú que aparecerá al hacer click con el botón derecho sobre los objetos del datagrid
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    isUserlocked de UserClass
        '           isdisabled de GenerciClass
        '==========================================================================

        Dim row As Integer = DataGridView1.SelectedCells(0).RowIndex
        Dim tipo As String = DataGridView1.Item("objectCategory", row).Value.ToString
        Dim nombre As String = DataGridView1.Item("HiddenName", row).Value.ToString
        'Si el objeto es un usuario
        If tipo = "PERSON" Then
            Enable.Enabled = True
            Disable.Enabled = True
            Movement.Enabled = True
            Rename.Enabled = True
            Delete.Enabled = True
            strip = New ContextMenuStrip()
            Movement.Text = "Mover"
            Delete.Text = "Eliminar"
            Properties.Text = "Propiedades"
            strip.Items.Add(Properties)
            strip.Items.Add(Movement)
            strip.Items.Add(Delete)
            Enable.Text = "Habilitar"
            Disable.Text = "Deshabilitar"
            strip.Items.Add(Enable)
            strip.Items.Add(Disable)
            Unlock.Text = "Desbloquear"
            strip.Items.Add(Unlock)
            PasswordChange.Text = "Reseteo Contraseña"
            strip.Items.Add(PasswordChange)
            Rename.Text = "Cambiar nombre"
            strip.Items.Add(Rename)
            Copy.Text = "Copiar"
            strip.Items.Add(Copy)
            ExchangeTasks.Text = "Tareas Exchange"
            strip.Items.Add(ExchangeTasks)
            e.ContextMenuStrip = strip

            If UserClass.isUserlocked(GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)) = False Then
                Unlock.Enabled = False
            End If
            Enable.Enabled = False
            If UserClass.isDisabled(GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)) Then
                Enable.Enabled = True
                Disable.Enabled = False
            End If
            If ConExchange Then
                ExchangeTasks.Enabled = True
            Else
                ExchangeTasks.Enabled = False
            End If

            'Si el objeto es un grupo
        ElseIf tipo = "GROUP" Then

            strip = New ContextMenuStrip()
            Movement.Text = "Mover"
            Delete.Text = "Eliminar"
            Properties.Text = "Propiedades"
            strip.Items.Add(Properties)
            strip.Items.Add(Movement)
            strip.Items.Add(Delete)
            Rename.Text = "Cambiar nombre"
            strip.Items.Add(Rename)
            Copy.Text = "Copiar"
            strip.Items.Add(Copy)
            ExchangeTasks.Text = "Tareas Exchange"
            strip.Items.Add(ExchangeTasks)
            e.ContextMenuStrip = strip
            If groupClass.GetGroupProperty(GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString), "systemFlags") = "-1946157056" Then
                Movement.Enabled = False
                Rename.Enabled = False
                Delete.Enabled = False
            Else
                Movement.Enabled = True
                Rename.Enabled = True
                Delete.Enabled = True
            End If

            If ConExchange Then
                ExchangeTasks.Enabled = True
            Else
                ExchangeTasks.Enabled = False
            End If
            'Si el objeto es un equipo
        ElseIf tipo = "COMPUTER" Then
            Enable.Enabled = True
            Disable.Enabled = True
            Movement.Enabled = True
            Rename.Enabled = True
            Delete.Enabled = True
            strip = New ContextMenuStrip()
            Movement.Text = "Mover"
            Delete.Text = "Eliminar"
            Properties.Text = "Propiedades"
            strip.Items.Add(Properties)
            strip.Items.Add(Movement)
            strip.Items.Add(Delete)
            Enable.Text = "Habilitar"
            Disable.Text = "Deshabilitar"
            strip.Items.Add(Enable)
            strip.Items.Add(Disable)
            Rename.Text = "Cambiar nombre"
            strip.Items.Add(Rename)
            Copy.Text = "Copiar"
            strip.Items.Add(Copy)
            e.ContextMenuStrip = strip
            Enable.Enabled = False
            If GenericClass.isDisabled(GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)) Then
                Enable.Enabled = True
                Disable.Enabled = False
            End If

        End If

    End Sub

    Private Sub dataGridView1_ColumnHeaderMouseClick(ByVal sender As Object, _
        ByVal e As DataGridViewCellMouseEventArgs) _
        Handles DataGridView1.ColumnHeaderMouseClick
        '==========================================================================
        ' Name:     dataGridView1_ColumnHeaderMouseClick
        ' Purpose:  Ordenar los datos del datagrid según el orden que establecen las cabeceras de las columnas
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If DataGridView1.Columns(e.ColumnIndex).Name = "Name" Then
            Dim newColumn As DataGridViewColumn = _
                DataGridView1.Columns(e.ColumnIndex + 1)
            Dim oldColumn As DataGridViewColumn = DataGridView1.SortedColumn
            Dim direction As ListSortDirection

            ' Sort the same column again, reversing the SortOrder.
            If DataGridView1.SortOrder = _
                SortOrder.Ascending Then
                direction = ListSortDirection.Descending
            Else
                ' Sort a new column and remove the old SortGlyph.
                direction = ListSortDirection.Ascending
                'oldColumn.HeaderCell.SortGlyphDirection = SortOrder.None
            End If

            ' Sort the selected column.
            DataGridView1.Sort(newColumn, direction)
            If direction = ListSortDirection.Ascending Then
                newColumn.HeaderCell.SortGlyphDirection = SortOrder.Ascending
            Else
                newColumn.HeaderCell.SortGlyphDirection = SortOrder.Descending
            End If
        End If

    End Sub

    'Private Sub DataGridView1_CellContentDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellContentDoubleClick
    '    '==========================================================================
    '    ' Name:     DataGridView1_CellContentDoubleClick
    '    ' Purpose:  Abrir la ventana de opciones del objeto sobre el que se haga un doble click
    '    ' Input:    1 Evento: 'e',
    '    '           1 Objeto: 'sender'
    '    ' Return:   None
    '    ' Calls:    None
    '    '==========================================================================

    '    Dim dname As String = DataGridView1.Item("distinguishedName", e.RowIndex).Value.ToString
    '    'Si el objeto es un container no se hace nada
    '    If DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "CONTAINER" Or DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "ORGANIZATIONAL-UNIT" Or DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "BUILTIN-DOMAIN" Then
    '        Me.Cursor = Cursors.WaitCursor
    '        TreeView1.SelectedNode = GetNode(dname, TreeView1.SelectedNode)
    '        Me.Cursor = Cursors.Default
    '        'Usuario
    '    ElseIf DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "PERSON" Then
    '        Dim logU As String = UserClass.GetUserlogonN(DataGridView1.Item("distinguishedName", e.RowIndex).Value.ToString)
    '        Me.Cursor = Cursors.WaitCursor
    '        Dim UP As New UserProperties
    '        UP.LoadUser(logU)
    '        UP.Show(Me)
    '        'If Not UserProperties.Visible = True Then
    '        '    UserProperties.LoadUser(logU)
    '        '    UserProperties.Show(Me)
    '        'End If
    '        Me.Cursor = Cursors.Default
    '        'Grupo
    '    ElseIf DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "GROUP" Then
    '        Dim logG As String = groupClass.GetGrouplogonN(DataGridView1.Item("distinguishedName", e.RowIndex).Value.ToString)
    '        Me.Cursor = Cursors.WaitCursor
    '        Dim GP As New PropiedadesGrupo
    '        GP.LoadGroup(logG)
    '        GP.Show(Me)
    '        'If Not PropiedadesGrupo.Visible = True Then
    '        '    PropiedadesGrupo.LoadGroup(logG)
    '        '    PropiedadesGrupo.Show(Me)
    '        'End If
    '        Me.Cursor = Cursors.Default
    '        'Equipo
    '    ElseIf DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "COMPUTER" Then
    '        Dim logC As String = GenericClass.GetComputerlogonN(DataGridView1.Item("distinguishedName", e.RowIndex).Value.ToString)
    '        Me.Cursor = Cursors.WaitCursor
    '        Dim CP As New PropiedadesEquipo
    '        CP.LoadComputer(logC)
    '        CP.Show(Me)
    '        'If Not PropiedadesEquipo.Visible Then
    '        '    PropiedadesEquipo.LoadComputer(logC)
    '        '    PropiedadesEquipo.Show(Me)
    '        'End If
    '        Me.Cursor = Cursors.Default
    '    End If

    'End Sub

    Function GetNode(ByVal dnNode As String, ByVal Tree As TreeNode) As TreeNode
        '==========================================================================
        ' Name:     GetNode
        ' Purpose:  Obtener el Nodo de un árbol
        ' Input:    1 String: dirección del nodo 'dnNode'
        '           1 TreeNode: el árbol 'Tree'
        ' Return:   1 TreeNode: El nodo que tiene como nombre la dirección que se pasa por parámetros
        ' Calls:    None
        '==========================================================================

        Return Tree.Nodes(Tree.Nodes.IndexOfKey(dnNode))

    End Function

    Private Sub NewUserStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewUserStripButton.Click
        '==========================================================================
        ' Name:     NewUserStripButton_Click
        ' Purpose:  Llamar al formulario que crea un nuevo usuario al hacer click en la barra superior
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Actual_OU = Settings.ADRoot Then
            MsgBox("No se puede crear en la raíz")
        Else
            'Crear el usuario en el container actual
            Dim NuevoUsuarioForm As New NuevoUsuario
            NuevoUsuarioForm.DN_OU = Actual_OU
            NuevoUsuarioForm.Show(Me)
            ActualizarContenedor(Actual_OU)
        End If
    End Sub

    Private Sub UsuarioToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UsuarioToolStripMenuItem.Click
        '==========================================================================
        ' Name:     UsuarioToolStripMenuItem_Click
        ' Purpose:  Llamar al formulario que crea un nuevo usuario al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Actual_OU = Settings.ADRoot Then
            MsgBox("No se puede crear en la raíz")
        Else
            'Crear el usuario en el container actual
            Dim NuevoUsuarioForm As New NuevoUsuario
            NuevoUsuarioForm.DN_OU = Actual_OU
            NuevoUsuarioForm.Show(Me)
            ActualizarContenedor(Actual_OU)
        End If
    End Sub

    Private Sub SearchToolStripButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles SearchToolStripButton.Click
        '==========================================================================
        ' Name:     SearchToolStripButton_Click
        ' Purpose:  Llamar al formulario buscador al hacer click en la barra superior
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Buscador.Show(Me)

    End Sub

    Private Sub NewGroupToolStripButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NewGroupToolStripButton.Click
        '==========================================================================
        ' Name:     NewGroupToolStripMenuItem_Click
        ' Purpose:  Llamar al formulario que crea un nuevo grupo al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Actual_OU = Settings.ADRoot Then
            MsgBox("No se puede crear en la raíz")
        Else
            'Crear el grupo en el container actual
            Dim NGrupo As New NuevoGrupo
            NGrupo.DN_OU = Actual_OU
            NGrupo.Show(Me)
            ActualizarContenedor(Actual_OU)
        End If
    End Sub

    Private Sub GrupoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GrupoToolStripMenuItem.Click
        '==========================================================================
        ' Name:     GroupToolStripMenuItem_Click
        ' Purpose:  Llamar al formulario que crea un nuevo grupo al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Actual_OU = Settings.ADRoot Then
            MsgBox("No se puede crear en la raíz")
        Else
            Dim NuevoGrupoForm As New NuevoGrupo
            NuevoGrupoForm.DN_OU = Actual_OU
            NuevoGrupoForm.Show(Me)
            ActualizarContenedor(Actual_OU)
        End If
    End Sub

    Private Sub Movement_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Movement.Click
        '==========================================================================
        ' Name:     Movement_Click
        ' Purpose:  Llamar al formulario que mueve de container al objeto al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim row As Integer = DataGridView1.SelectedCells(0).RowIndex
        Dim tipo As String = DataGridView1.Item("objectCategory", row).Value.ToString
        If tipo = "PERSON" Or tipo = "GROUP" Or tipo = "COMPUTER" Then
            Dim logU As String = GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)
            Mover.LoadObject(logU)
            Mover.ShowDialog()
            ActualizarContenedor(Actual_OU)

        End If

    End Sub

    Private Sub Delete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Delete.Click
        '==========================================================================
        ' Name:     Movement_Click
        ' Purpose:  Llamar la función que elimina el objeto al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        'Try
        '    Dim salida As String = "-------Eliminar-------"

        Dim row As Integer = DataGridView1.SelectedCells(0).RowIndex
        Dim tipo As String = DataGridView1.Item("objectCategory", row).Value.ToString
        If tipo = "PERSON" Or tipo = "GROUP" Or tipo = "COMPUTER" Then
            Dim logU As String = GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)
            Dim nom As String = GenericClass.GetName(DataGridView1.Item("distinguishedName", row).Value.ToString)

            If tipo = "PERSON" Or tipo = "COMPUTER" Then

                If Not GenericClass.isDisabled(logU) Then
                    MsgBox("Para poder eliminar " & nom & " debe estar deshabilitado")
                Else
                    EliminarAviso.loadObject(nom, tipo, logU, Actual_OU)
                    EliminarAviso.ShowDialog()

                    ActualizarContenedor(Actual_OU)
                    ActualizarInformacion(Actual_OU)
                End If
            Else
                EliminarAviso.loadObject(nom, tipo, logU, Actual_OU)
                EliminarAviso.ShowDialog()
                ActualizarContenedor(Actual_OU)
                ActualizarInformacion(Actual_OU)
            End If

        End If
        'Log
        '    GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        'Catch ex As Exception
        '    GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
        '    End
        'End Try
    End Sub

    Private Sub EquipoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EquipoToolStripMenuItem.Click
        '==========================================================================
        ' Name:     EquipoToolStripMenuItem_Click
        ' Purpose:  Llamar al formulario que crea un nuevo equipo al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Actual_OU = Settings.ADRoot Then
            MsgBox("No se puede crear en la raíz")
        Else
            Dim NuevoEquipoForm As New NuevoEquipo
            'Dim NuevoEquipoForm As New NUsuario
            NuevoEquipoForm.DN_OU = Actual_OU
            NuevoEquipoForm.Show(Me)
            ActualizarContenedor(Actual_OU)
        End If
    End Sub

    Private Sub Properties_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Properties.Click
        '==========================================================================
        ' Name:     GroupToolStripMenuItem_Click
        ' Purpose:  Llamar al formulario de opciones del objeto al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim row As Integer = DataGridView1.SelectedCells(0).RowIndex
        Dim tipo As String = DataGridView1.Item("objectCategory", row).Value.ToString
        Dim logU As String = GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)
        'Para cada tipo de objeto llama a su formulario de propiedades
        If tipo = "PERSON" Then
            Me.Cursor = Cursors.WaitCursor
            Dim UP As New UserProperties
            UP.LoadUser(logU)
            UP.Show(Me)
            'If Not UserProperties.Visible = True Then
            '    UserProperties.LoadUser(logU)
            '    UserProperties.Show(Me)
            'End If

            Me.Cursor = Cursors.Default
        ElseIf tipo = "GROUP" Then
            Me.Cursor = Cursors.WaitCursor
            Dim GP As New PropiedadesGrupo
            GP.LoadGroup(logU)
            GP.Show(Me)
            'If Not PropiedadesGrupo.Visible = True Then
            '    PropiedadesGrupo.LoadGroup(logU)
            '    PropiedadesGrupo.Show(Me)
            'End If
            Me.Cursor = Cursors.Default
        ElseIf tipo = "COMPUTER" Then
            Me.Cursor = Cursors.WaitCursor
            Dim CP As New PropiedadesEquipo
            CP.LoadComputer(logU)
            CP.Show(Me)
            'If Not PropiedadesEquipo.Visible Then
            '    PropiedadesEquipo.LoadComputer(logU)
            '    PropiedadesEquipo.Show(Me)
            'End If

            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub Enable_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Enable.Click
        '==========================================================================
        ' Name:     Enable_Click
        ' Purpose:  Llamar la función que habilita un usuario o un equipo al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Try
            Dim salida As String = "-------Habilitar-------"
            Dim row As Integer = DataGridView1.SelectedCells(0).RowIndex
            Dim tipo As String = DataGridView1.Item("objectCategory", row).Value.ToString
            If tipo = "PERSON" Or tipo = "COMPUTER" Then
                Dim logU As String = GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)
                salida = salida & vbCrLf & "Habilitar: " & logU & " tipo: " & tipo
                salida = salida & vbCrLf & "Habilitar..."
                Try
                    GenericClass.EnableAccount(logU)
                Catch ex As Exception When logU = ""
                    MsgBox("Error al habilitar la cuenta, el nombre de login del objeto a habilitar no puede ser vacío " & ex.Message)
                    salida = salida & vbCrLf & "Error: al habilitar la cuenta, el nombre de login del objeto a habilitar no puede ser vacío " & ex.Message
                Catch ex As Exception
                    MsgBox("Error al habilitar la cuenta " & ex.Message)
                    salida = salida & vbCrLf & "Error: al habilitar la cuenta " & ex.Message
                End Try

                ActualizarContenedor(Actual_OU)
                salida = salida & vbCrLf & "Habilitado"
            End If
            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub Rename_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Rename.Click
        '==========================================================================
        ' Name:     Rename_Click
        ' Purpose:  Llamar la función que habilita un usuario o un equipo al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Try
            Dim salida As String = "-------Renombrar-------"
            Dim row As Integer = DataGridView1.SelectedCells(0).RowIndex
            Dim tipo As String = DataGridView1.Item("objectCategory", row).Value.ToString
            'Obtener el nombre de login del objeto
            Dim logU As String = GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)
            If tipo = "PERSON" Then
                NuevoNombreUsuario.LoadUser(logU)
                NuevoNombreUsuario.ShowDialog()
                ActualizarContenedor(Actual_OU)
            ElseIf tipo = "GROUP" Or tipo = "COMPUTER" Then
                'Si el objeto es un grupo o un equipo
                NuevoNombre.ShowDialog()
                
                    'Renombrar el objeto
                If Not nombre = "" Then
                    If nombre = logU Then
                        MsgBox("El nombre que se quiere asignar es el mismo que ya tiene el objeto")
                    Else
                        salida = salida & vbCrLf & "Renombrar: " & logU & " tipo: " & tipo
                        salida = salida & vbCrLf & "Por el nombre: " & nombre
                        salida = salida & vbCrLf & "Renombrar..."
                        Try
                            GenericClass.Rename(logU, nombre, tipo)
                        Catch ex As Exception When logU = ""
                            MsgBox("Error al cambiar el nombre al objeto, el nombre de login del objeto no puede ser vacío " & ex.Message)
                            salida = salida & vbCrLf & "Error: al cambiar el nombre al objeto, el nombre de login del objeto no puede ser vacío " & ex.Message
                        Catch ex As Exception When nombre = ""
                            MsgBox("Error al cambiar el nombre al objeto, el nuevo nombre a asignarle al objeto no puede ser vacío " & ex.Message)
                            salida = salida & vbCrLf & "Error: al cambiar el nombre al objeto, el nuevo nombre a asignarle al objeto no puede ser vacío " & ex.Message
                        Catch ex As Exception When tipo = ""
                            MsgBox("Error al cambiar el nombre al objeto, el tipo del objeto no puede ser vacío " & ex.Message)
                            salida = salida & vbCrLf & "Error: al cambiar el nombre al objeto, el tipo del objeto no puede ser vacío " & ex.Message
                        Catch ex As Exception
                            MsgBox("Error al cambiar el nombre al objeto " & ex.Message)
                            salida = salida & vbCrLf & "Error: al cambiar el nombre al objeto " & ex.Message
                        End Try
                        ActualizarContenedor(Actual_OU)
                        salida = salida & vbCrLf & "Renombrado"
                    End If

                End If

            End If
            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub Disable_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Disable.Click
        '==========================================================================
        ' Name:     Disable_Click
        ' Purpose:  Llamar la función que deshabilita un usuario o un equipo al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Try
            Dim salida As String = "-------Habilitar-------"
            Dim row As Integer = DataGridView1.SelectedCells(0).RowIndex
            Dim tipo As String = DataGridView1.Item("objectCategory", row).Value.ToString
            If tipo = "PERSON" Or tipo = "COMPUTER" Then

                Dim logU As String = GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)
                salida = salida & vbCrLf & "Deshabilitar: " & logU & " tipo: " & tipo
                salida = salida & vbCrLf & "Desabilitar..."
                Try
                    GenericClass.DisableAccount(logU)
                Catch ex As Exception When logU = ""
                    MsgBox("Error al deshabilitar la cuenta, el nombre de login del objeto a deshabilitar no puede ser vacío " & ex.Message)
                    salida = salida & vbCrLf & "Error: al deshabilitar la cuenta, el nombre de login del objeto a deshabilitar no puede ser vacío " & ex.Message
                Catch ex As Exception
                    MsgBox("Error al deshabilitar la cuenta " & ex.Message)
                    salida = salida & vbCrLf & "Error: al deshabilitar la cuenta " & ex.Message
                End Try
                ActualizarContenedor(Actual_OU)
                salida = salida & vbCrLf & "Desabilitado"
            End If
            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub Unlock_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Unlock.Click
        '==========================================================================
        ' Name:     Unlock_Click
        ' Purpose:  Llamar la función que desbloquea un usuario al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Try
            Dim salida As String = "-------Desbloquear-------"
            Dim row As Integer = DataGridView1.SelectedCells(0).RowIndex
            Dim tipo As String = DataGridView1.Item("objectCategory", row).Value.ToString
            If tipo = "PERSON" Then
                Dim logU As String = GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)
                salida = salida & vbCrLf & "Desbloquear: " & logU
                salida = salida & vbCrLf & "Desbloquear..."
                Try
                    UserClass.UnlockUser(logU)
                Catch ex As Exception When logU = ""
                    MsgBox("Error al desbloquear el usuario, el nombre de login del ususario no puede ser vacío " & ex.Message)
                    salida = salida & vbCrLf & "Error: al desbloquear el usuario, el nombre de login del ususario no puede ser vacío " & ex.Message
                Catch ex As Exception
                    MsgBox("Error al desbloquear el usuario " & ex.Message)
                    salida = salida & vbCrLf & "Error: al desbloquear el usuario " & ex.Message
                End Try
                ActualizarContenedor(Actual_OU)
                salida = salida & vbCrLf & "Desbloqueado"
            End If
            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub PasswordChange_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles PasswordChange.Click
        '==========================================================================
        ' Name:     PasswordChange_Click
        ' Purpose:  Llamar a el formulario que resetea el password un usuario al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim row As Integer = DataGridView1.SelectedCells(0).RowIndex
        Dim tipo As String = DataGridView1.Item("objectCategory", row).Value.ToString
        If tipo = "PERSON" Or tipo = "COMPUTER" Then
            Dim logU As String = GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)
            ResetPassword.loadU(logU)
            ResetPassword.ShowDialog()
            ActualizarContenedor(Actual_OU)
        End If

    End Sub

    Private Sub RefreshToolStripButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RefreshToolStripButton.Click
        '==========================================================================
        ' Name:     RefreshToolStripButton_Click
        ' Purpose:  Actualiza el árbol
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim auxnode As TreeNode = New TreeNode()
        auxnode = TreeView1.SelectedNode

        If TreeView1.SelectedNode.Text = Settings.userDNSDomain Then
            'Borrar Arbol
            TreeView1.Nodes.Clear()
            'Nuevo Arbol
            TreeView1.Nodes.Add(Settings.ADRoot, Settings.userDNSDomain)
            crearArbol(Settings.ADRoot, TreeView1.Nodes(Settings.ADRoot))
            TreeView1.SelectedNode = TreeView1.Nodes(Settings.ADRoot)
            'TreeView1.SelectedNode = TreeView1.TopNode
        Else
            TreeView1.SelectedNode = auxnode
            Dim dn As String
            dn = auxnode.Name
            ActualizarContenedor(dn)
            ActualizarInformacion(dn)
        End If
    End Sub

    Private Sub ExchangeTasks_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ExchangeTasks.Click
        '==========================================================================
        ' Name:     ExchangeTasks_Click
        ' Purpose:  Llamar a el formulario de Tareas de Exchange
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim row As Integer = DataGridView1.SelectedCells(0).RowIndex
        Dim tipo As String = DataGridView1.Item("objectCategory", row).Value.ToString
        Dim nombre As String = DataGridView1.Item("HiddenName", row).Value.ToString

        If tipo = "PERSON" Or tipo = "GROUP" Then
            If GenericClass.isDisabled(GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)) Then
                MsgBox("No se pueden realizar tareas relacionadas con Exchange cuando el usuario está deshabilitado")
            Else

                Dim logU As String = GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString)
                Me.Cursor = Cursors.WaitCursor

                TareasExch.LoadUser(logU, tipo)
                TareasExch.ShowDialog()
                ActualizarContenedor(Actual_OU)
                Me.Cursor = Cursors.Default
            End If
        End If
    End Sub

    Private Sub NewCompToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewCompToolStripButton.Click
        '==========================================================================
        ' Name:     NewCompToolStripButton_Click
        ' Purpose:  Llamar al formulario que crea un nuevo equipo al hacer click en la opción nuevo usuario del menú
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Actual_OU = Settings.ADRoot Then
            MsgBox("No se puede crear en la raíz")
        Else
            Dim NuevoEquipoForm As New NuevoEquipo
            'Dim NuevoEquipoForm As New NUsuario
            NuevoEquipoForm.DN_OU = Actual_OU
            NuevoEquipoForm.Show(Me)
            ActualizarContenedor(Actual_OU)
        End If
    End Sub

    Private Sub Copy_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Copy.Click
        '==========================================================================
        ' Name:     Copy_Click
        ' Purpose:  Copiar el objeto
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim row As Integer = DataGridView1.SelectedCells(0).RowIndex
        Dim tipo As String = DataGridView1.Item("objectCategory", row).Value.ToString
        Dim nombre As String = DataGridView1.Item("HiddenName", row).Value.ToString
        'Si el objeto es un usuario
        If tipo = "PERSON" Then
            Me.Cursor = Cursors.WaitCursor
            UserClass.CopyUser(GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString), Actual_OU)
            ActualizarContenedor(Actual_OU)
            Me.Cursor = Cursors.Default
            'Si el objeto es un grupo
        ElseIf tipo = "GROUP" Then
            Me.Cursor = Cursors.WaitCursor
            groupClass.CopyGroup(GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString), Actual_OU)
            ActualizarContenedor(Actual_OU)
            Me.Cursor = Cursors.Default
            'Si el objeto es un equipo
        ElseIf tipo = "COMPUTER" Then
            Me.Cursor = Cursors.WaitCursor
            GenericClass.CopyComputer(GenericClass.GetlogonN(DataGridView1.Item("distinguishedName", row).Value.ToString), Actual_OU)
            ActualizarContenedor(Actual_OU)
            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub DataGridView1_CellDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellDoubleClick
        '==========================================================================
        ' Name:     DataGridView1_CellContentDoubleClick
        ' Purpose:  Abrir la ventana de opciones del objeto sobre el que se haga un doble click
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim dname As String = DataGridView1.Item("distinguishedName", e.RowIndex).Value.ToString
        'Si el objeto es un container no se hace nada
        If DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "CONTAINER" Or DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "ORGANIZATIONAL-UNIT" Or DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "BUILTIN-DOMAIN" Then
            Me.Cursor = Cursors.WaitCursor
            TreeView1.SelectedNode = GetNode(dname, TreeView1.SelectedNode)
            Me.Cursor = Cursors.Default
            'Usuario
        ElseIf DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "PERSON" Then
            Dim logU As String = UserClass.GetUserlogonN(DataGridView1.Item("distinguishedName", e.RowIndex).Value.ToString)
            Me.Cursor = Cursors.WaitCursor
            Dim UP As New UserProperties
            UP.LoadUser(logU)
            UP.Show(Me)
            'If Not UserProperties.Visible = True Then
            '    UserProperties.LoadUser(logU)
            '    UserProperties.Show(Me)
            'End If
            Me.Cursor = Cursors.Default
            'Grupo
        ElseIf DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "GROUP" Then
            Dim logG As String = groupClass.GetGrouplogonN(DataGridView1.Item("distinguishedName", e.RowIndex).Value.ToString)
            Me.Cursor = Cursors.WaitCursor
            Dim GP As New PropiedadesGrupo
            GP.LoadGroup(logG)
            GP.Show(Me)
            'If Not PropiedadesGrupo.Visible = True Then
            '    PropiedadesGrupo.LoadGroup(logG)
            '    PropiedadesGrupo.Show(Me)
            'End If
            Me.Cursor = Cursors.Default
            'Equipo
        ElseIf DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "COMPUTER" Then
            Dim logC As String = GenericClass.GetComputerlogonN(DataGridView1.Item("distinguishedName", e.RowIndex).Value.ToString)
            Me.Cursor = Cursors.WaitCursor
            Dim CP As New PropiedadesEquipo
            CP.LoadComputer(logC)
            CP.Show(Me)
            'If Not PropiedadesEquipo.Visible Then
            '    PropiedadesEquipo.LoadComputer(logC)
            '    PropiedadesEquipo.Show(Me)
            'End If
            Me.Cursor = Cursors.Default
        End If
    End Sub

    Private Sub TreeView1_NodeMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeNodeMouseClickEventArgs) Handles TreeView1.NodeMouseClick
        '==========================================================================
        ' Name:     TreeView1_NodeMouseClick
        ' Purpose:  Al hacer clic sobre un nodo con el botón derecho, que lo tome como seleccionado
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If e.Button = Windows.Forms.MouseButtons.Right Then
            TreeView1.SelectedNode = e.Node
        End If
    End Sub

    Private Sub DataGridView1_CellMouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DataGridView1.CellMouseDown
        '==========================================================================
        ' Name:     TreeView1_NodeMouseClick
        ' Purpose:  Al hacer clic sobre un nodo con el botón derecho, que lo tome como seleccionado
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If e.Button = Windows.Forms.MouseButtons.Right Then
            DataGridView1.CurrentCell = DataGridView1(e.ColumnIndex, e.RowIndex)
        End If
    End Sub
End Class
