﻿Public Class Añadir
    Public logU As String
    Dim seleccionado As Integer = -1
    Dim tipo As String = "vacio"
    Dim padreF As String

    Friend Sub Solo(ByVal type As String)
        '==========================================================================
        ' Name:     Solo
        ' Purpose:  Establecer el tipo de objeto que se va a buscar
        ' Input:    1 string: el tipo'type'
        ' Return:   1 string: el tipo
        ' Calls:    None
        '==========================================================================
        'El tipo puede ser:
        'user - usuario
        'group - grupo
        'computer - equipo
        'usergroup - usuarios y grupos
        'vacio - todos
        'userExch - usuarios con buzón
        tipo = type
    End Sub

    Friend Sub Padre(ByVal parent As String)
        '==========================================================================
        ' Name:     Solo
        ' Purpose:  Establecer el tipo de objeto que se va a buscar
        ' Input:    1 string: el tipo'type'
        ' Return:   1 string: el tipo
        ' Calls:    None
        '==========================================================================
        'El tipo puede ser:
        'user - usuario
        'group - grupo
        'computer - equipo
        'usergroup - usuarios y grupos
        'vacio - todos
        'userExch - usuarios con buzón
        padreF = parent
    End Sub

    Private Sub Buscador_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     Buscador_Load
        ' Purpose:  Carga el listview donde aparecerán los resultados de la búsqueda
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        ResultsListView.ShowItemToolTips = True
        ResultsListView.View = View.Details
        ResultsListView.Columns.Clear()
        'Columnas
        ResultsListView.Columns.Add("Nombre", 100, HorizontalAlignment.Left)
        ResultsListView.Columns.Add("Tipo", 60, HorizontalAlignment.Center)
        'Eliminar elementos anteriores
        ResultsListView.Items.Clear()

    End Sub

    Private Sub SearchButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles SearchButton.Click
        '==========================================================================
        ' Name:     SearchButton_Click
        ' Purpose:  Buscar los objetos cuyos nombres contengan la zadena de caracteres que se introducen en el textbox y cargarlos en el listview
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        SearchButton.Enabled = False
        If Not ToSearchTextBox.Text = "" Then
            ResultsListView.Items.Clear()
            Me.Cursor = Cursors.WaitCursor
            'Obtener todos los usuarios, grupos y equipos del directorio activo
            Dim UList As New List(Of String)
            Dim GList As New List(Of String)
            Dim CList As New List(Of String)

            'Buscar usuarios que tengan entre sus nombres el texto del textbox
            If tipo = "vacio" Or tipo = "user" Or tipo = "usergroup" Or tipo = "userExch" Or tipo = "userGroupExch" Then
                UList = GenericClass.HavePart(ToSearchTextBox.Text, "user")
                If UList.Count > 0 Then
                    For i = 0 To UList.Count - 1
                        'Si se trata de un usuario con Nombre de login
                        Dim UPN As String = UserClass.GetUserProperty(UList(i), "userPrincipalName")
                        If Not UPN = "" Then
                            If tipo = "userExch" Or tipo = "userGroupExch" Then
                                Dim homeMDB As String = UserClass.GetUserProperty(UserClass.GetUserProperty(UList(i), "sAMAccountName"), "homeMDB")
                                If Not homeMDB = "" Then
                                    'Si tiene buzón exchange
                                    'Generar datos para el listview y cargarlos
                                    Dim Tempnode As ListViewItem
                                    Dim datos(1) As String
                                    datos(0) = UserClass.GetUserProperty(UList(i), "cn") & "(" & UPN & ")"
                                    datos(1) = "user"
                                    Tempnode = New ListViewItem(datos)
                                    ResultsListView.Items.Add(Tempnode)
                                End If
                            Else

                                'Generar datos para el listview y cargarlos
                                Dim Tempnode As ListViewItem
                                Dim datos(1) As String
                                datos(0) = UserClass.GetUserProperty(UList(i), "cn") & "(" & UPN & ")"
                                datos(1) = "user"
                                Tempnode = New ListViewItem(datos)
                                ResultsListView.Items.Add(Tempnode)

                            End If
                        End If
                    Next
                End If
            End If

            'Buscar grupos que tengan entre sus nombres el texto del textbox
            If tipo = "vacio" Or tipo = "group" Or tipo = "usergroup" Or tipo = "userGroupExch" Then
                GList = GenericClass.HavePart(ToSearchTextBox.Text, "group")
                If GList.Count > 0 Then
                    For i = 0 To GList.Count - 1
                        'If UCase(groupClass.GetGroupProperty(GList(i), "sAMAccountName")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(groupClass.GetGroupProperty(GList(i), "displayName")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(groupClass.GetGroupProperty(GList(i), "cn")).Contains(UCase(ToSearchTextBox.Text)) Then
                        'If GenericClass.HavePart(UList(i), ToSearchTextBox.Text, "group") Then
                        'Generar datos para el listview y cargarlos
                        If Not tipo = "userGroupExch" Then
                            Dim Tempnode As ListViewItem
                            Dim datos(1) As String
                            datos(0) = groupClass.GetGroupProperty(GList(i), "sAMAccountName")
                            datos(1) = "group"
                            Tempnode = New ListViewItem(datos)
                            ResultsListView.Items.Add(Tempnode)
                        Else
                            Dim mail As String = groupClass.GetGroupProperty(groupClass.GetGroupProperty(GList(i), "sAMAccountName"), "legacyExchangeDN")
                            If Not mail = "" Then
                                Dim Tempnode As ListViewItem
                                Dim datos(1) As String
                                datos(0) = groupClass.GetGroupProperty(GList(i), "sAMAccountName")
                                datos(1) = "group"
                                Tempnode = New ListViewItem(datos)
                                ResultsListView.Items.Add(Tempnode)
                            End If
                        End If

                        'End If
                    Next
                End If
            End If
            'Buscar equipos que tengan entre sus nombres el texto del textbox
            If tipo = "vacio" Or tipo = "computer" Then
                CList = GenericClass.HavePart(ToSearchTextBox.Text, "computer")
                If CList.Count > 0 Then
                    For i = 0 To CList.Count - 1
                        'If UCase(GenericClass.GetComputerProperty(CList(i), "sAMAccountName")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(GenericClass.GetComputerProperty(CList(i), "displayName")).Contains(UCase(ToSearchTextBox.Text)) Then
                        'If GenericClass.HavePart(UList(i), ToSearchTextBox.Text, "computer") Then
                        'Generar datos para el listview y cargarlos
                        Dim Tempnode As ListViewItem
                        Dim datos(1) As String
                        datos(0) = GenericClass.GetComputerProperty(CList(i), "sAMAccountName") & "(" & GenericClass.GetComputerProperty(CList(i), "dNSHostName") & ")"
                        datos(1) = "computer"
                        Tempnode = New ListViewItem(datos)
                        ResultsListView.Items.Add(Tempnode)
                        'End If
                    Next
                End If
            End If
        Else
            MsgBox("No se ha introducido la cadena a buscar")
        End If
        Me.Cursor = Cursors.Default
        SearchButton.Enabled = True

    End Sub

    Private Sub ResultsListView_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ResultsListView.SelectedIndexChanged
        '==========================================================================
        ' Name:     ResultsListView_SelectedIndexChanged
        ' Purpose:  Guardar en la variable selecccionado el objeto del listview seleccionado
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim item As ListViewItem
        Dim seleccionados As ListView.SelectedListViewItemCollection = ResultsListView.SelectedItems
        'Buscar el seleccionado
        For Each item In seleccionados
            seleccionado = item.Index
        Next

    End Sub

    Private Sub AcceptButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Devuelve el nombre de login del objeto seleccionado
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim logN As String
        If Not seleccionado = -1 Then
            'Si es un grupo
            If ResultsListView.Items(seleccionado).SubItems(1).Text = "group" Then
                logN = ResultsListView.Items(seleccionado).SubItems(0).Text
                'Si es un usuario
            ElseIf ResultsListView.Items(seleccionado).SubItems(1).Text = "user" Then
                Dim partes() As String
                partes = ResultsListView.Items(seleccionado).SubItems(0).Text.Split("(")
                partes = partes(1).Split("@")
                logN = partes(0)
            Else
                'Si es un equipo
                Dim partes() As String
                partes = ResultsListView.Items(seleccionado).SubItems(0).Text.Split("(")
                logN = partes(0)

            End If

            logU = logN
            'Recorrer las ventanas abiertas y devolver el objeto seleccionado
            
            Dim frm As Form
            For Each frm In Arbol.OwnedForms
                If frm.Visible Then
                    If frm.Name = "PropiedadesGrupo" Then
                        Dim formAc As PropiedadesGrupo = DirectCast(frm, PropiedadesGrupo)
                        formAc.LoadObject(logN)
                    ElseIf frm.Name = "Mover" Then
                        Dim formAc As Mover = frm
                        formAc.LoadObject(logN)
                    ElseIf frm.Name = "NuevoEquipo" Then
                        Dim formAc As NuevoEquipo = DirectCast(frm, NuevoEquipo)
                        formAc.loadObjectAdmin(logN)
                    ElseIf frm.Name = "PropiedadesEquipo" Then
                        Dim formAc As PropiedadesEquipo = DirectCast(frm, PropiedadesEquipo)
                        formAc.loadObject(logN)
                    ElseIf frm.Name = "UserProperties" Then
                        Dim formAc As UserProperties = DirectCast(frm, UserProperties)
                        formAc.LoadObject(logN)
                        'ElseIf frm.Name = "PermisosBuzon" Then
                        '    Dim formAc As PermisosBuzon = DirectCast(frm, PermisosBuzon)
                        '    formAc.LoadObjeto(logN)
                        'ElseIf frm.Name = "OpcionesEnvio" Then
                        '    Dim formAc As OpcionesEnvio = DirectCast(frm, OpcionesEnvio)
                        '    formAc.LoadU(logN)
                        'ElseIf frm.Name = "RestriccionesEnvio" Then
                        '    Dim formAc As RestriccionesEnvio = DirectCast(frm, RestriccionesEnvio)
                        '    formAc.LoadU(logN)
                        'ElseIf frm.Name = recursosCompartidosArbol.Name Then
                        '    Dim formAc As SeguridadCarpeta = DirectCast(frm, SeguridadCarpeta)
                        '    formAc.LoadObjeto(logN)
                    End If

                End If
            Next
            SeguridadCarpeta.LoadObjeto(logN)
            PermisosBuzon.LoadObjeto(logN)
            OpcionesEnvio.LoadU(logN)
            RestriccionesEnvio.LoadU(logN)
        End If
        'Cerrar el formulario
        Me.Close()

    End Sub
End Class