﻿Public Class Buscador
    Dim seleccionado As Integer = -1

    Private Sub Buscador_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     Buscador_Load
        ' Purpose:  Establecer el listview del formulario
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        ResultsListView.ShowItemToolTips = True
        ' Set columnar mode
        ResultsListView.View = View.Details
        ' Set column header
        ResultsListView.Columns.Clear()

        ResultsListView.Columns.Add("DisplayName", 100, HorizontalAlignment.Left)
        ResultsListView.Columns.Add("Nombre", 100, HorizontalAlignment.Left)
        ResultsListView.Columns.Add("Tipo", 60, HorizontalAlignment.Center)
        ResultsListView.Columns.Add("Descripción", 208, HorizontalAlignment.Left)
        ResultsListView.Columns.Add("Dirección", 208, HorizontalAlignment.Left)

        ResultsListView.Items.Clear()

    End Sub

    Private Sub SearchButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles SearchButton.Click
        '==========================================================================
        ' Name:     SearchButton_Click
        ' Purpose:  Buscar los objetos que entre sus nombres tengan la cadena de caracteres introducida en el textbox
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Try
            Me.Cursor = Cursors.WaitCursor
            Dim salida As String = "-------Buscador-------"
            SearchButton.Enabled = False
            If Not ToSearchTextBox.Text = "" Then
                salida = salida & vbCrLf & "Busqueda de:" & ToSearchTextBox.Text
                ResultsListView.Items.Clear()
                Dim UList As New List(Of String)
                Dim GList As New List(Of String)
                Dim CList As New List(Of String)

                'Obtener todos los usuarios, grupos y equipos del directorio activo
                UList = GenericClass.HavePart(ToSearchTextBox.Text, "user")
                GList = GenericClass.HavePart(ToSearchTextBox.Text, "group")
                CList = GenericClass.HavePart(ToSearchTextBox.Text, "computer")

                If UList.Count > 0 Then
                    'Buscar usuarios con la cadena
                    Dim cuantos As Integer = 0
                    For i = 0 To UList.Count - 1
                        'If UCase(UserClass.GetUserProperty(UList(i), "sAMAccountName")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(UserClass.GetUserProperty(UList(i), "givenName")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(UserClass.GetUserProperty(UList(i), "sn")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(UserClass.GetUserProperty(UList(i), "displayName")).Contains(UCase(ToSearchTextBox.Text)) Then
                        'If GenericClass.HavePart(UList(i), ToSearchTextBox.Text, "user") Then
                        'Si se encuentra establecer los datos a devolver para que salgan en el listview
                        cuantos = cuantos + 1
                        If Not UserClass.GetUserProperty(UList(i), "userPrincipalName") = "" Then
                            Dim Tempnode As ListViewItem
                            Dim datos(4) As String
                            datos(0) = UserClass.GetUserProperty(UList(i), "displayName")
                            datos(1) = UserClass.GetUserProperty(UList(i), "cn") & "(" & UserClass.GetUserProperty(UList(i), "userPrincipalName") & ")"
                            datos(2) = "user"
                            datos(3) = UserClass.GetUserProperty(UList(i), "description")
                            datos(4) = UserClass.GetUserPropertyRefresh(UList(i), "canonicalName")
                            Tempnode = New ListViewItem(datos)

                            ResultsListView.Items.Add(Tempnode)
                        End If

                        'End If
                    Next
                    salida = salida & vbCrLf & "Encontrados " & cuantos & " Usuarios"
                Else
                    MsgBox("No se han encontrado objetos que incluyan " & ToSearchTextBox.Text)
                End If

                If GList.Count > 0 Then
                    'Buscar grupos con la cadena
                    Dim cuantos As Integer = 0
                    For i = 0 To GList.Count - 1
                        'If UCase(groupClass.GetGroupProperty(GList(i), "sAMAccountName")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(groupClass.GetGroupProperty(GList(i), "displayName")).Contains(UCase(ToSearchTextBox.Text)) Then
                        'If GenericClass.HavePart(GList(i), ToSearchTextBox.Text, "group") Then
                        'Si se encuentra establecer los datos a devolver para que salgan en el listview
                        cuantos = cuantos + 1
                        Dim Tempnode As ListViewItem
                        Dim datos(4) As String
                        datos(0) = groupClass.GetGroupProperty(GList(i), "displayName")
                        datos(1) = groupClass.GetGroupProperty(GList(i), "cn") & "(" & groupClass.GetGroupProperty(GList(i), "sAMAccountName") & ")"
                        datos(2) = "group"
                        datos(3) = groupClass.GetGroupProperty(GList(i), "description")
                        datos(4) = groupClass.GetGroupPropertyRefresh(GList(i), "canonicalName")
                        Tempnode = New ListViewItem(datos)
                        ResultsListView.Items.Add(Tempnode)
                        'End If
                    Next
                    salida = salida & vbCrLf & "Encontrados " & cuantos & " Grupos"
                End If

                If CList.Count > 0 Then
                    'Buscar equipos con la cadena
                    Dim cuantos As Integer = 0
                    For i = 0 To CList.Count - 1
                        'If UCase(GenericClass.GetComputerProperty(CList(i), "sAMAccountName")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(GenericClass.GetComputerProperty(CList(i), "displayName")).Contains(UCase(ToSearchTextBox.Text)) Then
                        'If GenericClass.HavePart(CList(i), ToSearchTextBox.Text, "computer") Then
                        'Si se encuentra establecer los datos a devolver para que salgan en el listview
                        cuantos = cuantos + 1
                        Dim Tempnode As ListViewItem
                        Dim datos(4) As String
                        datos(0) = GenericClass.GetComputerProperty(CList(i), "displayName") & "(" & GenericClass.GetComputerProperty(CList(i), "dNSHostName") & ")"
                        datos(1) = GenericClass.GetComputerProperty(CList(i), "cn") & "(" & GenericClass.GetComputerProperty(CList(i), "sAMAccountName") & ")"
                        datos(2) = "computer"
                        datos(3) = GenericClass.GetComputerProperty(CList(i), "description")
                        datos(4) = GenericClass.GetComputerPropertyRefresh(CList(i), "canonicalName")
                        Tempnode = New ListViewItem(datos)
                        ResultsListView.Items.Add(Tempnode)
                        ' End If
                    Next
                    salida = salida & vbCrLf & "Encontrados " & cuantos & " Equipos"
                End If

            End If
            SearchButton.Enabled = True
            Me.Cursor = Cursors.Default
            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub ResultsListView_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ResultsListView.MouseDoubleClick
        '==========================================================================
        ' Name:     ResultsListView_MouseDoubleClick
        ' Purpose:  Llamar al formulario del objeto de los resultados sobre el que se hace doble click
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not seleccionado = -1 Then
            'Propiedades de usuario
            If ResultsListView.Items(seleccionado).SubItems(2).Text = "user" Then
                Dim user As String = ResultsListView.Items(seleccionado).SubItems(1).Text
                Dim parts() As String = user.Split("(")
                Dim log() As String = parts(1).Split("@")
                Me.Cursor = Cursors.WaitCursor
                Dim UP As New UserProperties
                UP.LoadUser(log(0))
                UP.Show()
                Me.Cursor = Cursors.Default
                'Propiedades de grupo
            ElseIf ResultsListView.Items(seleccionado).SubItems(2).Text = "group" Then
                Dim user As String = ResultsListView.Items(seleccionado).SubItems(1).Text
                Dim parts() As String = user.Split("(")
                Dim log() As String = parts(1).Split(")")
                Me.Cursor = Cursors.WaitCursor
                Dim GP As New PropiedadesGrupo
                GP.LoadGroup(log(0))
                GP.Show()
                Me.Cursor = Cursors.Default
                'Propiedades de equipo
            ElseIf ResultsListView.Items(seleccionado).SubItems(2).Text = "computer" Then
                Dim user As String = ResultsListView.Items(seleccionado).SubItems(1).Text
                Dim parts() As String = user.Split("(")
                Dim log() As String = parts(1).Split(")")
                Me.Cursor = Cursors.WaitCursor
                Dim CP As New PropiedadesEquipo
                CP.LoadComputer(log(0))
                CP.Show()
                Me.Cursor = Cursors.Default
            End If
        End If

    End Sub

    Private Sub ResultsListView_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ResultsListView.SelectedIndexChanged
        '==========================================================================
        ' Name:     ResultsListView_SelectedIndexChanged
        ' Purpose:  Al seleccionar un objeto, cambiar la variable que guarda cual es el índice del seleccionado de entre los resultados
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        For i = 0 To ResultsListView.Items.Count - 1
            If ResultsListView.Items(i).Selected Then
                seleccionado = i

            End If
        Next

    End Sub

End Class