﻿Public Class DataGridViewRolloverCell
    Inherits DataGridViewTextBoxCell


    Protected Overrides Sub Paint( _
        ByVal graphics As Graphics, _
        ByVal clipBounds As Rectangle, _
        ByVal cellBounds As Rectangle, _
        ByVal rowIndex As Integer, _
        ByVal elementState As DataGridViewElementStates, _
        ByVal value As Object, _
        ByVal formattedValue As Object, _
        ByVal errorText As String, _
        ByVal cellStyle As DataGridViewCellStyle, _
        ByVal advancedBorderStyle As DataGridViewAdvancedBorderStyle, _
        ByVal paintParts As DataGridViewPaintParts)
        '==========================================================================
        ' Name:     Paint
        ' Purpose:  Establecer el estilo visual del DataGrid de Arbol
        ' Input:    1 Graphics: tipo de gráficos del DataGrid 'graphics'
        '           2 Rectangle: bordes 'clipBounds' y 'cellBounds'
        '           1 Integer: El índice de fila 'rowindex'
        '           1 DataGridViewElementStates: Estado del elemento 'ElementState'
        '           2 Object: valor del elemento 'value', Vlor con formato 'formattedValue'
        '           1 string: Error 'errorText'
        '           1 DataGridViewCellStyle: estilo de las celdas 'cellStyle'
        '           1 DataGridViewAdvancedBorderStyle: estilo de los bordes de celda 'advancedBorderStyle'
        '           1 DataGridViewPaintParts: partes 'paintParts'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        ' Establecer la apariencia básica del dataGridView
        MyBase.Paint(graphics, clipBounds, cellBounds, rowIndex, elementState, _
            value, formattedValue, errorText, cellStyle, _
            advancedBorderStyle, paintParts)

        'Establecer los iconos a dibujar en cada celda
        Dim objBitmap As Bitmap
        Dim objIcon As Icon
        Dim intIndexOfImageIWant As Int16
        Dim Tipo As String = Arbol.DataGridView1.Item("objectCategory", rowIndex).Value

        If Tipo = "COMPUTER" Then
            Dim logN As String = GenericClass.GetlogonN(Arbol.DataGridView1.Item("distinguishedName", rowIndex).Value)
            If GenericClass.isDisabled(logN) Then
                intIndexOfImageIWant = 16
            Else
                intIndexOfImageIWant = 15
            End If
        ElseIf Tipo = "PERSON" Then
            Dim logN As String = GenericClass.GetlogonN(Arbol.DataGridView1.Item("distinguishedName", rowIndex).Value)
            If GenericClass.isDisabled(logN) Then
                intIndexOfImageIWant = 13
            ElseIf UserClass.isUserlocked(logN) Then
                intIndexOfImageIWant = 14
            Else
                intIndexOfImageIWant = 12
            End If
        ElseIf Tipo = "GROUP" Then
            intIndexOfImageIWant = 17
        Else
            intIndexOfImageIWant = 3
        End If

        'Establecer de dónde se obtienen los iconos
        objBitmap = New Bitmap(Arbol.ContainerImageList.Images(intIndexOfImageIWant))
        objIcon = System.Drawing.Icon.FromHandle(objBitmap.GetHicon)

        'Estilo de dibujo
        Dim brushActual As Brush
        If Arbol.DataGridView1.Rows(rowIndex).GetState(rowIndex) = 97 Then
            brushActual = Brushes.White
        Else
            brushActual = Brushes.Black
        End If

        'Dibujo de la celda
        graphics.DrawIconUnstretched(objIcon, New Rectangle(cellBounds.X + 1, _
                cellBounds.Y + 1, cellBounds.Width - 4, _
                cellBounds.Height - 4))

        graphics.DrawString(DataGridView.Item("HiddenName", rowIndex).Value, New Font("Microsoft Sans Serif", 8), brushActual, New PointF(cellBounds.X + 32, cellBounds.Y + 10))

    End Sub


    Protected Overrides Sub OnDoubleClick(ByVal e As System.Windows.Forms.DataGridViewCellEventArgs)
        '==========================================================================
        ' Name:     OnDoubleClick
        ' Purpose:  Mostrar elementos de carpeta al hacer doble click sobre la celda
        ' Input:    1 Evento: 'e'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Seleccionar en el arbol el nodo que representa la misma carpeta que la celda sobre la que se ha hecho el doble click
        Dim dname As String = Arbol.DataGridView1.Item("distinguishedName", e.RowIndex).Value.ToString
        If Arbol.DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "CONTAINER" Or Arbol.DataGridView1.Item("objectCategory", e.RowIndex).Value.ToString = "ORGANIZATIONAL-UNIT" Then
            Arbol.TreeView1.SelectedNode = Arbol.getNode(dname, Arbol.TreeView1.SelectedNode)
        Else

        End If
        MyBase.OnDoubleClick(e)
    End Sub

End Class

Public Class DataGridViewRolloverCellColumn
    Inherits DataGridViewTextBoxColumn

    Public Sub New()
        '==========================================================================
        ' Name:     New
        ' Purpose:  Crear nueva celda
        ' Input:    None
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Me.CellTemplate = New DataGridViewRolloverCell()
        Me.HeaderText = "Name"
        Me.Name = "Name"

    End Sub

End Class
