﻿Imports System
Imports System.DirectoryServices
Imports Microsoft.VisualBasic
Imports System.Object
Imports System.Net.Mail
Imports System.Security.AccessControl
Imports System.Security.Principal
Imports CDOEXM
Imports ActiveDs



Public Class GenericClass

    '-------------------------------------------------------------------------------------------------------------------------
    '------------------------------------------------------Computer--------------------------------------------------------------
    Public Shared Function GetComputerList() As System.Collections.Generic.IList(Of String)
        '==========================================================================
        ' Name:     GetComputerList
        ' Purpose:  Obtener una lista con los nombres de los equipos del directorio activo 
        ' Input:    None
        ' Return:   1 array: arrayj de strings con los nombres de los equipos del directorio activo
        ' Calls:    None
        '==========================================================================

        'Obtener DirectoryEntrys de los equipos
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=computer))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        Dim lNewList As New List(Of String)
        Dim user As New DirectoryEntry
        Dim logonN As String
        If Not results.Count = 0 Then
            For Each oresult In results
                'Para cada equipo añadir su nombre al array
                Try
                    user = oresult.GetDirectoryEntry
                    logonN = user.Properties("sAMAccountName").Value.ToString
                    lNewList.Add(logonN)
                Catch e As FormatException
                    MsgBox("Error de formato de los nombres de los equipos  " & e.Message)
                Catch e As AccessViolationException
                    MsgBox("Error al obtener los nombres de los equipos, No tienes permisos para acceder a los equipos " & e.Message)
                Catch e As ArgumentOutOfRangeException
                    MsgBox("Error al obtener los nombres de los equipos, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
                Catch e As OperationCanceledException
                    MsgBox("Error al obtener los nombres de los equipos, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
                Catch e As OperationAbortedException
                    MsgBox("Error al obtener los nombres de los equipos, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
                Catch e As OutOfMemoryException
                    MsgBox("Error al obtener los nombres de los equipos, La memoria está totalmente ocupada " & e.Message)
                Catch e As FieldAccessException
                    MsgBox("Error al obtener los nombres de los equipos, Error al acceder a al ubicación física del dato " & e.Message)
                Catch e As InsufficientMemoryException
                    MsgBox("Error al obtener los nombres de los equipos, La memoria está totalmente ocupada " & e.Message)
                Catch e As MissingFieldException
                    MsgBox("Error al obtener los nombres de los equipos, Error al acceder a al ubicación física del dato, no existe " & e.Message)
                End Try
            Next
        End If
        Return lNewList
    End Function

    Public Shared Function GetComputerlogonN(ByVal UserDN As String) As String
        '==========================================================================
        ' Name:     GetComputerlogonN
        ' Purpose:  Obtener el atributo sAMAccountName de un equipo
        ' Input:    1 string: El atributo distinguishedName de un equipo 'UserDN'
        ' Return:   1 string: El sAMAccountName del equipo
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del equipo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=computer) (distinguishedName=" & UserDN & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        If results.Count = 0 Then
            Return "No hay Datos"
        Else
            oresult = results.Item(0)
            'Devolver su sAMAccountName
            Try
                If Not oresult.GetDirectoryEntry.Properties("sAMAccountName").Value Is Nothing Then
                    Return oresult.GetDirectoryEntry.Properties("sAMAccountName").Value.ToString
                Else
                    Return "No hay Datos"
                End If
            Catch e As FormatException
                MsgBox("Error de formato de los nombre login del equipo  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al obtener el nombre de login del equipo, No tienes permisos para acceder al equipo " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al obtener el nombre de login del equipo, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al obtener el nombre de login del equipo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al obtener el nombre de login del equipo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al obtener el nombre de login del equipo, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al obtener el nombre de login del equipo, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al obtener el nombre de login del equipo, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al obtener el nombre de login del equipo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetComputerProperty(ByVal UserName As String, ByVal UserProperty As String) As String
        '==========================================================================
        ' Name:     GetComputerProperty
        ' Purpose:  Obtener el valor de un atributo de tipo string de un equipo
        ' Input:    2 string: El nombre de login de un equipo'UserName', El nombre del atributo 'UserProperty'
        ' Return:   1 string: El valor del atributo
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del equipo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=computer) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        If results.Count = 0 Then
            Return ""
        Else
            Try
                oresult = results.Item(0)
                'Devolver el valor del atributo
                If Not oresult.GetDirectoryEntry.Properties(UserProperty).Value Is Nothing Then
                    Return oresult.GetDirectoryEntry.Properties(UserProperty).Value.ToString
                Else
                    Return ""
                End If
            Catch e As FormatException
                MsgBox("Error de formato del dato que se quiere obtener  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al obtener el valor del atributo del equipo, No tienes permisos para acceder a los atributos del equipo " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al obtener el valor del atributo del equipo, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al obtener el valor del atributo del equipo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al obtener el valor del atributo del equipo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al obtener el valor del atributo del equipo, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al obtener el valor del atributo del equipo, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al obtener el valor del atributo del equipo, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al obtener el valor del atributo del equipo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetComputerPropertyRefresh(ByVal UserName As String, ByVal UserProperty As String) As String
        '==========================================================================
        ' Name:     GetComputerPropertyRefresh
        ' Purpose:  Obtener el valor de un atributo de tipo string de un equipo previo refresco de memoria
        ' Input:    2 string: El nombre de login de un equipo'UserName', El nombre del atributo 'UserProperty'
        ' Return:   1 string: El valor del atributo
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del equipo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=computer) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            Return ""
        Else
            'Refrescar memoria
            Dim res As New DirectoryEntry(results(0).Path)
            Try
                res.RefreshCache(New String() {UserProperty})
                'Devolver el valor del atributo
                If Not res.Properties(UserProperty).Value Is Nothing Then
                    Return res.Properties(UserProperty).Value.ToString
                Else
                    Return ""
                End If
            Catch e As FormatException
                MsgBox("Error de formato del dato que se quiere obtener  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al obtener el valor del atributo del equipo, No tienes permisos para acceder a los atributos del equipo " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al obtener el valor del atributo del equipo, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al obtener el valor del atributo del equipo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al obtener el valor del atributo del equipo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al obtener el valor del atributo del equipo, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al obtener el valor del atributo del equipo, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al obtener el valor del atributo del equipo, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al obtener el valor del atributo del equipo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetComputerlogonNCN(ByVal UserDN As String) As String
        '==========================================================================
        ' Name:     GetComputerlogonN
        ' Purpose:  Obtener el atributo sAMAccountName de un equipo
        ' Input:    1 string: El atributo cn de un equipo'UserDN'
        ' Return:   1 string: El sAMAccountName del equipo
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del equipo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=computer) (cn=" & UserDN & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        If results.Count = 0 Then
            Return ""
        Else
            oresult = results.Item(0)
            'Devolver su sAMAccountName
            Try
                If Not oresult.GetDirectoryEntry.Properties("sAMAccountName").Value Is Nothing Then
                    Return oresult.GetDirectoryEntry.Properties("sAMAccountName").Value.ToString
                Else
                    Return ""
                End If
            Catch e As FormatException
                MsgBox("Error de formato del nombre canónico del equipo  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al obtener el valor del atributo del equipo, No tienes permisos para acceder a los atributos del equipo " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al obtener el valor del atributo del equipo, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al obtener el valor del atributo del equipo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al obtener el valor del atributo del equipo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al obtener el valor del atributo del equipo, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al obtener el valor del atributo del equipo, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al obtener el valor del atributo del equipo, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al obtener el valor del atributo del equipo, Error al obtener el valor del atributo del equipo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If
    End Function

    Public Shared Function ComputerExists(ByVal UserName As String) As Boolean
        '==========================================================================
        ' Name:     ComputerExists
        ' Purpose:  Saber si un equipo existe en el directorio activo o no
        ' Input:    1 string: El atributo cn de un equipo'UserName'
        ' Return:   1 boolean: True si existe el equipo, false en caso contrario
        ' Calls:    None
        '==========================================================================

        'Busqueda del DirectoryEntry del equipo
        Try
            Dim de As New DirectoryEntry()
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            de.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch As DirectorySearcher = New DirectorySearcher()
            deSearch.SearchRoot = de
            deSearch.Filter = "(&(objectClass=computer) (cn=" & UserName & "))"
            Dim results As SearchResultCollection = deSearch.FindAll()
            'Devolver true si existe, false si no existe
            If results.Count = 0 Then
                Return False
            Else
                Return True
            End If
        Catch e As FormatException
            MsgBox("Error al saber si el equipo existe, Error de formato del acceso al directorio activo  " & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al saber si el equipo existe, No tienes permisos para acceder al directorio activo" & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al saber si el equipo existe, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al saber si el equipo existe, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al saber si el equipo existe, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al saber si el equipo existe, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al saber si el equipo existe, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al saber si el equipo existe, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
    End Function

    Public Shared Sub SetComputerProperty(ByVal CName As String, ByVal CProperty As String, ByVal Datos As String)
        '==========================================================================
        ' Name:     SetComputerProperty
        ' Purpose:  Establecer el valor a un atributo de tipo string de un equipo
        ' Input:    3 string: El nombre de login de un equipo'CName', El nombre del atributo 'CProperty',
        '           El valor a darle al atributo 'Datos'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del equipo
        Dim de As DirectoryEntry = New DirectoryEntry()
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=computer) (sAMAccountName=" & CName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            MsgBox("Error cargando" & CProperty)
        Else
            'Asignar los datos al atributo
            Dim oresult As New DirectoryEntry(results(0).Path)
            oresult.Username = Settings.adminLogon
            oresult.Password = Settings.adminPassword
            oresult.AuthenticationType = AuthenticationTypes.Delegation

            oresult.Properties(CProperty).Value = Datos
            Try
                oresult.CommitChanges()
            Catch e As NullReferenceException
                MsgBox("Los datos han de tener algún valor para poder asignarlos a " & CProperty & e.Message)
            Catch e As FormatException
                MsgBox("Error de formato del dato a introducir en  " & CProperty & e.Message)
            Catch e As AccessViolationException
                MsgBox("No tienes permisos para asignar este dato a " & CProperty & e.Message)
            End Try
        End If

    End Sub

    Public Shared Sub SetComputerPropertyHex(ByVal CName As String, ByVal CProperty As String, ByVal Datos As String)
        '==========================================================================
        ' Name:     SetComputerPropertyHex
        ' Purpose:  Establecer el valor a un atributo de tipo hexadecimal de un equipo
        ' Input:    3 string: El nombre de login de un equipo'CName', El nombre del atributo 'CProperty',
        '           El valor a darle al atributo 'Datos'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del equipo
        Dim de As DirectoryEntry = New DirectoryEntry()
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=computer) (sAMAccountName=" & CName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            MsgBox("Error cargando" & CProperty)
        Else

            Dim salida As String = "("
            For i = 0 To 7
                salida = salida & Datos(i)
            Next
            salida = salida & "-"
            For i = 8 To 11
                salida = salida & Datos(i)
            Next
            salida = salida & "-"
            For i = 12 To 15
                salida = salida & Datos(i)
            Next
            salida = salida & "-"
            For i = 16 To 19
                salida = salida & Datos(i)
            Next
            salida = salida & "-"
            For i = 20 To 31
                salida = salida & Datos(i)
            Next
            salida = salida & ")"

            Dim gID As Guid = New Guid(salida)

            'Asignar los datos al atributo
            Dim oresult As New DirectoryEntry(results(0).Path)
            oresult.Username = Settings.adminLogon
            oresult.Password = Settings.adminPassword
            oresult.AuthenticationType = AuthenticationTypes.Delegation

            oresult.RefreshCache(New String() {CProperty})

            oresult.Properties(CProperty).Add(gID.ToByteArray())
            Try
                oresult.CommitChanges()
            Catch e As NullReferenceException
                MsgBox("Los datos han de tener algún valor para poder asignarlos a " & CProperty & e.Message)
            Catch e As FormatException
                MsgBox("Error de formato del dato a introducir en  " & CProperty & e.Message)
            Catch e As AccessViolationException
                MsgBox("No tienes permisos para asignar este dato a " & CProperty & e.Message)
            End Try
        End If

    End Sub

    Public Shared Function GetComputerGroups(ByVal Name As String) As List(Of String)
        '==========================================================================
        ' Name:     GetComputerGroups
        ' Purpose:  Obtener los grupos de los que el equipo es miembro
        ' Input:    1 string: El nombre de login de un equipo'Name'
        ' Return:   1 array: Array de strings en el que los elementos serán los nombres de los grupos
        ' Calls:    None
        '==========================================================================
        Try
            'Obtener el DirectoryEntry del equipo
            Dim de As DirectoryEntry = New DirectoryEntry()
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            de.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
            deSearch.Filter = "(&(objectClass=computer) (sAMAccountName=" & Name & "))"
            deSearch.SearchScope = SearchScope.Subtree
            Dim result As SearchResultCollection = deSearch.FindAll()
            Dim User As New DirectoryEntry(result(0).Path)
            Dim CNUSer As String = User.Properties("distinguishedName").Value.ToString


            'Buscar los grupos de los que el equipo es miembro
            Dim dire As DirectoryEntry = New DirectoryEntry()
            dire.Username = Settings.adminLogon
            dire.Password = Settings.adminPassword
            dire.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch2 As DirectorySearcher = New DirectorySearcher(dire)
            deSearch2.Filter = "(&(objectClass=group) (member=" & CNUSer & "))"
            deSearch2.SearchScope = SearchScope.Subtree
            Dim results As SearchResultCollection = deSearch2.FindAll()
            Dim resultado As SearchResult

            'Para cada grupo añadir su nombre al array
            Dim grupos As New List(Of String)
            Dim i As Integer = 1
            For Each resultado In results
                Dim Grupo As New DirectoryEntry(resultado.Path)
                grupos.Add(Grupo.Properties("sAMAccountName").Value.ToString)
            Next

            Return grupos
        Catch e As FormatException
            MsgBox("Error al obtener los grupos a los que pertenece el equipo, Error de formato del acceso a los grupos de los que el equipo es miembro  " & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al obtener los grupos a los que pertenece el equipo, No tienes permisos para acceder a los atributos del equipo " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al obtener los grupos a los que pertenece el equipo, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al obtener los grupos a los que pertenece el equipo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al obtener los grupos a los que pertenece el equipo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al obtener los grupos a los que pertenece el equipo, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al obtener los grupos a los que pertenece el equipo, Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al obtener los grupos a los que pertenece el equipo, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al obtener los grupos a los que pertenece el equipo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
    End Function

    Public Shared Function GetComputerPropertyOIdentifier(ByVal GName As String, ByVal GProperty As String) As String
        '==========================================================================
        ' Name:     GetComputerPropertyOIdentifier
        ' Purpose:  Obtener un atributo del tipo OIdentifier del equipo
        ' Input:    2 string: El nombre de login de un equipo'GName', el nombre del atributo'GName'
        ' Return:   1 string: El valor del atributo 
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del equipo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=computer) (sAMAccountName=" & GName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            Return ""
        Else
            Try
                Dim res As New DirectoryEntry(results(0).Path)
                'Devolver la parte que nos interesa del atributo
                If Not res.Properties(GProperty).Value Is Nothing Then
                    Dim sal() As Object = res.Properties(GProperty).Value
                    Return sal(sal.Length - 1).ToString
                Else
                    Return ""
                End If
            Catch e As FormatException
                MsgBox("Error al obtener el valor del atributo del equipoError de formato del acceso al atributo del equipo  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al obtener el valor del atributo del equipoNo tienes permisos para acceder a los atributos del equipo " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al obtener el valor del atributo del equipoSe ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al obtener el valor del atributo del equipoSe está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al obtener el valor del atributo del equipoSe está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al obtener el valor del atributo del equipoLa memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al obtener el valor del atributo del equipoError al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al obtener el valor del atributo del equipoLa memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al obtener el valor del atributo del equipoError al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetComputerPropertyLargeInterval(ByVal GName As String, ByVal GProperty As String) As String
        '==========================================================================
        ' Name:     GetComputerPropertyLargeInterval
        ' Purpose:  Obtener un atributo del tipo LargeInterval del equipo
        ' Input:    2 string: El nombre de login de un equipo'GName', el nombre del atributo'GName'
        ' Return:   1 string: El valor del atributo 
        ' Calls:    ToInt64 y GetBytes de la clase BitConverter
        '==========================================================================

        'Obtener el directoryEntry del equipo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=computer) (sAMAccountName=" & GName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            Return ""
        Else
            Dim res As New DirectoryEntry(results(0).Path)

            Dim low As Int32
            Dim high As Int32
            Dim valBytes(7) As Byte

            'Obtener mediante la interfaz IADsLargeInteger dos int32 que formarán el atributo 
            Dim longInt As IADsLargeInteger = CType(res.Properties(GProperty).Value, IADsLargeInteger)
            low = longInt.LowPart
            high = longInt.HighPart

            'Pasar los dos int32 a bytes
            BitConverter.GetBytes(low).CopyTo(valBytes, 0)
            BitConverter.GetBytes(high).CopyTo(valBytes, 4)

            'Unirlos convirtiéndolos a int64
            Dim salida As Int64 = BitConverter.ToInt64(valBytes, 0)
            Try
                If Not res.Properties(GProperty).Value Is Nothing Then
                    'Devolver el int64
                    Return salida
                Else
                    Return ""
                End If
            Catch e As FormatException
                MsgBox("Error al obtener el valor del atributo del equipoError de formato del acceso al atributo del equipo  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al obtener el valor del atributo del equipoNo tienes permisos para acceder a los atributos del equipo " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al obtener el valor del atributo del equipoSe ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al obtener el valor del atributo del equipoSe está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al obtener el valor del atributo del equipoSe está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al obtener el valor del atributo del equipoLa memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al obtener el valor del atributo del equipoError al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al obtener el valor del atributo del equipoLa memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al obtener el valor del atributo del equipoError al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If
    End Function

    Public Shared Sub RightsComputer(ByVal name As String, ByVal rightelem As String)
        '==========================================================================
        ' Name:     RightsComputer
        ' Purpose:  Asignar un Administrador (manager) para el equipo
        ' Input:    2 string: El nombre de login del equipo 'name', el nombre de login del administrador 'rightelem'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Try
            Dim DN As String = GenericClass.GetDN(name)
            MailClass.AddAceToDaclComputerNT(rightelem, DN, "Control total", "Allow")
            ''Obtener los directoryEntrys del equipo y el Administrador
            'Dim de As DirectoryEntry = New DirectoryEntry()
            'Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
            'deSearch.Filter = "(sAMAccountName=" & name & ")"
            'deSearch.SearchScope = SearchScope.Subtree
            'Dim results As SearchResultCollection = deSearch.FindAll()

            'Dim dacl As AccessControlList
            'Dim ace

            'Dim deSearch2 As DirectorySearcher = New DirectorySearcher(de)
            'deSearch2.Filter = "(&(sAMAccountName=" & rightelem & "))"
            'deSearch2.SearchScope = SearchScope.Subtree
            'Dim otherresults As SearchResultCollection = deSearch2.FindAll()

            'Dim trusUser As New DirectoryEntry(otherresults(0).Path)
            'trusUser.Username = Settings.adminLogon
            'trusUser.Password = Settings.adminPassword
            'trusUser.AuthenticationType = AuthenticationTypes.Delegation
            'Dim deMail As New DirectoryEntry(results(0).Path)
            'deMail.Username = Settings.adminLogon
            'deMail.Password = Settings.adminPassword
            'deMail.AuthenticationType = AuthenticationTypes.Delegation

            ''Obtener el securityDescriptor del equipo
            'Dim oSecurityDescriptor As IADsSecurityDescriptor = CType(deMail.Properties("ntSecurityDescriptor").Value, IADsSecurityDescriptor)
            'dacl = oSecurityDescriptor.DiscretionaryAcl
            'dacl = oSecurityDescriptor.DiscretionaryAcl
            'ace = CreateObject("AccessControlEntry")

            'Dim CN As String = trusUser.Properties("canonicalName").Value.ToString
            'Dim parts() As String = CN.Split(".")
            'Dim trustee As String = UCase(parts(0)) & "\" & trusUser.Properties("cn").Value.ToString

            ''Crear los permisos para el Administrador y añadirlos
            'ace.AceFlags = 0
            'ace.Trustee = trustee

            'ace.accessMask = 197076
            'ace.AceType = 0
            'ace.AceFlags = 0
            'ace.Flags = 0
            'dacl.AddAce(ace)

            'ace.AceType = 5
            'ace.Flags = 3
            'For i = 0 To 1
            '    ace.accessMask = 8
            '    If i = 0 Then
            '        ace.objectType = "{72E39547-7B18-11D1-ADEF-00C04FD8D5CD}"
            '    Else
            '        ace.objectType = "{F3A64788-5306-11D1-A9C5-0000F80367C1}"
            '    End If
            '    dacl.AddAce(ace)
            'Next

            'Dim tipo(4) As String
            'tipo(0) = "{4C164200-20C0-11D0-A768-00AA006E0529}"
            'tipo(1) = "{3E0ABFD0-126A-11D0-A060-00AA006C33ED}"
            'tipo(2) = "{5F202010-79A5-11D0-9020-00C04FC2D4CF}"
            'tipo(3) = "{BF967950-0DE6-11D0-A285-00AA003049E2}"
            'tipo(4) = "{BF967953-0DE6-11D0-A285-00AA003049E2}"

            'For i = 0 To 4
            '    ace.accessMask = 32
            '    ace.objectType = tipo(i)
            '    dacl.AddAce(ace)
            'Next

            ''Insertar los nuevos permisos
            'oSecurityDescriptor.DiscretionaryAcl = dacl
            'deMail.Properties("ntSecurityDescriptor").Value = oSecurityDescriptor
            'Try
            '    deMail.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("Error al conceder permisos de administración sobre un equipo, no tiene permisos para poder concederlos " & e.Message)
        Catch e As ArgumentNullException
            MsgBox("Error al conceder permisos de administración sobre un equipo, no se ha encontrado el equipo o el objeto al que conceder los permisos " & e.Message)
        Catch e As ConstraintException
            MsgBox("Error al conceder permisos de administración sobre un equipo, asignar los permisos viola un regla preexistente " & e.Message)
        End Try

    End Sub

    Public Shared Sub CreateComputer(ByVal Name As String, ByVal OU As String)
        '==========================================================================
        ' Name:     CreateComputer
        ' Purpose:  Crear un equipo 
        ' Input:    2 string: El nombre de login del equipo 'name', la direccion en la que crear el equipo'OU'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Try

            'Obtener solo el container de la dirección
            Dim parts() As String = OU.Split(",")
            Dim OU_AC As String = parts(0)
            For i = 1 To parts.Length - 1
                OU_AC = OU_AC & ";" & parts(i)
            Next

            'Crear el nuevo equipo
            Dim dirE As New DirectoryEntry()
            Dim dirEntry As DirectoryEntry = dirE.Children.Find(parts(0))
            dirEntry.Username = Settings.adminLogon
            dirEntry.Password = Settings.adminPassword
            dirEntry.AuthenticationType = AuthenticationTypes.Delegation
            Dim newUser As DirectoryEntry


            'Asignarle el nombre
            newUser = dirEntry.Children.Add("CN=" & Name, "Computer")
            newUser.Properties("SAMAccountName").Value = Name & "$"
            Try
                newUser.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error al crear un nuevo equipo, no posee permisos para crear nuevos equipos " & e.Message)
            Catch e As FormatException
                MsgBox("Error al crear un nuevo equipo, uno o varios de los argumetos poseen un formato no válido " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al crear un nuevo equipo, uno o varios de los argumetos es nulo " & e.Message)
            End Try

        Catch e As Exception
            Console.WriteLine(e)
        End Try

    End Sub

    Public Shared Sub CopyComputer(ByVal Computer As String, ByVal OU_AC As String)
        '==========================================================================
        ' Name:     CopyUser
        ' Purpose:  Copiar un usuario
        ' Input:    1 string: El nombre de Login de un usuaio 'sUserName'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim salida As String
        salida = "-------Copiar Equipo-------"

        Dim Equipo As String = Left(Computer, Computer.Length - 1)
        Dim Nnombre As String = "Copia de " & Equipo
        If Nnombre.Length > 20 Then
            MsgBox("No se puede copiar el usuario porque su nombre de Login no puede pasar de once caracteres")
        Else
            If ComputerExists(Nnombre) Then
                MsgBox("El equipo " & Nnombre & "ya existe")
            Else
                CreateComputer(Nnombre, OU_AC)

                Nnombre = Nnombre & "$"
                Try
                    Dim descrip As String = GenericClass.GetComputerProperty(Computer, "Description")
                    If Not descrip = "" Then
                        GenericClass.SetComputerProperty(Nnombre, "Description", descrip)
                    End If
                Catch ex As Exception
                    MsgBox("Error al intentar asignar la descripción a la copia del equipo " & ex.Message)
                End Try

                '--------------------------------------------------MemberOf------------------------------------------------------------------

                Try
                    'Obtener el grupo primario
                    Dim token As String = GetComputerPropertyRefresh(Computer, "primaryGroupID")
                    Dim Prim As String = UserClass.GetPrimaryGroup(token, Computer)
                    'SetUserPropertyRefresh("Copia de " & Usuario, "primaryGroupID", token)
                    'setUserPropertyObject("Copia de " & Usuario, "memberOf", GetUserPropertyObject(Usuario, "memberOf"))

                    'Obtener los demás grupos del usuario
                    Dim grupos As List(Of String) = GenericClass.GetComputerGroups(Computer)

                    If grupos.Count > 0 Then
                        For i = 0 To grupos.Count - 1

                            If Not grupos(i) = Prim Then
                                Dim DN As String = GenericClass.GetDN(grupos(i))

                                Dim logN As String = grupos(i)
                                Dim lnewlist As New List(Of String)
                                lnewlist = groupClass.GetGroupMembers(logN)
                                Try
                                    groupClass.SetGroupPropertyInsert(logN, "member", GenericClass.GetDN(Nnombre), lnewlist.Count)
                                Catch ex As AccessViolationException
                                    MsgBox("Error, por falta de permisos, al añadir el equipo al grupo " & logN & " " & ex.Message)
                                    salida = salida & vbCrLf & "Error, por falta de permisos, al añadir el equipo al grupo " & logN & " " & ex.Message

                                Catch ex As FieldAccessException
                                    MsgBox("Error, por falta de permisos, al añadir el equipo al grupo " & logN & " " & ex.Message)
                                    salida = salida & vbCrLf & "Error, por falta de permisos, al añadir el equipo al grupo " & logN & " " & ex.Message

                                Catch ex As MemberAccessException
                                    MsgBox("Error, por falta de permisos, al añadir el equipo al grupo" & ex.Message)
                                    salida = salida & vbCrLf & "Error por falta de permisos: al añadir el equipo al grupo" & ex.Message

                                Catch ex As UnauthorizedAccessException
                                    MsgBox("Error, por falta de permisos, al añadir el equipo al grupo" & ex.Message)
                                    salida = salida & vbCrLf & "Error por falta de permisos: al añadir el equipo al grupo" & ex.Message

                                Catch ex As Exception When DN = ""
                                    MsgBox("Error el Grupo al que se quiere añadir el equipo no pude ser vacío " & ex.Message)
                                    salida = salida & vbCrLf & "Error: el Grupo al que se quiere añadir el equipo no pude ser vacío " & ex.Message

                                Catch ex As FieldAccessException
                                    MsgBox("No tiene permisos para añadir el equipo a uno de los grupos " & ex.Message)
                                    salida = salida & vbCrLf & "Error: el Grupo al que se quiere añadir el equipo no pude ser vacío " & ex.Message

                                Catch ex As Exception
                                    MsgBox("Error al añadir el equipo al grupo " & logN)
                                    salida = salida & vbCrLf & "Error: al añadir el equipo al grupo " & grupos(i) & ex.Message
                                End Try
                            End If

                        Next
                    End If

                Catch ex As Exception
                    MsgBox("Error al compiar los grupos de los que es miembro " & ex.Message)
                End Try
                '---------------------------------------------------------------------------------
                '-----------------------------------Managed By---------------------------------------------------------------------
                '--------------------------------------------------------------------------------------------------------------------
                Try
                    If Not GenericClass.GetComputerProperty(Computer, "managedBy") = "" Then
                        GenericClass.SetComputerProperty(Nnombre, "managedBy", GenericClass.GetComputerProperty(Computer, "managedBy"))
                    End If
                Catch ex As Exception
                    MsgBox("Error al establecer el administrador del equipo " & ex.Message)
                    salida = salida & vbCrLf & "Error: al establecer el administrador del equipo " & ex.Message

                End Try
                '-----------------------------------Security---------------------------------------------------------------------
                '--------------------------------------------------------------------------------------------------------------------

                MailClass.CopyAces(Computer, Nnombre)
            End If

        End If
        salida = salida & vbCrLf & "equipo copiado"
        GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
    End Sub
    '-----------------------------------------------------------------------------------------------------------------------------
    '---------------------------------------------------------Generales------------------------------------------------------------

    Public Shared Function HavePart(ByVal ToSearch As String, ByVal tipo As String) As List(Of String)
        '==========================================================================
        ' Name:     GetComputerProperty
        ' Purpose:  Obtener el valor de un atributo de tipo string de un equipo
        ' Input:    2 string: El nombre de login de un equipo'UserName', El nombre del atributo 'UserProperty'
        ' Return:   1 string: El valor del atributo
        ' Calls:    None
        '==========================================================================

        Dim list As New List(Of String)
        'Obtener el DirectoryEntry del equipo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=" & tipo & ")(|(sAMAccountName=" & ToSearch & "*)(|(cn=" & ToSearch & "*)(displayName=" & ToSearch & "*)(givenName=" & ToSearch & "*))))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        If Not results.Count = 0 Then

            Try
                'For i = 0 To results.Count - 1
                '    oresult = results.Item(i)
                '    Dim puede As Boolean = False
                '    'oresult = results.Item(0)
                '    'Devolver el valor del atributo
                '    If ToSearch = "*" Then
                '        puede = True
                '    Else
                '        If UCase(oresult.GetDirectoryEntry.Properties("sAMAccountName").Value.ToString).Contains(UCase(ToSearch)) Then
                '            puede = True
                '        ElseIf Not UCase(oresult.GetDirectoryEntry.Properties("cn").Value) Is Nothing Then
                '            If UCase(oresult.GetDirectoryEntry.Properties("cn").Value.ToString).Contains(UCase(ToSearch)) Then
                '                puede = True
                '            End If
                '        ElseIf Not UCase(oresult.GetDirectoryEntry.Properties("displayName").Value) Is Nothing Then
                '            If UCase(oresult.GetDirectoryEntry.Properties("displayName").Value.ToString).Contains(UCase(ToSearch)) Then
                '                puede = True
                '            Else
                '                puede = False
                '            End If
                '        End If

                '        If tipo = "user" Then
                '            If oresult.GetDirectoryEntry.Properties("userPrincipalName").Value Is Nothing Then
                '                puede = False
                '            End If
                '        End If
                '    End If

                '    If puede Then
                '        list.Add(oresult.GetDirectoryEntry.Properties("sAMAccountName").Value.ToString)
                '    End If
                'Next
                For i = 0 To results.Count - 1
                    oresult = results.Item(i)
                    list.Add(oresult.GetDirectoryEntry.Properties("sAMAccountName").Value.ToString)

                Next
            Catch e As FormatException
                MsgBox("Error de formato del dato que se quiere obtener  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al obtener el valor del atributo del equipo, No tienes permisos para acceder a los atributos del equipo " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al obtener el valor del atributo del equipo, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al obtener el valor del atributo del equipo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al obtener el valor del atributo del equipo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al obtener el valor del atributo del equipo, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al obtener el valor del atributo del equipo, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al obtener el valor del atributo del equipo, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al obtener el valor del atributo del equipo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If
        Return list
    End Function

    Public Shared Function GetDateProperty(ByVal UserName As String, ByVal UserProperty As String) As Date
        '==========================================================================
        ' Name:     GetDateProperty
        ' Purpose:  Obtener el valor de un atributo de tipo date 
        ' Input:    2 string: El nombre de login del objeto'UserName', El nombre del atributo 'UserProperty'
        ' Return:   1 string: El valor del atributo
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del equipo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        If results.Count = 0 Then
            Return ""
        Else
            oresult = results.Item(0)
            'Devolver el valor del atributo
            Try
                If Not oresult.GetDirectoryEntry.Properties(UserProperty).Value Is Nothing Then
                    Return oresult.GetDirectoryEntry.Properties(UserProperty).Value
                Else
                    Return ""
                End If
            Catch e As FormatException
                MsgBox("Error al obtener el valor del atributo del equipo, Error de formato del objeto del tipo dato a obtener de  " & UserName & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al obtener el valor del atributo del equipo, No tienes permisos para acceder al tipo dato a obtener de " & UserName & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al obtener el valor del atributo del equipo, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al obtener el valor del atributo del equipo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al obtener el valor del atributo del equipo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al obtener el valor del atributo del equipo, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al obtener el valor del atributo del equipo, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al obtener el valor del atributo del equipo, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al obtener el valor del atributo del equipo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetDirectoryEntry() As DirectoryEntry
        '==========================================================================
        ' Name:     GetDirectoryEntry
        ' Purpose:  Obtener el DirectoryEntry de la raíz del servidor
        ' Input:    None
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Try
            Dim de As DirectoryEntry = New DirectoryEntry()
            de.Path = "LDAP://" & Settings.ldapServerName & "/" & Settings.ADRoot
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            Return de
        Catch e As FormatException
            MsgBox("Error de formato del acceso al directorio activo  " & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error del acceso al directorio activo, No tienes permisos para acceder al directorio activo " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error del acceso al directorio activo, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error del acceso al directorio activo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error del acceso al directorio activo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error del acceso al directorio activo, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error del acceso al directorio activo, Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error del acceso al directorio activo, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error del acceso al directorio activo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
    End Function

    Public Shared Function CargarServidoresGeneral() As List(Of String)
        '==========================================================================
        ' Name:     CargarServidoresGeneral
        ' Purpose:  Devuelve la lista con los nombres de los servidores del directorio activo
        ' Input:    None
        ' Return:   1 array: array de strings con los nombres de los servidores
        ' Calls:    None
        '==========================================================================

        Dim BackEndServers As SearchResultCollection
        Dim BackEndServer As SearchResult
        Dim lNewList As New List(Of String)

        'Obtener el DirectoryEntry de la raiz del directorio activo
        Dim RootDSE As New DirectoryEntry("LDAP://RootDSE")
        RootDSE.Username = Settings.adminLogon
        RootDSE.Password = Settings.adminPassword
        RootDSE.AuthenticationType = AuthenticationTypes.Delegation
        'Buscar los servidores
        Dim RootPath As String = "LDAP://" + RootDSE.Properties("configurationNamingContext").Value
        Dim ConfigContainer As New DirectoryEntry(RootPath)
        Dim Searcher As New DirectorySearcher(ConfigContainer)
        Searcher.Filter = "(&(objectClass=server) (objectClass=msExchExchangeServer))"
        Searcher.SearchScope = SearchScope.Subtree
        BackEndServers = Searcher.FindAll

        'Añadir el nombre de cada servidor en el array
        For Each BackEndServer In BackEndServers
            Try
                lNewList.Add(BackEndServer.GetDirectoryEntry.Properties("cn").Value.ToString)
            Catch e As FormatException
                MsgBox("Error del acceso a los servidores directorio activo, Error de formato del nombre de servidor a obtener  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error del acceso a los servidores directorio activo, No tienes permisos para acceder a los servidores " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error del acceso a los servidores directorio activo, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error del acceso a los servidores directorio activo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error del acceso a los servidores directorio activo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error del acceso a los servidores directorio activo, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error del acceso a los servidores directorio activo, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error del acceso a los servidores directorio activo, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error del acceso a los servidores directorio activo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        Next

        Return lNewList

    End Function

    Public Shared Function BuscarServidoresGeneral(ByVal ToSearch As String) As List(Of String)
        '==========================================================================
        ' Name:     CargarServidoresGeneral
        ' Purpose:  Devuelve la lista con los nombres de los servidores del directorio activo
        ' Input:    None
        ' Return:   1 array: array de strings con los nombres de los servidores
        ' Calls:    None
        '==========================================================================

        Dim BackEndServers As SearchResultCollection
        Dim BackEndServer As SearchResult
        Dim lNewList As New List(Of String)

        'Obtener el DirectoryEntry de la raiz del directorio activo
                Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        'deSearch.Filter = "(&(objectClass=computer))"
        'deSearch.SearchScope = SearchScope.Subtree
        'Dim results As SearchResultCollection = deSearch.FindAll()
        'Dim ConfigContainer As New DirectoryEntry(RootPath)
        'Dim Searcher As New DirectorySearcher(ConfigContainer)
        deSearch.Filter = "(&(objectClass=computer)(operatingSystem=windows server*)(cn=" & ToSearch & "*))"
        deSearch.SearchScope = SearchScope.Subtree
        BackEndServers = deSearch.FindAll
        If BackEndServers.Count > 0 Then
            'Añadir el nombre de cada servidor en el array
            For Each BackEndServer In BackEndServers
                Try

                    lNewList.Add(BackEndServer.GetDirectoryEntry.Properties("cn").Value.ToString)
                Catch e As FormatException
                    MsgBox("Error del acceso a los servidores directorio activo, Error de formato del nombre de servidor a obtener  " & e.Message)
                Catch e As AccessViolationException
                    MsgBox("Error del acceso a los servidores directorio activo, No tienes permisos para acceder a los servidores " & e.Message)
                Catch e As ArgumentOutOfRangeException
                    MsgBox("Error del acceso a los servidores directorio activo, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
                Catch e As OperationCanceledException
                    MsgBox("Error del acceso a los servidores directorio activo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
                Catch e As OperationAbortedException
                    MsgBox("Error del acceso a los servidores directorio activo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
                Catch e As OutOfMemoryException
                    MsgBox("Error del acceso a los servidores directorio activo, La memoria está totalmente ocupada " & e.Message)
                Catch e As FieldAccessException
                    MsgBox("Error del acceso a los servidores directorio activo, Error al acceder a al ubicación física del dato " & e.Message)
                Catch e As InsufficientMemoryException
                    MsgBox("Error del acceso a los servidores directorio activo, La memoria está totalmente ocupada " & e.Message)
                Catch e As MissingFieldException
                    MsgBox("Error del acceso a los servidores directorio activo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
                End Try
            Next
        End If

        Return lNewList

    End Function

    Public Shared Function CargarServidoresExch() As List(Of String)
        '==========================================================================
        ' Name:     CargarServidoresGeneral
        ' Purpose:  Devuelve la lista con los nombres de los servidores Exchange del directorio activo
        ' Input:    None
        ' Return:   1 array: array de strings con los nombres de los servidores
        ' Calls:    None
        '==========================================================================

        Dim BackEndServers As SearchResultCollection
        Dim BackEndServer As SearchResult
        Dim lNewList As New List(Of String)

        'Obtener el DirectoryEntry de la raiz del directorio activo
        Dim RootDSE As New DirectoryEntry("LDAP://RootDSE")
        RootDSE.Username = Settings.adminLogon
        RootDSE.Password = Settings.adminPassword
        RootDSE.AuthenticationType = AuthenticationTypes.Delegation
        'Buscar los servidores
        Dim RootPath As String = "LDAP://" + RootDSE.Properties("configurationNamingContext").Value
        Dim ConfigContainer As New DirectoryEntry(RootPath)
        Dim Searcher As New DirectorySearcher(ConfigContainer)
        Searcher.Filter = "(&(objectClass=msExchExchangeServer)(serverRole=0))"
        Searcher.SearchScope = SearchScope.Subtree
        BackEndServers = Searcher.FindAll
        If BackEndServers.Count > 0 Then
            Try
                'Añadir el nombre de cada servidor en el array
                For Each BackEndServer In BackEndServers
                    lNewList.Add(BackEndServer.GetDirectoryEntry.Properties("cn").Value.ToString)
                Next

            Catch e As FormatException
                MsgBox("Error del acceso a los servidores Exchange directorio activo, Error de formato del nombre de servidor a obtener  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error del acceso a los servidores Exchange directorio activo, No tienes permisos para acceder a los servidores " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error del acceso a los servidores Exchange directorio activo, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error del acceso a los servidores Exchange directorio activo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error del acceso a los servidores Exchange directorio activo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error del acceso a los servidores Exchange directorio activo, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error del acceso a los servidores Exchange directorio activo, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error del acceso a los servidores Exchange directorio activo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If

        Return lNewList
    End Function

    Public Shared Function CargarServidoresExchMove(ByVal AdminGroup As String) As List(Of String)
        '==========================================================================
        ' Name:     CargarServidoresGeneralMove
        ' Purpose:  Devuelve la lista con los nombres de los servidores Exchange del directorio activo que se 
        '           puedan usar para mover el buzón
        ' Input:    None
        ' Return:   1 array: array de strings con los nombres de los servidores
        ' Calls:    None
        '==========================================================================

        Dim BackEndServers As SearchResultCollection
        Dim BackEndServer As SearchResult
        Dim Organization As SearchResult
        Dim AdministrationGroups As SearchResultCollection
        Dim AdministrationGroup As SearchResult
        Dim lNewList As New List(Of String)

        'Obtener el DirectoryEntry de la raiz del directorio activo
        Dim RootDSE As New DirectoryEntry("LDAP://RootDSE")
        RootDSE.Username = Settings.adminLogon
        RootDSE.Password = Settings.adminPassword
        RootDSE.AuthenticationType = AuthenticationTypes.Delegation
        'Buscar el container de la organización Exchange
        Dim RootPath As String = "LDAP://" + RootDSE.Properties("configurationNamingContext").Value
        Dim ConfigContainer As New DirectoryEntry(RootPath)
        Dim Searcher As New DirectorySearcher(ConfigContainer)
        Searcher.Filter = "(&(objectClass=msExchOrganizationContainer))"
        Searcher.SearchScope = SearchScope.Subtree
        Organization = Searcher.FindOne

        'Si el Exchange se encuentra en modo mixto solo se buscan los servidores del grupo admnistrativo
        'al que pertenece el buzón
        If Organization.GetDirectoryEntry.Properties("msExchMixedMode").Value Then

            Dim Searcher2 As New DirectorySearcher(ConfigContainer)
            Searcher2.Filter = "(&(objectClass=msExchAdminGroup))"
            Searcher2.SearchScope = SearchScope.Subtree
            AdministrationGroups = Searcher2.FindAll
            For Each AdministrationGroup In AdministrationGroups
                If AdministrationGroup.GetDirectoryEntry.Properties("cn").Value.ToString = AdminGroup Then
                    Dim AGroup As New DirectoryEntry(AdministrationGroup.Path)
                    Dim Searcher3 As New DirectorySearcher(AGroup)
                    Searcher3.Filter = "(&(objectClass=msExchExchangeServer)(serverRole=0))"
                    Searcher3.SearchScope = SearchScope.Subtree
                    BackEndServers = Searcher3.FindAll

                    'Añadir el nombre de cada servidor en el array
                    Try
                        For Each BackEndServer In BackEndServers
                            lNewList.Add(BackEndServer.GetDirectoryEntry.Properties("cn").Value.ToString)
                        Next
                    Catch e As FormatException
                        MsgBox("Error del acceso a los servidores Exchange directorio activo, Error de formato del nombre de servidor a obtener  " & e.Message)
                    Catch e As AccessViolationException
                        MsgBox("Error del acceso a los servidores Exchange directorio activo, No tienes permisos para acceder a los servidores " & e.Message)
                    Catch e As ArgumentOutOfRangeException
                        MsgBox("Error del acceso a los servidores Exchange directorio activo, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
                    Catch e As OperationCanceledException
                        MsgBox("Error del acceso a los servidores Exchange directorio activo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
                    Catch e As OperationAbortedException
                        MsgBox("Error del acceso a los servidores Exchange directorio activo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
                    Catch e As OutOfMemoryException
                        MsgBox("Error del acceso a los servidores Exchange directorio activo, La memoria está totalmente ocupada " & e.Message)
                    Catch e As FieldAccessException
                        MsgBox("Error del acceso a los servidores Exchange directorio activo, Error al acceder a al ubicación física del dato " & e.Message)
                    Catch e As InsufficientMemoryException
                        MsgBox("Error del acceso a los servidores Exchange directorio activo, La memoria está totalmente ocupada " & e.Message)
                    Catch e As MissingFieldException
                        MsgBox("Error del acceso a los servidores Exchange directorio activo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
                    End Try
                End If
            Next
        Else

            lNewList = CargarServidoresExch()
        End If

        Return lNewList

    End Function

    Public Shared Function CargarGruposAdmin() As List(Of String)
        '==========================================================================
        ' Name:     CargarGruposAdmin
        ' Purpose:  Devuelve la lista con los nombres de los grupos administrativos Exchange del directorio activo
        ' Input:    None
        ' Return:   1 array: array de strings con los nombres de los grupos administrativos
        ' Calls:    None
        '==========================================================================

        Dim Agroups As SearchResultCollection
        Dim Agroup As SearchResult
        Dim AD As SearchResult
        Dim lNewList As New List(Of String)

        'Obtener el DirectoryEntry de la raiz del directorio activo
        Dim RootDSE As New DirectoryEntry("LDAP://RootDSE")
        RootDSE.Username = Settings.adminLogon
        RootDSE.Password = Settings.adminPassword
        RootDSE.AuthenticationType = AuthenticationTypes.Delegation
        'Buscar los servidores
        Dim RootPath As String = "LDAP://" + RootDSE.Properties("configurationNamingContext").Value

        Dim ConfigContainer As New DirectoryEntry(RootPath)
        Dim Searcher As New DirectorySearcher(ConfigContainer)
        Searcher.Filter = "((objectClass=msExchAdminGroup))"
        Searcher.SearchScope = SearchScope.Subtree
        'CN=DONOSTIA,CN=Administrative Groups,CN=IBERMATICA,CN=Microsoft Exchange,CN=Services,CN=Configuration,DC=intranet,DC=ibermatica
        'Dim Ro As New DirectoryEntry("LDAP://CN=DONOSTIA,CN=Administrative Groups,CN=IBERMATICA,CN=Microsoft Exchange,CN=Services,CN=Configuration,DC=intranet,DC=ibermatica")
        'lNewList.Add(Ro.Properties("cn").Value)
        Agroups = Searcher.FindAll
        'Añadir el nombre de cada servidor en el array
        Try
            For Each Agroup In Agroups
                lNewList.Add(Agroup.GetDirectoryEntry.Properties("cn").Value.ToString)
            Next
            Return lNewList
        Catch e As FormatException
            MsgBox("Error del acceso a los grupos administrativos, Error de formato del nombre de grupo Administrativo a obtener  " & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error del acceso a los grupos administrativos, No tienes permisos para acceder a los grupos Administrativos " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error del acceso a los grupos administrativos, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error del acceso a los grupos administrativos, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error del acceso a los grupos administrativos, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error del acceso a los grupos administrativos, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error del acceso a los grupos administrativos, Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error del acceso a los grupos administrativos, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error del acceso a los grupos administrativos, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try


    End Function

    Public Shared Function CargarMailBoxes(ByVal server As String) As List(Of String)
        '==========================================================================
        ' Name:     CargarMailBoxes
        ' Purpose:  Devuelve la lista con los nombres de los mailboxStores exchange del directorio activo
        ' Input:    None
        ' Return:   1 array: array de strings con los nombres de los servidores
        ' Calls:    GetMailboxes de la clase GenericClass
        '==========================================================================

        Dim oresults As SearchResultCollection
        Dim MailBoxStore As SearchResult
        Dim mailboxes As New List(Of String)
        Dim ExchangeServer As SearchResult

        'Obtener los servidores Exchange
        Dim RootDSE As New DirectoryEntry("LDAP://RootDSE")
        RootDSE.Username = Settings.adminLogon
        RootDSE.Password = Settings.adminPassword
        RootDSE.AuthenticationType = AuthenticationTypes.Delegation
        Dim RootPath As String = "LDAP://" + RootDSE.Properties("configurationNamingContext").Value
        Dim ConfigContainer As New DirectoryEntry(RootPath)
        Dim ConfigSearcher As New DirectorySearcher(ConfigContainer)
        ConfigSearcher.Filter = "(&(objectCategory=msExchExchangeServer))"
        ConfigSearcher.SearchScope = SearchScope.Subtree
        Dim oResultsBackendServers As Object = ConfigSearcher.FindAll

        'Decada servidor exchange obtener sus mailboxstores
        Try
            For Each ExchangeServer In oResultsBackendServers
                If server = ExchangeServer.GetDirectoryEntry.Properties("cn").Value.ToString Then
                    Dim ServerDN As String
                    ServerDN = ExchangeServer.GetDirectoryEntry.Properties("distinguishedName").Value.ToString
                    oresults = GenericClass.GetMailBoxStores(ServerDN)
                End If
            Next
        Catch e As FormatException
            MsgBox("Error del acceso a los almacenes de buzones, Error de formato del nombre de servidor Exchange a obtener  " & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error del acceso a los almacenes de buzones, No tienes permisos para acceder a los grupos servidores Exchange " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error del acceso a los almacenes de buzones, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error del acceso a los almacenes de buzones, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error del acceso a los almacenes de buzones, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error del acceso a los almacenes de buzones, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error del acceso a los almacenes de buzones, Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error del acceso a los almacenes de buzones, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error del acceso a los almacenes de buzones, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
        'Para cada mialboxStore añadir su nombre al array
        For Each MailBoxStore In oresults
            'Si el mailbox está montado, añadirlo
            Try
                If MailBoxStore.GetDirectoryEntry.Properties("msExchDatabaseCreated").Value Then
                    'Obtener su StorgeGroup / Nombre del mailbox
                    Dim dn As String = MailBoxStore.GetDirectoryEntry.Properties("distinguishedName").Value.ToString
                    Dim parts() As String = dn.Split(",")
                    Dim mailboxName As String = parts(1).Substring(3) & "/" & parts(0).Substring(3)

                    'mailboxes.Add(MailBoxStore.GetDirectoryEntry.Properties("cn").Value.ToString)
                    mailboxes.Add(mailboxName)
                End If
            Catch e As FormatException
                MsgBox("Error del acceso a los buzones, Error de formato del nombre de Buzón a obtener  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error del acceso a los buzones, No tienes permisos para acceder a los Buzones " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error del acceso a los buzones, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error del acceso a los buzones, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error del acceso a los buzones, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error del acceso a los buzones, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error del acceso a los buzones, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error del acceso a los buzones, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error del acceso a los buzones, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        Next
        Return mailboxes
    End Function

    Public Shared Function NumeroMailBoxes(ByVal server As String) As Integer
        '==========================================================================
        ' Name:     NumeroMailBoxes
        ' Purpose:  Devuelve el número de mailboxStores exchange del directorio activo
        ' Input:    None
        ' Return:   1 array: array de strings con los nombres de los servidores
        ' Calls:    GetMailboxes de la clase GenericClass
        '==========================================================================

        Dim oresults As SearchResultCollection
        Dim MailBoxStore As SearchResult
        Dim mailboxes As New List(Of String)
        Dim ExchangeServer As SearchResult

        'Obtener los servidores Exchange
        Dim RootDSE As New DirectoryEntry("LDAP://RootDSE")
        RootDSE.Username = Settings.adminLogon
        RootDSE.Password = Settings.adminPassword
        RootDSE.AuthenticationType = AuthenticationTypes.Delegation
        Dim RootPath As String = "LDAP://" + RootDSE.Properties("configurationNamingContext").Value
        Dim ConfigContainer As New DirectoryEntry(RootPath)
        Dim ConfigSearcher As New DirectorySearcher(ConfigContainer)
        ConfigSearcher.Filter = "(&(objectCategory=msExchExchangeServer))"
        ConfigSearcher.SearchScope = SearchScope.Subtree
        Dim oResultsBackendServers As Object = ConfigSearcher.FindAll

        'Decada servidor exchange obtener sus mailboxstores
        Try
            For Each ExchangeServer In oResultsBackendServers
                If server = ExchangeServer.GetDirectoryEntry.Properties("cn").Value.ToString Then
                    Dim ServerDN As String
                    ServerDN = ExchangeServer.GetDirectoryEntry.Properties("distinguishedName").Value.ToString
                    oresults = GenericClass.GetMailBoxStores(ServerDN)
                End If
            Next
        Catch e As FormatException
            MsgBox("Error del acceso a los buzones, Error de formato del nombre servidor Exchange a obtener  " & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error del acceso a los buzones, No tienes permisos para acceder a los servidores Exchange " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error del acceso a los buzones, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error del acceso a los buzones, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error del acceso a los buzones, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error del acceso a los buzones, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error del acceso a los buzones, Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error del acceso a los buzones, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error del acceso a los buzones, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
        Return oresults.Count
    End Function

    Public Shared Function ServidorCN(ByVal Name As String) As String
        '==========================================================================
        ' Name:     ServidorCN
        ' Purpose:  Devuelve el nombre canónico de un servidor exchange del directorio activo
        ' Input:    1 string: Nombre del servidor 'Name'
        ' Return:   1 string: El nombre canónico del servidor
        ' Calls:    None
        '==========================================================================

        Dim BackEndServers As SearchResultCollection
        Dim lNewList As New List(Of String)

        'Obtener el DirectoryEntry del servidor
        Dim RootDSE As New DirectoryEntry("LDAP://RootDSE")
        RootDSE.Username = Settings.adminLogon
        RootDSE.Password = Settings.adminPassword
        RootDSE.AuthenticationType = AuthenticationTypes.Delegation
        Dim RootPath As String = "LDAP://" + RootDSE.Properties("configurationNamingContext").Value
        Dim ConfigContainer As New DirectoryEntry(RootPath)
        Dim ConfigSearcher As New DirectorySearcher(ConfigContainer)
        ConfigSearcher.Filter = "(&(objectCategory=msExchExchangeServer) (cn=" & Name & "))"
        ConfigSearcher.SearchScope = SearchScope.Subtree
        BackEndServers = ConfigSearcher.FindAll
        Try
            Dim de As New DirectoryEntry(BackEndServers(0).Path)
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            de.AuthenticationType = AuthenticationTypes.Delegation
            'Devolver su nombre canónico
            Return de.Properties("legacyExchangeDN").Value
        Catch e As FormatException
            MsgBox("Error del acceso al servidor, Error de formato del atributo legacyExchangeDN del servidor   " & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error del acceso al servidor, No tienes permisos para acceder al atributo legacyExchangeDN del servidor  " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error del acceso al servidor, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error del acceso al servidor, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error del acceso al servidor, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error del acceso al servidor, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error del acceso al servidor, Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error del acceso al servidor, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error del acceso al servidor, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
    End Function

    Public Shared Function GetMailBoxStores(ByVal ExchangeServerDN) As SearchResultCollection
        '==========================================================================
        ' Name:     GetMailBoxStores
        ' Purpose:  Devuelve la lista con los nombres de los mailboxStores exchange del servidor
        ' Input:    1 string: El nombre del servidor exchange 'ExchangeServerDN'
        ' Return:   1 SearchResultCollection: los mailboxStores
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del servidor
        Dim ldapPath As String = "LDAP://" + ExchangeServerDN
        Dim ConfigContainer As New DirectoryEntry(ldapPath)
        ConfigContainer.Username = Settings.adminLogon
        ConfigContainer.Password = Settings.adminPassword
        ConfigContainer.AuthenticationType = AuthenticationTypes.Delegation
        Try
            'Buscar los mailboxstores
            Dim ConfigSearcher As New DirectorySearcher(ConfigContainer)
            ConfigSearcher.Filter = "(&(objectCategory=msExchPrivateMDB))"
            ConfigSearcher.SearchScope = SearchScope.Subtree
            Dim oResultsMailBoxStores As Object = ConfigSearcher.FindAll

            'Devolver los mailboxStores encontrados
            Return oResultsMailBoxStores
        Catch e As FormatException
            MsgBox("Error del acceso a los buzones del servidor, Error de formato del acceso al servidor   " & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error del acceso a los buzones del servidor, No tienes permisos para acceder a los buzones del servidor " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error del acceso a los buzones del servidor, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error del acceso a los buzones del servidor, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error del acceso a los buzones del servidor, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error del acceso a los buzones del servidor, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error del acceso a los buzones del servidor, Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error del acceso a los buzones del servidor, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error del acceso a los buzones del servidor, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
    End Function

    Public Shared Function GetMailBoxStoreName(ByVal server, ByVal mailbox) As String
        '==========================================================================
        ' Name:     GetMailBoxStoreName
        ' Purpose:  Busca un buzón y devuelve su nombre
        ' Input:    2 string: El nombre del servidor exchange 'server', El nombre del mailboxStore 'mailbox'
        ' Return:   1 SearchResultCollection: los mailboxStores
        ' Calls:    None
        '==========================================================================

        Dim MailBoxStore As SearchResult
        Dim storage As String = mailbox

        'Buscar los servidores exchange
        Dim ExchangeServer As SearchResult
        Dim RootDSE As New DirectoryEntry("LDAP://RootDSE")
        RootDSE.Username = Settings.adminLogon
        RootDSE.Password = Settings.adminPassword
        RootDSE.AuthenticationType = AuthenticationTypes.Delegation
        Dim RootPath As String = "LDAP://" + RootDSE.Properties("configurationNamingContext").Value
        Dim ConfigContainer As New DirectoryEntry(RootPath)
        Dim ConfigSearcher As New DirectorySearcher(ConfigContainer)
        ConfigSearcher.Filter = "(&(objectCategory=msExchExchangeServer))"
        ConfigSearcher.SearchScope = SearchScope.Subtree
        Dim oResultsBackendServers As Object = ConfigSearcher.FindAll

        'De entre los servidores buscar a server
        For Each ExchangeServer In oResultsBackendServers
            Try
                If server = ExchangeServer.GetDirectoryEntry.Properties("cn").Value.ToString Then
                    Dim ServerDN As String
                    ServerDN = ExchangeServer.GetDirectoryEntry.Properties("distinguishedName").Value.ToString
                    Dim MailboxStores As Object = GenericClass.GetMailBoxStores(ServerDN)
                    'De entre los mailboxstores encontrados buscar a mailbox y devolver su nombre
                    For Each MailBoxStore In MailboxStores
                        If storage = MailBoxStore.GetDirectoryEntry.Properties("cn").Value.ToString Then
                            Return MailBoxStore.GetDirectoryEntry.Properties("distinguishedName").Value.ToString
                        End If
                    Next
                End If
            Catch e As FormatException
                MsgBox("Error del acceso a los alamcenes de buzones del servidor, Error de formato del acceso al servidor   " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error del acceso a los alamcenes de buzones del servidor, No tienes permisos para acceder a los almacenes de buzones del servidor " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error del acceso a los alamcenes de buzones del servidor, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error del acceso a los alamcenes de buzones del servidor, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error del acceso a los alamcenes de buzones del servidor, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error del acceso a los alamcenes de buzones del servidor, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error del acceso a los alamcenes de buzones del servidor, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error del acceso a los alamcenes de buzones del servidor, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error del acceso a los alamcenes de buzones del servidor, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        Next
    End Function

    Public Shared Function GetDNCanonicalN(ByVal Name As String) As String
        '==========================================================================
        ' Name:     GetDNCanonicalN
        ' Purpose:  Devolver el nombre canónico de un objeto
        ' Input:    1 string: El distinguishedName de un objeto 'Name'
        ' Return:   1 string: El canonicalName del objeto
        ' Calls:    None
        '==========================================================================

        'Dim partesDN() As String = Name.Split("/")
        'Dim DN As String = ""
        'For i = 0 To partesDN.Count - 1
        '    If i = 0 Then
        '        Dim pri() As String
        '        pri = partesDN(0).Split(".")
        '        DN = "DC=" & pri(0) & ",DC=" & pri(1)
        '    Else
        '        DN = "CN=" & partesDN(i) & "," & DN
        '    End If
        'Next

        'Return DN
        'Obtener el DirectoryEntry del objeto

        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "&(canonicalName=" & Name & "))"
        deSearch.SearchScope = SearchScope.Subtree

        Dim results As SearchResultCollection = deSearch.FindAll()

        Dim oresult As SearchResult

        If results.Count = 0 Then

            Return ""
        Else
            Try
                oresult = results.Item(0)
                'Devolver su distinguishedName

                If Not oresult.GetDirectoryEntry.Properties("distinguishedName").Value Is Nothing Then

                    Return oresult.GetDirectoryEntry.Properties("distinguishedName").Value.ToString
                Else
                    Return ""
                End If
            Catch e As FormatException
                MsgBox("Error del acceso al nombre canónico del objeto, Error de formato del acceso al nombre canónico del objeto  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error del acceso al nombre canónico del objeto, No tienes permisos para acceder al nombre canónico del objeto " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error del acceso al nombre canónico del objeto, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error del acceso al nombre canónico del objeto, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error del acceso al nombre canónico del objeto, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error del acceso al nombre canónico del objeto, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error del acceso al nombre canónico del objeto, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error del acceso al nombre canónico del objeto, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error del acceso al nombre canónico del objeto, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If

    End Function

    Public Shared Function GetlogonN(ByVal ElementDN As String) As String
        '==========================================================================
        ' Name:     GetlogonN
        ' Purpose:  Devolver el nombre de login de un objeto
        ' Input:    1 string: El distinguishedName de un objeto 'Name'
        ' Return:   1 string: El sAMAccountName del objeto
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del objeto
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(distinguishedName=" & ElementDN & ")"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        If results.Count = 0 Then
            Return "No hay Datos"
        Else
            Try
                oresult = results.Item(0)
                'Devolver su sAMAccountName

                If Not oresult.GetDirectoryEntry.Properties("sAMAccountName").Value Is Nothing Then
                    Return oresult.GetDirectoryEntry.Properties("sAMAccountName").Value.ToString
                Else
                    Return "No hay Datos"
                End If
            Catch e As FormatException
                MsgBox("Error del acceso al nombre de login del objeto, Error de formato del acceso al nombre de login del objeto  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error del acceso al nombre de login del objeto, No tienes permisos para acceder al nombre de login del objeto " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error del acceso al nombre de login del objeto, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error del acceso al nombre de login del objeto, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error del acceso al nombre de login del objeto, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error del acceso al nombre de login del objeto, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error del acceso al nombre de login del objeto, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetDN(ByVal ElementLog As String) As String
        '==========================================================================
        ' Name:     GetDN
        ' Purpose:  Devolver el distinguishedName de un objeto
        ' Input:    1 string: El nombre de log in de un objeto 'Name'
        ' Return:   1 string: El distinguishedName del objeto
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del objeto
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(sAMAccountName=" & ElementLog & ")"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        If results.Count = 0 Then
            Return ""
        Else
            Try
                oresult = results.Item(0)
                'Devolver su sAMAccountName
                If Not oresult.GetDirectoryEntry.Properties("distinguishedName").Value Is Nothing Then
                    Return oresult.GetDirectoryEntry.Properties("distinguishedName").Value.ToString
                Else
                    Return ""
                End If
            Catch e As FormatException
                MsgBox("Error del acceso a la dirección del objeto, Error de formato del acceso a la dirección del objeto  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error del acceso a la dirección del objeto, No tienes permisos para acceder a la dirección del objeto " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error del acceso a la dirección del objeto, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error del acceso a la dirección del objeto, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error del acceso a la dirección del objeto, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error del acceso a la dirección del objeto, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error del acceso a la dirección del objeto, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error del acceso a la dirección del objeto, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error del acceso a la dirección del objeto, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetName(ByVal ElementDN As String) As String
        '==========================================================================
        ' Name:     GetName
        ' Purpose:  Devolver el nombre de un objeto
        ' Input:    1 string: El distinguishedName de un objeto 'Name'
        ' Return:   1 string: El Name del objeto
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del objeto
        Dim de As DirectoryEntry = New DirectoryEntry("LDAP://" & Settings.ldapServerName & "/" & ElementDN, Settings.adminLogon, Settings.adminPassword, AuthenticationTypes.Secure)
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        Try
            Return de.Properties("Name").Value.ToString
        Catch e As FormatException
            MsgBox("Error del acceso alnombre del objeto, Error de formato del acceso al nombre del objeto  " & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error del acceso alnombre del objeto, No tienes permisos para acceder al nombre del objeto " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error del acceso alnombre del objeto, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error del acceso alnombre del objeto, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error del acceso alnombre del objeto, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error del acceso alnombre del objeto, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error del acceso alnombre del objeto, Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error del acceso alnombre del objeto, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error del acceso alnombre del objeto, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
    End Function

    Public Shared Sub MoveTo(ByVal Name As String, ByVal newOU As String)
        '==========================================================================
        ' Name:     MoveTo
        ' Purpose:  Mover un objeto a un continer
        ' Input:    2 string: El nombre de login de un objeto 'Name', El container al que moverlo 'newOU' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Buscar el DirectoryEntry objeto
        Dim de As New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher()
        deSearch.SearchRoot = de
        deSearch.Filter = "(&(sAMAccountName=" & Name & "))"
        Dim results As SearchResultCollection = deSearch.FindAll()
        If results.Count = 0 Then
            Console.WriteLine("usuario no existe")
        Else
            Dim oUser As New DirectoryEntry(results(0).Path)
            'Mover el usuario al nuevo container
            Try
                oUser.MoveTo(New DirectoryEntry("LDAP://" & Settings.ldapServerName & "/" & newOU, Settings.adminLogon, Settings.adminPassword, AuthenticationTypes.Secure))
            Catch e As AccessViolationException
                MsgBox("Error al mover un objeto del directorio activo, no tiene permisos para mover el objeto " & e.Message)
            Catch e As FormatException
                MsgBox("Error al mover un objeto del directorio activo, el formato de la dirección a la que moverlo no es válido " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al mover un objeto del directorio activo, el formato de la dirección a la que moverlo no puede ser nulo " & e.Message)
            End Try
        End If

    End Sub

    Public Shared Sub Rename(ByVal Name As String, ByVal newName As String, ByVal tipo As String)
        '==========================================================================
        ' Name:     Rename
        ' Purpose:  Cambiar el nombre de un objeto
        ' Input:    2 string: El nombre de login de un objeto 'Name', El nuevo nombre a asignarle al objeto 'newName' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Buscar el DirectoryEntry objeto
        Dim de As New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher()
        deSearch.SearchRoot = de
        deSearch.Filter = "(&(sAMAccountName=" & Name & "))"
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            Console.WriteLine("usuario no existe")
        Else
            Dim DEUser As New DirectoryEntry(results(0).Path)
            DEUser.Username = Settings.adminLogon
            DEUser.Password = Settings.adminPassword
            DEUser.AuthenticationType = AuthenticationTypes.Delegation

            Dim oUser As Object

            Dim OldDN As String = DEUser.Properties("distinguishedName").Value
            Dim NewDN As String = DEUser.Properties("distinguishedName").Value
            'Obtener la dirección del contenedor
            Dim cambio() As String = NewDN.Split(",")
            NewDN = cambio(1)
            For i = 2 To cambio.Length - 1
                NewDN = NewDN & "," & cambio(i)
            Next
            'Se le da a oUser el objeto contenedor
            oUser = GetObject("LDAP://" & Settings.ldapServerName & "/" & NewDN)
            'Mover el objeto con el nombre cambiado
            Try
                oUser.MoveHere("LDAP://" & Settings.ldapServerName & "/" & OldDN, "CN=" & newName)
            Catch e As ArgumentNullException
                MsgBox("Error al renombrar el objeto, No se puede asignar un nombre con valor nulo " & e.Message)
            Catch e As ArgumentException
                MsgBox("Error al renombrar el objeto, El tipo de dato del nuevo nombre no es válido " & e.Message)
            Catch e As DuplicateNameException
                MsgBox("Error al renombrar el objeto, Ya existe un elemento con ese nombre en el directorio activo " & e.Message)
            End Try
        End If

    End Sub

    Public Shared Sub RemoveFromOU(ByVal Name As String, ByVal OU As String)
        '==========================================================================
        ' Name:     RemoveFromOU
        ' Purpose:  Eliminar un objeto de un continer
        ' Input:    2 string: El nombre de login de un objeto 'Name', El container del que eliminarlo 'OU' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Buscar el directoryentry del objeto
        Dim de As New DirectoryEntry("LDAP://" & Settings.ldapServerName & "/" & OU)
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher()
        deSearch.SearchRoot = de
        deSearch.Filter = "(&(sAMAccountName=" & Name & "))"
        Dim results As SearchResultCollection = deSearch.FindAll()
        If results.Count = 0 Then
            MsgBox("Elemento no existe")
        Else
            If Not results(0).GetDirectoryEntry.Properties("isCriticalSystemObject").Value Then
                Dim oUser As New DirectoryEntry(results(0).Path)
                'Eliminarlo
                Try
                    de.Children.Remove(oUser)
                Catch e As AccessViolationException
                    MsgBox("Error al eliminar el objeto, no tiene permisos para eliminar objeto s del directorio activo " & e.Message)
                Catch e As ArgumentNullException
                    MsgBox("Error al eliminar el objeto, no se ha encontrado el objeto a eliminar " & e.Message)
                Catch e As FormatException
                    MsgBox("Error al eliminar el objeto, el objeto a eliminar no tiene un formato válido " & e.Message)
                End Try
            Else
                MsgBox("Ese objeto no se puede eliminar porque es crítico para el buen funcionamiento del directorio activo")
            End If

        End If

    End Sub

    Public Shared Sub setPrimaryGroup(ByVal Name As String, ByVal grupo As String)
        '==========================================================================
        ' Name:     setPrimaryGroup
        ' Purpose:  Establecer el grupo primario de un objeto
        ' Input:    2 string: El nombre de login de un objeto 'Name', El nombre del grupo 'grupo' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        Dim PG As Integer
        'Obtener el directoryEntry del grupo
        deSearch.Filter = "(&(objectClass=group) (cn=" & grupo & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim res As SearchResult = deSearch.FindOne()
        Dim PGrupo As New DirectoryEntry(res.Path)
        PGrupo.Username = Settings.adminLogon
        PGrupo.Password = Settings.adminPassword
        PGrupo.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener el token del grupo
        PGrupo.RefreshCache(New String() {"primaryGroupToken"})
        PG = PGrupo.Properties("primaryGroupToken").Value

        'Obtener el directoryentry del objeto
        deSearch.Filter = "(sAMAccountName=" & Name & ")"
        deSearch.SearchScope = SearchScope.Subtree
        Dim resC As SearchResult = deSearch.FindOne()
        Dim PUsuario As New DirectoryEntry(resC.Path)
        PUsuario.Username = Settings.adminLogon
        PUsuario.Password = Settings.adminPassword
        PUsuario.AuthenticationType = AuthenticationTypes.Delegation
        'Asignar como grupo primario del objeto el token del grupo
        PUsuario.Properties("primaryGroupID").Value = PG

        Try
            PUsuario.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("Error, no tiene permisos para establecer el grupo primario del equipo " & e.Message)
        Catch e As ArgumentNullException
            MsgBox("Error, no se puede asignar un null como grupo primario del equipo " & e.Message)
        Catch e As FormatException
            MsgBox("Error, el formato del grupo que se quiere asignar al equipo no es aceptable " & e.Message)
        End Try
    End Sub

    Public Shared Sub RemoveMemberOfGroup(ByVal Name As String, ByVal Group As String)
        '==========================================================================
        ' Name:     RemoveMemberOfGroup
        ' Purpose:  Eliminar un objeto como miembro de un grupo
        ' Input:    2 string: El nombre de login de un objeto 'Name', El nombre del grupo 'grupo' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim de As New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        'Obtener el atributo distinguishedName del objeto
        Dim deSearchU As DirectorySearcher = New DirectorySearcher(de)
        deSearchU.Filter = "(sAMAccountName=" & Name & ")"
        deSearchU.SearchScope = SearchScope.Subtree
        Dim resUC As SearchResultCollection = deSearchU.FindAll()
        Dim PUser As New DirectoryEntry(resUC(0).Path)
        Dim UserComplete As String = PUser.Properties("distinguishedName").Value.ToString

        'Obtener el directoryEntry del grupo
        deSearch.Filter = "(&(objectClass=group) (cn=" & Group & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim resC As SearchResultCollection = deSearch.FindAll()
        Dim res As SearchResult

        'Actualizar los miembros del grupo con todos los elementos menos el objeto
        If resC.Count > 0 Then
            For Each res In resC
                Dim PGrupo As New DirectoryEntry(res.Path)
                PGrupo.RefreshCache(New String() {"member"})
                If Not PGrupo.Properties("member").Value.GetType = GetType(String) Then
                    Dim member() As Object = PGrupo.Properties("member").Value
                    Dim sal(member.Length - 1) As String
                    If Not member Is Nothing Then
                        PGrupo.Properties("member").Clear()
                        Dim j As Integer = 0
                        For i = 0 To member.Length - 1
                            'MsgBox(member(i).ToString)
                            If Not member(i).ToString = UserComplete Then
                                PGrupo.Properties("member").Add(member(j)) '.Insert(i, member(j))
                                j = j + 1
                            End If
                        Next
                    End If
                Else
                    PGrupo.Properties("member").Clear()
                End If
                Try
                    PGrupo.CommitChanges()
                Catch e As AccessViolationException
                    MsgBox("No tiene permisos para establecer que el equipo deje de ser miembro del grupo " & e.Message)
                Catch e As ArgumentNullException
                    MsgBox("Error al establecer que el equipo deje de ser miembro del grupo, el grupo o el equipo es nulo " & e.Message)
                Catch e As FormatException
                    MsgBox("Error al establecer que el equipo deje de ser miembro del grupo, el grupo o el equipo no tiene un formato válido " & e.Message)
                End Try
            Next
        Else
            MsgBox("No encuentro grupo")
        End If

    End Sub

    Public Shared Sub ClearProperty(ByVal UserName As String, ByVal UserProperty As String)
        '==========================================================================
        ' Name:     ClearProperty
        ' Purpose:  Eliminar un atributo de un objeto
        ' Input:    2 string: El nombre de login de un objeto 'UserName', El nombre del atributo 'UserProperty' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtenemos el directoryEntry del objeto
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(sAMAccountName=" & UserName & ")"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            MsgBox("Error obteniendo datos")
        Else
            Dim res As New DirectoryEntry(results(0).Path)
            res.Username = Settings.adminLogon
            res.Password = Settings.adminPassword
            res.AuthenticationType = AuthenticationTypes.Delegation
            'Eliminar el atributo

            res.Properties(UserProperty).Clear()

            Try
                res.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para eliminar los elementos de " & UserProperty & e.Message)
            Catch e As ArgumentNullException
                MsgBox("No tiene permisos para eliminar los elementos de una propiedad que es nula " & e.Message)
            End Try
            res.Close()
        End If
    End Sub

    Public Shared Sub EnableAccount(ByVal Name As String)
        '==========================================================================
        ' Name:     EnableAccount
        ' Purpose:  Habilitar un objeto
        ' Input:    1 string: El nombre de login de un objeto 'UserName'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del objeto
        Dim dire As New DirectoryEntry()
        dire.Username = Settings.adminLogon
        dire.Password = Settings.adminPassword
        Dim dirSearcher As DirectorySearcher = New DirectorySearcher(dire)
        dirSearcher.Filter = "(SAMAccountName=" & Name & ")"
        dirSearcher.SearchScope = SearchScope.Subtree
        Dim results As SearchResult = dirSearcher.FindOne()


        If Not results Is Nothing Then
            'Cambiar los valores del atributo userAccountControl
            Dim de As New DirectoryEntry(results.Path)
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            '&H1 cuando la contraseña no se deshabilita nunca
            Dim exp As Integer = CInt(de.Properties("userAccountControl").Value)
            de.Properties("userAccountControl").Value = exp Or &H1
            Try
                de.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error al habilitar la cuenta, no tiene permisos para habilitar la cuenta " & e.Message)
            Catch e As ConstraintException
                MsgBox("Error al habilitar la cuenta, el habilitar la cuenta viola una regla preexistente " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al habilitar la cuenta, no se ha encontrado el objeto a habilitar " & e.Message)
            End Try
            '&H2 cuando la cuenta está deshabilitada
            Dim val As Integer = CInt(de.Properties("userAccountControl").Value)
            de.Properties("userAccountControl").Value = val And Not &H2
            Try
                de.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error al habilitar la cuenta, no tiene permisos para habilitar la cuenta " & e.Message)
            Catch e As ConstraintException
                MsgBox("Error al habilitar la cuenta, el habilitar la cuenta viola una regla preexistente " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al habilitar la cuenta, no se ha encontrado el objeto a habilitar " & e.Message)
            End Try
            de.Close()
        Else
            MsgBox("Usuario no existe")
        End If
        dire.Close()
    End Sub

    Public Shared Sub DisableAccount(ByVal Name As String)
        '==========================================================================
        ' Name:     DisableAccount
        ' Purpose: Deshabilitar un objeto
        ' Input:    1 string: El nombre de login de un objeto 'UserName'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener el directoryEntry del objeto
        Dim dirEntry As New DirectoryEntry()
        Dim dirSearcher As DirectorySearcher = New DirectorySearcher(dirEntry)
        dirSearcher.Filter = "(SAMAccountName=" & Name & ")"
        dirSearcher.SearchScope = SearchScope.Subtree
        Dim results As SearchResult = dirSearcher.FindOne()

        If Not results Is Nothing Then
            'Cambiar el Atributo userAcountControl
            Dim dirEntryResults As New DirectoryEntry(results.Path)
            dirEntryResults.Username = Settings.adminLogon
            dirEntryResults.Password = Settings.adminPassword
            Dim iVal As Integer = CInt(dirEntryResults.Properties("userAccountControl").Value)
            '&H2 cuenta deshabilitada
            dirEntryResults.Properties("userAccountControl").Value = iVal Or &H2
            Try
                dirEntryResults.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error al deshabilitar la cuenta, no tiene permisos para deshabilitar la cuenta " & e.Message)
            Catch e As ConstraintException
                MsgBox("Error al deshabilitar la cuenta, el habilitar la cuenta viola una regla preexistente " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al deshabilitar la cuenta, no se ha encontrado el objeto a deshabilitar " & e.Message)
            End Try
            dirEntryResults.Close()
        Else
            Console.WriteLine("Usuario no existe")
        End If
        dirEntry.Close()
    End Sub

    Public Shared Function isDisabled(ByVal Name As String) As Boolean
        '==========================================================================
        ' Name:     isDisabled
        ' Purpose:  Saber si una cuenta de un objetoestá deshabilitada 
        ' Input:    1 string: El nombre de login de un objeto 'UserName'
        ' Return:   1 boolean: True si está deshabilitada, false en el caso contrario
        ' Calls:    None
        '==========================================================================

        'Obtener el directoryEntry del objeto
        Dim dirEntry As New DirectoryEntry()
        dirEntry.Username = Settings.adminLogon
        dirEntry.Password = Settings.adminPassword
        dirEntry.AuthenticationType = AuthenticationTypes.Delegation
        Dim dirSearcher As DirectorySearcher = New DirectorySearcher(dirEntry)
        dirSearcher.Filter = "(&(SAMAccountName=" & Name & "))"
        dirSearcher.SearchScope = SearchScope.Subtree
        Dim results As SearchResult = dirSearcher.FindOne()

        If Not results Is Nothing Then
            'Comprobar el userAccountControl
            Dim dirEntryResults As New DirectoryEntry(results.Path)
            Try
                Dim iVal As Integer = CInt(dirEntryResults.Properties("userAccountControl").Value)
                'Si se cumple está deshabilitada
                If iVal And &H2 Then
                    Return True
                End If
            Catch e As FormatException
                MsgBox("Error al comprobar si el objeto está deshabilitado, Error de formato del dato que establece si el objeto está deshabilitado  " & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al comprobar si el objeto está deshabilitado, No tienes permisos para acceder al dato que establece si el objeto está deshabilitado " & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al comprobar si el objeto está deshabilitado, Se ha intentado obtener un dato con un índice fuera de rango " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al comprobar si el objeto está deshabilitado, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al comprobar si el objeto está deshabilitado, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al comprobar si el objeto está deshabilitado, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al comprobar si el objeto está deshabilitado, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al comprobar si el objeto está deshabilitado, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al comprobar si el objeto está deshabilitado, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
            dirEntryResults.Close()
        Else
            MsgBox("Usuario no existe")
        End If
        dirEntry.Close()
    End Function

    '---------------------------------------------------------------------------------------------------------------------
    '---------------------------------------------Arbol-------------------------------------------------------------------
    Public Shared Function ContenedorDataTable(ByVal dname As String) As DataTable
        '==========================================================================
        ' Name:     ContenedorDataTable
        ' Purpose:  Devuleve el datatable auxiliar a insertar en el formulario Arbol
        ' Input:    1 string: dirección del contenedor 'dname'
        ' Return:   1 DataTable: El datatable formado con los elementos del container
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del contenedor
        Dim oRoot As DirectoryEntry = New DirectoryEntry("LDAP://" & Settings.ldapServerName & "/" & dname, Settings.adminLogon, Settings.adminPassword, AuthenticationTypes.Secure)
        oRoot.Username = Settings.adminLogon
        oRoot.Password = Settings.adminPassword
        oRoot.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener sus elementos que no son de la vista avanzada
        Dim oSearcher As DirectorySearcher = New DirectorySearcher(oRoot)
        oSearcher.PropertiesToLoad.Add("objectCategory")
        oSearcher.PropertiesToLoad.Add("distinguishedName")
        oSearcher.PropertiesToLoad.Add("Name")
        oSearcher.PropertyNamesOnly = True
        oSearcher.Filter = "(&(objectClass=*)(!showInAdvancedViewOnly=TRUE))"
        oSearcher.SearchScope = SearchScope.OneLevel

        Dim dt As New DataTable()
        Dim dr As DataRow = Nothing
        'establecer columnas del datagrid auxiliar
        dt.Columns.Add("HiddenName")
        dt.Columns.Add("objectCategory")
        dt.Columns.Add("distinguishedName")

        Dim oResults As SearchResultCollection
        Dim oResult As SearchResult
        oResults = oSearcher.FindAll
        'Insertar los objetos encontrados en las columnas
        For Each oResult In oResults
            dr = dt.NewRow()

            'Obtener el tipo de objeto
            Try
                Dim category As String = oResult.GetDirectoryEntry.Properties("objectCategory").Value.ToString
                Dim poscoma As Integer = category.IndexOf(",")
                Dim longitud As Integer = category.Length
                'Se manipula la cadena para quedarse solo con la parte que indica el tipo de objeto
                category = category.ToUpper
                category = category.Substring(0, poscoma)
                category = category.Replace("CN=", "")
                Dim Tipo As String = category
                dr("HiddenName") = oResult.GetDirectoryEntry.Properties("Name").Value.ToString
                dr("objectCategory") = Tipo
                dr("distinguishedName") = oResult.GetDirectoryEntry.Properties("distinguishedName").Value.ToString
                dt.Rows.Add(dr)
            Catch e As FormatException
                MsgBox("Error datatable, Error de formato al obtener los datos del objeto a incluir en el contenedor  " & dname & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error datatable, No tienes permisos para acceder a los datos del objeto a incluir en el contenedor " & dname & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error datatable, Se ha intentado obtener un dato con un índice fuera de rango " & dname & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error datatable, Se está intentando obtener un dato involucrado en una operación cancelada " & dname & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error datatable, Se está intentando obtener un dato involucrado en una operación abortada " & dname & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error datatable, La memoria está totalmente ocupada " & dname & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error datatable, Error al acceder a al ubicación física del dato " & dname & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error datatable, La memoria está totalmente ocupada " & dname & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error datatable, Error al acceder a al ubicación física del dato, no existe " & dname & e.Message)
            End Try



        Next
        Return dt
    End Function

    Public Shared Function InfoContenedor(ByVal dname As String) As String
        '==========================================================================
        ' Name:     InfoContenedor
        ' Purpose:  Devuleve el número de elementos que pertenecen a un container
        ' Input:    1 string: dirección del contenedor 'dname'
        ' Return:   1 string: El número de elementos
        ' Calls:    None
        '==========================================================================
        'Obtener el container
        Dim ldapServerName As String = Settings.ldapServerName
        Dim oRoot As DirectoryEntry = New DirectoryEntry("LDAP://" & ldapServerName & "/" & dname, Settings.adminLogon, Settings.adminPassword, AuthenticationTypes.Secure)
        oRoot.Username = Settings.adminLogon
        oRoot.Password = Settings.adminPassword
        oRoot.AuthenticationType = AuthenticationTypes.Delegation
        'Buscar sus elementos
        Try
            Dim oSearcher As DirectorySearcher = New DirectorySearcher(oRoot)
            oSearcher.Filter = "(!showInAdvancedViewOnly=TRUE)"
            oSearcher.SearchScope = SearchScope.OneLevel
            Dim oResults As SearchResultCollection
            oResults = oSearcher.FindAll
            'Devolverlos
            Return oResults.Count.ToString
        Catch e As FormatException
            MsgBox("Error info contenedor, Error de formato al obtener el número de objetos en el contenedor  " & dname & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error info contenedor, No tienes permisos para acceder al número de objetos en el contenedor " & dname & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error info contenedor, Se ha intentado obtener un dato con un índice fuera de rango " & dname & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error info contenedor, Se está intentando obtener un dato involucrado en una operación cancelada " & dname & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error info contenedor, Se está intentando obtener un dato involucrado en una operación abortada " & dname & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error info contenedor, La memoria está totalmente ocupada " & dname & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error info contenedor, Error al acceder a al ubicación física del dato " & dname & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error info contenedor, La memoria está totalmente ocupada " & dname & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error info contenedor, Error al acceder a al ubicación física del dato, no existe " & dname & e.Message)
        End Try
    End Function

    Public Shared Function ElementosNodo(ByVal dn As String) As List(Of String)
        '==========================================================================
        ' Name:     ElementosNodo
        ' Purpose:  Devuleve los elementos hijos del elemento en la dirección que se obtienen en los parámetros
        ' Input:    1 string: dirección del contenedor 'dn'
        ' Return:   1 array de strings: La lista con los elementos hijo
        ' Calls:    None
        '==========================================================================
        'Obtener DirectoryEntry de la raiz
        Dim oRoot As DirectoryEntry = New DirectoryEntry("LDAP://" & Settings.ldapServerName & "/" & dn, Settings.adminLogon, Settings.adminPassword, AuthenticationTypes.Secure)
        oRoot.Username = Settings.adminLogon
        oRoot.Password = Settings.adminPassword
        oRoot.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener los elementos que no son contenedores de las vistas avanzadas del directorioActivo
        Dim oSearcher As DirectorySearcher = New DirectorySearcher(oRoot)
        oSearcher.PropertiesToLoad.Add("distinguishedName")
        oSearcher.PropertiesToLoad.Add("Name")
        oSearcher.Filter = "(|(objectClass=BuiltinDomain)(&(objectClass=Container)(!showInAdvancedViewOnly=TRUE))(&(objectClass=OrganizationalUnit)(!showInAdvancedViewOnly=TRUE)))"
        oSearcher.SearchScope = SearchScope.OneLevel

        Dim oResults As SearchResultCollection
        Dim oResult As SearchResult
        oResults = oSearcher.FindAll

        Dim elementos As New List(Of String)
        'Añadir la dirección de cada elemnto a la lista
        For Each oResult In oResults
            Try
                Dim DName As String = oResult.GetDirectoryEntry.Properties("distinguishedName").Value.ToString()
                elementos.Add(DName)
            Catch e As FormatException
                MsgBox("Error info nodo, Error de formato al obtener un nodo para el árbol general  " & dn & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error info nodo, No tienes permisos para acceder al nodo para el árbol general " & dn & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error info nodo, Se ha intentado obtener un dato con un índice fuera de rango " & dn & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error info nodo, Se está intentando obtener un dato involucrado en una operación cancelada " & dn & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error info nodo, Se está intentando obtener un dato involucrado en una operación abortada " & dn & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error info nodo, La memoria está totalmente ocupada " & dn & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error info nodo, Error al acceder a al ubicación física del dato " & dn & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error info nodo, La memoria está totalmente ocupada " & dn & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error info nodo, Error al acceder a al ubicación física del dato, no existe " & dn & e.Message)
            End Try

        Next

        Return elementos
    End Function

    '----------------------------------------------------------------------------------------------------------------------
    '----------------------------------------------Log---------------------------------------------------------------------

    Public Shared Sub Log(ByVal sPathName As String, ByVal sMsg As String, Optional ByVal MostrarMsgBox As Boolean = True, Optional ByVal TipoDeMsgBox As MessageBoxIcon = MessageBoxIcon.Information)
        ErrorLog(sPathName, sMsg)
        If (MostrarMsgBox = True) Then
            MessageBox.Show(sMsg, "Cuadro de Mensajes", MessageBoxButtons.OK, TipoDeMsgBox)
        End If
    End Sub

    Public Shared Sub ErrorLog(ByVal sPathName As String, ByVal sErrMsg As String)
        Try
            
            Dim sYear As String = DateTime.Now.Year.ToString()
            Dim sMonth As String = DateTime.Now.Month.ToString()
            Dim sDay As String = DateTime.Now.Day.ToString()
            Dim sErrorTime As String = sYear + sMonth + sDay
            Dim oWindowsIdentity As WindowsIdentity
            Dim p As WindowsPrincipal

            Dim actualU As String = WMIClass.getWinUser(".") 'oWindowsIdentity.GetCurrent.Name
            Dim environ As Environment
            Dim actualM As String = Environment.MachineName.ToString
            Dim actualOS As String = Environment.OSVersion.ToString
            Dim strHostName As String
            Dim strIPAddress As String
            strHostName = System.Net.Dns.GetHostName()
            strIPAddress = System.Net.Dns.GetHostByName(strHostName).AddressList(0).ToString()
            Dim hora As Integer = DateTime.Now.Hour
            Dim minutos As Integer = DateTime.Now.Minute
            Dim sLogFormat = DateTime.Now.ToShortDateString().ToString() + " " + DateTime.Now.ToLongTimeString().ToString()

            If System.IO.File.Exists(sPathName & "\AdmintoolLog(" & sErrorTime & ").txt") Then
                Dim sw As System.IO.StreamWriter = System.IO.File.AppendText(sPathName & "\AdmintoolLog(" & sErrorTime & ").txt")
                sw.WriteLine(sLogFormat)
                sw.WriteLine(actualU)
                sw.WriteLine(strIPAddress + " " + actualM + " " + actualOS)
                sw.WriteLine(sErrMsg)
                sw.WriteLine("-------------------------------------------------------")
                sw.WriteLine("-------------------------------------------------------")
                sw.Close()
            Else

                Dim sw As System.IO.StreamWriter = System.IO.File.CreateText(sPathName & "\AdmintoolLog(" & sErrorTime & ").txt")
                sw.WriteLine(sLogFormat)
                sw.WriteLine(actualU)
                sw.WriteLine(strIPAddress + " " + actualM + " " + actualOS)
                sw.WriteLine(sErrMsg)
                sw.WriteLine("-------------------------------------------------------")
                sw.WriteLine("-------------------------------------------------------")
                sw.Close()
            End If

        Catch ex As Exception
            Dim fi As System.IO.FileInfo = New System.IO.FileInfo(sPathName)
            System.IO.Directory.CreateDirectory(fi.DirectoryName)
            ErrorLog(sPathName, sErrMsg)
        End Try

    End Sub

End Class
