﻿Public Class Añadir

    Dim seleccionado As Integer = -1
    Dim tipo As String = "vacio"
    Friend Sub Solo(ByVal type As String)
        '==========================================================================
        ' Name:     Solo
        ' Purpose:  Establecer el tipo de objeto que se va a buscar
        ' Input:    1 string: el tipo'type'
        ' Return:   1 string: el tipo
        ' Calls:    None
        '==========================================================================
        'El tipo puede ser:
        'user - usuario
        'group - grupo
        'computer - equipo
        'usergroup - usuarios y grupos
        'vacio - todos
        tipo = type
    End Sub

    Private Sub Buscador_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     Buscador_Load
        ' Purpose:  Carga el listview donde aparecerán los resultados de la búsqueda
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        ResultsListView.ShowItemToolTips = True
        ResultsListView.View = View.Details
        ResultsListView.Columns.Clear()
        'Columnas
        ResultsListView.Columns.Add("Nombre", 100, HorizontalAlignment.Left)
        ResultsListView.Columns.Add("Tipo", 60, HorizontalAlignment.Center)
        'Eliminar elementos anteriores
        ResultsListView.Items.Clear()

    End Sub

    Private Sub SearchButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles SearchButton.Click
        '==========================================================================
        ' Name:     SearchButton_Click
        ' Purpose:  Buscar los objetos cuyos nombres contengan la zadena de caracteres que se introducen en el textbox y cargarlos en el listview
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        SearchButton.Enabled = False
        If Not ToSearchTextBox.Text = "" Then
            ResultsListView.Items.Clear()

            'Obtener todos los usuarios, grupos y equipos del directorio activo
            Dim UList As New List(Of String)
            Dim GList As New List(Of String)
            Dim CList As New List(Of String)

            UList = UserClass.GetUserList
            GList = groupClass.GetGroupList
            CList = GenericClass.GetComputerList

            'Buscar usuarios que tengan entre sus nombres el texto del textbox
            If UList.Count > 0 Then
                If tipo = "vacio" Or tipo = "user" Or tipo = "usergroup" Then
                    For i = 0 To UList.Count - 1
                        If UCase(UserClass.GetUserProperty(UList(i), "sAMAccountName")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(UserClass.GetUserProperty(UList(i), "givenName")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(UserClass.GetUserProperty(UList(i), "sn")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(UserClass.GetUserProperty(UList(i), "displayName")).Contains(UCase(ToSearchTextBox.Text)) Then
                            'Generar datos para el listview y cargarlos
                            Dim Tempnode As ListViewItem
                            Dim datos(1) As String
                            datos(0) = UserClass.GetUserProperty(UList(i), "cn") & "(" & UserClass.GetUserProperty(UList(i), "userPrincipalName") & ")"
                            datos(1) = "user"
                            Tempnode = New ListViewItem(datos)
                            ResultsListView.Items.Add(Tempnode)
                        End If
                    Next
                End If
            End If

            'Buscar grupos que tengan entre sus nombres el texto del textbox
            If GList.Count > 0 Then
                If tipo = "vacio" Or tipo = "group" Or tipo = "usergroup" Then
                    For i = 0 To GList.Count - 1
                        If UCase(groupClass.GetGroupProperty(GList(i), "sAMAccountName")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(groupClass.GetGroupProperty(GList(i), "displayName")).Contains(UCase(ToSearchTextBox.Text)) Then
                            'Generar datos para el listview y cargarlos
                            Dim Tempnode As ListViewItem
                            Dim datos(1) As String
                            datos(0) = groupClass.GetGroupProperty(GList(i), "cn")
                            datos(1) = "group"
                            Tempnode = New ListViewItem(datos)
                            ResultsListView.Items.Add(Tempnode)
                        End If
                    Next
                End If
            End If
            'Buscar equipos que tengan entre sus nombres el texto del textbox
            If CList.Count > 0 Then
                If tipo = "vacio" Or tipo = "computer" Then
                    For i = 0 To CList.Count - 1
                        If UCase(GenericClass.GetComputerProperty(CList(i), "sAMAccountName")).Contains(UCase(ToSearchTextBox.Text)) Or UCase(GenericClass.GetComputerProperty(CList(i), "displayName")).Contains(UCase(ToSearchTextBox.Text)) Then
                            'Generar datos para el listview y cargarlos
                            Dim Tempnode As ListViewItem
                            Dim datos(1) As String
                            datos(0) = GenericClass.GetComputerProperty(CList(i), "cn") & "(" & GenericClass.GetComputerProperty(CList(i), "dNSHostName") & ")"
                            datos(1) = "computer"
                            Tempnode = New ListViewItem(datos)
                            ResultsListView.Items.Add(Tempnode)
                        End If
                    Next
                End If
            End If

        End If
        SearchButton.Enabled = True

    End Sub

    Private Sub ResultsListView_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ResultsListView.SelectedIndexChanged
        '==========================================================================
        ' Name:     ResultsListView_SelectedIndexChanged
        ' Purpose:  Guardar en la variable selecccionado el objeto del listview seleccionado
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        seleccionado = ResultsListView.SelectedItems(0).Index
 
    End Sub

    Private Sub AcceptButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Devuelve el nombre de login del objeto seleccionado
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim logN As String
        If Not seleccionado = -1 Then
            'Si es un grupo
            If ResultsListView.Items(seleccionado).SubItems(1).Text = "group" Then
                logN = ResultsListView.Items(seleccionado).SubItems(0).Text
                'Si es un usuario
            ElseIf ResultsListView.Items(seleccionado).SubItems(1).Text = "user" Then
                Dim partes() As String
                partes = ResultsListView.Items(seleccionado).SubItems(0).Text.Split("(")
                partes = partes(1).Split("@")
                logN = partes(0)
            Else
                'Si es un equipo
                Dim partes() As String
                partes = ResultsListView.Items(seleccionado).SubItems(0).Text.Split("(")
                logN = partes(0) & "$"
            End If

            PropiedadesGrupo.LoadObject(logN)
            Mover.LoadObject(logN)
            NuevoEquipo.loadObject(logN)
            PropiedadesEquipo.loadObject(logN)
            UserProperties.LoadObject(logN)
            PermisosBuzon.LoadObjeto(logN)
            OpcionesEnvio.LoadU(logN)
            RestriccionesEnvio.LoadU(logN)
        End If
        'Cerrar el formulario
        Me.Close()

    End Sub
End Class