﻿Imports System
Imports System.IO
Imports System.Text.RegularExpressions

Public Class IExplorer
    Dim local As Boolean
    Dim EquipoAceptado As Boolean = False

    Private Sub SearchButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchButton.Click
        '==========================================================================
        ' Name:     SearchButton_Click
        ' Purpose:  Llamar a la función que devolverá los datos de los campos de la ventana y cargarlos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    IExplorerDatos de WMIClass
        '==========================================================================

        If ComputerTextBox.Text = "" Then
            MsgBox("Para cargar los datos de IExplorer de un equipo, hay que especificar su nombre")
        Else
            ComputerTextBox.Text.Replace(" ", "")
            Dim salida As New List(Of String)
            'Llamada a la función
            Me.Cursor = Cursors.WaitCursor
            salida = WMIClass.IExplorerDatos(ComputerTextBox.Text)
            If Not salida Is Nothing Then

                'Carga de los datos
                EnabledRadioButton.Enabled = True
                DisabledRadioButton.Enabled = True
                If salida(0) = 1 Then
                    EnabledRadioButton.Checked = True
                    DisabledRadioButton.Checked = False
                Else
                    EnabledRadioButton.Checked = False
                    DisabledRadioButton.Checked = True
                End If
                ProxyTextBox.Enabled = True
                PortTextBox.Enabled = True
                Dim proxyport() As String = salida(1).Split(":")
                If proxyport.Count = 2 Then

                    ProxyTextBox.Text = proxyport(0)
                    PortTextBox.Text = proxyport(1)
                Else
                    ProxyTextBox.Text = salida(1)
                End If
                local = False
                Dim excepciones As String = salida(2)
                If salida(2).Contains(";<local>") Then
                    local = True
                    excepciones = excepciones.Substring(0, excepciones.Length - 8)
                End If

                ExceptionsTextBox.Enabled = True
                ExceptionsTextBox.Text = excepciones
                EquipoAceptado = True
            End If
            Me.Cursor = Cursors.Default
        End If


    End Sub

    Private Sub AcceptButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Llamar a la función que aplicará los datos de los campos de la ventana al Internet Explorer del equipo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    IExplorerCarga de WMIClass
        '==========================================================================
        Try
            Me.Cursor = Cursors.WaitCursor
            If EquipoAceptado Then
                Dim salida As String = "-------Configuración IExplorer-------" & vbCrLf & "Cambios que se producen en la configuración de Internet Explorer"
                Dim dwValue As String = -1
                'Obtener el valor para saber si se habilita el InternetExplorer o no
                If EnabledRadioButton.Checked Then
                    dwValue = 1
                Else
                    dwValue = 0
                End If

                If dwValue = -1 Or ProxyTextBox.Text = "" Then
                    MsgBox(" Se ha de establecer, por lo menos, si está habilitado, el proxy y su puerto")
                Else
                    If Not checkRejexProxy(ProxyTextBox.Text) Then
                        If Not checkRejexIP(ProxyTextBox.Text) Then
                            Me.Cursor = Cursors.Default
                            MsgBox("El proxy debe ser un nombre o una dirección de ip")
                        Else
                            'Llamar a la función
                            salida = salida & vbCrLf & "Nombre del equipo:" & ComputerTextBox.Text
                            salida = salida & vbCrLf & "Estado, Habilitado(1)/Deshabilitado(0):" & dwValue
                            salida = salida & vbCrLf & "Proxy:" & ProxyTextBox.Text
                            salida = salida & vbCrLf & "Excepciones:" & ExceptionsTextBox.Text
                            salida = salida & vbCrLf & "Carga de datos..."
                            Try
                                Dim excep As String = ExceptionsTextBox.Text
                                If local Then
                                    excep = excep & ";<local>"
                                End If
                                WMIClass.IExplorerCarga(ComputerTextBox.Text, dwValue, ProxyTextBox.Text & ":" & PortTextBox.Text, Excep)
                            Catch ex As Exception When ComputerTextBox.Text = ""
                                MsgBox("Error al cargar los datos a InternetExplorer, el nombre del equipo al que pertenece no puede ser vacío " & ex.Message)
                                salida = salida & vbCrLf & "Error: al cargar los datos a InternetExplorer, el nombre del equipo al que pertenece no puede ser vacío " & ex.Message
                            Catch ex As Exception When dwValue = ""
                                MsgBox("Error al cargar los datos a InternetExplorer, no se ha elegido si se habilita o deshabilita " & ex.Message)
                                salida = salida & vbCrLf & "Error: al cargar los datos a InternetExplorer, no se ha elegido si se habilita o deshabilita " & ex.Message
                            Catch ex As Exception When ProxyTextBox.Text = ""
                                MsgBox("Error al cargar los datos a InternetExplorer, el proxy no puede ser vacío " & ex.Message)
                                salida = salida & vbCrLf & "Error: al cargar los datos a InternetExplorer, el proxy no puede ser vacío " & ex.Message
                            Catch ex As Exception
                                MsgBox("Error al cargar los datos a InternetExplorer " & ex.Message & ex.ToString)
                                salida = salida & vbCrLf & "Error: al cargar los datos a InternetExplorer " & ex.Message
                            End Try
                            salida = salida & vbCrLf & "Configuración cambiada"
                            'Log
                            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
                            Me.Cursor = Cursors.Default
                            Me.Close()
                        End If
                    Else
                        'Llamar a la función
                        salida = salida & vbCrLf & "Nombre del equipo:" & ComputerTextBox.Text
                        salida = salida & vbCrLf & "Estado, Habilitado(1)/Deshabilitado(0):" & dwValue
                        salida = salida & vbCrLf & "Proxy:" & ProxyTextBox.Text
                        salida = salida & vbCrLf & "Excepciones:" & ExceptionsTextBox.Text
                        salida = salida & vbCrLf & "Carga de datos..."
                        Dim excep As String = ExceptionsTextBox.Text
                        If local Then
                            excep = excep & ";<local>"
                        End If
                        Try
                            WMIClass.IExplorerCarga(ComputerTextBox.Text, dwValue, ProxyTextBox.Text & ":" & PortTextBox.Text, excep)
                        Catch ex As Exception When ComputerTextBox.Text = ""
                            MsgBox("Error al cargar los datos a InternetExplorer, el nombre del equipo al que pertenece no puede ser vacío " & ex.Message)
                            salida = salida & vbCrLf & "Error: al cargar los datos a InternetExplorer, el nombre del equipo al que pertenece no puede ser vacío " & ex.Message
                        Catch ex As Exception When dwValue = ""
                            MsgBox("Error al cargar los datos a InternetExplorer, no se ha elegido si se habilita o deshabilita " & ex.Message)
                            salida = salida & vbCrLf & "Error: al cargar los datos a InternetExplorer, no se ha elegido si se habilita o deshabilita " & ex.Message
                        Catch ex As Exception When ProxyTextBox.Text = ""
                            MsgBox("Error al cargar los datos a InternetExplorer, el proxy no puede ser vacío " & ex.Message)
                            salida = salida & vbCrLf & "Error: al cargar los datos a InternetExplorer, el proxy no puede ser vacío " & ex.Message
                        Catch ex As Exception
                            MsgBox("Error al cargar los datos a InternetExplorer " & ex.Message & ex.Data.ToString)
                            salida = salida & vbCrLf & "Error: al cargar los datos a InternetExplorer " & ex.Message
                        End Try
                        salida = salida & vbCrLf & "Configuración cambiada"
                        'Log
                        GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
                        Me.Cursor = Cursors.Default
                        Me.Close()
                    End If

                End If
            Else
                MsgBox("No se ha establecido el equipo al que pertenece el Internet Explorer a configurar")
            End If

        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub CancelButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        '==========================================================================
        ' Name:     CancelButton_Click
        ' Purpose:  Cerrar la ventana sin aplicar ningún cambio
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================

        Me.Close()

    End Sub

    Private Sub IExplorer_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     IExplorer_Load
        ' Purpose:  Cargar la ventana deshabilitando los controles hasta que se produzca la carga
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        EnabledRadioButton.Enabled = False
        DisabledRadioButton.Enabled = False
        ProxyTextBox.Enabled = False
        ExceptionsTextBox.Enabled = False
        PortTextBox.Enabled = False
    End Sub

    Private Function checkRejexIP(ByVal strFindin As String) As Boolean
        Dim myRegex As New Regex("^(([01]?\d\d?|2[0-4]\d|25[0-5])\.){3}([01]?\d\d?|25[0-5]|2[0-4]\d)$")
        If myRegex.IsMatch(strFindin) Then
            Return True
        Else
            Return False
        End If
    End Function

    Private Function checkRejexProxy(ByVal strFindin As String) As Boolean
        Dim myRegex As New Regex("^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$")
        If myRegex.IsMatch(strFindin) Then
            Return True
        Else
            Return False
        End If
    End Function

    Private Sub PortTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles PortTextBox.KeyPress
        '==========================================================================
        ' Name:     PortTextBox_KeyPress
        ' Purpose:  Controlar que en el textbox solo se insertan integers
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Not (Char.IsNumber(e.KeyChar) Or Char.IsControl(e.KeyChar)) Then e.Handled = True
    End Sub
End Class