﻿Public Class LimitesAlmacenamiento
    Dim Usuario As String
    Dim primero As Boolean
    Dim UDN As String
    Dim defaultLimits As Boolean = False
    Dim deniedSendLimit As Boolean = False
    Dim deniedSendRecieveLimit As Boolean = False
    Dim warningIssue As Boolean = False

    Friend Sub LoadUser(ByVal User As String)
        '==========================================================================
        ' Name:     LoadUser
        ' Purpose:  Asignar Usuario del que manipular los datos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Usuario = User
    End Sub

    Private Sub LimitesAlmacenamiento_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     LimitesAlmacenamiento_Load
        ' Purpose:  Cargar los datos del usuario a la ventana
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    GetUserProperty, GetUserPropertyBool, GetUserPropertyInteger de UserClass
        '==========================================================================
        Dim HayError As Boolean = False
        Dim salida As String
        primero = True

        Try
            UDN = UserClass.GetUserProperty(Usuario, "distinguishedName")
        Catch ex As Exception
            MsgBox("Error al obtener el dato que establece la dirección del usuario " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el dato que establece la dirección del usuario " & Usuario & ex.Message
            HayError = True
        End Try
        'Límtes de almacenamiento por defecto?
        Try
            DefaultLimitsCheckBox.Checked = UserClass.GetUserPropertyBool(Usuario, "mDBUseDefaults")
        Catch ex As Exception
            MsgBox("Error al obtener el dato que establece si los límites para el buzón de correo utilizados son los establecidos por defecto para el usuario " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el dato que establece si los límites para el buzón de correo utilizados son los establecidos por defecto para el usuario " & Usuario & ex.Message
            HayError = True
        End Try

        WarningIssueTextBox.Enabled = False
        DeniedSendLimitTextBox.Enabled = False
        DeniedSendRecieveLimitTextBox.Enabled = False

        If DefaultLimitsCheckBox.Checked Then
            'Si utiliza los límites por defecto no dejamos actualizar los límites
            WarningIssueCheckBox.Enabled = False
            DeniedSendLimitCheckBox.Enabled = False
            DeniedSendReciveLimitCheckBox.Enabled = False

        Else
            'Al no utilizar los límites por defecto, obtenerlos y cargarlos
            Try
                If Not UserClass.GetUserPropertyInteger(Usuario, "mDBStorageQuota") = 0 Then
                    WarningIssueCheckBox.Enabled = True
                    WarningIssueTextBox.Enabled = True
                    WarningIssueCheckBox.Checked = True
                    WarningIssueTextBox.Text = UserClass.GetUserPropertyInteger(Usuario, "mDBStorageQuota").ToString
                End If
            Catch ex As Exception
                MsgBox("Error al obtener el dato que establece el límite para el buzón de correo en el que salta la alarma por excesiva carga para el usuario " & ex.Message)
                salida = salida & vbCrLf & "Error al obtener el dato que establece el límite para el buzón de correo en el que salta la alarma por excesiva carga para el usuario " & Usuario & ex.Message
                HayError = True
            End Try
            Try
                If Not UserClass.GetUserPropertyInteger(Usuario, "mDBOverQuotaLimit") = 0 Then
                    DeniedSendLimitCheckBox.Enabled = True
                    DeniedSendLimitTextBox.Enabled = True
                    DeniedSendLimitCheckBox.Checked = True
                    DeniedSendLimitTextBox.Text = UserClass.GetUserPropertyInteger(Usuario, "mDBOverQuotaLimit").ToString
                End If
            Catch ex As Exception
                MsgBox("Error al obtener el dato que establece el límite para el buzón de correo en el que se prohibe el envío por excesiva carga para el usuario " & ex.Message)
                salida = salida & vbCrLf & "Error al obtener el dato que establece el límite para el buzón de correo en el que se prohibe el envío por excesiva carga para el usuario " & Usuario & ex.Message
                HayError = True
            End Try
            Try
                If Not UserClass.GetUserPropertyInteger(Usuario, "mDBOverHardQuotaLimit") = 0 Then
                    DeniedSendRecieveLimitTextBox.Enabled = True
                    DeniedSendReciveLimitCheckBox.Enabled = True
                    DeniedSendRecieveLimitTextBox.Text = UserClass.GetUserPropertyInteger(Usuario, "mDBOverHardQuotaLimit").ToString
                    DeniedSendReciveLimitCheckBox.Checked = True
                End If
            Catch ex As Exception
                MsgBox("Error al obtener el dato que establece el límite para el buzón de correo en el que se prohibe el envío y recepción por excesiva carga para el usuario " & ex.Message)
                salida = salida & vbCrLf & "Error al obtener el dato que establece el límite para el buzón de correo en el que se prohibe el envío y recepción por excesiva carga para el usuario " & Usuario & ex.Message
                HayError = True
            End Try
        End If

        If HayError Then
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        End If
        primero = False
        'Habilitar el botón cancelar
        AcceptButton.Enabled = False
        CancelButton.Enabled = True

    End Sub
    '--------------------------------------------------------------------------------------------------------------------------
    '-----------------------------------------------------Control de eventos---------------------------------------------------

    Private Sub DefaultLimitsCheckBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DefaultLimitsCheckBox.Click
        '==========================================================================
        ' Name:     DefaultLimitsCheckBox_Click
        ' Purpose:  Controlar los cambios que se producen al marcar el checkbox de utilizar los límites por defecto
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not primero Then
            If DefaultLimitsCheckBox.Checked = True Then
                'Deshabilitar todos los textbox
                WarningIssueTextBox.Enabled = False
                WarningIssueTextBox.Text = ""
                DeniedSendLimitTextBox.Enabled = False
                DeniedSendLimitTextBox.Text = ""
                DeniedSendRecieveLimitTextBox.Enabled = False
                DeniedSendRecieveLimitTextBox.Text = ""
                WarningIssueCheckBox.Enabled = False
                WarningIssueCheckBox.Checked = False
                DeniedSendLimitCheckBox.Enabled = False
                DeniedSendLimitCheckBox.Checked = False
                DeniedSendReciveLimitCheckBox.Enabled = False
                DeniedSendReciveLimitCheckBox.Checked = False
            Else
                'Habilitar los textbox
                WarningIssueCheckBox.Enabled = True
                DeniedSendLimitCheckBox.Enabled = True
                DeniedSendReciveLimitCheckBox.Enabled = True
            End If
            AcceptButton.Enabled = True
            defaultLimits = True
        End If

    End Sub

    Private Sub DeniedSendLimitCheckBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DeniedSendLimitCheckBox.Click
        '==========================================================================
        ' Name:     DeniedSendLimitCheckBox_Click
        ' Purpose:  Habilitar su textBox y el botón aceptar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not primero Then
            If DeniedSendLimitCheckBox.Checked Then
                DeniedSendLimitTextBox.Enabled = True
                AcceptButton.Enabled = True
                deniedSendLimit = True
            Else
                DeniedSendLimitTextBox.Enabled = False
                DeniedSendLimitTextBox.Text = ""
                AcceptButton.Enabled = True
                deniedSendLimit = False
            End If

        End If

    End Sub

    Private Sub DeniedSendReciveLimitCheckBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DeniedSendReciveLimitCheckBox.Click
        '==========================================================================
        ' Name:     DeniedSendReciveLimitCheckBox_Click
        ' Purpose:  Habilitar su textBox y el botón aceptar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not primero Then
            If DeniedSendReciveLimitCheckBox.Checked Then
                DeniedSendRecieveLimitTextBox.Enabled = True
                AcceptButton.Enabled = True
                deniedSendRecieveLimit = True
            Else
                DeniedSendRecieveLimitTextBox.Enabled = False
                DeniedSendRecieveLimitTextBox.Text = ""
                deniedSendRecieveLimit = False
                AcceptButton.Enabled = True
            End If

        End If

    End Sub

    Private Sub WarningIssueCheckBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles WarningIssueCheckBox.Click
        '==========================================================================
        ' Name:     WarningIssueCheckBox_Click
        ' Purpose:  Habilitar su textBox y el botón aceptar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not primero Then
            If WarningIssueCheckBox.Checked Then
                WarningIssueTextBox.Enabled = True
                AcceptButton.Enabled = True
                warningIssue = True
            Else
                warningIssue = False
                WarningIssueTextBox.Enabled = False
                WarningIssueTextBox.Text = ""
                AcceptButton.Enabled = True
            End If

        End If
 
    End Sub

    Private Sub WarningIssueTextBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles WarningIssueTextBox.Click
        '==========================================================================
        ' Name:     WarningIssueTextBox_Click
        ' Purpose:  Habilitar el botón aceptar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not primero Then
            AcceptButton.Enabled = True
        End If

    End Sub

    Private Sub WarningIssueTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles WarningIssueTextBox.KeyPress
        '==========================================================================
        ' Name:     WarningIssueTextBox_KeyPress
        ' Purpose:  Permitir solo integers en el textbox
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Not (Char.IsNumber(e.KeyChar) Or Char.IsControl(e.KeyChar)) Then e.Handled = True
        
    End Sub

    Private Sub DeniedSendLimitTextBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DeniedSendLimitTextBox.Click
        '==========================================================================
        ' Name:     DeniedSendLimitTextBox_Click
        ' Purpose:  Habilitar el botón aceptar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        AcceptButton.Enabled = True

    End Sub

    Private Sub DeniedSendLimitTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles DeniedSendLimitTextBox.KeyPress
        '==========================================================================
        ' Name:     DeniedSendLimitTextBox_KeyPress
        ' Purpose:  Permitir solo integers en el textbox
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Not (Char.IsNumber(e.KeyChar) Or Char.IsControl(e.KeyChar)) Then e.Handled = True
    End Sub

    Private Sub DeniedSendRecieveLimitTextBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DeniedSendRecieveLimitTextBox.Click
        '==========================================================================
        ' Name:     DeniedSendRecieveLimitTextBox_Click
        ' Purpose:  Habilitar el botón aceptar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        AcceptButton.Enabled = True

    End Sub

    Private Sub DeniedSendRecieveLimitTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles DeniedSendRecieveLimitTextBox.KeyPress
        '==========================================================================
        ' Name:     DeniedSendRecieveLimitTextBox_KeyPress
        ' Purpose:  Permitir solo integers en el textbox
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Not (Char.IsNumber(e.KeyChar) Or Char.IsControl(e.KeyChar)) Then e.Handled = True
    End Sub

    '---------------------------------------------------------------------------------------------------------------------------------
    '----------------------------------------------------------Botones----------------------------------------------------------------

    Private Sub CancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        '==========================================================================
        ' Name:     CancelButton_Click
        ' Purpose:  Cerrar la ventana si efectuar cambios
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Me.Close()

    End Sub

    Private Sub AcceptButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Cerrar la ventana llevando a cambio las modificaciones que se hayan producido de los datos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    SetUseMDBDefaults, SetWarningLimit, SetDeniedSendLimit, SetDeniedSendAndReceiveLimit de MailClass
        '==========================================================================
        Try
            Me.Cursor = Cursors.WaitCursor
            Dim HayError As Boolean = False
            Dim salida As String = "-------Límites Almacenamiento-------" & vbCrLf & "Dentro de Propiedades Usuario"
            salida = salida & vbCrLf & "Dueño del buzón:" & Usuario
            If defaultLimits Then
                'Establecer límites por defecto
                If DefaultLimitsCheckBox.Checked = True Then
                    salida = salida & vbCrLf & "Establecer límites por defecto" & Usuario
                    Try
                        MailClass.SetUseMDBDefaults(UDN, True)
                    Catch ex As Exception
                        MsgBox("Error al establecer los límites del buzón como los límites por defecto " & ex.Message)
                        salida = salida & vbCrLf & "Error: al establecer los límites del buzón como los límites por defecto " & ex.Message
                        HayError = True
                    End Try
                    deniedSendLimit = False
                    warningIssue = False
                    deniedSendRecieveLimit = False
                Else
                    salida = salida & vbCrLf & "Quitar límites por defecto" & Usuario
                    Try
                        MailClass.SetUseMDBDefaults(UDN, False)
                    Catch ex As Exception
                        MsgBox("Error al establecer los límites del buzón como los límites por defecto " & ex.Message)
                        salida = salida & vbCrLf & "Error: al establecer los límites del buzón como los límites por defecto " & ex.Message
                        HayError = True
                    End Try
                End If
            End If
            'Establecer los límites
            If warningIssue Then
                If WarningIssueTextBox.Text = "" Then
                    MsgBox("Establece el tamaño en KB a partir del cual sonará la alarma")
                    HayError = True
                Else
                    salida = salida & vbCrLf & "límite de KB que una vez superado provocara que suene la alarma" & WarningIssueTextBox.Text
                    Try
                        MailClass.SetWarningLimit(UDN, WarningIssueTextBox.Text)
                    Catch ex As Exception
                        MsgBox("Error al establecer el valor de almacenamiento del buzón que una vez sobrepasado hace saltar un aviso " & ex.Message)
                        salida = salida & vbCrLf & "Error: al establecer el valor de almacenamiento del buzón que una vez sobrepasado hace saltar un aviso " & ex.Message
                        HayError = True
                    End Try
                End If
            Else
                UserClass.ClearUserProperty(Usuario, "mDBStorageQuota")
            End If
            If deniedSendLimit Then
                If DeniedSendLimitTextBox.Text = "" Then
                    MsgBox("Establece el máximo en KB para envío")
                    HayError = True
                Else
                    salida = salida & vbCrLf & "límite de KB para envío" & DeniedSendLimitTextBox.Text
                    Try
                        MailClass.SetDeniedSendLimit(UDN, DeniedSendLimitTextBox.Text)
                    Catch ex As Exception
                        MsgBox("Error al establecer el valor de almacenamiento máximo, en el envío, del buzón : " & ex.Message)
                        salida = salida & vbCrLf & "Error: al establecer el valor de almacenamiento máximo, en el envío, del buzón : " & ex.Message
                        HayError = True
                    End Try
                End If
            Else
                UserClass.ClearUserProperty(Usuario, "mDBOverQuotaLimit")
            End If
            If deniedSendRecieveLimit Then
                If DeniedSendRecieveLimitTextBox.Text = "" Then
                    MsgBox("Establece el máximo en KB para envío y recepción")
                    HayError = True
                Else
                    salida = salida & vbCrLf & "límite de KB para envío y recepción" & DeniedSendRecieveLimitTextBox.Text
                    Try
                        MailClass.SetDeniedSendAndReceiveLimit(UDN, DeniedSendRecieveLimitTextBox.Text)
                    Catch ex As Exception
                        MsgBox("Error al establecer el valor de almacenamiento máximo, en el envío y la recepción, del buzón : " & ex.Message)
                        salida = salida & vbCrLf & "Error: al establecer el valor de almacenamiento máximo, en el envío y la recepción, del buzón : " & ex.Message
                        HayError = True
                    End Try
                End If
            Else
                UserClass.ClearUserProperty(Usuario, "mDBOverHardQuotaLimit")
            End If
            '-------------------------------------------------------------------------------------------
            Me.Cursor = Cursors.Default
            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
            If Not HayError Then
                Me.Close()
            End If

        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub DeniedSendLimitTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeniedSendLimitTextBox.TextChanged
        '==========================================================================
        ' Name:     DeniedSendLimitTextBox_TextChanged
        ' Purpose:  Habilitar el botón aceptar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Not primero Then
            AcceptButton.Enabled = True
        End If

    End Sub

    Private Sub DeniedSendRecieveLimitTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeniedSendRecieveLimitTextBox.TextChanged
        '==========================================================================
        ' Name:     DeniedSendRecieveLimitTextBox_TextChanged
        ' Purpose:  Habilitar el botón aceptar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not primero Then
            AcceptButton.Enabled = True
        End If

    End Sub

    Private Sub WarningIssueTextBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles WarningIssueTextBox.TextChanged
        '==========================================================================
        ' Name:     WarningIssueTextBox_TextChanged
        ' Purpose:  Habilitar el botón aceptar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not primero Then
            AcceptButton.Enabled = True
        End If

    End Sub
End Class