﻿Imports System.DirectoryServices
Imports System.Text
Imports System.ComponentModel

Public Class Mover

    Private Actual_OU As String
    Dim objeto As Object

    Friend Sub LoadObject(ByVal obj As String)
        '==========================================================================
        ' Name:     LoadObject
        ' Purpose:  Obtener el nombre de login de un objeto a utilizar más adelante
        ' Input:    1 string: el nombre del objeto obtenido'obj'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        objeto = obj
    End Sub

    Private Sub crearArbol(ByVal dn As String, ByRef NodoPadre As TreeNode)
        '==========================================================================
        ' Name:     crearArbol
        ' Purpose:  Obtener el nombre de login de un objeto a utilizar más adelante
        ' Input:    1 string: La dirección de donde obtner los datos del árbol'dn'
        '           1 TreeNode: El nodo padre 'NodoPadre'
        ' Return:   None
        ' Calls:    none
        '==========================================================================

        ''Obtener DirectoryEntry de la raiz
        'Dim oRoot As DirectoryEntry = New DirectoryEntry("LDAP://" & Settings.ldapServerName & "/" & dn, Settings.adminLogon, Settings.adminPassword, AuthenticationTypes.Secure)

        ''Obtener los contenedores que no son de las vistas avanzadas del directorioActivo
        'Dim oSearcher As DirectorySearcher = New DirectorySearcher(oRoot)
        'oSearcher.PropertiesToLoad.Add("distinguishedName")
        'oSearcher.PropertiesToLoad.Add("Name")
        'oSearcher.Filter = "(|(objectClass=BuiltinDomain)(&(objectClass=Container)(!showInAdvancedViewOnly=TRUE))(&(objectClass=OrganizationalUnit)(!showInAdvancedViewOnly=TRUE)))"
        'oSearcher.SearchScope = SearchScope.OneLevel

        'Dim oResults As SearchResultCollection
        'Dim oResult As SearchResult
        'oResults = oSearcher.FindAll

        'Dim dname, clave, nombre As String
        ''Insertar los resultados obtenidos y volver a llamar recursivamente a la función hasta llegar a las hojas del árbol
        'For Each oResult In oResults
        '    dname = oResult.GetDirectoryEntry.Properties("distinguishedName").Value.ToString
        '    nombre = oResult.GetDirectoryEntry.Properties("Name").Value.ToString
        '    clave = dname
        '    NodoPadre.Nodes.Add(clave, nombre, 1)
        '    crearArbol(dname, NodoPadre.Nodes(clave))
        'Next
        Dim elementos As List(Of String) = GenericClass.ElementosNodo(dn)
        Dim dname, clave, nombre As String
        'Insertar los resultados obtenidos y volver a llamar recursivamente a la función hasta llegar a las hojas del árbol
        If Not elementos Is Nothing Then
            For i = 0 To elementos.Count - 1
                dname = elementos(i) 'oResult.GetDirectoryEntry.Properties("distinguishedName").Value.ToString
                nombre = GenericClass.GetName(elementos(i)) 'oResult.GetDirectoryEntry.Properties("Name").Value.ToString
                clave = dname
                NodoPadre.Nodes.Add(clave, nombre, 1)
                'crearArbol(dname, NodoPadre.Nodes(clave))
            Next
        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '==========================================================================
        ' Name:     Form1_Load
        ' Purpose:  Crear el primer Nodo del árbol y llamar a la función que lo crea
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    crearArbol
        '==========================================================================

        TreeView1.Nodes.Clear()
        TreeView1.Nodes.Add(Settings.ADRoot, Settings.userDNSDomain)
        crearArbol(Settings.ADRoot, TreeView1.Nodes(Settings.ADRoot))

    End Sub

    Private Sub TreeView1_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeView1.AfterSelect
        '==========================================================================
        ' Name:     TreeView1_AfterSelect
        ' Purpose:  Actualizar la variable que posee el contenedor actual al seleccionar un nodo del árbol
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim dn As String
        
        Me.Cursor = Cursors.WaitCursor
        dn = e.Node.Name
        
        Actual_OU = dn

        'Si es un nodo hoja, Añadir subOUs
        If e.Node.Nodes.Count = 0 Then
            crearArbol(dn, e.Node)
        End If
        Me.Cursor = Cursors.Default
    End Sub

    Function GetNode(ByVal dnNode As String, ByVal Tree As TreeNode) As TreeNode
        '==========================================================================
        ' Name:     GetNode
        ' Purpose:  Obtener el Nodo de un árbol
        ' Input:    1 String: dirección del nodo 'dnNode'
        '           1 TreeNode: el árbol 'Tree'
        ' Return:   1 TreeNode: El nodo que tiene como nombre la dirección que se pasa por parámetros
        ' Calls:    None
        '==========================================================================
        Return Tree.Nodes(Tree.Nodes.IndexOfKey(dnNode))

    End Function

    Private Sub cancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cancelButton.Click
        '==========================================================================
        ' Name:     CancelButton_Click
        ' Purpose:  Cerrar la ventana sin aplicar ningún cambio
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================

        Me.Close()

    End Sub

    Private Sub AcceptButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Llamar a la función que mueve el objeto al container seleccionado
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    MoveTo de GenericClass
        '==========================================================================
        Dim HayError As Boolean = False
        Dim salida As String = "-------Mover-------"
        Me.Cursor = Cursors.WaitCursor
        Try

            If Not TreeView1.SelectedNode Is Nothing Then
                If Not TreeView1.SelectedNode.Equals(TreeView1.TopNode) Then

                    salida = salida & vbCrLf & "objeto a mover:" & objeto
                    salida = salida & vbCrLf & "a la dirección:" & Actual_OU
                    salida = salida & vbCrLf & "Mover..."
                    Try
                        GenericClass.MoveTo(objeto, Actual_OU)
                    Catch ex As Exception When objeto = ""
                        MsgBox("Error al mover un objeto del directorio activo, el objeto no puede ser vacío " & ex.Message)
                        salida = salida & vbCrLf & "Error: al mover un objeto del directorio activo, el objeto no puede ser vacío " & ex.Message
                        HayError = True
                    Catch ex As Exception When Actual_OU = ""
                        MsgBox("Error al mover un objeto del directorio activo, la dirección a la que mover el objeto no puede ser vacía " & ex.Message)
                        salida = salida & vbCrLf & "Error: al mover un objeto del directorio activo, la dirección a la que mover el objeto no puede ser vacía " & ex.Message
                        HayError = True
                    Catch ex As Exception
                        MsgBox("Error al mover un objeto del directorio activo " & ex.Message)
                        salida = salida & vbCrLf & "Error: al mover un objeto del directorio activo " & ex.Message
                        HayError = True
                    End Try
                    salida = salida & vbCrLf & "objeto se ha movido"

                    'Log
                    GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
                    Me.Cursor = Cursors.Default
                    If Not HayError Then
                        Me.Close()
                    End If
                Else
                    MsgBox("No se puede mover un objeto a la raiz del directorio activo")
                End If
            Else
                MsgBox("No se ha seleccionado donde mover el objeto")
            End If

        Catch ex As Exception
            salida = salida & vbCrLf & "Error: al mover un objeto del directorio activo " & ex.Message
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
            End
        End Try
    End Sub
End Class