﻿Imports System
Imports System.IO
Imports System.Text.RegularExpressions

Public Class NuevoEquipo
    Public administrador As String
    Dim bool As Boolean = False
    Dim HayError As Boolean = False

    Public Property DN_OU As String
    Property MailBoxStore As String


    Friend Sub loadObjectAdmin(ByVal user As String)
        administrador = user

    End Sub

    Private Sub NuevoEquipo_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        '==========================================================================
        ' Name:     NuevoUsuario_FormClosing
        ' Purpose:  Actualizar Arbol al cerrar este formulario
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        Arbol.PropertiesClosed()
    End Sub

    '---------------------------------------------------------------------------------------------------------------------
    '--------------------------------------------------------------Paneles-------------------------------------------------
    'Carga del primer panel y de los demás al hacer click en el botón siguiente o atrás. Cancelar cierra la ventana sin hacer cambios
    Private Sub LoadNuevoUsuario(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '==========================================================================
        ' Name:     LoadNuevoUsuario
        ' Purpose:  Visualizar el panel inicial y ocultar los demás
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        NextButton.Text = "Siguiente>"
        NamePanel.Visible = True
        NamePanel.Dock = DockStyle.Fill
        ManagedByPanel.Visible = False
        ResumePanel.Visible = False
        NextButton.Enabled = False
        BackButton.Enabled = False
        'Establecer el Container donde crear el equipo
        OULabel.Text = DN_OU
        If UserMTextBox.Text = "" Then
            UserMTextBox.Text = "Default: Domain Admins"
        End If

    End Sub

    Private Sub NextButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NextButton.Click
        '==========================================================================
        ' Name:     NextButton_Click
        ' Purpose:  Cada vez que se hace click en next se avanza para visualizar el siguiente panel y en el úlltimo se llama a la función que crea el equipo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CrearEquipo
        '           computerExists de genericClass
        '==========================================================================
        If NamePanel.Visible = True Then
            Dim Name As String = NameTextBox.Text
            If GenericClass.ComputerExists(Name) Or UserClass.UserNameExists(Name) Or groupClass.GroupExists(Name) Then
                MsgBox("El nombre de equipo ya existe en el dominio." & vbNewLine & "Elija otro e intentelo de nuevo.", MsgBoxStyle.Exclamation, "Nuevo usuario")

            ElseIf Not checkRejexCName(Name) Then
                MsgBox("El nombre de equipo no tiene el formato adecuado, solo se pueden utilizar letras, números o el símbolo -" & vbNewLine & "Elija otro e intentelo de nuevo.", MsgBoxStyle.Exclamation, "Nuevo usuario")
            Else
                'Si el nombre de equipo no existe se muestra el siguiente panel y se ocultan los demás
                NamePanel.Dock = DockStyle.None
                ManagedByPanel.Dock = DockStyle.Fill
                ManagedByPanel.Visible = True
                NamePanel.Visible = False
                BackButton.Enabled = True
            End If
        ElseIf ManagedByPanel.Visible = True Then

            ResumePanel.Dock = DockStyle.Fill
            ManagedByPanel.Dock = DockStyle.None
            ResumePanel.Visible = True
            ManagedByPanel.Visible = False
            NextButton.Text = "Finalizar"

        ElseIf ResumePanel.Visible = True Then
            Me.Cursor = Cursors.WaitCursor
            crearequipo()
            Me.Cursor = Cursors.Default
            If Not HayError Then
                Me.Close()
            End If
        End If
    End Sub

    Private Sub BackButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles BackButton.Click
        '==========================================================================
        ' Name:     BackButton_Click
        ' Purpose:  Cada vez que se hace click en back se vuelve al panel anterior independientemente
        '           de lo que se haya escrito en sus campos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        If ManagedByPanel.Visible = True Then
            NamePanel.Dock = DockStyle.Fill
            ManagedByPanel.Dock = DockStyle.None
            NamePanel.Visible = True
            ManagedByPanel.Visible = False
        ElseIf ResumePanel.Visible = True Then
            NextButton.Text = "Siguiente >"
            ResumePanel.Dock = DockStyle.None
            ManagedByPanel.Dock = DockStyle.Fill
            ResumePanel.Visible = False
            ManagedByPanel.Visible = True
        End If
    End Sub

    Private Sub CancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        '==========================================================================
        ' Name:     CancelButton_Click
        ' Purpose:  Cerrar la ventana sin producir cambios
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Me.Close()
    End Sub

    Private Sub NameTextBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles NameTextBox.TextChanged
        '==========================================================================
        ' Name:     NameTextBox_TextChanged
        ' Purpose:  Cuando se escribe un nombre para el equipo se habilita el botón siguiente(Next)
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not NameTextBox.Text = "" Then
            NextButton.Enabled = True
        Else
            NextButton.Enabled = False
        End If

    End Sub

    Private Sub ChangeButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChangeButton.Click
        '==========================================================================
        ' Name:     NameTextBox_TextChanged
        ' Purpose:  Insertar un usuario o grupo en el textbox de administrador del equipo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        'Dim administrador As String

        'Llamar a la ventana que devuelve el usuario o grupo
        Añadir.Solo("usergroup")
        Añadir.ShowDialog()

        'MsgBox(Añadir.logU)
        administrador = Añadir.logU
        'Insertar su nombre canónico en el textbox
        If Not administrador = "" Then
            UserMTextBox.ReadOnly = False
            UserMTextBox.Text = UserClass.GetUserPropertyRefresh(administrador, "canonicalName")
            If UserMTextBox.Text = "" Then
                UserMTextBox.Text = groupClass.GetGroupPropertyRefresh(administrador, "canonicalName")
            End If
            UserMTextBox.ReadOnly = True
        End If

    End Sub

    Private Sub ResumePanel_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ResumePanel.VisibleChanged
        '==========================================================================
        ' Name:     ResumePanel_VisibleChanged
        ' Purpose:  Rellenar el cuadro de texto del panel Resumepanel
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If ResumePanel.Visible = True Then
            'Establecer datos a escribir en el cuadro de texto
            Dim fullName As String = ""
            Dim GUID As String = ""
            fullName = NameTextBox.Text
            GUID = GuidTextBox.Text
            'Escribirlos
            Dim resumen As String
            If Not GUID = "" Then
                resumen = "Full name: " & fullName & vbNewLine & "Este es un PC administrado: " & vbNewLine & "GUID:{" & GUID & "}"
            Else
                resumen = "Full name: " & fullName
            End If
            ResumeTextBox.Text = resumen
        End If

    End Sub

    Private Sub ManagedByCheckBox_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ManagedByCheckBox.CheckedChanged
        '==========================================================================
        ' Name:     ManagedByCheckBox_CheckedChanged
        ' Purpose:  Si se marca el checkbox de administrador de equipo se abilita el textbox del GUID de la máquina y si se desmarca el checkbox se deshabilita
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If ManagedByCheckBox.Checked Then
            GuidTextBox.Enabled = True
            Dim hexadec As Boolean = System.Text.RegularExpressions.Regex.IsMatch(GuidTextBox.Text, "\A\b[0-9a-fA-F]+\b\Z")
            If GuidTextBox.Text.Length = 32 And hexadec Then
                NextButton.Enabled = True
            Else
                NextButton.Enabled = False
            End If
        Else
            GuidTextBox.Enabled = False
            NextButton.Enabled = True
        End If

    End Sub

    Public Function crearequipo() As Boolean
        '==========================================================================
        ' Name:     crearequipo
        ' Purpose:  Función que crea el equipo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   1 Boolean: True si se ha creado el equipo correctamente, false en caso contrario
        ' Calls:    None
        '==========================================================================
        Try
            HayError = False
            Dim salida As String = "-------Crear Equipo-------" & vbCrLf & "Datos del Equipo"
            salida = salida & vbCrLf & "Nombre del equipo:" & NameTextBox.Text
            'Llamar a la función que crea el equipo en el container actual
            salida = salida & vbCrLf & "Se crea el equipo..."
            Try
                GenericClass.CreateComputer(NameTextBox.Text, DN_OU)
            Catch ex As Exception When NameTextBox.Text = ""
                MsgBox("Error al crear un nuevo equipo, el nombre del equipo no puede ser vacío " & ex.Message)
                salida = salida & vbCrLf & "Error: al crear un nuevo equipo, el nombre del equipo no puede ser vacío " & ex.Message
                HayError = True
                NamePanel.Visible = True
                NamePanel.Dock = DockStyle.Fill
                ManagedByPanel.Visible = False
                ResumePanel.Visible = False
                NextButton.Enabled = False
                BackButton.Enabled = False
            Catch ex As Exception When DN_OU = ""
                MsgBox("Error al crear un nuevo equipo, la dirección en la que crear el equipo no puede ser vacío " & ex.Message)
                salida = salida & vbCrLf & "Error: al crear un nuevo equipo, la dirección en la que crear el equipo no puede ser vacío " & ex.Message
                HayError = True
                NamePanel.Visible = True
                NamePanel.Dock = DockStyle.Fill
                ManagedByPanel.Visible = False
                ResumePanel.Visible = False
                NextButton.Enabled = False
                BackButton.Enabled = False
            Catch ex As Exception
                MsgBox("Error al crear un nuevo equipo " & ex.Message)
                salida = salida & vbCrLf & "Error: al crear un nuevo equipo " & ex.Message
                HayError = True
                NamePanel.Visible = True
                NamePanel.Dock = DockStyle.Fill
                ManagedByPanel.Visible = False
                ResumePanel.Visible = False
                NextButton.Enabled = False
                BackButton.Enabled = False
            End Try

            If GenericClass.ComputerExists(NameTextBox.Text) Then
                GenericClass.EnableAccount(NameTextBox.Text & "$")
                salida = salida & vbCrLf & "Equipo creado"
                'Si el equipo tiene un administrador darle los permisos para poder administar el equipo
                If Not UserMTextBox.Text.Contains("Default") Then
                    Try
                        GenericClass.RightsComputer(NameTextBox.Text & "$", administrador)
                    Catch ex As Exception When NameTextBox.Text = ""
                        MsgBox("Error al conceder permisos de administrador sobre el equipo a un objeto, el nombre del equipo no puede ser vacío " & ex.Message)
                        salida = salida & vbCrLf & "Error: al conceder permisos de administrador sobre el equipo a un objeto, el nombre del equipo no puede ser vacío " & ex.Message
                        HayError = True
                        NamePanel.Visible = True
                        NamePanel.Dock = DockStyle.Fill
                        ManagedByPanel.Visible = False
                        ResumePanel.Visible = False
                        NextButton.Enabled = False
                        BackButton.Enabled = False
                    Catch ex As Exception When administrador = ""
                        MsgBox("Error al conceder permisos de administrador sobre el equipo a un objeto, el objeto al que conceder permisos de administración sobre el equipo no puede ser vacío " & ex.Message)
                        salida = salida & vbCrLf & "Error: al conceder permisos de administrador sobre el equipo a un objeto, el objeto al que conceder permisos de administración sobre el equipo no puede ser vacío " & ex.Message
                        HayError = True
                        NamePanel.Dock = DockStyle.None
                        ManagedByPanel.Dock = DockStyle.Fill
                        ManagedByPanel.Visible = True
                        NamePanel.Visible = False
                        BackButton.Enabled = True
                    Catch ex As Exception
                        MsgBox("Error al conceder permisos de administrador sobre el equipo a un objeto " & ex.Message)
                        salida = salida & vbCrLf & "Error: al conceder permisos de administrador sobre el equipo a un objeto " & ex.Message
                        HayError = True
                        NamePanel.Dock = DockStyle.None
                        ManagedByPanel.Dock = DockStyle.Fill
                        ManagedByPanel.Visible = True
                        NamePanel.Visible = False
                        BackButton.Enabled = True
                    End Try
                    salida = salida & vbCrLf & "Administrador del equipo" & administrador
                End If
                'Si el equipo está administrado, insertar su GUID
                If ManagedByCheckBox.Checked Then
                    Try
                        'GenericClass.SetComputerProperty(NameTextBox.Text & "$", "objectGUID", GuidTextBox.Text)
                        GenericClass.SetComputerPropertyHex(NameTextBox.Text & "$", "netbootGUID", GuidTextBox.Text)
                    Catch ex As Exception When NameTextBox.Text = ""
                        MsgBox("Error al asignar el GUID al equipo, el nombre del equipo no puede ser vacío " & ex.Message)
                        salida = salida & vbCrLf & "Error: al asignar el GUID al equipo, el nombre del equipo no puede ser vacío " & ex.Message
                        HayError = True
                        NamePanel.Visible = True
                        NamePanel.Dock = DockStyle.Fill
                        ManagedByPanel.Visible = False
                        ResumePanel.Visible = False
                        NextButton.Enabled = False
                        BackButton.Enabled = False
                    Catch ex As Exception When GuidTextBox.Text = ""
                        MsgBox("Error al asignar el GUID al equipo, el GUID del equipo no puede ser vacío " & ex.Message)
                        salida = salida & vbCrLf & "Error: al asignar el GUID al equipo, el GUID del equipo no puede ser vacío " & ex.Message
                        HayError = True
                        NamePanel.Dock = DockStyle.None
                        ManagedByPanel.Dock = DockStyle.Fill
                        ManagedByPanel.Visible = True
                        NamePanel.Visible = False
                        BackButton.Enabled = True
                    Catch ex As Exception
                        MsgBox("Error al asignar el GUID al equipo " & ex.Message)
                        salida = salida & vbCrLf & "Error: al asignar el GUID al equipo " & ex.Message
                        HayError = True
                        NamePanel.Dock = DockStyle.None
                        ManagedByPanel.Dock = DockStyle.Fill
                        ManagedByPanel.Visible = True
                        NamePanel.Visible = False
                        BackButton.Enabled = True
                    End Try
                    salida = salida & vbCrLf & "GUID del equipo" & GuidTextBox.Text
                End If
                'Log
                GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
                Return True
            Else
                MsgBox("Error al crear al equipo.")
                Return False
            End If

        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Function

    Private Sub GuidTextBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GuidTextBox.TextChanged
        Dim hexadec As Boolean = System.Text.RegularExpressions.Regex.IsMatch(GuidTextBox.Text, "\A\b[0-9a-fA-F]+\b\Z")
        If GuidTextBox.Text.Length = 32 And hexadec Then
            NextButton.Enabled = True
        Else
            NextButton.Enabled = False
        End If
    End Sub

    Private Function checkRejexCName(ByVal strFindin As String) As Boolean
        Dim myRegex As New Regex("^([0-9a-zA-Z]|-)+$")
        If myRegex.IsMatch(strFindin) Then
            Return True
        Else
            Return False
        End If
    End Function
End Class