﻿Imports System.DirectoryServices
Imports System
Imports System.IO
Imports System.Text.RegularExpressions

Public Class NuevoGrupo

    Public Property DN_OU As String
    Dim HayError As Boolean = False

    Private Sub NuevoGrupo_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        '==========================================================================
        ' Name:     NuevoUsuario_FormClosing
        ' Purpose:  Actualizar Arbol al cerrar este formulario
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        Arbol.PropertiesClosed()
    End Sub

    Private Sub NuevoGrupo_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     NuevoGrupo_Load
        ' Purpose:  Visualizar el panel inicial y ocultar los demás
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        NextButton.Text = "Siguiente>"
        NamePanel.Visible = True
        NamePanel.Dock = DockStyle.Fill
        MailPanel.Visible = False
        ResumePanel.Visible = False
        NextButton.Enabled = False
        BackButton.Enabled = False
        DomLocalRadioButton.Checked = True
        SecurityRadioButton.Checked = True
        DomUniversalRadioButton.Enabled = False
        'Establecer el contenedor en el que crear el grupo
        OULabel.Text = DN_OU

    End Sub

    Private Sub NextButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NextButton.Click
        '==========================================================================
        ' Name:     NextButton_Click
        ' Purpose:  Cada vez que se hace click en next se avanza para visualizar el siguiente panel y en el úlltimo se llama a la función que crea el grupo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CrearGrupo
        '           groupExists de groupClass
        '==========================================================================

        If NamePanel.Visible = True Then
            Dim GroupName As String = GroupNameTextBox.Text
            If groupClass.GroupExists(GroupName) Then
                MsgBox("El nombre de grupo ya existe en el dominio." & vbNewLine & "Elija otro e intentelo de nuevo.", MsgBoxStyle.Exclamation, "Nuevo grupo")
            ElseIf UserClass.UserNameExists(GroupName) Then
                MsgBox("El nombre de grupo ya existe en el dominio." & vbNewLine & "Elija otro e intentelo de nuevo.", MsgBoxStyle.Exclamation, "Nuevo grupo")
            ElseIf GenericClass.ComputerExists(GroupName) Then
                MsgBox("El nombre de grupo ya existe en el dominio." & vbNewLine & "Elija otro e intentelo de nuevo.", MsgBoxStyle.Exclamation, "Nuevo grupo")
            ElseIf Not checkRejexUName(GroupName) Then
                MsgBox("El formato del nombre no es el adecuado, no se puede añadir \/[]:;|=,+*?<> o """)
            Else
                Dim lEx As List(Of String)
                lEx = GenericClass.CargarServidoresExch
                If lEx.Count = 0 Then
                    'Si los campos de panel de correo se han rellenado correctamente pasa al último panel
                    ResumePanel.Dock = DockStyle.Fill
                    NamePanel.Dock = DockStyle.None
                    ResumePanel.Visible = True
                    MailPanel.Visible = False
                    NamePanel.Visible = False
                    NextButton.Text = "Finalizar"
                Else
                    'Si el grupo no existe se pasa al siguiente panel
                    MailPanel.Dock = DockStyle.Fill
                    NamePanel.Dock = DockStyle.None
                    MailPanel.Visible = True
                    NamePanel.Visible = False
                    BackButton.Enabled = True
                    AliasTextBox.Enabled = False
                    AdminGroupComboBox.Enabled = False
                End If

            End If

        ElseIf MailPanel.Visible = True Then
            If ComprobarPanelCorreo() Then
                'Si los campos de panel de correo se han rellenado correctamente pasa al último panel
                ResumePanel.Dock = DockStyle.Fill
                MailPanel.Dock = DockStyle.None
                ResumePanel.Visible = True
                MailPanel.Visible = False
                NextButton.Text = "Finalizar"
            End If

        ElseIf ResumePanel.Visible = True Then
            'En el último panel se llama a la función que crea el grupo
            Me.Cursor = Cursors.WaitCursor
            CrearGrupo()
            Me.Cursor = Cursors.Default
            If Not HayError Then
                Me.Close()
            End If

        End If

    End Sub

    Private Sub BackButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles BackButton.Click
        '==========================================================================
        ' Name:     BackButton_Click
        ' Purpose:  Cada vez que se hace click en back se vuelve al panel anterior independientemente
        '           de lo que se haya escrito en sus campos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        If MailPanel.Visible = True Then
            NamePanel.Dock = DockStyle.Fill
            MailPanel.Dock = DockStyle.None
            NamePanel.Visible = True
            MailPanel.Visible = False
        ElseIf ResumePanel.Visible = True Then
            NextButton.Text = "Siguiente >"
            ResumePanel.Dock = DockStyle.None
            MailPanel.Dock = DockStyle.Fill
            ResumePanel.Visible = False
            MailPanel.Visible = True
        End If
    End Sub

    Private Sub CancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        '==========================================================================
        ' Name:     CancelButton_Click
        ' Purpose:  Cerrar la ventana sin producir cambios
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Me.Close()

    End Sub

    Private Sub ComprobarHabilitarBotonSiguiente()
        '==========================================================================
        ' Name:     ComprobarHabilitarBotonSiguiente
        ' Purpose:  Si de los radiobuttons que asignan el tipo de grupo hay alguno seleccionado y el textbox del nombre de grupo no es vacio se habilita el boton siguiente(Next)
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================

        If GroupNameTextBox.Text <> "" Then
            If DomGlobalRadioButton.Checked = True Or DomLocalRadioButton.Checked = True Then
                If DistributionRadioButton.Checked = True Or SecurityRadioButton.Checked = True Then
                    NextButton.Enabled = True
                Else
                    NextButton.Enabled = False
                End If
            Else
                NextButton.Enabled = False
            End If
        Else
            NextButton.Enabled = False
        End If

    End Sub

    '--------------------------------------------------------Panel nombre----------------------------------------------------------
    Private Sub GroupNameTextBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GroupNameTextBox.TextChanged
        '==========================================================================
        ' Name:     GroupNameTextBox_TextChanged
        ' Purpose:  Cuando se cambia el texto de GroupNameTextBox, a AliasTextBox se le asigna el mismo texto 
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        If GroupNameTextBox.Text = "" Then
            MsgBox("No se puede crear un grupo sin nombre")
            HayError = True
            NextButton.Enabled = False
        Else
            NextButton.Enabled = True
        End If
    End Sub

    Private Sub DistributionRadioButton_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles DistributionRadioButton.CheckedChanged
        '==========================================================================
        ' Name:     DistributionRadioButton_CheckedChanged
        ' Purpose:  Si se marca el radio button DistributionradioButton se deshabilita el DomUniversalRadioButton, habilitándose en caso contrario
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        If DistributionRadioButton.Checked = True Then
            DomUniversalRadioButton.Enabled = True
        Else
            DomUniversalRadioButton.Enabled = False
        End If
    End Sub

    '-----------------------------------------------Panel resumen/último-----------------------------------------------------------
    Private Function CrearGrupo()
        '==========================================================================
        ' Name:     CrearGrupo
        ' Purpose:  función que crea el grupo
        ' Input:    None
        ' Return:   1 Boolean: Devolverá True si el grupo se crea correctamente y false en caso contrario
        ' Calls:    CrateGroup, GroupExists de groupClass
        '==========================================================================
        Try
            Dim salida As String = "-------Crear Grupo-------" & vbCrLf & "Datos del Grupo"
            HayError = False
            Dim Domain As String
            'Establecer el tipo y Dominio del grupo
            Dim Type As String
            If DomLocalRadioButton.Checked = True Then
                Domain = "Local"
            ElseIf DomGlobalRadioButton.Checked = True Then
                Domain = "Global"
            ElseIf DomUniversalRadioButton.Checked = True Then
                Domain = "Universal"
            End If
            If SecurityRadioButton.Checked = True Then
                Type = "Security"
            ElseIf DistributionRadioButton.Checked = True Then
                Type = "Distribution"
            End If

            If GroupNameTextBox.Text = "" Then
                MsgBox("No se puede crear un grupo sin nombre")
                HayError = True
            Else
                salida = salida & vbCrLf & "Nombre del grupo:" & GroupNameTextBox.Text
                salida = salida & vbCrLf & "Tipo de dominio:" & Domain
                salida = salida & vbCrLf & "Tipo de grupo:" & Type

                'Llamada a la función que crea el grupo
                salida = salida & vbCrLf & "Comienzo de la creación del grupo..."
                Try
                    groupClass.CreateGroup(GroupNameTextBox.Text, Domain, Type, DN_OU)
                Catch ex As Exception When GroupNameTextBox.Text = ""
                    MsgBox("Error al crear el nuevo grupo, el nombre del grupo no puede ser vacío " & ex.Message)
                    salida = salida & vbCrLf & "Error: al crear el nuevo grupo, el nombre del grupo no puede ser vacío " & ex.Message
                    HayError = True
                    NextButton.Text = "Siguiente>"
                    MailCheckBox.Checked = False
                    NamePanel.Dock = DockStyle.Fill
                    ResumePanel.Dock = DockStyle.None
                    ResumePanel.Visible = False
                    NamePanel.Visible = True
                Catch ex As Exception When Domain = ""
                    MsgBox("Error al crear el nuevo grupo, el dominio no puede ser vacío " & ex.Message)
                    salida = salida & vbCrLf & "Error: al crear el nuevo grupo, el dominio no puede ser vacío " & ex.Message
                    HayError = True
                    NextButton.Text = "Siguiente>"
                    MailCheckBox.Checked = False
                    NamePanel.Dock = DockStyle.Fill
                    ResumePanel.Dock = DockStyle.None
                    ResumePanel.Visible = False
                    NamePanel.Visible = True
                Catch ex As Exception When Type = ""
                    MsgBox("Error al crear el nuevo grupo, el tipo no puede ser vacío " & ex.Message)
                    salida = salida & vbCrLf & "Error: al crear el nuevo grupo, el tipo no puede ser vacío " & ex.Message
                    HayError = True
                    NextButton.Text = "Siguiente>"
                    MailCheckBox.Checked = False
                    NamePanel.Dock = DockStyle.Fill
                    ResumePanel.Dock = DockStyle.None
                    ResumePanel.Visible = False
                    NamePanel.Visible = True
                Catch ex As Exception When DN_OU = ""
                    MsgBox("Error al crear el nuevo grupo, la direccíon en la que crear el nuevo grupo no puede ser vacío " & ex.Message)
                    salida = salida & vbCrLf & "Error: al crear el nuevo grupo, la direccíon en la que crear el nuevo grupo no puede ser vacío " & ex.Message
                    HayError = True
                    NextButton.Text = "Siguiente>"
                    MailCheckBox.Checked = False
                    NamePanel.Dock = DockStyle.Fill
                    ResumePanel.Dock = DockStyle.None
                    ResumePanel.Visible = False
                    NamePanel.Visible = True
                Catch ex As Exception
                    MsgBox("Error al crear el nuevo grupo " & ex.Message)
                    salida = salida & vbCrLf & "Error: al crear el nuevo grupo " & ex.Message
                    HayError = True
                    NextButton.Text = "Siguiente>"
                    MailCheckBox.Checked = False
                    NamePanel.Dock = DockStyle.Fill
                    ResumePanel.Dock = DockStyle.None
                    ResumePanel.Visible = False
                    NamePanel.Visible = True
                End Try

            End If

            If groupClass.GroupExists(GroupNameTextBox.Text) Then
                'Si se ha creado correctamente
                salida = salida & vbCrLf & "grupo creado correctamente"
                'Log
                GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
                If MailCheckBox.Checked Then
                    Try
                        MailClass.Group_MailEnable(GroupNameTextBox.Text, AdminGroupComboBox.SelectedItem.ToString, AliasTextBox.Text)
                    Catch ex As Exception
                        MsgBox("Error al habilitar el correo al grupo " & ex.Message)
                        salida = salida & vbCrLf & "Error: al habilitar el correo al grupo " & ex.Message
                        HayError = True
                        NamePanel.Dock = DockStyle.Fill
                        ResumePanel.Dock = DockStyle.None
                        ResumePanel.Visible = False
                        NamePanel.Visible = True
                    End Try
                End If

        Return True
            Else
        MsgBox("Error al crear al usuario.")
        Return False
            End If

        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Function

    Private Sub ResumePanel_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ResumePanel.VisibleChanged
        '==========================================================================
        ' Name:     ResumePanel_VisibleChanged
        ' Purpose:  Rellenar el cuadro de texto del ResumePanel
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CrateGroup, GroupExists de groupClass
        '==========================================================================
        If ResumePanel.Visible = True Then
            'Escribir el nombre del grupo
            Dim resumen As String = "Full name: " & GroupNameTextBox.Text

            ResumeTextBox.Text = resumen
        End If
    End Sub

    '-----------------------------------------------Panel mail-----------------------------------------------------------
    Private Sub MailCheckBox_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles MailCheckBox.CheckedChanged
        '==========================================================================
        ' Name:     MailboxCheckBox_CheckedChanged
        ' Purpose:  Controlar cambios al marcar el checkbox del panel de mail
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    LimpiarComboBox, CargarServidores
        '==========================================================================
        If MailCheckBox.Checked = False Then
            'Si se se quita la marca del checkbox se llama a la función que elimina los valores del combobox
            LimpiarComboBox()
            AliasTextBox.Enabled = False
            AdminGroupComboBox.Enabled = False
            AliasTextBox.Text = ""
        Else
            'Si se marca el checkbox se llama a la función que establece los valores del combobox
            CargarServidores()
            AliasTextBox.Enabled = True
            AdminGroupComboBox.Enabled = True

        End If
    End Sub

    Private Sub LimpiarComboBox()
        '==========================================================================
        ' Name:     LimpiarComboBox
        ' Purpose:  Quitar los elementos de ServerCombobox
        ' Input:    None
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        AdminGroupComboBox.Items.Clear()
        AdminGroupComboBox.Text = ""

    End Sub

    Private Sub CargarServidores()
        '==========================================================================
        ' Name:     CargarServidores
        ' Purpose:  Añadir elementos a ServerCombobox
        ' Input:    none
        ' Return:   None
        ' Calls:    CargarServidoresGeneral de GenericClass
        '==========================================================================
        Me.Cursor = Cursors.WaitCursor
        Dim servidores As New List(Of String)
        'Obtener los servidores del dominio
        'servidores = GenericClass.CargarServidoresGeneral()
        servidores = GenericClass.CargarGruposAdmin
        'Añadir sus nombres al combobox
        For i = 0 To servidores.Count - 1
            AdminGroupComboBox.Items.Add(servidores(i))
        Next
        Me.Cursor = Cursors.Default
    End Sub

    Private Function ComprobarPanelCorreo() As Boolean
        '==========================================================================
        ' Name:     ComprobarPanelCorreo
        ' Purpose:  Si ninguno de los campos del panel de mail es vacio, devuleve true
        ' Input:    None
        ' Return:   Si no hay campos vacios en el panel se devuelve true, sino false
        ' Calls:    None
        '==========================================================================

        If MailCheckBox.Checked = True Then
            If AliasTextBox.Text <> "" And AdminGroupComboBox.Text <> "" Then
                Return True
            Else
                MsgBox("Es necesario rellenar todos los campos")
                Return False
            End If
        Else
            Return True
        End If

    End Function

    Private Function checkRejexUName(ByVal strFindin As String) As Boolean
        Dim myRegex As New Regex("^([^\\/\[\]:;\|=,\+\*\?<""])+$")
        If myRegex.IsMatch(strFindin) Then
            Return True
        Else
            Return False
        End If
    End Function
End Class