﻿Imports System.Text.RegularExpressions

Public Class NuevoNombreUsuario
    Dim Usuario As String

    Friend Sub LoadUser(ByVal User As String)
        '==========================================================================
        ' Name:     LoadUser
        ' Purpose:  Establecer el usuario del que manipular los datos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Usuario = User
    End Sub

    Private Sub CancelButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        '==========================================================================
        ' Name:     CancelButton_Click
        ' Purpose:  Cerrar la ventana sin hacer cambios
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Me.Close()
    End Sub

    Private Sub NuevoNombreUsuario_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     ApplyButton_Click
        ' Purpose:  Cargar los campos de la ventana
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    GetUserProperty de UserClass
        '==========================================================================
        'Obtener datos generales e insertarlos en los texbox, checkbox...
        NameTextBox.Text = UserClass.GetUserProperty(Usuario, "givenName")
        SurNameTextBox.Text = UserClass.GetUserProperty(Usuario, "sn")
        FullNameTextBox.Text = UserClass.GetUserProperty(Usuario, "cn")
        DisplayNameTextBox.Text = UserClass.GetUserProperty(Usuario, "DisplayName")
        UserLogNameTextBox.Text = UserClass.GetUserProperty(Usuario, "sAMAccountName")
    End Sub

    Private Sub AcceptButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Llevar a cabo los cambios efectuados en las opciones sin cerrar la ventana
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    SetUserProperty, ClearUserProperty de UserClass
        '           Rename de GenericClass
        '==========================================================================
        Dim HayError As Boolean = False
        If UserLogNameTextBox.Text = "" Then
            MsgBox("El nombre de Login del usuario debe tener algún valor")
            HayError = True
        Else
            If UserLogNameTextBox.Text = Usuario Then
                MsgBox("El nombre de login que se le quiere signar al objeto es el mismo que ya tiene")
            Else
                If Not checkRejexUName(UserLogNameTextBox.Text) Then
                    MsgBox("El nombre de usuario incluye caracteres no permitidos, no puede contener \/[]:;|=,+*?<>@""")
                Else
                    Try
                        UserClass.SetUserProperty(Usuario, "sAMAccountName", UserLogNameTextBox.Text)
                        Usuario = UserLogNameTextBox.Text
                        UserClass.SetUserProperty(Usuario, "userPrincipalName", UserLogNameTextBox.Text & "@" & Settings.userDNSDomain)
                    Catch ex As Exception When UserLogNameTextBox.Text = ""
                        HayError = True
                        MsgBox("Error al intentar asignar el nombre de login al usuario, no se le puede asignar un string vacío " & ex.Message)
                    Catch ex As Exception
                        HayError = True
                        MsgBox("Error al intentar asignar el nombre de login al usuario " & ex.Message)
                    End Try
                End If
            End If

        End If

        If NameTextBox.Text = "" Then
            Try
                UserClass.ClearUserProperty(Usuario, "givenName")
            Catch ex As Exception
                HayError = True
                MsgBox("Error al intentar eliminar el nombre al usuario " & ex.Message)
            End Try
        Else
            Try
                UserClass.SetUserProperty(Usuario, "givenName", NameTextBox.Text)
            Catch ex As Exception
                HayError = True
                MsgBox("Error al intentar asignar el nombre al usuario " & ex.Message)
            End Try
        End If

        If SurNameTextBox.Text = "" Then
            Try
                UserClass.ClearUserProperty(Usuario, "sn")
            Catch ex As Exception
                HayError = True
                MsgBox("Error al intentar eliminar los apellidos al usuario " & ex.Message)
            End Try
        Else
            Try
                UserClass.SetUserProperty(Usuario, "sn", SurNameTextBox.Text)
            Catch ex As Exception
                HayError = True
                MsgBox("Error al intentar asignar los apellidos al usuario " & ex.Message)
            End Try
        End If

        If DisplayNameTextBox.Text = "" Then
            Try
                UserClass.ClearUserProperty(Usuario, "DisplayName")
            Catch ex As Exception
                HayError = True
                MsgBox("Error al intentar eliminar el nombre de Display al usuario " & ex.Message)
            End Try
        Else
            Try
                UserClass.SetUserProperty(Usuario, "DisplayName", DisplayNameTextBox.Text)
            Catch ex As Exception
                HayError = True
                MsgBox("Error al intentar asignar el nombre de Display al usuario " & ex.Message)
            End Try
        End If

        If FullNameTextBox.Text = "" Then
            MsgBox("El FullName (nombre completo) debe tener algún valor")
            HayError = True
        Else
            If FullNameTextBox.Text = UserClass.GetUserProperty(Usuario, "cn") Then
                MsgBox("El FullName (nombre completo) que se quiere asignar al usuario es el mismo que ya tiene")
            Else
                If Not checkRejexUName(FullNameTextBox.Text) Then
                    MsgBox("El nombre de usuario incluye caracteres no permitidos, no puede contener \/[]:;|=,+*?<>@""")
                Else
                    Try
                        GenericClass.Rename(Usuario, FullNameTextBox.Text, "User")
                    Catch ex As Exception When FullNameTextBox.Text = ""
                        HayError = True
                        MsgBox("Error al intentar asignar el nombre completo al usuario, no se le puede asignar un string vacío " & ex.Message)
                    Catch ex As Exception
                        HayError = True
                        MsgBox("Error al intentar asignar el nombre completo al usuario " & ex.Message)
                    End Try
                End If
            End If
        End If

        If Not HayError Then
            Me.Close()
        End If
    End Sub

    Private Function checkRejexUName(ByVal strFindin As String) As Boolean
        Dim myRegex As New Regex("^([^\\/\[\]:;\|=,\+\*\?<@""])+$")
        If myRegex.IsMatch(strFindin) Then
            Return True
        Else
            Return False
        End If
    End Function
End Class