﻿Imports System.DirectoryServices
Imports System
Imports System.IO
Imports System.Text.RegularExpressions

Public Class NuevoUsuario

    Public Property DN_OU As String
    Property MailBoxStore As String
    Dim HayError As Boolean = False

    Private Sub NuevoUsuario_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        '==========================================================================
        ' Name:     NuevoUsuario_FormClosing
        ' Purpose:  Actualizar Arbol al cerrar este formulario
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        Arbol.PropertiesClosed()
    End Sub
    '---------------------------------------------------------------------------------------------------------------------
    '--------------------------------------------------------------Paneles-------------------------------------------------
    'Carga del primer panel y de los demás al hacer click en el botón siguiente o atrás. Cancelar cierra la ventana sin hacer cambios
    Private Sub LoadNuevoUsuario(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '==========================================================================
        ' Name:     LoadNuevoUsuario
        ' Purpose:  Visualizar el panel inicial y ocultar los demás
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        NextButton.Text = "Siguiente>"
        NamePanel.Visible = True
        NamePanel.Dock = DockStyle.Fill
        PasswordPanel.Visible = False
        MailPanel.Visible = False
        ResumePanel.Visible = False
        NextButton.Enabled = False
        BackButton.Enabled = False
        'Establecer el container en el que se va a crear el usuario
        OULabel.Text = DN_OU

    End Sub

    Private Sub NextButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NextButton.Click
        '==========================================================================
        ' Name:     NextButton_Click
        ' Purpose:  Cada vez que se hace click en next se avanza para visualizar el siguiente panel y en el úlltimo se llama a la función que crea el usuario
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CrearUsuario, ComprobarContraseñas, Comprobar Panel correo
        '           UserExists de UserClass
        '==========================================================================
        If NamePanel.Visible = True Then
            Dim LogonName As String = LogonNameTextBox.Text
            If UserClass.UserExists(LogonName) Then
                MsgBox("El nombre de usuario ya existe en el dominio." & vbNewLine & "Elija otro e intentelo de nuevo.", MsgBoxStyle.Exclamation, "Nuevo usuario")
            Else
                If checkRejexUName(LogonName) Then
                    If Not checkRejexUName(FullNameTextBox.Text) Then
                        MsgBox("El formato de los nombres no es el adecuado, no se puede añadir \/[]:;|=,+*?<>@ o """)
                    Else
                        'Si elnombre de usuario elegido no existe en el dominio se pasa al siguiente panel
                        NamePanel.Dock = DockStyle.None
                        PasswordPanel.Dock = DockStyle.Fill
                        PasswordPanel.Visible = True
                        NamePanel.Visible = False
                        BackButton.Enabled = True
                    End If
                Else
                    MsgBox("El formato de los nombres no es el adecuado, no se puede añadir \/[]:;|=,+*?<>@ o """)
                End If
            End If
        ElseIf PasswordPanel.Visible = True Then
            If ComprobarPasswords() Then
                Dim lEx As List(Of String)
                lEx = GenericClass.CargarServidoresExch
                If lEx.Count = 0 Then
                    'Si los campos de panel de correo se han rellenado correctamente pasa al último panel
                    ResumePanel.Dock = DockStyle.Fill
                    PasswordPanel.Dock = DockStyle.None
                    ResumePanel.Visible = True
                    PasswordPanel.Visible = False
                    NextButton.Text = "Finalizar"
                Else
                    'Si las contraseñas insertadas en el panel de contraseñas no coinciden se pasa al siguiente panel
                    MailPanel.Dock = DockStyle.Fill
                    PasswordPanel.Dock = DockStyle.None
                    MailPanel.Visible = True
                    PasswordPanel.Visible = False
                End If


            Else
                Dim mensaje As String = "Las contraseñas no coinciden o no tienen nigún valor asignado."
                MsgBox(mensaje, MsgBoxStyle.OkOnly, "Active Directory")
                PasswordTextBox.Text = ""
                ConfirmPasswordTextBox.Text = ""
            End If
        ElseIf MailPanel.Visible = True Then
            If ComprobarPanelCorreo() Then
                'Si los campos de panel de correo se han rellenado correctamente pasa al último panel
                ResumePanel.Dock = DockStyle.Fill
                MailPanel.Dock = DockStyle.None
                ResumePanel.Visible = True
                MailPanel.Visible = False
                NextButton.Text = "Finalizar"
            End If
        ElseIf ResumePanel.Visible = True Then
            'En el último panel se llama a la función que crea el usuario
            Me.Cursor = Cursors.WaitCursor
            If Not CrearUsuario() Then
                Me.Cursor = Cursors.Default
                NextButton.Text = "Siguiente>"
                NamePanel.Dock = DockStyle.Fill
                PasswordPanel.Dock = DockStyle.None
                PasswordPanel.Visible = False
                NamePanel.Visible = True
                BackButton.Enabled = False
            Else
                Me.Cursor = Cursors.Default
                If Not HayError Then
                    Me.Close()
                End If
            End If

        End If
    End Sub

    Private Sub BackButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles BackButton.Click
        '==========================================================================
        ' Name:     BackButton_Click
        ' Purpose:  Cada vez que se hace click en back se vuelve al panel anterior independientemente
        '           de lo que se haya escrito en sus campos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        If PasswordPanel.Visible = True Then
            PasswordPanel.Dock = DockStyle.None
            NamePanel.Dock = DockStyle.Fill
            PasswordPanel.Visible = False
            NamePanel.Visible = True
            BackButton.Enabled = False
        ElseIf MailPanel.Visible = True Then
            PasswordPanel.Dock = DockStyle.Fill
            MailPanel.Dock = DockStyle.None
            PasswordPanel.Visible = True
            MailPanel.Visible = False
        ElseIf ResumePanel.Visible = True Then
            NextButton.Text = "Siguiente >"
            ResumePanel.Dock = DockStyle.None
            MailPanel.Dock = DockStyle.Fill
            ResumePanel.Visible = False
            MailPanel.Visible = True
        End If
    End Sub

    Private Sub CancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        '==========================================================================
        ' Name:     CancelButton_Click
        ' Purpose:  Cerrar la ventana sin producir cambios
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Me.Close()

    End Sub

    '-----------------------------------------------------------------------------------------------------------------------
    '----------------------------------------------------Control panel password---------------------------------------------------------------
    Private Function ComprobarPasswords() As Boolean
        '==========================================================================
        ' Name:     ComprobarPasswords()
        ' Purpose:  Comprobar que los dos textbox de las contraseñas del panel password tienen el mismo texto escrito
        ' Input:    none
        ' Return:   1 Boolean: True si en los dos textbox está escrito lo mismo, false en caso contrario
        ' Calls:    None
        '==========================================================================

        If PasswordTextBox.Text = ConfirmPasswordTextBox.Text Then
            If Not PasswordTextBox.Text = "" Then
                Return True
            Else
                Return False
            End If
        Else
            Return False
        End If

    End Function

    Private Sub PassChangeCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PassChangeCheckBox.CheckedChanged
        If PassChangeCheckBox.Checked = True And NeverExpiresPassCheckBox.Checked = True Then
            Dim mensaje As String = "Has establecido que el password nunca expira." & vbNewLine & "El usuario no deberá cambiar el password al acceder la siguiente vez."
            MsgBox(mensaje, MsgBoxStyle.OkOnly, "Directorio Activo")
            PassChangeCheckBox.Checked = False
        ElseIf PassChangeCheckBox.Checked = True And CannotPassCheckBox.Checked = True Then
            Dim mensaje As String = "Si el usuario tiene que cambiar el password en el siguiente acceso, no puede establecer que ese mismo usuario no pueda cambiar el password."
            MsgBox(mensaje, MsgBoxStyle.OkOnly, "Directorio Activo")
            CannotPassCheckBox.Checked = False
        End If
    End Sub

    Private Sub CannotChangePassCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CannotPassCheckBox.CheckedChanged
        If PassChangeCheckBox.Checked = True And CannotPassCheckBox.Checked = True Then
            Dim mensaje As String = "Si el usuario tiene que cambiar el password en el siguiente acceso, no puede establecer que ese mismo usuario no pueda cambiar el password."
            MsgBox(mensaje, MsgBoxStyle.OkOnly, "Directorio Activo")
            CannotPassCheckBox.Checked = False
        End If
    End Sub

    Private Sub PassNeverExpiresCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeverExpiresPassCheckBox.CheckedChanged
        If PassChangeCheckBox.Checked = True And NeverExpiresPassCheckBox.Checked = True Then
            Dim mensaje As String = "Si se establece que la contraseña del usuario no expira nunca." & vbNewLine & "El usuario no podrá cambiar el password en el siguiente acceso."
            MsgBox(mensaje, MsgBoxStyle.OkOnly, "Directorio Activo")
            PassChangeCheckBox.Checked = False
        End If
    End Sub


    '-----------------------------------------------------------------------------------------------------------------------------
    '----------------------------------------------------Control primer panel------------------------------------------------------
    Private Sub FirstNameTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FirstNameTextBox.TextChanged
        '==========================================================================
        ' Name:     FirstNameTextBox_TextChanged
        ' Purpose:  Si cambia el texto del firstNametextbox del usuario se llama a actualizar el de el fullNametxtbox
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    ActualizarFullNameTextBox
        '==========================================================================
        ActualizarFullNameTextBox()
    End Sub

    Private Sub LastNameTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LastNameTextBox.TextChanged
        '==========================================================================
        ' Name:     FirstNameTextBox_TextChanged
        ' Purpose:  Si cambia el texto del LastNametextbox del usuario se llama a actualizar el de el fullNametxtbox
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    ActualizarFullNameTextBox
        '==========================================================================
        ActualizarFullNameTextBox()
    End Sub

    Private Sub ActualizarFullNameTextBox()
        '==========================================================================
        ' Name:     ActualizarFullNameTextBox
        ' Purpose:  Si cambia el texto del firstNametextbox o LastNameTextbox del usuario se actualiza fullNametxtbox,
        '           ya que es una combinación del texto de ambos
        ' Input:    None
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        'If LastNameTextBox.Text <> "" Then
        '    FullNameTextBox.Text = LastNameTextBox.Text & FirstNameTextBox.Text
        'Else
        '    FullNameTextBox.Text = FirstNameTextBox.Text
        'End If
        If FirstNameTextBox.Text = "" Then
            FullNameTextBox.Text = LastNameTextBox.Text
        Else
            FullNameTextBox.Text = FirstNameTextBox.Text & " " & LastNameTextBox.Text
        End If

    End Sub

    Private Sub LogonNameTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LogonNameTextBox.TextChanged
        '==========================================================================
        ' Name:     LogonNameTextBox_TextChanged
        ' Purpose:  Una vez cambia el texto de Logon NameTextbox, se llama a la función que comprueba si se ha de habilitar el botón siguiente(Next)
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    ComprobarHabilitarBotonSiguiente
        '==========================================================================
        ComprobarHabilitarBotonSiguiente()
    End Sub

    Private Sub FullNameTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FullNameTextBox.TextChanged
        '==========================================================================
        ' Name:     fullNameTextBox_TextChanged
        ' Purpose:  Una vez cambia el texto de fullNameTextbox, se llama a la función que comprueba si se ha de habilitar el botón siguiente(Next)
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    ComprobarHabilitarBotonSiguiente
        '==========================================================================
        ComprobarHabilitarBotonSiguiente()
    End Sub

    Private Sub ComprobarHabilitarBotonSiguiente()
        '==========================================================================
        ' Name:     ComprobarHabilitarBotonSiguiente
        ' Purpose:  Si los textbox fullnameTextbox y LogonNameTexbox no están vacios se habilita el boton siguiente(Next)
        ' Input:    None
        ' Return:   None
        ' Calls:    none
        '==========================================================================
            If FullNameTextBox.Text <> "" And LogonNameTextBox.Text <> "" Then
                NextButton.Enabled = True
            Else
                NextButton.Enabled = False
            End If

    End Sub

    '---------------------------------------------------------------------------------------------------------------------------------
    '-----------------------------------------------------Control panel del mail------------------------------------------------------
    Private Sub CrearBuzon()
        '==========================================================================
        ' Name:     CrearBuzon
        ' Purpose:  Se obtiene la dirección del usuario reciencreado y se llama a la función que crea su buzón 
        ' Input:    None
        ' Return:   None
        ' Calls:    GetUserDN de UserClass
        '           CreateMailbox de MailClass
        '==========================================================================

        Dim UserDN As String = UserClass.GetUserDN(LogonNameTextBox.Text)
        If MailClass.CreateMailbox(UserDN, MailBoxStore) Then
            'MsgBox("Buzon creado correctamente para el usuario " & LogonNameTextBox.Text)
        Else
            MsgBox("Error al crear el buzon para el usuario " & LogonNameTextBox.Text)
        End If

    End Sub

    Private Function ComprobarPanelCorreo() As Boolean
        '==========================================================================
        ' Name:     ComprobarPanelCorreo
        ' Purpose:  Si ninguno de los campos del panel de mail es vacio, devuleve true
        ' Input:    None
        ' Return:   Si no hay campos vacios en el panel se devuelve true, sino false
        ' Calls:    None
        '==========================================================================

        If MailBoxCheckBox.Checked = True Then
            If AliasTextBox.Text <> "" And ServerComboBox.Text <> "" And MailboxStoreComboBox.Text <> "" Then
                Return True
            Else
                MsgBox("Es necesario rellenar todos los campos")
                Return False
            End If
        Else
            Return True
        End If

    End Function

    Private Sub MailboxCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MailBoxCheckBox.CheckedChanged
        '==========================================================================
        ' Name:     MailboxCheckBox_CheckedChanged
        ' Purpose:  Controlar cambios al marcar el checkbox del panel de mail
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    LimpiarComboBox, CargarServidores
        '==========================================================================
        If MailBoxCheckBox.Checked = False Then
            'Si se se quita la marca del checkbox se llama a la función que elimina los valores del combobox
            LimpiarComboBox()
            AliasTextBox.Enabled = False
            ServerComboBox.Enabled = False
            MailboxStoreComboBox.Enabled = False
        Else
            'Si se marca el checkbox se llama a la función que establece los valores del combobox
            CargarServidores()
            AliasTextBox.Enabled = True
            ServerComboBox.Enabled = True
            MailboxStoreComboBox.Enabled = True
        End If
    End Sub

    Private Sub LimpiarComboBox()
        '==========================================================================
        ' Name:     LimpiarComboBox
        ' Purpose:  Quitar los elementos de ServerCombobox
        ' Input:    None
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        ServerComboBox.Items.Clear()
        MailboxStoreComboBox.Items.Clear()
        ServerComboBox.Text = ""
        MailboxStoreComboBox.Text = ""
    End Sub

    Private Sub CargarServidores()
        '==========================================================================
        ' Name:     CargarServidores
        ' Purpose:  Añadir elementos a ServerCombobox
        ' Input:    none
        ' Return:   None
        ' Calls:    CargarServidoresGeneral de GenericClass
        '==========================================================================
        Me.Cursor = Cursors.WaitCursor
        Dim servidores As New List(Of String)
        'Obtener los servidores del dominio
        'servidores = GenericClass.CargarServidoresGeneral()
        servidores = GenericClass.CargarServidoresExch
        'Añadir sus nombres al combobox
        For i = 0 To servidores.Count - 1
            ServerComboBox.Items.Add(servidores(i))
        Next
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub ServidorComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ServerComboBox.SelectedIndexChanged
        '==========================================================================
        ' Name:     ServidorComboBox_SelectedIndexChanged
        ' Purpose:  Cambios que se producen al seleccionar un elmento de ServerCombobox
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CargarMailboxStores
        '==========================================================================
        'Se llama a la función que carga el combobox de Mailboxstores
        'MailboxStoreComboBox.SelectedIndex = -1
        Me.Cursor = Cursors.WaitCursor
        CargarMailboxStores()
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub CargarMailboxStores()
        '==========================================================================
        ' Name:     CargarMailboxStores
        ' Purpose:  Añadir elementos a MailboxStoreCombobox
        ' Input:    None
        ' Return:   None
        ' Calls:    CargarMailbox de GenericClass
        '==========================================================================
            Dim salida As New List(Of String)
            'Se obtienen los mailboxStores del servidor seleccionado en el combobox anterior
            salida = GenericClass.CargarMailBoxes(ServerComboBox.SelectedItem.ToString)
            'Se añaden sus nombres al combobox
        MailboxStoreComboBox.Items.Clear()
        For i = 0 To salida.Count - 1
            MailboxStoreComboBox.Items.Add(salida(i))
        Next

    End Sub

    Private Sub MailboxStoreComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MailboxStoreComboBox.SelectedIndexChanged
        '==========================================================================
        ' Name:     MailboxStoreComboBox_SelectedIndexChanged
        ' Purpose:  Al cambiar el elemento seleccionado del mailboxstoreCombobox se actualiza la variable MailboxStore
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CargarMailbox de GenericClass
        '==========================================================================
        Me.MailBoxStore = GenericClass.GetMailBoxStoreName(ServerComboBox.SelectedItem.ToString, MailboxStoreComboBox.SelectedItem.ToString)

    End Sub


    '-----------------------------------------------------------------------------------------------------------------------
    '----------------------------------------------------Control panel último/Resumen---------------------------------------------------------------
    Private Sub ResumePanel_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ResumePanel.VisibleChanged
        '==========================================================================
        ' Name:     ResumePanel_VisibleChanged
        ' Purpose:  Cambios que se producen al visibiliazar el Panel Resume en su cuadro de texto
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        If ResumePanel.Visible = True Then
            'Establecer el texto a escribir en el cuadro de texto
            Dim MustChangePass As String = ""
            Dim PassNeverExpires As String = ""
            Dim CannotChangePass As String = ""
            Dim AccountDisabled As String = ""
            Dim CreateMailbox As String = ""

            If PassChangeCheckBox.Checked = True Then
                MustChangePass = "El usuario ha de cambiar el password en el siguiente Login"
            End If
            If NeverExpiresPassCheckBox.Checked = True Then
                PassNeverExpires = "El password nunca expira"
            End If
            If CannotPassCheckBox.Checked = True Then
                CannotChangePass = "El usuario no puede cambiar el password"
            End If
            If DisabledAccountCheckBox.Checked = True Then
                AccountDisabled = "La cuenta está deshabilitada"
            End If

            'Escribirlo
            If MailBoxCheckBox.Checked = True Then
                CreateMailbox = "Alias: " & AliasTextBox.Text & vbNewLine
                CreateMailbox = CreateMailbox & "Se creara un buzon de Exchange en el almacen " & vbNewLine
                Dim serv() As String = ServerComboBox.Text.Split("/")
                CreateMailbox = CreateMailbox & serv(serv.Count - 1) & "/" & MailboxStoreComboBox.Text & vbNewLine
            End If
            Dim resumen As String = "Full name: " & FullNameTextBox.Text & vbNewLine & "User logon name: " & LogonNameTextBox.Text & vbNewLine & MustChangePass & vbNewLine & PassNeverExpires & vbNewLine & CannotChangePass & vbNewLine & AccountDisabled & vbNewLine & CreateMailbox

            ResumeTextBox.Text = resumen
        End If
    End Sub

    '------------------------------------------------------------------------------------------------------------------------------------
    '-------------------------------------------------Al hacer click en finalizar(Botón next que cambia de nombre en el panel último/resumen)--------------------------------------------------------
    Private Function CrearUsuario()
        '==========================================================================
        ' Name:     CrearUsuario
        ' Purpose:  función que crea el usuario
        ' Input:    None
        ' Return:   1 Boolean: Devolverá True si el usuario se crea correctamente y false en caso contrario
        ' Calls:    none
        '==========================================================================
        Try
            HayError = False
            Dim salida As String = "-------Crear Usuario-------" & vbCrLf & "Datos del Usuario"
            'Establecer sus datos
            Dim atributosHashTable As New Hashtable
            atributosHashTable.Add("givenName", FirstNameTextBox.Text)
            atributosHashTable.Add("sn", LastNameTextBox.Text)
            atributosHashTable.Add("displayName", FullNameTextBox.Text)
            atributosHashTable.Add("samAccountName", LogonNameTextBox.Text)
            atributosHashTable.Add("password", PasswordTextBox.Text)
            atributosHashTable.Add("HomeMDB", MailBoxStore)
            atributosHashTable.Add("mailNickname", AliasTextBox.Text)
            salida = salida & vbCrLf & "nombre:" & FirstNameTextBox.Text & vbCrLf &
                "apellido:" & LastNameTextBox.Text & vbCrLf &
                "nombre de login:" & LogonNameTextBox.Text & vbCrLf &
                "password:" & PasswordTextBox.Text
            salida = salida & vbCrLf & "Creando el usuario..."
            'Llamar a la función que crea la cuenta de usuario
            If Not UserClass.UserExists(LogonNameTextBox.Text) Then
                Try
                    UserClass.CreateAdAccount2(LogonNameTextBox.Text, PasswordTextBox.Text, FirstNameTextBox.Text, DN_OU, FullNameTextBox.Text)
                Catch ex As Exception When LogonNameTextBox.Text = ""
                    MsgBox("Error al crear el usuario, el nombre de login no puede ser vacio " & ex.Message)
                    salida = salida & vbCrLf & "Error: al crear el usuario, el nombre de login no puede ser vacio " & ex.Message
                    HayError = True
                    PasswordPanel.Dock = DockStyle.None
                    NamePanel.Dock = DockStyle.Fill
                    PasswordPanel.Visible = False
                    NamePanel.Visible = True
                    BackButton.Enabled = True
                Catch ex As Exception When PasswordTextBox.Text = ""
                    MsgBox("Error al crear el usuario, el password no puede ser vacio " & ex.Message)
                    salida = salida & vbCrLf & "Error: al crear el usuario, el password no puede ser vacio " & ex.Message
                    HayError = True
                    NamePanel.Dock = DockStyle.None
                    PasswordPanel.Dock = DockStyle.Fill
                    PasswordPanel.Visible = True
                    NamePanel.Visible = False
                    BackButton.Enabled = True
                Catch ex As Exception When DN_OU = ""
                    MsgBox("Error al crear el usuario, la dirección en la que se crea el nuevo usuario no puede ser vacio " & ex.Message)
                    salida = salida & vbCrLf & "Error: al crear el usuario, la dirección en la que se crea el nuevo usuario no puede ser vacio " & ex.Message
                    HayError = True
                    PasswordPanel.Dock = DockStyle.None
                    NamePanel.Dock = DockStyle.Fill
                    PasswordPanel.Visible = False
                    NamePanel.Visible = True
                    BackButton.Enabled = True
                Catch ex As Exception
                    MsgBox("Error al crear el usuario " & ex.Message)
                    salida = salida & vbCrLf & "Error: al crear el usuario " & ex.Message
                    HayError = True
                    PasswordPanel.Dock = DockStyle.None
                    NamePanel.Dock = DockStyle.Fill
                    PasswordPanel.Visible = False
                    NamePanel.Visible = True
                    BackButton.Enabled = True
                End Try
                If UserClass.UserExists(LogonNameTextBox.Text) Then
                    'Si la se ha de crear el correo se llama a la función que habilita el mail y crea el buzón exchange
                    salida = salida & vbCrLf & "Usuario creado"
                    If MailBoxCheckBox.Checked Then
                        salida = salida & vbCrLf & "Estableciendo mail del usuario y creando el buzón..."
                        Try
                            Dim parts() As String = MailboxStoreComboBox.SelectedItem.ToString.Split("/")
                            MailClass.User_MailEnable(LogonNameTextBox.Text, parts(1), ServerComboBox.SelectedItem.ToString)
                        Catch ex As Exception When LogonNameTextBox.Text = ""
                            MsgBox("Error al habilitar el correo y crear el buzón del usuario, el nombre de login debe tener algun valor " & ex.Message)
                            salida = salida & vbCrLf & "Error: al habilitar el correo y crear el buzón del usuario, el nombre de login debe tener algun valor " & ex.Message
                            HayError = True
                            PasswordPanel.Dock = DockStyle.None
                            NamePanel.Dock = DockStyle.Fill
                            PasswordPanel.Visible = False
                            NamePanel.Visible = True
                            BackButton.Enabled = True
                        Catch ex As Exception When MailboxStoreComboBox.SelectedItem.ToString = ""
                            MsgBox("Error al habilitar el correo y crear el buzón del usuario, el nombre de mailstore debe tener algun valor " & ex.Message)
                            salida = salida & vbCrLf & "Error: al habilitar el correo y crear el buzón del usuario, el nombre de mailstore debe tener algun valor " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            MailPanel.Dock = DockStyle.Fill
                            MailPanel.Visible = True
                            NamePanel.Visible = False
                            PasswordPanel.Visible = False
                        Catch ex As Exception When ServerComboBox.SelectedItem.ToString = ""
                            MsgBox("Error al habilitar el correo y crear el buzón del usuario, el nombre de servidor debe tener algun valor " & ex.Message)
                            salida = salida & vbCrLf & "Error: al habilitar el correo y crear el buzón del usuario, el nombre de servidor debe tener algun valor " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            MailPanel.Dock = DockStyle.Fill
                            MailPanel.Visible = True
                            NamePanel.Visible = False
                            PasswordPanel.Visible = False
                        Catch ex As Exception
                            MsgBox("Error al habilitar el correo y crear el buzón del usuario " & ex.Message)
                            salida = salida & vbCrLf & "Error: al habilitar el correo y crear el buzón del usuario " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            MailPanel.Dock = DockStyle.Fill
                            MailPanel.Visible = True
                            NamePanel.Visible = False
                            PasswordPanel.Visible = False
                        End Try
                        salida = salida & vbCrLf & "Con buzón de correo" & vbCrLf &
                            "Home del buzón:" & MailBoxStore & vbCrLf &
                            "nickname:" & AliasTextBox.Text
                    End If
                    'Funciones que establecen las propiedades que hemos marcado en los checkboxes del passwordPanel
                    Dim de_user As DirectoryEntry = UserClass.getUserDirectoryEntry(LogonNameTextBox.Text)
                    If PassChangeCheckBox.Checked = True Then
                        Try
                            UserClass.MustChangePasswordNextLogon(de_user)
                        Catch ex As Exception When de_user Is Nothing
                            MsgBox("Error al establecer que el usuario tenga que actualizar el password al acceder por primera vez, El usuario no puede ser nulo " & ex.Message)
                            salida = salida & vbCrLf & "Error: al establecer que el usuario tenga que actualizar el password al acceder por primera vez, El usuario no puede ser nulo " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            PasswordPanel.Dock = DockStyle.Fill
                            PasswordPanel.Visible = True
                            NamePanel.Visible = False
                            BackButton.Enabled = True
                        Catch ex As Exception
                            MsgBox("Error al establecer que el usuario tenga que actualizar el password al acceder por primera vez " & ex.Message)
                            salida = salida & vbCrLf & "Error: al establecer que el usuario tenga que actualizar el password al acceder por primera vez " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            PasswordPanel.Dock = DockStyle.Fill
                            PasswordPanel.Visible = True
                            NamePanel.Visible = False
                            BackButton.Enabled = True
                        End Try
                        salida = salida & vbCrLf & "El usuario debe cambiar el password"
                    Else
                        Dim dato As Int64 = -1
                        salida = salida & vbCrLf & "El usuario no tiene que cambiar el password en el primer acceso"
                        Try
                            UserClass.SetUserPropertyInt(LogonNameTextBox.Text, "pwdLastSet", dato)
                        Catch ex As Exception When LogonNameTextBox.Text = ""
                            MsgBox("Error al establecer que el usuario tenga que actualizar el password al acceder por primera vez, El usuario no puede ser nulo " & ex.Message)
                            salida = salida & vbCrLf & "Error: al establecer que el usuario tenga que actualizar el password al acceder por primera vez, El usuario no puede ser nulo " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            PasswordPanel.Dock = DockStyle.Fill
                            PasswordPanel.Visible = True
                            NamePanel.Visible = False
                            BackButton.Enabled = True
                        Catch ex As Exception
                            MsgBox("Error al establecer que el usuario tenga que actualizar el password al acceder por primera vez " & ex.Message)
                            salida = salida & vbCrLf & "Error: al establecer que el usuario tenga que actualizar el password al acceder por primera vez " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            PasswordPanel.Dock = DockStyle.Fill
                            PasswordPanel.Visible = True
                            NamePanel.Visible = False
                            BackButton.Enabled = True
                        End Try
                    End If
                    If CannotPassCheckBox.Checked = True Then
                        Try
                            UserClass.DenyChangePassword(de_user)
                        Catch ex As Exception When de_user Is Nothing
                            MsgBox("Error al establecer que el usuario no pueda actualizar el password, El usuario no puede ser nulo " & ex.Message)
                            salida = salida & vbCrLf & "Error: al establecer que el usuario no pueda actualizar el password, El usuario no puede ser nulo " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            PasswordPanel.Dock = DockStyle.Fill
                            PasswordPanel.Visible = True
                            NamePanel.Visible = False
                            BackButton.Enabled = True
                        Catch ex As Exception
                            MsgBox("Error al establecer que el usuario no pueda actualizar el password " & ex.Message)
                            salida = salida & vbCrLf & "Error: al establecer que el usuario no pueda actualizar el password " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            PasswordPanel.Dock = DockStyle.Fill
                            PasswordPanel.Visible = True
                            NamePanel.Visible = False
                            BackButton.Enabled = True
                        End Try
                        salida = salida & vbCrLf & "El usuario no puede cambiar el password"
                    End If
                    If NeverExpiresPassCheckBox.Checked = True Then
                        Try
                            UserClass.DontExpirePassword(de_user)
                        Catch ex As Exception When de_user Is Nothing
                            MsgBox("Error al establecer que el password del usuario no expire nunca, El usuario no puede ser nulo " & ex.Message)
                            salida = salida & vbCrLf & "Error: al establecer que el password del usuario no expire nunca, El usuario no puede ser nulo " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            PasswordPanel.Dock = DockStyle.Fill
                            PasswordPanel.Visible = True
                            NamePanel.Visible = False
                            BackButton.Enabled = True
                        Catch ex As Exception
                            MsgBox("Error al establecer que el password del usuario no expire nunca " & ex.Message)
                            salida = salida & vbCrLf & "Error: al establecer que el password del usuario no expire nunca " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            PasswordPanel.Dock = DockStyle.Fill
                            PasswordPanel.Visible = True
                            NamePanel.Visible = False
                            BackButton.Enabled = True
                        End Try
                        salida = salida & vbCrLf & "El password del usuario no expira"
                    End If
                    If DisabledAccountCheckBox.Checked = True Then
                        Try
                            UserClass.DisableAccount(LogonNameTextBox.Text)
                        Catch ex As Exception When LogonNameTextBox.Text = ""
                            MsgBox("Error al deshabilitar la nueva cuenta de usuario, el nombre de login del usuario no puede ser vacío " & ex.Message)
                            salida = salida & vbCrLf & "Error: al deshabilitar la nueva cuenta de usuario, el nombre de login del usuario no puede ser vacío " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            PasswordPanel.Dock = DockStyle.Fill
                            PasswordPanel.Visible = True
                            NamePanel.Visible = False
                            BackButton.Enabled = True
                        Catch ex As Exception
                            MsgBox("Error al deshabilitar la nueva cuenta de usuario " & ex.Message)
                            salida = salida & vbCrLf & "Error: al deshabilitar la nueva cuenta de usuario " & ex.Message
                            HayError = True
                            NamePanel.Dock = DockStyle.None
                            PasswordPanel.Dock = DockStyle.Fill
                            PasswordPanel.Visible = True
                            NamePanel.Visible = False
                            BackButton.Enabled = True
                        End Try
                        salida = salida & vbCrLf & "Cuenta del usuario deshabilitada"
                    End If
                    'Log
                    GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
                    Return True
                Else
                    'MsgBox("Error al crear al usuario.")
                    Return False
                End If
            Else
                MsgBox("El nombre de usuario ya pertenece al directorio activo")
            End If
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Function

    Private Function checkRejexUName(ByVal strFindin As String) As Boolean
        Dim myRegex As New Regex("^([^\\/\[\]:;\|=,\+\*\?<@""])+$")
        If myRegex.IsMatch(strFindin) Then
            Return True
        Else
            Return False
        End If
    End Function
End Class
