﻿Public Class PermisosBuzon

    Dim Usuario As String
    Dim UsuarioToGrant As String
    Dim UsersToRemove As New List(Of String)
    Dim primero As Boolean

    Private Structure MyCell
        Dim Row As Integer
        Dim Col As Integer
    End Structure
    Private bOWCheck() As Boolean
    '--------------------------Estructura auxiliar donde guardar los permisos--------------------
    Private Structure allowDeny
        Dim allow As Boolean
        Dim deny As Boolean
        Dim fijoA As Boolean
        Dim fijoD As Boolean
    End Structure
    Private Structure Permissions
        Dim perms() As allowDeny
        Dim usuario As String
        Dim modificado As Boolean
    End Structure
    Dim TodosPermisos As New List(Of Permissions)

    'Dim TodosPermisos() As Permissions
    '------------------------------------------------------------------------------------------------

    Dim seleccionado As Integer = 0
    Dim usersremove As Boolean = False
    Dim usersadd As Boolean = False
    Dim permisChange As Boolean = False
    Dim Objeto As String


    Friend Sub LoadU(ByVal User As String)
        '==========================================================================
        ' Name:     LoadU
        ' Purpose:  Establecer el objeto a incluir permisos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        UsuarioToGrant = User
    End Sub
    Friend Sub LoadUser(ByVal User As String)
        '==========================================================================
        ' Name:     LoadU
        ' Purpose:  Establecer el usuario dueño del buzón al que asignar permisos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Usuario = User
    End Sub
    Friend Sub LoadObjeto(ByVal obje As String)
        '==========================================================================
        ' Name:     LoadU
        ' Purpose:  Establecer el objeto al que aqsignar permisos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Objeto = obje
    End Sub

    Private Sub PermisosBuzon_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     PermisosBuzon_Load
        ' Purpose:  Carga de los datos del usuario en la ventana
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    GetDaclNames, GetAcePermission de MailClass
        '==========================================================================
        Dim HayError As Boolean = False
        Dim salida As String
        primero = True
        '-------------------------------------Listview Usuarios-----------------------------------------
        'Crear lista de usuarios con permisos
        'UsersListView.Sorting = SortOrder.Ascending
        UsersListView.ShowItemToolTips = True
        UsersListView.View = View.Details
        UsersListView.Columns.Add("", 380, HorizontalAlignment.Left)

        'Obtener usuarios con permisos sobre el buzón e insertarlos en el listview
        Dim GrantedUsers As System.Collections.Generic.IList(Of String)
        'Dim GrantedUsers As New List(Of String)
        Try
            GrantedUsers = MailClass.GetDaclNames(Usuario)
        Catch ex As Exception
            MsgBox("Error al obtener los objetos que poseen permisos sobre el buzón del usuario " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener los objetos que poseen permisos sobre el buzón del usuario " & Usuario & ex.Message
            HayError = True
        End Try

        For i = 0 To GrantedUsers.Count - 1
            Dim item As ListViewItem
            item = New ListViewItem(GrantedUsers(i).ToString)
            UsersListView.Items.Add(item)
        Next
        UsersListView.Sort()

        '-------------------------------------Listview Permisos-----------------------------------------
        'Crear listview para los permisos
        Dim myCheckFont As New System.Drawing.Font("Wingdings", 12, FontStyle.Regular)
        ' Columnas
        UsersView.Columns.Add("Permiso", 208, HorizontalAlignment.Left)
        UsersView.Columns.Add("Allow", 50, HorizontalAlignment.Center)
        UsersView.Columns.Add("Deny", 50, HorizontalAlignment.Center)
        'Nombres para las Filas
        Dim opcion(5) As String
        opcion(0) = "Borrado de la memoria del buzón"
        opcion(1) = "Permisos de lectura"
        opcion(2) = "Permisos de modificación"
        opcion(3) = "Tomar posesión"
        opcion(4) = "Acceso total al buzón"

        'Crear filas
        With UsersView
            For I As Integer = 0 To 4
                .Items.Add(opcion(I))
                .Items(I).UseItemStyleForSubItems = False
                'Los caracters son especiales y tienen la forma de un checkbox con un tick y un chesckbox vacío
                .Items(I).SubItems.Add(Chr(168))
                .Items(I).SubItems.Add(Chr(168))
                .Items(I).SubItems.Item(1).ForeColor = Color.Black
                .Items(I).SubItems.Item(1).Font = myCheckFont
                .Items(I).SubItems.Item(2).ForeColor = Color.Black
                .Items(I).SubItems.Item(2).Font = myCheckFont
                ReDim bOWCheck(I)
            Next I
        End With

        'TodosPermisos = New List(Of Permissions)
        ' TodosPermisos.Clear()
        '-------------------------------Carga de la tabla-------------------------------
        'Cargar la tabla auxiliar para los permisos
        Dim j As Integer = 0
        'For j = 0 To UsersListView.Items.Count - 1
        Dim permisos(4) As allowDeny
        For i = 0 To 4
            Try
                Dim allow() As Boolean = MailClass.GetAcePermission(UsersListView.Items(j).Text, Usuario, UsersView.Items(i).SubItems(0).Text)
                permisos(i).fijoA = allow(2)
                permisos(i).fijoD = allow(3)
                If allow(0) Then
                    permisos(i).allow = True
                Else
                    permisos(i).allow = False
                End If
                If allow(1) Then
                    permisos(i).deny = True
                Else
                    permisos(i).deny = False
                End If
            Catch ex As Exception
                MsgBox("Error al obtener el permiso " & UsersView.Items(i).SubItems(0).Text & " para el objeto " & UsersListView.Items(j).Text & " sobre el buzón del usuario " & ex.Message)
                salida = salida & vbCrLf & "Error al obtener el permiso " & UsersView.Items(i).SubItems(0).Text & " para el objeto " & UsersListView.Items(j).Text & " sobre el buzón del usuario " & Usuario & ex.Message
                HayError = True
            End Try
        Next
        Dim Tperms As Permissions
        Tperms.perms = permisos
        Tperms.usuario = UsersListView.Items(j).Text
        Tperms.modificado = False
        TodosPermisos.Add(Tperms)
        'TodosPermisos(j) = Tperms
        'Next

        'Actualizar el listview de los permisos con los datos del primer objeto
        If Not TodosPermisos.Count = 0 Then

            UGNameLabel.Text = TodosPermisos(0).usuario
            For i = 0 To 4
                If TodosPermisos(0).perms(i).allow Then
                    UsersView.Items(i).SubItems(1).Text = (Chr(254))
                    If TodosPermisos(0).perms(i).fijoA Then
                        UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                    Else
                        UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                    End If
                Else
                    UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                    UsersView.Items(i).SubItems(1).Text = (Chr(168))
                End If
                If TodosPermisos(0).perms(i).deny Then
                    UsersView.Items(i).SubItems(2).Text = (Chr(254))
                    If TodosPermisos(0).perms(i).fijoD Then
                        UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                    Else
                        UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                    End If
                Else
                    UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                    UsersView.Items(i).SubItems(2).Text = (Chr(168))
                End If
            Next
        End If
        primero = False
        usersremove = False
        usersadd = False
        permisChange = False

        If HayError Then
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        End If
        'Deshabilitar los botones adeptar y aplicar 
        AcceptButton.Enabled = False
        ApplyButton.Enabled = False
        CancelButton.Enabled = True

    End Sub

    Private Sub UsersView_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles UsersView.MouseUp
        '==========================================================================
        ' Name:     UsersView_MouseUp
        ' Purpose:  Controlar los cambios que se producen al hacer click en el listview de los permisos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    WhichCell
        '==========================================================================

        If Not primero Then
            permisChange = True

            Dim indice As Integer = 0
            'Obtener el índice del objeto actual
            For i = 0 To TodosPermisos.Count - 1
                If TodosPermisos(i).usuario = UGNameLabel.Text Then
                    indice = i
                End If
            Next
            'Cambiar el checkbox que aparece en el listview de permisos y actualizar la tabla auxiliar de los permisos 
            Dim cellLoc As MyCell
            'obtener la celda que se ha de cambiar
            cellLoc = WhichCell(UsersView, e.X, e.Y)

            If Not UsersView.Items(cellLoc.Row).SubItems(cellLoc.Col - 1).ForeColor = Color.DarkGray Then
                If cellLoc.Col = 2 Or cellLoc.Col = 3 Then
                    If bOWCheck(cellLoc.Row) = True Then
                        'Actualizar checkbox

                        UsersView.Items(cellLoc.Row).SubItems(cellLoc.Col - 1).Text = Chr(168)
                        If cellLoc.Col = 2 Then

                            TodosPermisos(indice).perms(cellLoc.Row).allow = False
                        Else

                            TodosPermisos(indice).perms(cellLoc.Row).deny = False
                        End If
                        bOWCheck(cellLoc.Row) = False

                    Else

                        'Actualizar checkbox
                        UsersView.Items(cellLoc.Row).SubItems(cellLoc.Col - 1).Text = Chr(254)
                        If cellLoc.Col = 2 Then

                            If Not UsersView.Items(cellLoc.Row).SubItems(2).ForeColor = Color.DarkGray Then
                                UsersView.Items(cellLoc.Row).SubItems(2).Text = Chr(168)
                                TodosPermisos(indice).perms(cellLoc.Row).deny = False
                            End If
                            'actializar tabla
                            TodosPermisos(indice).perms(cellLoc.Row).allow = True


                            bOWCheck(cellLoc.Row) = True
                        Else
                            If Not UsersView.Items(cellLoc.Row).SubItems(1).ForeColor = Color.DarkGray Then
                                UsersView.Items(cellLoc.Row).SubItems(1).Text = Chr(168)
                                TodosPermisos(indice).perms(cellLoc.Row).allow = False
                            End If
                            'actializar tabla
                            TodosPermisos(indice).perms(cellLoc.Row).deny = True

                            bOWCheck(cellLoc.Row) = True
                        End If
                    End If


                End If
                If Not TodosPermisos(indice).modificado Then
                    Dim tperms As New Permissions
                    tperms.modificado = True
                    tperms.usuario = TodosPermisos(indice).usuario
                    tperms.perms = TodosPermisos(indice).perms
                    TodosPermisos.RemoveAt(indice)
                    TodosPermisos.Add(tperms)
                End If

                AcceptButton.Enabled = True
                ApplyButton.Enabled = True
                CancelButton.Enabled = True
            End If
        End If
    End Sub

    Private Function WhichCell(ByVal lvw As ListView, ByVal X As Integer, ByVal Y As Integer) As MyCell
        '==========================================================================
        ' Name:     WhichCell
        ' Purpose:  Obtener la celda a cambiar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   1 Mycell: La celda
        ' Calls:    None
        '==========================================================================
        Dim colstart As Integer = 0
        Dim colend As Integer = 0
        Dim xCol As Integer
        'Obtener la columna
        For xCol = 0 To (UsersView.Columns.Count - 1)
            colend = colend + UsersView.Columns(xCol).Width
            If colstart <= X And X <= colend Then
                WhichCell.Col = xCol + 1
                Exit For
            End If
            colstart = colstart + UsersView.Columns(xCol).Width
        Next
        'Obtener la celda
        WhichCell.Row = UsersView.FocusedItem.Index
        Return WhichCell
    End Function

    Private Sub UsersListView_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles UsersListView.SelectedIndexChanged
        '==========================================================================
        ' Name:     UsersListView_SelectedIndexChanged
        ' Purpose:  Actualizar el listview de los permisos con los datos del objeto seleccionado
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Not primero Then
            Me.Cursor = Cursors.WaitCursor
            Dim item As ListViewItem
            Dim seleccionados As ListView.SelectedListViewItemCollection = UsersListView.SelectedItems
            'buscar el objeto seleccionado en la tabla auxiliar y actualizar el listview de los permisos
            For Each item In seleccionados
                seleccionado = item.Index
                UGNameLabel.Text = item.Text

                Dim esta As Boolean = False
                Dim ind As Integer = 0
                For i = 0 To TodosPermisos.Count - 1
                    If TodosPermisos(i).usuario = item.Text Then
                        esta = True
                        ind = i
                        Exit For
                    End If
                Next

                If Not esta Then
                    'Cargar los permisos del objeto por primera vez
                    Dim j As Integer = item.Index

                    Dim permisos(4) As allowDeny
                    For i = 0 To 4
                        Try
                            Dim allow() As Boolean = MailClass.GetAcePermission(UsersListView.Items(j).Text, Usuario, UsersView.Items(i).SubItems(0).Text)
                            permisos(i).fijoA = allow(2)
                            permisos(i).fijoD = allow(3)
                            If allow(0) Then
                                permisos(i).allow = True
                            Else
                                permisos(i).allow = False
                            End If
                            If allow(1) Then
                                permisos(i).deny = True
                            Else
                                permisos(i).deny = False
                            End If
                        Catch ex As Exception
                            MsgBox("Error al obtener el permiso " & UsersView.Items(i).SubItems(0).Text & " para el objeto " & UsersListView.Items(j).Text & " sobre el buzón del usuario " & ex.Message)

                        End Try
                    Next
                    Dim Tperms As Permissions
                    Tperms.perms = permisos
                    Tperms.usuario = UsersListView.Items(j).Text
                    TodosPermisos.Add(Tperms)
                    Tperms.modificado = False

                    'Se cargan en el listView los permisos del objeto
                    ind = TodosPermisos.Count - 1
                    UGNameLabel.Text = TodosPermisos(ind).usuario
                    For i = 0 To 4

                        If TodosPermisos(ind).perms(i).allow Then
                            UsersView.Items(i).SubItems(1).Text = (Chr(254))
                            If TodosPermisos(ind).perms(i).fijoA Then
                                UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                            Else
                                UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                            End If
                        Else
                            UsersView.Items(i).SubItems(1).Text = (Chr(168))
                            UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                        If TodosPermisos(ind).perms(i).deny Then
                            UsersView.Items(i).SubItems(2).Text = (Chr(254))
                            If TodosPermisos(ind).perms(i).fijoD Then
                                UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                            Else
                                UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                            End If
                        Else
                            UsersView.Items(i).SubItems(2).Text = (Chr(168))
                            UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If

                    Next

                Else
                    For i = 0 To 4

                        If TodosPermisos(ind).perms(i).allow Then
                            UsersView.Items(i).SubItems(1).Text = (Chr(254))
                            If TodosPermisos(ind).perms(i).fijoA Then
                                UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                            Else
                                UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                            End If
                        Else
                            UsersView.Items(i).SubItems(1).Text = (Chr(168))
                            UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                        If TodosPermisos(ind).perms(i).deny Then
                            UsersView.Items(i).SubItems(2).Text = (Chr(254))
                            If TodosPermisos(ind).perms(i).fijoD Then
                                UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                            Else
                                UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                            End If
                        Else
                            UsersView.Items(i).SubItems(2).Text = (Chr(168))
                            UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If

                    Next
                End If
            Next
            Me.Cursor = Cursors.Default
        End If
    End Sub

    Private Sub AddButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddButton.Click
        '==========================================================================
        ' Name:     AddButton_Click
        ' Purpose:  Añadir un objeto al listview de los objetos con permisos y cargar éstos en el listview de los permisos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        usersadd = True

        Añadir.ShowDialog()

        If Not Objeto = "" Then
            Dim puede As Boolean = True
            For i = 0 To UsersListView.Items.Count - 1
                If UsersListView.Items(i).Text = Objeto Then
                    puede = False
                End If
            Next
            If puede Then
                'insertar en el listbox de los nombres
                Dim item As ListViewItem
                item = New ListViewItem(Objeto)
                UsersListView.Items.Add(item)

                'Dim ind As Integer
                'For i = 0 To UsersListView.Items.Count - 1
                '    If UsersListView.Items(i).Text = Objeto Then
                '        ind = i
                '    End If
                'Next

                'seleccionado = ind

                'cargar sus datos en la estructura provisional
                Dim permisos(6) As allowDeny
                For i = 0 To 5
                    permisos(i).allow = False
                    permisos(i).deny = False
                Next
                Dim Tperms As Permissions
                Tperms.perms = permisos
                Tperms.usuario = Objeto
                TodosPermisos.Add(Tperms)
                'TodosPermisos.Insert(ind, Tperms)

                seleccionado = TodosPermisos.Count - 1
                'sacar datos en el listview de los permisos
                UGNameLabel.Text = Objeto
                For i = 0 To 4     
                    UsersView.Items(i).SubItems(1).Text = (Chr(168))
                    UsersView.Items(i).SubItems(2).Text = (Chr(168))
                Next
                AcceptButton.Enabled = True
                ApplyButton.Enabled = True
                CancelButton.Enabled = True
            Else
                MsgBox(Objeto & " ya tiene permisos")
            End If
        End If
    End Sub

    Private Sub RemoveButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RemoveButton.Click
        '==========================================================================
        ' Name:     RemoveButton_Click
        ' Purpose:  Eliminar un objeto del listview de los objetos con permisos 
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================


        Dim seleccionados As ListView.SelectedListViewItemCollection = UsersListView.SelectedItems
        If seleccionados.Count > 0 Then
            usersremove = True
            'Eliminar el usuario del listview y añadirlo al array de usuarios a eliminar
            For Each item In seleccionados
                UsersToRemove.Add(item.text)
                For i = 0 To TodosPermisos.Count - 1
                    If TodosPermisos(i).usuario = item.text Then
                        TodosPermisos.RemoveAt(i)
                        item.Remove()
                        Exit For
                    End If
                Next
            Next
            'Establecer actual como el primero
            seleccionado = 0
            UGNameLabel.Text = TodosPermisos(0).usuario
            For i = 0 To 4
                If TodosPermisos(0).perms(i).allow Then
                    UsersView.Items(i).SubItems(1).Text = (Chr(254))
                    If TodosPermisos(0).perms(i).fijoA Then
                        UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                    Else
                        UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                    End If
                Else
                    UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                    UsersView.Items(i).SubItems(1).Text = (Chr(168))
                End If
                If TodosPermisos(0).perms(i).deny Then
                    UsersView.Items(i).SubItems(2).Text = (Chr(254))
                    If TodosPermisos(0).perms(i).fijoD Then
                        UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                    Else
                        UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                    End If
                Else
                    UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                    UsersView.Items(i).SubItems(2).Text = (Chr(168))
                End If
            Next

            'Habilitar aceptar y aplicar
            AcceptButton.Enabled = True
            ApplyButton.Enabled = True
            CancelButton.Enabled = True
        End If
    End Sub

    Private Sub ApplyButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ApplyButton.Click
        '==========================================================================
        ' Name:     ApplyButton_Click
        ' Purpose:  Establecer los cambios efectuados en la ventana y deshabilitar los botones aceptar y aplicar 
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    RemoveAceFromDacl, GetAcePermission, GetDaclNames, AddAceToDacl de MailClass
        '==========================================================================
        Try
            Me.Cursor = Cursors.WaitCursor
            Dim salida As String = "---------Permisos Buzón---------" & vbCrLf & "Cambios al hacer click en el botón aplicar (Propiedades Usuario)"
            Dim nuevo As String = ""
            salida = salida & vbCrLf & "Dueño del buzón:" & Usuario
            If usersadd Then
                salida = salida & vbCrLf & "Añadir permisos a:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = MailClass.GetDaclNames(Usuario)
                For i = 0 To UsersListView.Items.Count - 1
                    Dim esta As Boolean = False
                    For j = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(j) = UsersListView.Items(i).Text Then
                            esta = True
                        End If
                    Next
                    If Not esta Then
                        For j = 0 To TodosPermisos.Count - 1
                            If TodosPermisos(j).usuario = UsersListView.Items(i).Text Then
                                salida = salida & vbCrLf & UsersListView.Items(i).Text
                                For k = 0 To 4
                                    If TodosPermisos(j).perms(k).allow Then
                                        Try
                                            MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                        Catch ex As Exception
                                            MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message

                                        End Try
                                    ElseIf TodosPermisos(j).perms(k).deny Then
                                        Try
                                            MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                        Catch ex As Exception
                                            MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message

                                        End Try
                                    End If
                                Next
                                nuevo = TodosPermisos(j).usuario
                            End If
                        Next
                    End If
                Next
            End If

            '-------------------------------------------Cambio de permisos a un usuario que ya tiene-------------------------------
            If permisChange Then
                salida = salida & vbCrLf & "Modificar permisos:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = MailClass.GetDaclNames(Usuario)
                Dim esta As Boolean = False
                For i = 0 To UsersListView.Items.Count - 1
                    For j = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(j) = UsersListView.Items(i).Text Then
                            esta = True
                        End If
                    Next
                    If esta Then
                        For j = 0 To TodosPermisos.Count - 1
                            If Not nuevo = UsersListView.Items(i).Text Then
                                If TodosPermisos(j).usuario = UsersListView.Items(i).Text And TodosPermisos(j).modificado Then
                                    For k = 0 To 4
                                        Dim allow() As Boolean = MailClass.GetAcePermission(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text)
                                        If TodosPermisos(j).perms(k).allow Then
                                            If Not allow(0) Then
                                                salida = salida & vbCrLf & "Añadir permiso a:" & UsersListView.Items(i).Text
                                                Try
                                                    MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                                Catch ex As Exception
                                                    MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                                End Try
                                            End If
                                        End If
                                        If Not TodosPermisos(j).perms(k).allow Then
                                            If allow(0) Then
                                                salida = salida & vbCrLf & "Quitar permiso a:" & UsersListView.Items(i).Text
                                                Try
                                                    MailClass.RemoveAceFromDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                                Catch ex As Exception
                                                    MsgBox("Error al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message

                                                End Try
                                            End If
                                        End If
                                        If TodosPermisos(j).perms(k).deny Then
                                            If Not allow(1) Then
                                                Try
                                                    salida = salida & vbCrLf & "Añadir permiso a:" & UsersListView.Items(i).Text
                                                    MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                                Catch ex As Exception
                                                    MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                                End Try
                                            End If
                                        End If
                                        If Not TodosPermisos(j).perms(k).deny Then
                                            If allow(1) Then
                                                salida = salida & vbCrLf & "Quitar permiso a:" & UsersListView.Items(i).Text
                                                Try
                                                    MailClass.RemoveAceFromDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                                Catch ex As Exception
                                                    MsgBox("Error al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message

                                                End Try
                                            End If
                                        End If
                                    Next
                                    Dim tperms As New Permissions
                                    tperms.modificado = False
                                    tperms.usuario = TodosPermisos(j).usuario
                                    tperms.perms = TodosPermisos(j).perms
                                    TodosPermisos.RemoveAt(j)
                                    TodosPermisos.Add(tperms)
                                End If
                            End If
                        Next
                    End If
                Next
            End If

        '------------------------------------------------Borrado de todos los permisos de un usuario-----------------------------
        If usersremove Then
            salida = salida & vbCrLf & "Quitar todos los permisos a:"
            Dim GrantedUsers As System.Collections.Generic.IList(Of String)
            'MsgBox(UsersToRemove(0))
            For i = 0 To UsersToRemove.Count - 1

                    salida = salida & vbCrLf & UsersToRemove(i)
                    Try
                        MailClass.RemoveAcesMailbox(UsersToRemove(i), Usuario)
                    Catch ex As Exception
                        MsgBox("Error al quitar todos los permisos sobre el buzón para " & UsersListView.Items(i).Text & ex.Message)
                        salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message

                    End Try
                Next
        End If

        'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)

        '----------------------------------Variables de control y botones------------------------------------------------------
        permisChange = False
        usersremove = False
        usersadd = False
        'Deshabilitar aceptar y aplicar
            AcceptButton.Enabled = True
        ApplyButton.Enabled = False
        CancelButton.Enabled = True
        Me.Cursor = Cursors.Default
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub
   
    Private Sub CancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        '==========================================================================
        ' Name:     ApplyButton_Click
        ' Purpose:  Cerrar la ventana sin realizar cambios
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        UsersListView.Clear()
        'UsersListView.Items.Clear()
        UsersView.Clear()
        'UsersView.Items.Clear()
        TodosPermisos.Clear()
        Me.Close()

    End Sub

    Private Sub AcceptButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     ApplyButton_Click
        ' Purpose:  Establecer los cambios efectuados en la ventana y cerrar la ventana
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    RemoveAceFromDacl, GetAcePermission, GetDaclNames, AddAceToDacl de MailClass
        '==========================================================================
        Try
            Me.Cursor = Cursors.WaitCursor
            Dim HayError As Boolean = False
            'Es exactamente igual que applybutton pero con un me.close al final en vez de deshabilitar los botones
            Dim salida As String = "---------Permisos Buzón---------" & vbCrLf & "Cambios al hacer click en el botón aplicar (Propiedades Usuario)"
            Dim nuevo As String = ""
            salida = salida & vbCrLf & "Dueño del buzón:" & Usuario
            If usersadd Then
                salida = salida & vbCrLf & "Añadir permisos a:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = MailClass.GetDaclNames(Usuario)
                For i = 0 To UsersListView.Items.Count - 1
                    Dim esta As Boolean = False
                    For j = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(j) = UsersListView.Items(i).Text Then
                            esta = True
                        End If
                    Next
                    If Not esta Then
                        For j = 0 To TodosPermisos.Count - 1
                            If TodosPermisos(j).usuario = UsersListView.Items(i).Text Then
                                salida = salida & vbCrLf & UsersListView.Items(i).Text
                                For k = 0 To 4
                                    If TodosPermisos(j).perms(k).allow Then
                                        Try
                                            MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                        Catch ex As Exception
                                            MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                            HayError = True
                                        End Try
                                    ElseIf TodosPermisos(j).perms(k).deny Then
                                        Try
                                            MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                        Catch ex As Exception
                                            MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                            HayError = True
                                        End Try
                                    End If
                                Next
                                nuevo = TodosPermisos(j).usuario
                            End If
                        Next
                    End If
                Next
            End If

            '-------------------------------------------Cambio de permisos a un usuario que ya tiene-------------------------------
            If permisChange Then
                salida = salida & vbCrLf & "Modificar permisos:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = MailClass.GetDaclNames(Usuario)
                Dim esta As Boolean = False
                For i = 0 To UsersListView.Items.Count - 1
                    For j = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(j) = UsersListView.Items(i).Text Then
                            esta = True
                        End If
                    Next
                    If esta Then
                        For j = 0 To TodosPermisos.Count - 1
                            If Not nuevo = UsersListView.Items(i).Text Then
                                If TodosPermisos(j).usuario = UsersListView.Items(i).Text And TodosPermisos(j).modificado Then
                                    For k = 0 To 4
                                        Dim allow() As Boolean = MailClass.GetAcePermission(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text)
                                        If TodosPermisos(j).perms(k).allow Then
                                            If Not allow(0) Then
                                                salida = salida & vbCrLf & "Añadir permiso a:" & UsersListView.Items(i).Text
                                                Try
                                                    MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                                Catch ex As Exception
                                                    MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                End Try
                                            End If
                                        End If
                                        If Not TodosPermisos(j).perms(k).allow Then
                                            If allow(0) Then
                                                salida = salida & vbCrLf & "Quitar permiso a:" & UsersListView.Items(i).Text
                                                Try
                                                    MailClass.RemoveAceFromDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                                Catch ex As Exception
                                                    MsgBox("Error al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                End Try
                                            End If
                                        End If
                                        If TodosPermisos(j).perms(k).deny Then
                                            If Not allow(1) Then
                                                salida = salida & vbCrLf & "Añadir permiso a:" & UsersListView.Items(i).Text
                                                Try
                                                    MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                                Catch ex As Exception
                                                    MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                End Try
                                            End If
                                        End If
                                        If Not TodosPermisos(j).perms(k).deny Then
                                            If allow(1) Then
                                                salida = salida & vbCrLf & "Quitar permiso a:" & UsersListView.Items(i).Text
                                                Try
                                                    MailClass.RemoveAceFromDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                                Catch ex As Exception
                                                    MsgBox("Error al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                End Try
                                            End If
                                        End If
                                    Next
                                End If
                            End If
                        Next
                    End If
                Next
            End If

            '------------------------------------------------Borrado de todos los permisos de un usuario-----------------------------
            If usersremove Then
                salida = salida & vbCrLf & "Quitar todos los permisos a:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = MailClass.GetDaclNames(Usuario)
                For i = 0 To UsersToRemove.Count - 1
                    Dim esta As Boolean = False
                    For j = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(j).Contains(UsersToRemove(i)) Then
                            esta = True
                        End If
                    Next
                    If esta Then
                        Dim ind As Integer
                        For j = 0 To TodosPermisos.Count - 1
                            If TodosPermisos(j).usuario = UsersToRemove(i) Then
                                salida = salida & vbCrLf & UsersToRemove(i)
                                ind = j
                                For k = 0 To 4
                                    Dim allow() As Boolean = MailClass.GetAcePermission(GrantedUsers(j).ToString, Usuario, UsersView.Items(k).SubItems(0).Text)
                                    If allow(0) Then
                                        Try
                                            MailClass.RemoveAceFromDacl(UsersToRemove(i), Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                        Catch ex As Exception
                                            MsgBox("Error al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                            HayError = True
                                        End Try
                                    End If
                                    If allow(1) Then
                                        Try
                                            MailClass.RemoveAceFromDacl(UsersToRemove(i), Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                        Catch ex As Exception
                                            MsgBox("Error al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                            HayError = True
                                        End Try
                                    End If
                                Next
                            End If
                        Next
                        TodosPermisos.RemoveAt(ind)
                    End If
                Next
            End If
            '--------------------------------------------------------------------------------------------------------------
            UsersListView.Items.Clear()
            UsersView.Items.Clear()
            Me.Cursor = Cursors.Default
            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
            If Not HayError Then
                UsersView.Clear()
                UsersListView.Clear()
                TodosPermisos.Clear()
                Me.Close()
            End If
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

End Class