﻿Imports System.Text.RegularExpressions

Public Class PropiedadesEquipo

    Dim Equipo As String
    Dim primera As Boolean
    Dim sinsec As String = True
    '-----------------------------------------------------------
    '-------------------Variables Security---------------------
    'Estructura provisional para guardar todos los permisos del equipo
    Private Structure MyCell
        Dim Row As Integer
        Dim Col As Integer
    End Structure
    Private bOWCheck() As Boolean

    Private Structure allowDeny
        Dim allow As Boolean
        Dim deny As Boolean
        Dim fijoA As Boolean
        Dim fijoD As Boolean
    End Structure
    Private Structure Permissions
        Dim perms() As allowDeny
        Dim usuario As String
        Dim modificado As Boolean
    End Structure
    Dim TodosPermisos As New List(Of Permissions)

    '--------------------------------------------------------------
    Dim UsuarioToGrant As String
    Dim UsersToRemove As New List(Of String)
    Dim seleccionado As Integer = 0
    Dim usersremove As Boolean = False
    Dim usersadd As Boolean = False
    Dim permisChange As Boolean = False

    '----------------------------------------------------------
    '------------------------------------------------------------
    Dim groupsToRemove As Boolean = False
    Dim Objeto As String
    Dim groupslviewchanged As Boolean = False
    Dim removeGroups As New List(Of String)
    Dim managerchange As Boolean = False
    Dim descriptionchanged As Boolean = False
    Dim Namechanged As Boolean = False
    Dim PrimeraSeguridad As Boolean = False

    Friend Sub LoadComputer(ByVal PC As String)
        '==========================================================================
        ' Name:     LoadComputer
        ' Purpose:  Obtener el Equipo del que manipular sus datos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Equipo = PC
    End Sub
    Friend Sub loadObject(ByVal Elem As String)
        '==========================================================================
        ' Name:     LoadObject
        ' Purpose:  Obtener Objetos del directorio activo para diferentes opciones del equipo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Objeto = Elem
    End Sub

    Private Sub PropiedadesEquipo_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        '==========================================================================
        ' Name:     UserProperties_FormClosing
        ' Purpose:  Controlar el cierre de la ventana
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    PropertiesClosed de Arbol
        '==========================================================================
        Arbol.PropertiesClosed()
    End Sub

    Private Sub PropiedadesEquipo_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     PropiedadesEquipo_Load
        ' Purpose:  Carga de los datos de los campos que posee la ventana
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    GetComputerProperty, GetComputerPropertyRefresh, GetComputerGroups, 
        '           GetComputerPropertyLargeInterval, GetComputerPropertyOIdentifier de GenericClass
        '           GetPrimaryGroup de groupClass
        '           getGroupadress de UserClass
        '==========================================================================

        'Visualizar el panel general y ocultar los demás
        GeneralPanel.Visible = True
        GeneralPanel.Dock = DockStyle.Fill
        MemberOfPanel.Visible = False
        OSPanel.Visible = False
        ManagedByPanel.Visible = False
        ObjectPanel.Visible = False
        SecurityPanel.Visible = False
        primera = True
        PrimeraSeguridad = True
        Dim HayError As Boolean = False
        Dim salida As String
        '------------------------------------------------------------------------------------------------------------------
        '---------------------------------------------General--------------------------------------------------------------

        'Cargar campos del panel general
        Dim name As String = GenericClass.GetComputerProperty(Equipo, "cn")
        NameLabel.Text = name
        NameTextBox.Text = name
        Try
            DescriptionTextBox.Text = GenericClass.GetComputerProperty(Equipo, "description")
        Catch ex As Exception
            MsgBox("Error al obtener la descripción del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener la descripción del equipo " & Equipo & ex.Message
            HayError = True
            GeneralPanel.Visible = True
            GeneralPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = False
            ManagedByPanel.Visible = False
            ObjectPanel.Visible = False
            SecurityPanel.Visible = False
        End Try
        Try
            DNSTextBox.Text = GenericClass.GetComputerProperty(Equipo, "dNSHostName")
        Catch ex As Exception
            MsgBox("Error al obtener el nombre de Host del DNS del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el nombre de Host del DNS del equipo " & Equipo & ex.Message
            HayError = True
            GeneralPanel.Visible = True
            GeneralPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = False
            ManagedByPanel.Visible = False
            ObjectPanel.Visible = False
            SecurityPanel.Visible = False
        End Try
        Try
            If GenericClass.GetComputerProperty(Equipo, "serverReferenceBL") = "" Then
                RoleTextBox.Text = "Estación de trabajo o servidor"
            Else
                RoleTextBox.Text = "Controlador de dominio"
            End If
        Catch ex As Exception
            MsgBox("Error al obtener el dato que establece el rol del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el dato que establece el rol del equipo " & Equipo & ex.Message
            HayError = True
            GeneralPanel.Visible = True
            GeneralPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = False
            ManagedByPanel.Visible = False
            ObjectPanel.Visible = False
            SecurityPanel.Visible = False
        End Try
        '------------------------------------------------------------------------------------------------------------------
        '---------------------------------------------OS--------------------------------------------------------------
        'Cargar campos del panel OS
        Try
            OSTextBox.Text = GenericClass.GetComputerProperty(Equipo, "operatingSystem")
        Catch ex As Exception
            MsgBox("Error al obtener el dato que establece el SO del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el dato que establece el SO del equipo " & Equipo & ex.Message
            HayError = True
            GeneralPanel.Visible = False
            OSPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = True
            ManagedByPanel.Visible = False
            ObjectPanel.Visible = False
            SecurityPanel.Visible = False
        End Try
        Try
            VersionTextBox.Text = GenericClass.GetComputerProperty(Equipo, "operatingSystemVersion")
        Catch ex As Exception
            MsgBox("Error al obtener el dato que establece la versión de SO del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el dato que establece el versión de SO del equipo " & Equipo & ex.Message
            HayError = True
            GeneralPanel.Visible = False
            OSPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = True
            ManagedByPanel.Visible = False
            ObjectPanel.Visible = False
            SecurityPanel.Visible = False
        End Try
        Try
            ServicePackTextBox.Text = GenericClass.GetComputerProperty(Equipo, "operatingSystemServicePack")
        Catch ex As Exception
            MsgBox("Error al obtener el dato que establece la versión de service pack de el SO del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el dato que establece el versión de service pack de el SO del equipo " & Equipo & ex.Message
            HayError = True
            GeneralPanel.Visible = False
            OSPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = True
            ManagedByPanel.Visible = False
            ObjectPanel.Visible = False
            SecurityPanel.Visible = False
        End Try
        '-------------------------------------------------------------------------------------------------------------------------------
        '-----------------------------------------------------Member of-----------------------------------------------------------------
        'Crear el listview de los grupos a los que pertenece el equipo
        Dim TempN As New ListViewItem
        GroupsListView.ShowItemToolTips = True
        GroupsListView.View = View.Details
        GroupsListView.Clear()
        GroupsListView.Columns.Add("Name", 150)
        GroupsListView.Columns.Add("Active Directory Folder", 250)
        GroupsListView.Items.Clear()
        'Obtener el grupo primario del equipo
        Try
            Dim token As String = GenericClass.GetComputerPropertyRefresh(Equipo, "primaryGroupID")
            Dim Prim As String = UserClass.GetPrimaryGroup(token, Equipo)

            'Obtener grupos de los que el equipo es miembro e insertarlos en el listview
            Dim grupos As New List(Of String)
            grupos = GenericClass.GetComputerGroups(Equipo)
            If grupos.Count > 0 Then
                For i = 0 To grupos.Count - 1
                    Dim padre3(1) As String
                    padre3(0) = grupos(i)
                    Dim dir As String = groupClass.getGroupadress(grupos(i))
                    padre3(1) = dir.Replace("/" & grupos(i), "")
                    TempN = New ListViewItem(padre3)
                    GroupsListView.Items.Add(TempN)
                Next
            End If
            'Añadir también el grupo primario y darle color azul
            Dim padre4(1) As String
            padre4(0) = Prim
            Dim dire As String = groupClass.getGroupadress(Prim)
            padre4(1) = dire.Replace("/" & Prim, "")
            TempN = New ListViewItem(padre4)
            GroupsListView.Items.Add(TempN)
            GroupsListView.Items(GroupsListView.Items.Count - 1).ForeColor = Color.MediumTurquoise
        Catch ex As Exception
            MsgBox("Error al obtener los grupos de los que es miembro el equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener los grupos de los que es miembro el equipo " & Equipo & ex.Message
            HayError = True
            MemberOfPanel.Visible = True
            MemberOfPanel.Dock = DockStyle.Fill
            ManagedByPanel.Visible = False
            OSPanel.Visible = False
            GeneralPanel.Visible = False
            ObjectPanel.Visible = False
            SecurityPanel.Visible = False
        End Try

        '--------------------------------------------------------------------------------------------------------------------------------
        '-------------------------------------------------------Managed By---------------------------------------------------------------
        Try
            'Obtener el administrador del equipo
            If GenericClass.GetComputerProperty(Equipo, "managedBy") = "" Then
                'Si no tiene deshabilita los botones propiedades y borrar
                changeButton.Enabled = True
                PropertiesButton.Enabled = False
                ClearButton.Enabled = False
            Else
                ManagerTextBox.Text = GenericClass.GetComputerProperty(Equipo, "managedBy")
                'Si tiene habilita todos los botones del panel
                changeButton.Enabled = True
                PropertiesButton.Enabled = True
                ClearButton.Enabled = True

            End If
        Catch ex As Exception
            MsgBox("Error al obtener el administrador del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el administrador del equipo " & Equipo & ex.Message
            HayError = True
            ManagedByPanel.Visible = True
            ManagedByPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = False
            GeneralPanel.Visible = False
            ObjectPanel.Visible = False
            SecurityPanel.Visible = False
        End Try
        '----------------------------------------------------------------------------------------------------------------------------------
        '-------------------------------------------------------------Object---------------------------------------------------------------
        'Carga de todos los campos del panel Object
        Try
            canonicoTextBox.Text = GenericClass.GetComputerPropertyRefresh(Equipo, "canonicalName")
        Catch ex As Exception
            MsgBox("Error al obtener el nombre canónico del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el nombre canónico del equipo " & Equipo & ex.Message
            HayError = True
            ManagedByPanel.Visible = False
            ObjectPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = False
            GeneralPanel.Visible = False
            ObjectPanel.Visible = True
            SecurityPanel.Visible = False
        End Try
        Try
            ObjClassLabel.Text = GenericClass.GetComputerPropertyOIdentifier(Equipo, "objectClass")
        Catch ex As Exception
            MsgBox("Error al obtener el tipo de clase de objeto del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el tipo de clase de objeto del equipo " & Equipo & ex.Message
            HayError = True
            ManagedByPanel.Visible = False
            ObjectPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = False
            GeneralPanel.Visible = False
            ObjectPanel.Visible = True
            SecurityPanel.Visible = False
        End Try
        Try
            Dim Wcreated As Date = GenericClass.GetDateProperty(Equipo, "WhenCreated")
            Dim tz As TimeZone = TimeZone.CurrentTimeZone
            If tz.IsDaylightSavingTime(Wcreated) Then
                Wcreated = Wcreated.AddHours(2)
            Else
                Wcreated = Wcreated.AddHours(1)
            End If
            'WhenCreatedLabel.Text = UserClass.GetUserProperty(Usuario, "WhenCreated")
            WhenCreatedLabel.Text = Wcreated
        Catch ex As Exception
            MsgBox("Error al obtener la fecha de creación del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener la fecha de creación del equipo " & Equipo & ex.Message
            HayError = True
            ManagedByPanel.Visible = False
            ObjectPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = False
            GeneralPanel.Visible = False
            ObjectPanel.Visible = True
            SecurityPanel.Visible = False
        End Try
        Try
            Dim Wchanged As Date = GenericClass.GetDateProperty(Equipo, "WhenChanged")
            Dim tz As TimeZone = TimeZone.CurrentTimeZone
            If tz.IsDaylightSavingTime(Wchanged) Then
                Wchanged = Wchanged.AddHours(2)
            Else
                Wchanged = Wchanged.AddHours(1)
            End If
            'WhenChangedLabel.Text = UserClass.GetUserProperty(Usuario, "WhenChanged")
            WhenChangedLabel.Text = Wchanged
        Catch ex As Exception
            MsgBox("Error al obtener la fecha de modificación del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener la fecha de modificación del equipo " & Equipo & ex.Message
            HayError = True
            ManagedByPanel.Visible = False
            ObjectPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = False
            GeneralPanel.Visible = False
            ObjectPanel.Visible = True
            SecurityPanel.Visible = False
        End Try
        Try
            uSNChangedLabel.Text = GenericClass.GetComputerPropertyLargeInterval(Equipo, "uSNChanged")
        Catch ex As Exception
            MsgBox("Error al obtener la fecha de creación USN del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener la fecha de creación USN del equipo " & Equipo & ex.Message
            HayError = True
            ManagedByPanel.Visible = False
            ObjectPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = False
            GeneralPanel.Visible = False
            ObjectPanel.Visible = True
            SecurityPanel.Visible = False
        End Try
        Try
            uSNCreatedLabel.Text = GenericClass.GetComputerPropertyLargeInterval(Equipo, "usNCreated")
        Catch ex As Exception
            MsgBox("Error al obtener la fecha de modificación USN del equipo " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener la fecha de modificación USN del equipo " & Equipo & ex.Message
            HayError = True
            ManagedByPanel.Visible = False
            ObjectPanel.Dock = DockStyle.Fill
            MemberOfPanel.Visible = False
            OSPanel.Visible = False
            GeneralPanel.Visible = False
            ObjectPanel.Visible = True
            SecurityPanel.Visible = False
        End Try
        '--------------------------------------------------------------------------------------------------------------------------

        If HayError Then
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        End If

        'Marcar como terminada la primera carga de datos
        primera = False
        'Habilitar el botón cancelar y deshabilitar los demás
        AcceptButton.Enabled = False
        CancelButton.Enabled = True
        ApplyButton.Enabled = False

    End Sub

    '-----------------------------------------------------------------------------------------------------------------------------------
    '---------------------------------------------------Security------------------------------------------------------------------------
    Private Sub PermisListView_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PermisListView.MouseUp
        '==========================================================================
        ' Name:     PermisListView_MouseUp
        ' Purpose:  Cambios en los checkboxes del listview de los permisos de seguridad
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    WhichCell
        '==========================================================================

        Dim indice As Integer
        'Obtener el índice del objeto que ha cambiado
        For i = 0 To TodosPermisos.Count - 1
            If TodosPermisos(i).usuario = UGNameLabel.Text Then
                indice = i
            End If
        Next

        'Actualizar la estructura auxiliar (TodosPermisos) en la que se guardan los permisos
        'y cambiar el caracter que hace que aparezca el checkbox con tick o vacio
        Dim cellLoc As MyCell
        cellLoc = WhichCell(PermisListView, e.X, e.Y)
        If Not PermisListView.Items(cellLoc.Row).SubItems(cellLoc.Col - 1).ForeColor = Color.DarkGray Then
            If cellLoc.Col = 2 Or cellLoc.Col = 3 Then
                If bOWCheck(cellLoc.Row) = True Then
                    'Cambio de caracter
                    PermisListView.Items(cellLoc.Row).SubItems(cellLoc.Col - 1).Text = Chr(168)
                    'Cambio en la estructura auxiliar
                    If cellLoc.Col = 2 Then
                        PermisListView.Items(0).SubItems(1).Text = Chr(168)
                        TodosPermisos(0).perms(cellLoc.Row).allow = False
                        TodosPermisos(indice).perms(cellLoc.Row).allow = False
                    Else
                        PermisListView.Items(0).SubItems(2).Text = Chr(168)
                        TodosPermisos(0).perms(cellLoc.Row).deny = False
                        TodosPermisos(indice).perms(cellLoc.Row).deny = False
                    End If
                    bOWCheck(cellLoc.Row) = False
                Else
                    'Cambio de caracter
                    PermisListView.Items(cellLoc.Row).SubItems(cellLoc.Col - 1).Text = Chr(254)
                    'Cambio en la estructura auxiliar
                    If cellLoc.Row = 0 Then
                        For i = 1 To 19
                            PermisListView.Items(i).SubItems(cellLoc.Col - 1).Text = Chr(254)
                            If cellLoc.Col = 2 Then
                                PermisListView.Items(0).SubItems(2).Text = Chr(168)
                                TodosPermisos(indice).perms(0).deny = False
                                If Not PermisListView.Items(i).SubItems(2).ForeColor = Color.DarkGray Then
                                    PermisListView.Items(i).SubItems(2).Text = Chr(168)
                                    TodosPermisos(indice).perms(i).deny = False
                                End If
                                TodosPermisos(indice).perms(i).allow = True
                            Else
                                PermisListView.Items(0).SubItems(1).Text = Chr(168)
                                TodosPermisos(indice).perms(0).allow = False
                                If Not PermisListView.Items(i).SubItems(1).ForeColor = Color.DarkGray Then
                                    PermisListView.Items(i).SubItems(1).Text = Chr(168)
                                    TodosPermisos(indice).perms(i).allow = False
                                End If

                                TodosPermisos(indice).perms(i).deny = True
                            End If
                        Next
                    ElseIf cellLoc.Row = 1 Then
                        For i = 1 To 4
                            PermisListView.Items(2 * i + 10).SubItems(cellLoc.Col - 1).Text = Chr(254)
                            If cellLoc.Col = 2 Then
                                If Not (PermisListView.Items(0).SubItems(2).ForeColor = Color.DarkGray And PermisListView.Items(0).SubItems(2).Text = Chr(254)) Then
                                    If Not PermisListView.Items(2 * i + 10).SubItems(2).ForeColor = Color.DarkGray Then
                                        PermisListView.Items(0).SubItems(2).Text = Chr(168)
                                        TodosPermisos(indice).perms(0).deny = False
                                        PermisListView.Items(2 * i + 10).SubItems(2).Text = Chr(168)
                                        TodosPermisos(indice).perms(2 * i + 10).deny = False
                                    End If
                                End If
                                TodosPermisos(indice).perms(2 * i + 10).allow = True
                            Else
                                If Not (PermisListView.Items(0).SubItems(1).ForeColor = Color.DarkGray And PermisListView.Items(0).SubItems(1).Text = Chr(254)) Then
                                    If Not PermisListView.Items(2 * i + 10).SubItems(1).ForeColor = Color.DarkGray Then
                                        PermisListView.Items(0).SubItems(1).Text = Chr(168)
                                        TodosPermisos(indice).perms(0).allow = False
                                        PermisListView.Items(2 * i + 10).SubItems(1).Text = Chr(168)
                                        TodosPermisos(indice).perms(2 * i + 10).allow = False
                                    End If
                                End If
                                TodosPermisos(indice).perms(2 * i + 10).deny = True
                            End If
                        Next
                    ElseIf cellLoc.Row = 2 Then
                        'Escritura validada
                        PermisListView.Items(10).SubItems(cellLoc.Col - 1).Text = Chr(254)
                        If cellLoc.Col = 2 Then
                            If Not (PermisListView.Items(0).SubItems(2).ForeColor = Color.DarkGray And PermisListView.Items(0).SubItems(2).Text = Chr(254)) Then
                                If Not PermisListView.Items(10).SubItems(2).ForeColor = Color.DarkGray Then
                                    PermisListView.Items(0).SubItems(2).Text = Chr(168)
                                    TodosPermisos(indice).perms(0).deny = False
                                    PermisListView.Items(10).SubItems(2).Text = Chr(168)
                                    TodosPermisos(indice).perms(10).deny = False

                                End If
                            End If
                            TodosPermisos(indice).perms(10).allow = True
                        Else
                            If Not (PermisListView.Items(0).SubItems(1).ForeColor = Color.DarkGray And PermisListView.Items(0).SubItems(1).Text = Chr(254)) Then
                                If Not PermisListView.Items(10).SubItems(1).ForeColor = Color.DarkGray Then
                                    PermisListView.Items(0).SubItems(1).Text = Chr(168)
                                    TodosPermisos(indice).perms(0).allow = False
                                    PermisListView.Items(10).SubItems(1).Text = Chr(168)
                                    TodosPermisos(indice).perms(10).allow = False
                                End If
                            End If
                            TodosPermisos(indice).perms(10).deny = True
                        End If
                        'Todos los de escritura siguientes
                        For i = 0 To 4
                            PermisListView.Items(2 * i + 11).SubItems(cellLoc.Col - 1).Text = Chr(254)
                            If cellLoc.Col = 2 Then
                                If Not (PermisListView.Items(0).SubItems(2).ForeColor = Color.DarkGray And PermisListView.Items(0).SubItems(2).Text = Chr(254)) Then
                                    If Not PermisListView.Items(2 * i + 11).SubItems(2).ForeColor = Color.DarkGray Then
                                        PermisListView.Items(0).SubItems(2).Text = Chr(168)
                                        TodosPermisos(indice).perms(0).deny = False
                                        PermisListView.Items(2 * i + 11).SubItems(2).Text = Chr(168)
                                        TodosPermisos(indice).perms(2 * i + 11).deny = False
                                    End If
                                End If
                                TodosPermisos(indice).perms(2 * i + 11).allow = True
                            Else
                                If Not (PermisListView.Items(0).SubItems(1).ForeColor = Color.DarkGray And PermisListView.Items(0).SubItems(1).Text = Chr(254)) Then
                                    If Not PermisListView.Items(2 * i + 11).SubItems(1).ForeColor = Color.DarkGray Then
                                        PermisListView.Items(0).SubItems(1).Text = Chr(168)
                                        TodosPermisos(indice).perms(0).allow = False
                                        PermisListView.Items(2 * i + 11).SubItems(1).Text = Chr(168)
                                        TodosPermisos(indice).perms(2 * i + 11).allow = False
                                    End If
                                End If
                                TodosPermisos(indice).perms(2 * i + 11).deny = True
                            End If
                        Next
                    End If
                    If cellLoc.Col = 2 Then
                        If Not (PermisListView.Items(0).SubItems(2).ForeColor = Color.DarkGray And PermisListView.Items(0).SubItems(2).Text = Chr(254)) Then
                            If Not PermisListView.Items(cellLoc.Row).SubItems(2).ForeColor = Color.DarkGray Then
                                PermisListView.Items(0).SubItems(2).Text = Chr(168)
                                PermisListView.Items(cellLoc.Row).SubItems(2).Text = Chr(168)
                                TodosPermisos(indice).perms(0).deny = False
                                TodosPermisos(indice).perms(cellLoc.Row).deny = False
                            End If
                        End If
                        TodosPermisos(indice).perms(cellLoc.Row).allow = True
                    Else
                        If Not (PermisListView.Items(0).SubItems(1).ForeColor = Color.DarkGray And PermisListView.Items(0).SubItems(1).Text = Chr(254)) Then
                            If Not PermisListView.Items(cellLoc.Row).SubItems(1).ForeColor = Color.DarkGray Then
                                PermisListView.Items(0).SubItems(1).Text = Chr(168)
                                TodosPermisos(indice).perms(0).allow = False
                                PermisListView.Items(cellLoc.Row).SubItems(1).Text = Chr(168)
                                TodosPermisos(indice).perms(cellLoc.Row).allow = False
                            End If
                        End If
                        TodosPermisos(indice).perms(cellLoc.Row).deny = True
                    End If
                    bOWCheck(cellLoc.Row) = True
                End If
            End If

            If Not TodosPermisos(indice).modificado Then
                Dim tperms As New Permissions
                tperms.usuario = TodosPermisos(indice).usuario
                tperms.modificado = False
                tperms.perms = TodosPermisos(indice).perms
                TodosPermisos.RemoveAt(indice)
                TodosPermisos.Add(tperms)
            End If
            'Habilitar los botones aceptar y aplicar
            permisChange = True
            AcceptButton.Enabled = True
            CancelButton.Enabled = True
            ApplyButton.Enabled = True
        End If

    End Sub

    Private Function WhichCell(ByVal lvw As ListView, ByVal X As Integer, ByVal Y As Integer) As MyCell
        '==========================================================================
        ' Name:     WhichCell
        ' Purpose:  Devolver la celda que ha sido seleccionada
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   1 Mycell: La Celda
        ' Calls:    None
        '==========================================================================
        Dim colstart As Integer = 0
        Dim colend As Integer = 0
        Dim xCol As Integer
        'Columna
        For xCol = 0 To (PermisListView.Columns.Count - 1)
            colend = colend + PermisListView.Columns(xCol).Width
            If colstart <= X And X <= colend Then
                WhichCell.Col = xCol + 1
                Exit For
            End If
            colstart = colstart + PermisListView.Columns(xCol).Width
        Next
        'Fila
        WhichCell.Row = PermisListView.FocusedItem.Index
        Return WhichCell
    End Function

    Private Sub UsersGroupsListView_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles UsersGroupsListView.Click
        '==========================================================================
        ' Name:     UsersGroupsListView_Click
        ' Purpose:  Actualizar el listview de los permisos con los del objeto seleccionado
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   1 Mycell: La Celda
        ' Calls:    None
        '==========================================================================
        Me.Cursor = Cursors.WaitCursor
        Dim item As ListViewItem
        Dim seleccionados As ListView.SelectedListViewItemCollection = UsersGroupsListView.SelectedItems
        Dim equipodn As String = GenericClass.GetDN(Equipo)
        'Buscar el objeto seleccionado en la estructura auxiliar y cargar sus datos
        For Each item In seleccionados
            seleccionado = item.Index
            UGNameLabel.Text = item.Text

            Dim esta As Boolean = False
            Dim ind As Integer = 0
            For i = 0 To TodosPermisos.Count - 1
                If TodosPermisos(i).usuario = item.Text Then
                    esta = True
                    ind = i
                    Exit For
                End If
            Next

            If Not esta Then
                'Cargar los datos del seleccionado por primera vez
                Dim j As Integer = item.Index
                Dim permisos(19) As allowDeny
                For i = 0 To 19
                    Try
                        Dim allow() As Boolean = MailClass.GetAcePermissionComputerNT(UsersGroupsListView.Items(j).Text, equipodn, PermisListView.Items(i).SubItems(0).Text)
                        permisos(i).fijoA = allow(2)
                        permisos(i).fijoD = allow(3)
                        If allow(0) Then
                            permisos(i).allow = True
                        Else
                            permisos(i).allow = False
                        End If
                        If allow(1) Then
                            permisos(i).deny = True
                        Else
                            permisos(i).deny = False
                        End If
                    Catch ex As Exception
                        MsgBox("Error al asignar el permiso" & PermisListView.Items(i).SubItems(0).Text & "para el equipo" & Equipo & " a " & UsersGroupsListView.Items(j).Text & ex.Message)
                        'salida = salida & vbCrLf & "Error: al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                        'HayError = True
                        SecurityPanel.Visible = True
                        SecurityPanel.Dock = DockStyle.Fill
                        ManagedByPanel.Visible = False
                        OSPanel.Visible = False
                        GeneralPanel.Visible = False
                        MemberOfPanel.Visible = False
                        ObjectPanel.Visible = False
                    End Try
                Next
                Dim Tperms As Permissions
                Tperms.perms = permisos
                Tperms.usuario = UsersGroupsListView.Items(j).Text
                Tperms.modificado = False
                TodosPermisos.Add(Tperms)

                'Se cargan en el listView los permisos del objeto
                ind = TodosPermisos.Count - 1
                UGNameLabel.Text = TodosPermisos(ind).usuario
                For i = 0 To 19
                    If TodosPermisos(ind).perms(i).allow Then
                        PermisListView.Items(i).SubItems(1).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(1).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                    End If
                    If TodosPermisos(ind).perms(i).deny Then
                        PermisListView.Items(i).SubItems(2).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(2).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                    End If
                Next
            Else
                'Actualizar el listview con los permisos del seleccionado
                For i = 0 To 19
                    If TodosPermisos(ind).perms(i).allow Then
                        PermisListView.Items(i).SubItems(1).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(1).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                    End If
                    If TodosPermisos(ind).perms(i).deny Then
                        PermisListView.Items(i).SubItems(2).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(2).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                    End If
                Next
            End If

        Next
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub AddPButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddPButton.Click
        '==========================================================================
        ' Name:     AddPButton_Click
        ' Purpose:  Añadir nuevo objeto a los listview de los permisos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================


        Añadir.ShowDialog()

        If Not Objeto = "" Then
            Dim puede As Boolean = True
            For i = 0 To UsersGroupsListView.Items.Count - 1
                If UsersGroupsListView.Items(i).Text = Objeto Then
                    puede = False
                End If
            Next
            If puede Then
                usersadd = True
                'insertar en el listbox de los nombres
                Dim item As ListViewItem
                item = New ListViewItem(Objeto)
                UsersGroupsListView.Items.Add(item)
                'Dim ind As Integer
                'For i = 0 To UsersGroupsListView.Items.Count - 1
                '    If UsersGroupsListView.Items(i).Text = Objeto Then
                '        ind = i
                '    End If
                'Next

                'seleccionado = ind

                'cargar sus datos en la estructura provisional
                Dim permisos(19) As allowDeny
                For i = 0 To 19
                    permisos(i).allow = False
                    permisos(i).deny = False
                Next
                permisos(1).allow = True
                For i = 1 To 4
                    permisos(2 * i + 10).allow = True
                Next
                Dim Tperms As Permissions
                Tperms.perms = permisos
                Tperms.usuario = Objeto
                TodosPermisos.Add(Tperms)
                'TodosPermisos.Insert(ind, Tperms)
                seleccionado = TodosPermisos.Count - 1
                'sacar datos en el listview de los permisos
                UGNameLabel.Text = Objeto
                For i = 0 To 19
                    PermisListView.Items(i).SubItems(1).Text = (Chr(168))
                    PermisListView.Items(i).SubItems(2).Text = (Chr(168))
                Next
                PermisListView.Items(1).SubItems(1).Text = (Chr(254))
                For i = 1 To 4
                    PermisListView.Items(2 * i + 10).SubItems(1).Text = (Chr(254))
                Next

                'Habilitar los botones aceptar y aplicar
                AcceptButton.Enabled = True
                ApplyButton.Enabled = True
                CancelButton.Enabled = True
            Else
                MsgBox("El elemento seleccionado ya pertenece al grupo")
            End If
        Else
            MsgBox("No se ha seleccionado ningún elemento a insertar")
        End If
    End Sub

    Private Sub RemovePButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemovePButton.Click
        '==========================================================================
        ' Name:     RemovePButton_Click
        ' Purpose:  Eliminar objeto de los listview de los permisos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================


        Dim seleccionados As ListView.SelectedListViewItemCollection = UsersGroupsListView.SelectedItems
        If seleccionados.Count > 0 Then
            usersremove = True
            'Eliminar seleccionado del listview y añadirlo al array de objetos a borrar
            For Each item In seleccionados
                UsersToRemove.Add(item.text)
                For i = 0 To TodosPermisos.Count - 1
                    If TodosPermisos(i).usuario = item.text Then
                        TodosPermisos.RemoveAt(i)
                        item.Remove()
                        Exit For
                    End If
                Next
            Next

            'Actualizar el listview de permisos con los del primer objeto con permisos
            seleccionado = 0
            UGNameLabel.Text = UsersGroupsListView.Items(0).Text
            For i = 0 To 19
                If TodosPermisos(0).perms(i).allow Then
                    PermisListView.Items(i).SubItems(1).Text = (Chr(254))
                    If TodosPermisos(0).perms(i).fijoA Then
                        PermisListView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                    Else
                        PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                    End If
                Else
                    PermisListView.Items(i).SubItems(1).Text = (Chr(168))
                    PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                End If
                If TodosPermisos(0).perms(i).deny Then
                    PermisListView.Items(i).SubItems(2).Text = (Chr(254))
                    If TodosPermisos(0).perms(i).fijoD Then
                        PermisListView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                    Else
                        PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                    End If
                Else
                    PermisListView.Items(i).SubItems(2).Text = (Chr(168))
                    PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                End If
            Next

            'Habilitar los botones aceptar y aplicar
            AcceptButton.Enabled = True
            ApplyButton.Enabled = True
            CancelButton.Enabled = True
        Else
            MsgBox("No se ha seleccionado ningún elemento a eliminar")
        End If
    End Sub

    '----------------------------------------------------------------------------------------------------------------------------------------

    '----------------------------------------------------------------------------------------------------------------------------------------
    '--------------------------------------------------------------Paneles-------------------------------------------------------------------
    Private Sub GeneralStripButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GeneralStripButton.Click
        '==========================================================================
        ' Name:     GeneralStripButton_Click
        ' Purpose:  Visualizar el panel y ocultar los demás
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        GeneralPanel.Visible = True
        GeneralPanel.Dock = DockStyle.Fill
        MemberOfPanel.Visible = False
        OSPanel.Visible = False
        ManagedByPanel.Visible = False
        ObjectPanel.Visible = False
        SecurityPanel.Visible = False
    End Sub

    Private Sub ManagedByToolStripButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ManagedByToolStripButton.Click
        '==========================================================================
        ' Name:     ManagedByToolStripButton_Click
        ' Purpose:  Visualizar el panel y ocultar los demás
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        ManagedByPanel.Visible = True
        ManagedByPanel.Dock = DockStyle.Fill
        MemberOfPanel.Visible = False
        OSPanel.Visible = False
        GeneralPanel.Visible = False
        ObjectPanel.Visible = False
        SecurityPanel.Visible = False
    End Sub

    Private Sub MemberOfToolStripButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MemberOfToolStripButton.Click
        '==========================================================================
        ' Name:     MemberOfToolStripButton_Click
        ' Purpose:  Visualizar el panel y ocultar los demás
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        MemberOfPanel.Visible = True
        MemberOfPanel.Dock = DockStyle.Fill
        ManagedByPanel.Visible = False
        OSPanel.Visible = False
        GeneralPanel.Visible = False
        ObjectPanel.Visible = False
        SecurityPanel.Visible = False
    End Sub

    Private Sub SecurityStripButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles SecurityStripButton.Click
        '==========================================================================
        ' Name:     MemberOfToolStripButton_Click
        ' Purpose:  Visualizar el panel, cargar sus datos y ocultar los demás
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    GetAcePermissionComputerNT, GetDaclNamesNT de MailClass
        '==========================================================================
        Dim HayError As Boolean = False
        Dim salida As String
        If sinsec Then
            '----------------------------------------------------------------------------------------------------------------------------------
            '----------------------------------------------------------Security----------------------------------------------------------------
            If PrimeraSeguridad Then
                Me.Cursor = Cursors.WaitCursor
                Dim equipodn As String = GenericClass.GetDN(Equipo)

                '-------------------------------------Listview Usuarios-----------------------------------------
                'Crear listview de objetos con permisos
                UsersGroupsListView.ShowItemToolTips = True
                UsersGroupsListView.View = View.Details
                UsersGroupsListView.Clear()
                UsersGroupsListView.Columns.Add("", 380, HorizontalAlignment.Left)

                'Obtener los objetos con permisos e incluirlos en el listview
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                Try
                    GrantedUsers = MailClass.GetDaclNamesNT(Equipo)
                    For i = 0 To GrantedUsers.Count - 1
                        Dim item As ListViewItem
                        item = New ListViewItem(GrantedUsers(i).ToString)
                        UsersGroupsListView.Items.Add(item)
                    Next
                Catch ex As Exception
                    MsgBox("Error al obtener objetos con permisos sobre el equipo " & ex.Message)
                    salida = salida & vbCrLf & "Error al obtener objetos con permisos sobre el equipo " & Equipo & ex.Message
                    HayError = True
                    SecurityPanel.Visible = True
                    SecurityPanel.Dock = DockStyle.Fill
                    ManagedByPanel.Visible = False
                    OSPanel.Visible = False
                    GeneralPanel.Visible = False
                    MemberOfPanel.Visible = False
                    ObjectPanel.Visible = False
                End Try
                UsersGroupsListView.Sorting = SortOrder.Ascending

                '-------------------------------------Listview Permisos-----------------------------------------
                'Crear el listview de los permisos
                Dim myCheckFont As New System.Drawing.Font("Wingdings", 12, FontStyle.Regular)
                'Nombres de las columnas
                PermisListView.Columns.Add("Permiso", 280, HorizontalAlignment.Left)
                PermisListView.Columns.Add("Allow", 40, HorizontalAlignment.Center)
                PermisListView.Columns.Add("Deny", 40, HorizontalAlignment.Center)

                'Nombres de las filas
                Dim opcion(19) As String
                opcion(0) = "Control total"
                opcion(1) = "Lectura"
                opcion(2) = "Escritura"
                opcion(3) = "Crear todos los objetos hijo"
                opcion(4) = "Eliminar todos los objetos hijo"
                opcion(5) = "Permiso de autenticarse"
                opcion(6) = "cambio Password"
                opcion(7) = "Recibir como"
                opcion(8) = "Reset password"
                opcion(9) = "Enviar como"
                opcion(10) = "Escritura validada del DNS Host name"
                opcion(11) = "Escritura validada del nombre del servicio principal"
                opcion(12) = "Lectura de restricciones de la cuenta"
                opcion(13) = "Escritura de restricciones de la cuenta"
                opcion(14) = "Lectura de atributos del DNS Host name"
                opcion(15) = "Escritura de atributos del DNS Host name"
                opcion(16) = "Lectura de información  personal"
                opcion(17) = "Escritura de información  personal"
                opcion(18) = "Lectura de información pública"
                opcion(19) = "Escritura de información pública"

                'Insertar filas
                With PermisListView
                    For I As Integer = 0 To 19
                        .Items.Add(opcion(I))
                        .Items(I).UseItemStyleForSubItems = False
                        'Los checkbox de cada fila se crean con caracteres especiales con forma de checkbos seleccionado y checkbox sin seleccionar
                        .Items(I).SubItems.Add(Chr(254))
                        .Items(I).SubItems.Add(Chr(168))
                        .Items(I).SubItems.Item(1).ForeColor = Color.Black
                        .Items(I).SubItems.Item(1).Font = myCheckFont
                        .Items(I).SubItems.Item(2).ForeColor = Color.Black
                        .Items(I).SubItems.Item(2).Font = myCheckFont
                        ReDim bOWCheck(I)
                    Next I
                End With

                '-------------------------------Carga de la tabla-------------------------------
                'Para cada objeto con permisos incluirlos en la estructura provisional
                Dim j As Integer = 0
                'For j = 0 To GrantedUsers.Count - 1
                Dim permisos(19) As allowDeny
                For i = 0 To 19
                    Try
                        Dim allow() As Boolean = MailClass.GetAcePermissionComputerNT(UsersGroupsListView.Items(j).Text, equipodn, PermisListView.Items(i).SubItems(0).Text)
                        permisos(i).fijoA = allow(2)
                        permisos(i).fijoD = allow(3)
                        If allow(0) Then
                            permisos(i).allow = True
                        Else
                            permisos(i).allow = False
                        End If
                        If allow(1) Then
                            permisos(i).deny = True
                        Else
                            permisos(i).deny = False
                        End If
                    Catch ex As Exception
                        MsgBox("Error al asignar el permiso" & PermisListView.Items(i).SubItems(0).Text & "para el equipo" & Equipo & " a " & UsersGroupsListView.Items(j).Text & ex.Message)
                        salida = salida & vbCrLf & "Error: al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                        HayError = True
                        SecurityPanel.Visible = True
                        SecurityPanel.Dock = DockStyle.Fill
                        ManagedByPanel.Visible = False
                        OSPanel.Visible = False
                        GeneralPanel.Visible = False
                        MemberOfPanel.Visible = False
                        ObjectPanel.Visible = False
                    End Try
                Next
                Dim Tperms As Permissions
                Tperms.modificado = False
                Tperms.perms = permisos
                Tperms.usuario = UsersGroupsListView.Items(j).Text
                TodosPermisos.Add(Tperms)

                'Next

                'Actualizar el listview de permisos con los del primer objeto con permisos
                UGNameLabel.Text = TodosPermisos(0).usuario
                For i = 0 To 19
                    If TodosPermisos(0).perms(i).allow Then
                        PermisListView.Items(i).SubItems(1).Text = (Chr(254))
                        If TodosPermisos(0).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(1).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                    End If
                    If TodosPermisos(0).perms(i).deny Then
                        PermisListView.Items(i).SubItems(2).Text = (Chr(254))
                        If TodosPermisos(0).perms(i).fijoD Then
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(2).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                    End If
                Next
                PrimeraSeguridad = False
                Me.Cursor = Cursors.Default
            End If


            sinsec = False
        End If

        If HayError Then
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        End If

        'Visualizar el panel Security y ocultar los demás
        SecurityPanel.Visible = True
        SecurityPanel.Dock = DockStyle.Fill
        ManagedByPanel.Visible = False
        OSPanel.Visible = False
        GeneralPanel.Visible = False
        MemberOfPanel.Visible = False
        ObjectPanel.Visible = False
    End Sub

    Private Sub OPSToolStripButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles OPSToolStripButton.Click
        '==========================================================================
        ' Name:     OPSToolStripButton_Click
        ' Purpose:  Visualizar el panel y ocultar los demás
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        OSPanel.Visible = True
        OSPanel.Dock = DockStyle.Fill
        ManagedByPanel.Visible = False
        ObjectPanel.Visible = False
        GeneralPanel.Visible = False
        MemberOfPanel.Visible = False
        SecurityPanel.Visible = False
    End Sub

    Private Sub ObjectToolStripButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ObjectToolStripButton.Click
        '==========================================================================
        ' Name:     ObjectToolStripButton_Click
        ' Purpose:  Visualizar el panel y ocultar los demás
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        ObjectPanel.Visible = True
        ObjectPanel.Dock = DockStyle.Fill
        ManagedByPanel.Visible = False
        OSPanel.Visible = False
        GeneralPanel.Visible = False
        MemberOfPanel.Visible = False
        SecurityPanel.Visible = False
    End Sub

    '------------------------------------------------------------------------------------------------------------------------------------------

    Private Sub DescriptionTextBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles DescriptionTextBox.TextChanged
        '==========================================================================
        ' Name:     DescriptionTextBox_TextChanged
        ' Purpose:  Controlar los cambios que se producen al cambiar el texto del textbox
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Si no es la primera carga de datos 
        If Not primera Then
            'Marcar el cambio del textbox
            descriptionchanged = True
            'Habilitar los botones aceptar y aplicar
            AcceptButton.Enabled = True
            CancelButton.Enabled = True
            ApplyButton.Enabled = True
        End If

    End Sub

    '----------------------------------------------------Member of------------------------------------------------------------------------------
    Private Sub AddMemberOfButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddMemberOfButton.Click
        '==========================================================================
        ' Name:     AddMemberOfButton_Click
        ' Purpose:  Añadir un grupo al que de entre los que es miembro el equipo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    GetComputerGroups de genericClass
        '           getGroupadress de groupClass
        '==========================================================================

        'Llamar a la ventana para elegir el grupo a incluir
        Añadir.Solo("group")
        Añadir.ShowDialog()

        If Not Objeto = "" Then
            groupslviewchanged = True
            Dim encontrado As Boolean = False
            Dim grupos As New List(Of String)
            grupos = GenericClass.GetComputerGroups(Equipo)
            encontrado = False
            'Buscar que el grupo no sea ya uno de los que el equipo es miembro
            For j = 0 To grupos.Count - 1
                If grupos(j) = Objeto Then
                    encontrado = True
                End If
            Next
            Dim GrupoA As String = groupClass.getGroupadress(Objeto)
            If Objeto = "" Or GrupoA = "" Then
                MsgBox("faltan datos")
            ElseIf encontrado Then
                MsgBox("El usuario ya pertenece a ese grupo")
            Else
                'Si no lo es añadir al listview si se puede(si grupo y equipo pertenecen al mismo dominio)
                If Not Objeto = "" Then
                    Dim adress As String = GrupoA.Replace("/" & Objeto, "")
                    Dim tempNode As ListViewItem
                    Dim padre(1) As String
                    padre(0) = Objeto
                    padre(1) = adress
                    tempNode = New ListViewItem(padre)
                    GroupsListView.Items.Add(tempNode)

                    If Not primera Then
                        'Habilitar botones aceptar y aplicar
                        AcceptButton.Enabled = True
                        CancelButton.Enabled = True
                        ApplyButton.Enabled = True
                    End If
                End If
            End If
        Else
            MsgBox("No se ha seleccionado ningún grupo al que añadir el equipo como miembro")
        End If

    End Sub

    Private Sub RemoveMemberOfButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RemoveMemberOfButton.Click
        '==========================================================================
        ' Name:     AddMemberOfButton_Click
        ' Purpose:  Eliminar un grupo de entre los que es miembro el equipo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================


        Dim seleccionados As ListView.SelectedListViewItemCollection = Me.GroupsListView.SelectedItems
        If seleccionados.Count > 0 Then
            groupslviewchanged = True
            Dim item As ListViewItem
            Dim i As Integer = 0
            Dim gruposEliminar(seleccionados.Count - 1) As String

            'Eliminar del listview los grupos seleccionados
            For Each item In seleccionados
                If item.ForeColor = Color.MediumTurquoise Then
                    MsgBox("No se puede eliminar el grupo primario")
                Else
                    removeGroups.Add(item.SubItems(0).Text)
                    item.Remove()
                End If

            Next

            ''Añadir al array de los grupos a borrar los seleccionados
            'If groupsToRemove Then
            '    i = removeGroups.Length
            '    For j = 0 To gruposEliminar.Length - 1
            '        removeGroups(i) = gruposEliminar(j)
            '        i = i + 1
            '    Next
            'Else
            '    removeGroups = gruposEliminar
            'End If

            If Not primera Then
                'Habilitar los botones aceptar y aplicar
                AcceptButton.Enabled = True
                CancelButton.Enabled = True
                ApplyButton.Enabled = True
            End If
            groupsToRemove = True

        Else
            MsgBox("No se ha seleccionado ningún grupo")
        End If
    End Sub

    Private Sub SetPrGroupButton_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        '==========================================================================
        ' Name:     SetPrGroupButton_Click
        ' Purpose:  Establecer el grupo seleccionado como el primario del equipo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Darle al grupo seleccionado el color azul
        GroupsListView.SelectedItems(0).ForeColor = Color.MediumTurquoise
        'A los demás darle el color negro
        Dim seleccionado As String = GroupsListView.SelectedItems(0).SubItems(0).Text
        For i = 0 To GroupsListView.Items.Count - 1
            If Not GroupsListView.Items(i).SubItems(0).Text = seleccionado Then
                GroupsListView.Items(i).ForeColor = Color.Black
            End If
        Next
        groupslviewchanged = True
        If Not primera Then
            'Habilitar los botones aplicar y aceptar
            AcceptButton.Enabled = True
            CancelButton.Enabled = True
            ApplyButton.Enabled = True
        End If

    End Sub

    '------------------------------------------------------Managed By--------------------------------------------------------------------------
    Private Sub changeButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles changeButton.Click
        '==========================================================================
        ' Name:     changeButton_Click
        ' Purpose:  Establecer el usuario administrador del equipo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Llamar a la ventana de selección mediante búsqueda del usuario
        Añadir.Solo("user")
        Añadir.ShowDialog()
        'Si el objeto no es vacio insertarlo en el textbox
        If Not Objeto = "" Then
            ManagerTextBox.Text = UserClass.GetUserProperty(Objeto, "distinguishedName")
            'Marcar cambio de administrador
            managerchange = True
            'Habilitar los botones del panel mas el de aceptar y el de aplicar
            AcceptButton.Enabled = True
            ApplyButton.Enabled = True
            ClearButton.Enabled = True
            PropertiesButton.Enabled = True
        Else
            MsgBox("No se ha seleccionado ningún usuario para establecerlo como administrador del equipo")
        End If

    End Sub

    Private Sub PropertiesButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PropertiesButton.Click
        '==========================================================================
        ' Name:     PropertiesButton_Click
        ' Purpose:  Obtener la ventana de propiedades del usuario administrador del equipo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    GetUserlogonN de UserClass
        '==========================================================================

        If Not ManagerTextBox.Text = "" Then
            'Si hay usuario administrador sacar su ventana de propiedades
            Me.Cursor = Cursors.WaitCursor
            If Not UserProperties.Visible Then
                UserProperties.LoadUser(UserClass.GetUserlogonN(ManagerTextBox.Text))
                UserProperties.Show()
            Else
                MsgBox("Solo puede haber una ventana de propiedades de usuario abierta")
            End If

            Me.Cursor = Cursors.Default
        Else
            MsgBox("No hay un administrador del que obtener sus propiedades")
        End If

    End Sub

    Private Sub ClearButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearButton.Click
        '==========================================================================
        ' Name:     ClearButton_Click
        ' Purpose:  Obtener la ventana de propiedades del usuario administrador del equipo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    GetUserlogonN de UserClass
        '==========================================================================

        If Not ManagerTextBox.Text = "" Then
            'Si hay usuario administrador del equipo, borra el textbox
            ManagerTextBox.Text = ""
            'Marcar que hay cambio en el administrador
            managerchange = True
            'Deshabilitar el botón de propiedades
            PropertiesButton.Enabled = False
            'Deshabilitarse a sí mismo
            ClearButton.Enabled = False
            'Habilitar el botón de aceptar y el de aplicar
            AcceptButton.Enabled = True
            ApplyButton.Enabled = True
            CancelButton.Enabled = True
        Else
            MsgBox("No hay un administrador que quitar")
        End If

    End Sub

    '------------------------------------------------------Botones------------------------------------------------------------------------------

    Private Sub ApplyButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ApplyButton.Click
        '==========================================================================
        ' Name:     ApplyButton_Click
        ' Purpose:  Aplicar los cambios realizados en la ventana y deshabilitar los botones aceptar y aplicar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    ClearProperty, GetComputerGroups, setPrimaryGroup,SetComputerProperty,
        '           RemoveMemberOfGroup de GenericClass
        '           AddToGroup de groupClass
        '           RemoveAceFromDaclComputerNT, AddAceToDaclComputerNT, GetAcePermissionComputerNT, GetDaclNamesNT 
        '==========================================================================
        Try
            Dim equipodn As String = GenericClass.GetDN(Equipo)
            Dim salida As String = "-------Propiedades Grupo-------" & vbCrLf & "Cambios realizados al hacer click en el botón aplicar"
            salida = salida & vbCrLf & "Nombre del equipo:" & Equipo
            Dim HayError As Boolean = False
            Me.Cursor = Cursors.WaitCursor
            '---------------------------------------------------General--------------------------------------------------------
            'Aplicar cambios en el textbox descripción
            If Namechanged Then
                If Not NameTextBox.Text = "" Then
                    If Not UserClass.UserNameExists(NameTextBox.Text) Or GenericClass.ComputerExists(NameTextBox.Text) Or groupClass.GroupExists(NameTextBox.Text) Then
                        If Not checkRejexCName(NameTextBox.Text) Then
                            salida = salida & vbCrLf & "nombre:" & NameTextBox.Text
                            Try
                                GenericClass.Rename(Equipo, NameTextBox.Text, "computer")
                            Catch ex As Exception When DescriptionTextBox.Text = ""
                                MsgBox("Error al asignar el nombre al equipo" & ex.Message)
                                salida = salida & vbCrLf & "Error: al asignar el nombre al equipo" & ex.Message
                                HayError = True
                                GeneralPanel.Visible = True
                                GeneralPanel.Dock = DockStyle.Fill
                                MemberOfPanel.Visible = False
                                OSPanel.Visible = False
                                ManagedByPanel.Visible = False
                                ObjectPanel.Visible = False
                                SecurityPanel.Visible = False
                            End Try
                            Try
                                GenericClass.SetComputerProperty(Equipo, "sAMAccountName", NameTextBox.Text & "$")
                            Catch ex As Exception When DescriptionTextBox.Text = ""
                                MsgBox("Error al asignar el nombre de Login al equipo" & ex.Message)
                                salida = salida & vbCrLf & "Error: al asignar el nombre de Login al equipo " & ex.Message
                                HayError = True
                                GeneralPanel.Visible = True
                                GeneralPanel.Dock = DockStyle.Fill
                                MemberOfPanel.Visible = False
                                OSPanel.Visible = False
                                ManagedByPanel.Visible = False
                                ObjectPanel.Visible = False
                                SecurityPanel.Visible = False
                            End Try
                            Namechanged = False
                            NameLabel.Text = NameTextBox.Text
                            Equipo = NameTextBox.Text & "$"
                            equipodn = GenericClass.GetComputerProperty(Equipo, "distinguishedName")
                        Else
                            MsgBox("El nombre no tiene el formato adecuado")
                            salida = salida & vbCrLf & "Error: al asignar el nombre al equipo, El nombre no tiene el formato adecuado"
                            HayError = True
                            GeneralPanel.Visible = True
                            GeneralPanel.Dock = DockStyle.Fill
                            MemberOfPanel.Visible = False
                            OSPanel.Visible = False
                            ManagedByPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        End If

                    Else
                        MsgBox("Error al asignar el nombre al equipo, El nombre ya existe en el dominio")
                        salida = salida & vbCrLf & "Error: al asignar el nombre al equipo, El nombre ya existe en el dominio"
                        HayError = True
                        GeneralPanel.Visible = True
                        GeneralPanel.Dock = DockStyle.Fill
                        MemberOfPanel.Visible = False
                        OSPanel.Visible = False
                        ManagedByPanel.Visible = False
                        ObjectPanel.Visible = False
                        SecurityPanel.Visible = False
                    End If

                Else
                    MsgBox("El equipo debe tener algún nombre")
                    salida = salida & vbCrLf & "Error: al asignar el nombre al equipo, El equipo debe tener algún nombre"
                    HayError = True
                    GeneralPanel.Visible = True
                    GeneralPanel.Dock = DockStyle.Fill
                    MemberOfPanel.Visible = False
                    OSPanel.Visible = False
                    ManagedByPanel.Visible = False
                    ObjectPanel.Visible = False
                    SecurityPanel.Visible = False
                End If
                Namechanged = False
            End If
            If descriptionchanged Then
                If Not DescriptionTextBox.Text = "" Then
                    salida = salida & vbCrLf & "descripción:" & DescriptionTextBox.Text
                    Try
                        GenericClass.SetComputerProperty(Equipo, "description", DescriptionTextBox.Text)
                    Catch ex As Exception When DescriptionTextBox.Text = ""
                        MsgBox("Error al asignar la descripción al grupo, el dato descripción debe tener algún valor " & ex.Message)
                        salida = salida & vbCrLf & "Error: al asignar la descripción al grupo, el dato descripción debe tener algún valor " & ex.Message
                        HayError = True
                        GeneralPanel.Visible = True
                        GeneralPanel.Dock = DockStyle.Fill
                        MemberOfPanel.Visible = False
                        OSPanel.Visible = False
                        ManagedByPanel.Visible = False
                        ObjectPanel.Visible = False
                        SecurityPanel.Visible = False
                    Catch ex As Exception
                        MsgBox("Error al asignar la descripción al grupo " & ex.Message)
                        salida = salida & vbCrLf & "Error: al asignar la descripción al grupo " & ex.Message
                        HayError = True
                        GeneralPanel.Visible = True
                        GeneralPanel.Dock = DockStyle.Fill
                        MemberOfPanel.Visible = False
                        OSPanel.Visible = False
                        ManagedByPanel.Visible = False
                        ObjectPanel.Visible = False
                        SecurityPanel.Visible = False
                    End Try
                Else
                    GenericClass.ClearProperty(Equipo, "description")
                End If
                descriptionchanged = False
            End If
            '--------------------------------------------------MemberOf------------------------------------------------------------------
            If groupslviewchanged Then
                salida = salida & vbCrLf & "cambios en los grupos de los que es miembro el grupo"
                'Obtener el grupo primario
                Dim token As String = GenericClass.GetComputerPropertyRefresh(Equipo, "primaryGroupID")
                Dim Prim As String = UserClass.GetPrimaryGroup(token, Equipo)
                'Obtener los demás grupos del usuario
                Dim grupos As List(Of String) = GenericClass.GetComputerGroups(Equipo)
                Try

                    'groupClass.SetGroupPropertyRemove(Grupo, "memberOf")
                    If grupos.Count > 0 Then
                        For i = 0 To grupos.Count - 1
                            If Not grupos(i) = Prim Then
                                groupClass.RemoveMemberOfGroup(Equipo, grupos(i))
                            End If
                        Next
                    End If
                Catch ex As AccessViolationException
                    MsgBox("Error al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no tiens permisos para hacerlo" & ex.Message)
                    salida = salida & vbCrLf & "Error: al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no se tenían permisos para hacerlo" & ex.Message
                    HayError = True
                    MemberOfPanel.Visible = True
                    MemberOfPanel.Dock = DockStyle.Fill
                    ManagedByPanel.Visible = False
                    OSPanel.Visible = False
                    GeneralPanel.Visible = False
                    ObjectPanel.Visible = False
                    SecurityPanel.Visible = False
                Catch ex As FieldAccessException
                    MsgBox("Error al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no tiens permisos para hacerlo" & ex.Message)
                    salida = salida & vbCrLf & "Error: al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no se tenían permisos para hacerlo" & ex.Message
                    HayError = True
                    MemberOfPanel.Visible = True
                    MemberOfPanel.Dock = DockStyle.Fill
                    ManagedByPanel.Visible = False
                    OSPanel.Visible = False
                    GeneralPanel.Visible = False
                    ObjectPanel.Visible = False
                    SecurityPanel.Visible = False
                Catch ex As MemberAccessException
                    MsgBox("Error al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no tiens permisos para hacerlo" & ex.Message)
                    salida = salida & vbCrLf & "Error: al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no se tenían permisos para hacerlo" & ex.Message
                    HayError = True
                    MemberOfPanel.Visible = True
                    MemberOfPanel.Dock = DockStyle.Fill
                    ManagedByPanel.Visible = False
                    OSPanel.Visible = False
                    GeneralPanel.Visible = False
                    ObjectPanel.Visible = False
                    SecurityPanel.Visible = False
                Catch ex As UnauthorizedAccessException
                    MsgBox("Error al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no tiens permisos para hacerlo" & ex.Message)
                    salida = salida & vbCrLf & "Error: al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no se tenían permisos para hacerlo" & ex.Message
                    HayError = True
                    MemberOfPanel.Visible = True
                    MemberOfPanel.Dock = DockStyle.Fill
                    ManagedByPanel.Visible = False
                    OSPanel.Visible = False
                    GeneralPanel.Visible = False
                    ObjectPanel.Visible = False
                    SecurityPanel.Visible = False
                Catch ex As Exception
                    MsgBox("Error al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos" & ex.Message)
                    salida = salida & vbCrLf & "Error: al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos" & ex.Message
                    HayError = True
                    MemberOfPanel.Visible = True
                    MemberOfPanel.Dock = DockStyle.Fill
                    ManagedByPanel.Visible = False
                    OSPanel.Visible = False
                    GeneralPanel.Visible = False
                    ObjectPanel.Visible = False
                    SecurityPanel.Visible = False
                End Try

                For i = 0 To GroupsListView.Items.Count - 1
                    'Dim DN As String = GenericClass.GetDNCanonicalN(GroupsListView.Items(i).SubItems(1).Text)
                    If Not GroupsListView.Items(i).Text = Prim Then
                        Dim logN As String = GroupsListView.Items(i).SubItems(0).Text
                        Dim lnewlist As New List(Of String)
                        lnewlist = groupClass.GetGroupMembers(logN)
                        Try
                            groupClass.SetGroupPropertyInsert(logN, "member", GenericClass.GetDN(Equipo), lnewlist.Count)
                        Catch ex As AccessViolationException
                            MsgBox("Error, por falta de permisos, al añadir el equipo al grupo " & logN)
                            salida = salida & vbCrLf & "Error por falta de permisos: al añadir el equipo al grupo " & GroupsListView.Items(i).SubItems(0).Text & ex.Message
                            HayError = True
                            MemberOfPanel.Visible = True
                            MemberOfPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        Catch ex As FieldAccessException
                            MsgBox("Error, por falta de permisos, al añadir el equipo al grupo " & logN)
                            salida = salida & vbCrLf & "Error por falta de permisos: al añadir el equipo al grupo " & GroupsListView.Items(i).SubItems(0).Text & ex.Message
                            HayError = True
                            MemberOfPanel.Visible = True
                            MemberOfPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        Catch ex As MemberAccessException
                            MsgBox("Error, por falta de permisos, al añadir el equipo al grupo " & logN)
                            salida = salida & vbCrLf & "Error por falta de permisos: al añadir el equipo al grupo " & GroupsListView.Items(i).SubItems(0).Text & ex.Message
                            HayError = True
                            MemberOfPanel.Visible = True
                            MemberOfPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        Catch ex As UnauthorizedAccessException
                            MsgBox("Error, por falta de permisos, al añadir el equipo al grupo " & logN)
                            salida = salida & vbCrLf & "Error por falta de permisos: al añadir el equipo al grupo " & GroupsListView.Items(i).SubItems(0).Text & ex.Message
                            HayError = True
                            MemberOfPanel.Visible = True
                            MemberOfPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        Catch ex As Exception When logN = ""
                            MsgBox("Error el Grupo al que se quiere añadir el equipo no pude ser vacío " & ex.Message)
                            salida = salida & vbCrLf & "Error: el Grupo al que se quiere añadir el equipo no pude ser vacío " & ex.Message
                            HayError = True
                            MemberOfPanel.Visible = True
                            MemberOfPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        Catch ex As Exception
                            MsgBox("Error al añadir el equipo al grupo " & logN)
                            salida = salida & vbCrLf & "Error: al añadir el equipo al grupo " & GroupsListView.Items(i).SubItems(0).Text & ex.Message
                            HayError = True
                            MemberOfPanel.Visible = True
                            MemberOfPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        End Try
                    End If

                Next
                groupslviewchanged = False
            End If

            '------------------------------------------------------Managed By---------------------------------------------------------------------
            'Establecer los cambios en el administrador del equipo
            If managerchange Then
                If Not ManagerTextBox.Text = "" Then
                    salida = salida & vbCrLf & "establecer el administrador del equipo:" & ManagerTextBox.Text
                    Try
                        GenericClass.SetComputerProperty(Equipo, "managedBy", ManagerTextBox.Text)
                    Catch ex As Exception When ManagerTextBox.Text = ""
                        MsgBox("Error al asignar el administrador del equipo, el administrador no puede ser vacío " & ex.Message)
                        salida = salida & vbCrLf & "Error: al asignar el administrador del equipo, el administrador no puede ser vacío " & ex.Message
                        HayError = True
                        ManagedByPanel.Visible = True
                        ManagedByPanel.Dock = DockStyle.Fill
                        MemberOfPanel.Visible = False
                        OSPanel.Visible = False
                        GeneralPanel.Visible = False
                        ObjectPanel.Visible = False
                        SecurityPanel.Visible = False
                    Catch ex As Exception
                        MsgBox("Error al asignar " & ManagerTextBox.Text & " como administrador del equipo " & ex.Message)
                        salida = salida & vbCrLf & "Error: al asignar " & ManagerTextBox.Text & " como administrador del equipo " & ex.Message
                        HayError = True
                        ManagedByPanel.Visible = True
                        ManagedByPanel.Dock = DockStyle.Fill
                        MemberOfPanel.Visible = False
                        OSPanel.Visible = False
                        GeneralPanel.Visible = False
                        ObjectPanel.Visible = False
                        SecurityPanel.Visible = False
                    End Try
                Else
                    salida = salida & vbCrLf & "eliminar el administrador del equipo:"
                    Try
                        GenericClass.ClearProperty(Equipo, "managedBy")
                    Catch ex As Exception
                        MsgBox("Error al eliminar el administrador del equipo " & ex.Message)
                        salida = salida & vbCrLf & "Error: al eliminar el administrador del equipo " & ex.Message
                        HayError = True
                        ManagedByPanel.Visible = True
                        ManagedByPanel.Dock = DockStyle.Fill
                        MemberOfPanel.Visible = False
                        OSPanel.Visible = False
                        GeneralPanel.Visible = False
                        ObjectPanel.Visible = False
                        SecurityPanel.Visible = False
                    End Try
                End If
                managerchange = False
            End If
            '------------------------------------------------------Security-------------------------------------------------------------------------

            Dim nuevo As String = ""

            If usersadd Then
                'Si hay objetos a los que añadir permisos
                salida = salida & vbCrLf & "Conceder permisos a:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = MailClass.GetDaclNamesNT(Equipo)
                'Buscar los objetos del listview que todavía no tienen permisos
                For i = 0 To UsersGroupsListView.Items.Count - 1
                    Dim esta As Boolean = False
                    For j = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(j) = UsersGroupsListView.Items(i).Text Then
                            esta = True
                        End If
                    Next

                    If Not esta Then
                        'Para cada objeto nuevo añadir los permisos obtenidos a través de la estructura auxiliar
                        For j = 0 To TodosPermisos.Count - 1
                            If TodosPermisos(j).usuario = UsersGroupsListView.Items(i).Text Then
                                'Una vez localizado el objeto en la estructura auxiliar, añadir sus permisos
                                salida = salida & vbCrLf & UsersGroupsListView.Items(i).Text
                                For k = 0 To 19
                                    If TodosPermisos(j).perms(k).allow Then
                                        Try
                                            MailClass.AddAceToDaclComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text, "Allow")
                                        Catch ex As Exception
                                            MsgBox("Error al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                                            HayError = True
                                            SecurityPanel.Visible = True
                                            SecurityPanel.Dock = DockStyle.Fill
                                            ManagedByPanel.Visible = False
                                            OSPanel.Visible = False
                                            GeneralPanel.Visible = False
                                            MemberOfPanel.Visible = False
                                            ObjectPanel.Visible = False
                                        End Try
                                    ElseIf TodosPermisos(j).perms(k).deny Then
                                        Try
                                            MailClass.AddAceToDaclComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text, "deny")
                                        Catch ex As Exception
                                            MsgBox("Error al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                                            HayError = True
                                            SecurityPanel.Visible = True
                                            SecurityPanel.Dock = DockStyle.Fill
                                            ManagedByPanel.Visible = False
                                            OSPanel.Visible = False
                                            GeneralPanel.Visible = False
                                            MemberOfPanel.Visible = False
                                            ObjectPanel.Visible = False
                                        End Try
                                    End If
                                Next
                                nuevo = TodosPermisos(j).usuario
                            End If
                        Next
                    End If
                Next
                usersadd = False
            End If

            '-------------------------------------------Cambio de permisos a un usuario que ya tiene-------------------------------
            If permisChange Then
                'Si ha cambiado algún permisos
                salida = salida & vbCrLf & "Modificar permisos de:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = MailClass.GetDaclNamesNT(Equipo)
                Dim esta As Boolean = False
                Dim allow(1) As Boolean
                'Para cada objeto no nuevo
                For i = 0 To UsersGroupsListView.Items.Count - 1
                    For l = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(l) = UsersGroupsListView.Items(i).Text Then
                            esta = True
                        End If
                    Next
                    If esta Then
                        'Actualizar todos sus permisos
                        For j = 0 To TodosPermisos.Count - 1
                            If Not nuevo = UsersGroupsListView.Items(i).Text Then

                                If TodosPermisos(j).usuario = UsersGroupsListView.Items(i).Text And TodosPermisos(j).modificado Then
                                    'Añadir o borrar los permisos para ajustarse a los que están marcados en la estructura auxiliar
                                    For k = 0 To 19
                                        allow = MailClass.GetAcePermissionComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text)
                                        If TodosPermisos(j).perms(k).allow Then
                                            If Not allow(0) Then
                                                salida = salida & vbCrLf & "Añadir permisos a:" & UsersGroupsListView.Items(i).Text
                                                Try
                                                    MailClass.AddAceToDaclComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text, "Allow")
                                                Catch ex As Exception
                                                    MsgBox("Error al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                    SecurityPanel.Visible = True
                                                    SecurityPanel.Dock = DockStyle.Fill
                                                    ManagedByPanel.Visible = False
                                                    OSPanel.Visible = False
                                                    GeneralPanel.Visible = False
                                                    MemberOfPanel.Visible = False
                                                    ObjectPanel.Visible = False
                                                End Try
                                            End If
                                        End If
                                        If Not TodosPermisos(j).perms(k).allow Then
                                            If allow(0) Then
                                                salida = salida & vbCrLf & "Quitar permisos a:" & UsersGroupsListView.Items(i).Text
                                                Try
                                                    MailClass.RemoveAceFromDaclComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text, "Allow")
                                                Catch ex As Exception
                                                    MsgBox("Error al quitar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al quitar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                    SecurityPanel.Visible = True
                                                    SecurityPanel.Dock = DockStyle.Fill
                                                    ManagedByPanel.Visible = False
                                                    OSPanel.Visible = False
                                                    GeneralPanel.Visible = False
                                                    MemberOfPanel.Visible = False
                                                    ObjectPanel.Visible = False
                                                End Try
                                            End If
                                        End If
                                        If TodosPermisos(j).perms(k).deny Then
                                            If Not allow(1) Then
                                                salida = salida & vbCrLf & "Añadir permisos a:" & UsersGroupsListView.Items(i).Text
                                                Try
                                                    MailClass.AddAceToDaclComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text, "deny")
                                                Catch ex As Exception
                                                    MsgBox("Error al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                    SecurityPanel.Visible = True
                                                    SecurityPanel.Dock = DockStyle.Fill
                                                    ManagedByPanel.Visible = False
                                                    OSPanel.Visible = False
                                                    GeneralPanel.Visible = False
                                                    MemberOfPanel.Visible = False
                                                    ObjectPanel.Visible = False
                                                End Try
                                            End If
                                        End If
                                        If Not TodosPermisos(j).perms(k).deny Then
                                            If allow(1) Then
                                                salida = salida & vbCrLf & "Quitar permisos a:" & UsersGroupsListView.Items(i).Text
                                                Try
                                                    MailClass.RemoveAceFromDaclComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text, "deny")
                                                Catch ex As Exception
                                                    MsgBox("Error al quitar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al quitar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                    SecurityPanel.Visible = True
                                                    SecurityPanel.Dock = DockStyle.Fill
                                                    ManagedByPanel.Visible = False
                                                    OSPanel.Visible = False
                                                    GeneralPanel.Visible = False
                                                    MemberOfPanel.Visible = False
                                                    ObjectPanel.Visible = False
                                                End Try
                                            End If
                                        End If
                                    Next

                                    Dim tperms As New Permissions
                                    tperms.usuario = TodosPermisos(j).usuario
                                    tperms.modificado = False
                                    tperms.perms = TodosPermisos(j).perms
                                    TodosPermisos.RemoveAt(j)
                                    TodosPermisos.Add(tperms)

                                End If
                            End If
                Next
                    End If
                Next
                permisChange = False
            End If

            '------------------------------------------------Borrado de todos los permisos de un usuario-----------------------------
            If usersremove Then
                'Si hay objetos a los que quitarles todos sus permisos
                salida = salida & vbCrLf & "Quitar todos los permisos a:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = MailClass.GetDaclNamesNT(Equipo)
                'Buscar los objetos entre los que tienen permisos
                For i = 0 To UsersToRemove.Count - 1
                    Dim esta As Boolean = False
                    For j = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(j).Contains(UsersToRemove(i)) Then
                            esta = True
                        End If
                    Next
                    If esta Then
                        'Una vez encontrados, recorrer todos los permisos que tienen concedidos eliminándolos
                        'Si existe el objeto
                        Dim ind As Integer
                        For j = 0 To TodosPermisos.Count - 1
                            If TodosPermisos(j).usuario = UsersToRemove(i) Then
                                ind = j
                            End If
                        Next
                        salida = salida & vbCrLf & UsersToRemove(i)
                        Try
                            MailClass.RemoveAces(UsersToRemove(i), Equipo)
                        Catch ex As Exception
                            MsgBox("Error al quitar todos los permisos para el equipo a " & UsersToRemove(i) & ex.Message)
                            salida = salida & vbCrLf & "Error: al quitar todos los permisos para el equipo a " & UsersToRemove(i) & ex.Message
                            HayError = True
                            SecurityPanel.Visible = True
                            SecurityPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            MemberOfPanel.Visible = False
                            ObjectPanel.Visible = False
                        End Try
                        TodosPermisos.RemoveAt(ind)
                    End If
                Next
                usersremove = False
            End If
            Me.Cursor = Cursors.Default
            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
            '------------------------------------Deshabilitar botón Aplicar---------------------------
            AcceptButton.Enabled = True
            CancelButton.Enabled = True
            ApplyButton.Enabled = False
            Arbol.PropertiesClosed()
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub AcceptButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Aplicar los cambios realizados en la ventana y cerrar la ventana
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    ClearProperty, GetComputerGroups, setPrimaryGroup,SetComputerProperty,
        '           RemoveMemberOfGroup de GenericClass
        '           AddToGroup de groupClass
        '           RemoveAceFromDaclComputerNT, AddAceToDaclComputerNT, GetAcePermissionComputerNT, GetDaclNamesNT 
        '==========================================================================
        Try
            Dim equipodn As String = GenericClass.GetDN(Equipo)
            Dim salida As String = "-------Propiedades Grupo-------" & vbCrLf & "Cambios realizados al hacer click en el botón aceptar"
            salida = salida & vbCrLf & "Nombre del equipo:" & Equipo
            Dim HayError As Boolean = False
            Me.Cursor = Cursors.WaitCursor
            '---------------------------------------------------General--------------------------------------------------------
            If Namechanged Then
                If Not NameTextBox.Text = "" Then
                    If Not UserClass.UserNameExists(NameTextBox.Text) Or GenericClass.ComputerExists(NameTextBox.Text) Or groupClass.GroupExists(NameTextBox.Text) Then
                        If Not checkRejexCName(NameTextBox.Text) Then
                            salida = salida & vbCrLf & "nombre:" & NameTextBox.Text
                            Try
                                GenericClass.Rename(Equipo, NameTextBox.Text, "computer")
                            Catch ex As Exception When DescriptionTextBox.Text = ""
                                MsgBox("Error al asignar el nombre al equipo" & ex.Message)
                                salida = salida & vbCrLf & "Error: al asignar el nombre al equipo" & ex.Message
                                HayError = True
                                GeneralPanel.Visible = True
                                GeneralPanel.Dock = DockStyle.Fill
                                MemberOfPanel.Visible = False
                                OSPanel.Visible = False
                                ManagedByPanel.Visible = False
                                ObjectPanel.Visible = False
                                SecurityPanel.Visible = False
                            End Try
                            Try
                                GenericClass.SetComputerProperty(Equipo, "sAMAccountName", NameTextBox.Text & "$")
                            Catch ex As Exception When DescriptionTextBox.Text = ""
                                MsgBox("Error al asignar el nombre de Login al equipo" & ex.Message)
                                salida = salida & vbCrLf & "Error: al asignar el nombre de Login al equipo " & ex.Message
                                HayError = True
                                GeneralPanel.Visible = True
                                GeneralPanel.Dock = DockStyle.Fill
                                MemberOfPanel.Visible = False
                                OSPanel.Visible = False
                                ManagedByPanel.Visible = False
                                ObjectPanel.Visible = False
                                SecurityPanel.Visible = False
                            End Try
                            Namechanged = False
                            NameLabel.Text = NameTextBox.Text
                            Equipo = NameTextBox.Text & "$"
                            equipodn = GenericClass.GetComputerProperty(Equipo, "distinguishedName")
                        Else
                            MsgBox("El nombre no tiene el formato adecuado")
                            salida = salida & vbCrLf & "Error: al asignar el nombre al equipo, El nombre no tiene el formato adecuado"
                            HayError = True
                            GeneralPanel.Visible = True
                            GeneralPanel.Dock = DockStyle.Fill
                            MemberOfPanel.Visible = False
                            OSPanel.Visible = False
                            ManagedByPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        End If
                    Else
                        MsgBox("Error al asignar el nombre al equipo, El nombre ya existe en el dominio")
                        salida = salida & vbCrLf & "Error: al asignar el nombre al equipo, El nombre ya existe en el dominio"
                        HayError = True
                        GeneralPanel.Visible = True
                        GeneralPanel.Dock = DockStyle.Fill
                        MemberOfPanel.Visible = False
                        OSPanel.Visible = False
                        ManagedByPanel.Visible = False
                        ObjectPanel.Visible = False
                        SecurityPanel.Visible = False
                    End If

                Else
                    MsgBox("El equipo debe tener algún nombre")
                    salida = salida & vbCrLf & "Error: al asignar el nombre al equipo, El equipo debe tener algún nombre"
                    HayError = True
                    GeneralPanel.Visible = True
                    GeneralPanel.Dock = DockStyle.Fill
                    MemberOfPanel.Visible = False
                    OSPanel.Visible = False
                    ManagedByPanel.Visible = False
                    ObjectPanel.Visible = False
                    SecurityPanel.Visible = False
                End If
                Namechanged = False
            End If
            'Aplicar cambios en el textbox descripción
            If descriptionchanged Then
                If Not DescriptionTextBox.Text = "" Then
                    salida = salida & vbCrLf & "descripción:" & DescriptionTextBox.Text
                    Try
                        GenericClass.SetComputerProperty(Equipo, "description", DescriptionTextBox.Text)
                    Catch ex As Exception When DescriptionTextBox.Text = ""
                        MsgBox("Error al asignar la descripción al grupo, el dato descripción debe tener algún valor " & ex.Message)
                        salida = salida & vbCrLf & "Error: al asignar la descripción al grupo, el dato descripción debe tener algún valor " & ex.Message
                        HayError = True
                        GeneralPanel.Visible = True
                        GeneralPanel.Dock = DockStyle.Fill
                        MemberOfPanel.Visible = False
                        OSPanel.Visible = False
                        ManagedByPanel.Visible = False
                        ObjectPanel.Visible = False
                        SecurityPanel.Visible = False
                    Catch ex As Exception
                        MsgBox("Error al asignar la descripción al grupo " & ex.Message)
                        salida = salida & vbCrLf & "Error: al asignar la descripción al grupo " & ex.Message
                        HayError = True
                        GeneralPanel.Visible = True
                        GeneralPanel.Dock = DockStyle.Fill
                        MemberOfPanel.Visible = False
                        OSPanel.Visible = False
                        ManagedByPanel.Visible = False
                        ObjectPanel.Visible = False
                        SecurityPanel.Visible = False
                    End Try
                Else
                    GenericClass.ClearProperty(Equipo, "description")
                End If
            End If
            '--------------------------------------------------MemberOf------------------------------------------------------------------
            If groupslviewchanged Then
                salida = salida & vbCrLf & "cambios en los grupos de los que es miembro el grupo"
                'Obtener el grupo primario
                Dim token As String = GenericClass.GetComputerPropertyRefresh(Equipo, "primaryGroupID")
                Dim Prim As String = UserClass.GetPrimaryGroup(token, Equipo)
                'Obtener los demás grupos del usuario
                Dim grupos As List(Of String) = GenericClass.GetComputerGroups(Equipo)
                Try

                    'groupClass.SetGroupPropertyRemove(Grupo, "memberOf")
                    If grupos.Count > 0 Then
                        For i = 0 To grupos.Count - 1
                            If Not grupos(i) = Prim Then
                                groupClass.RemoveMemberOfGroup(Equipo, grupos(i))
                            End If
                        Next
                    End If
                Catch ex As AccessViolationException
                    MsgBox("Error al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no tiens permisos para hacerlo" & ex.Message)
                    salida = salida & vbCrLf & "Error: al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no se tenían permisos para hacerlo" & ex.Message
                    HayError = True
                    MemberOfPanel.Visible = True
                    MemberOfPanel.Dock = DockStyle.Fill
                    ManagedByPanel.Visible = False
                    OSPanel.Visible = False
                    GeneralPanel.Visible = False
                    ObjectPanel.Visible = False
                    SecurityPanel.Visible = False
                Catch ex As FieldAccessException
                    MsgBox("Error al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no tiens permisos para hacerlo" & ex.Message)
                    salida = salida & vbCrLf & "Error: al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no se tenían permisos para hacerlo" & ex.Message
                    HayError = True
                    MemberOfPanel.Visible = True
                    MemberOfPanel.Dock = DockStyle.Fill
                    ManagedByPanel.Visible = False
                    OSPanel.Visible = False
                    GeneralPanel.Visible = False
                    ObjectPanel.Visible = False
                    SecurityPanel.Visible = False
                Catch ex As MemberAccessException
                    MsgBox("Error al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no tiens permisos para hacerlo" & ex.Message)
                    salida = salida & vbCrLf & "Error: al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no se tenían permisos para hacerlo" & ex.Message
                    HayError = True
                    MemberOfPanel.Visible = True
                    MemberOfPanel.Dock = DockStyle.Fill
                    ManagedByPanel.Visible = False
                    OSPanel.Visible = False
                    GeneralPanel.Visible = False
                    ObjectPanel.Visible = False
                    SecurityPanel.Visible = False
                Catch ex As UnauthorizedAccessException
                    MsgBox("Error al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no tiens permisos para hacerlo" & ex.Message)
                    salida = salida & vbCrLf & "Error: al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos, no se tenían permisos para hacerlo" & ex.Message
                    HayError = True
                    MemberOfPanel.Visible = True
                    MemberOfPanel.Dock = DockStyle.Fill
                    ManagedByPanel.Visible = False
                    OSPanel.Visible = False
                    GeneralPanel.Visible = False
                    ObjectPanel.Visible = False
                    SecurityPanel.Visible = False
                Catch ex As Exception
                    MsgBox("Error al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos" & ex.Message)
                    salida = salida & vbCrLf & "Error: al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos" & ex.Message
                    HayError = True
                    MemberOfPanel.Visible = True
                    MemberOfPanel.Dock = DockStyle.Fill
                    ManagedByPanel.Visible = False
                    OSPanel.Visible = False
                    GeneralPanel.Visible = False
                    ObjectPanel.Visible = False
                    SecurityPanel.Visible = False
                End Try

                For i = 0 To GroupsListView.Items.Count - 1
                    'Dim DN As String = GenericClass.GetDNCanonicalN(GroupsListView.Items(i).SubItems(1).Text)
                    If Not GroupsListView.Items(i).Text = Prim Then
                        Dim logN As String = GroupsListView.Items(i).SubItems(0).Text
                        Dim lnewlist As New List(Of String)
                        lnewlist = groupClass.GetGroupMembers(logN)
                        Try
                            groupClass.SetGroupPropertyInsert(logN, "member", GenericClass.GetDN(Equipo), lnewlist.Count)
                        Catch ex As AccessViolationException
                            MsgBox("Error, por falta de permisos, al añadir el equipo al grupo " & logN)
                            salida = salida & vbCrLf & "Error por falta de permisos: al añadir el equipo al grupo " & GroupsListView.Items(i).SubItems(0).Text & ex.Message
                            HayError = True
                            MemberOfPanel.Visible = True
                            MemberOfPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        Catch ex As FieldAccessException
                            MsgBox("Error, por falta de permisos, al añadir el equipo al grupo " & logN)
                            salida = salida & vbCrLf & "Error por falta de permisos: al añadir el equipo al grupo " & GroupsListView.Items(i).SubItems(0).Text & ex.Message
                            HayError = True
                            MemberOfPanel.Visible = True
                            MemberOfPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        Catch ex As MemberAccessException
                            MsgBox("Error, por falta de permisos, al añadir el equipo al grupo " & logN)
                            salida = salida & vbCrLf & "Error por falta de permisos: al añadir el equipo al grupo " & GroupsListView.Items(i).SubItems(0).Text & ex.Message
                            HayError = True
                            MemberOfPanel.Visible = True
                            MemberOfPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        Catch ex As UnauthorizedAccessException
                            MsgBox("Error, por falta de permisos, al añadir el equipo al grupo " & logN)
                            salida = salida & vbCrLf & "Error por falta de permisos: al añadir el equipo al grupo " & GroupsListView.Items(i).SubItems(0).Text & ex.Message
                            HayError = True
                            MemberOfPanel.Visible = True
                            MemberOfPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        Catch ex As Exception When logN = ""
                            MsgBox("Error el Grupo al que se quiere añadir el equipo no pude ser vacío " & ex.Message)
                            salida = salida & vbCrLf & "Error: el Grupo al que se quiere añadir el equipo no pude ser vacío " & ex.Message
                            HayError = True
                            MemberOfPanel.Visible = True
                            MemberOfPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        Catch ex As Exception
                            MsgBox("Error al añadir el equipo al grupo " & logN)
                            salida = salida & vbCrLf & "Error: al añadir el equipo al grupo " & GroupsListView.Items(i).SubItems(0).Text & ex.Message
                            HayError = True
                            MemberOfPanel.Visible = True
                            MemberOfPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            ObjectPanel.Visible = False
                            SecurityPanel.Visible = False
                        End Try
                    End If

                Next
                groupslviewchanged = False
            End If
            '------------------------------------------------------Managed By---------------------------------------------------------------------
            'Establecer los cambios en el administrador del equipo
            If managerchange Then
                If Not ManagerTextBox.Text = "" Then
                    salida = salida & vbCrLf & "establecer el administrador del equipo:" & ManagerTextBox.Text
                    Try
                        GenericClass.SetComputerProperty(Equipo, "managedBy", ManagerTextBox.Text)
                    Catch ex As Exception When ManagerTextBox.Text = ""
                        MsgBox("Error al asignar el administrador del equipo, el administrador no puede ser vacío " & ex.Message)
                        salida = salida & vbCrLf & "Error: al asignar el administrador del equipo, el administrador no puede ser vacío " & ex.Message
                        HayError = True
                        ManagedByPanel.Visible = True
                        ManagedByPanel.Dock = DockStyle.Fill
                        MemberOfPanel.Visible = False
                        OSPanel.Visible = False
                        GeneralPanel.Visible = False
                        ObjectPanel.Visible = False
                        SecurityPanel.Visible = False
                    Catch ex As Exception
                        MsgBox("Error al asignar " & ManagerTextBox.Text & " como administrador del equipo " & ex.Message)
                        salida = salida & vbCrLf & "Error: al asignar " & ManagerTextBox.Text & " como administrador del equipo " & ex.Message
                        HayError = True
                        ManagedByPanel.Visible = True
                        ManagedByPanel.Dock = DockStyle.Fill
                        MemberOfPanel.Visible = False
                        OSPanel.Visible = False
                        GeneralPanel.Visible = False
                        ObjectPanel.Visible = False
                        SecurityPanel.Visible = False
                    End Try
                Else
                    salida = salida & vbCrLf & "eliminar el administrador del equipo:"
                    Try
                        GenericClass.ClearProperty(Equipo, "managedBy")
                    Catch ex As Exception
                        MsgBox("Error al eliminar el administrador del equipo " & ex.Message)
                        salida = salida & vbCrLf & "Error: al eliminar el administrador del equipo " & ex.Message
                        HayError = True
                        ManagedByPanel.Visible = True
                        ManagedByPanel.Dock = DockStyle.Fill
                        MemberOfPanel.Visible = False
                        OSPanel.Visible = False
                        GeneralPanel.Visible = False
                        ObjectPanel.Visible = False
                        SecurityPanel.Visible = False
                    End Try
                End If
            End If
            '------------------------------------------------------Security-------------------------------------------------------------------------

            Dim nuevo As String = ""

            If usersadd Then
                'Si hay objetos a los que añadir permisos
                salida = salida & vbCrLf & "Conceder permisos a:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = MailClass.GetDaclNamesNT(Equipo)
                'Buscar los objetos del listview que todavía no tienen permisos
                For i = 0 To UsersGroupsListView.Items.Count - 1
                    Dim esta As Boolean = False
                    For j = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(j) = UsersGroupsListView.Items(i).Text Then
                            esta = True
                        End If
                    Next

                    If Not esta Then
                        'Para cada objeto nuevo añadir los permisos obtenidos a través de la estructura auxiliar
                        For j = 0 To TodosPermisos.Count - 1
                            If TodosPermisos(j).usuario = UsersGroupsListView.Items(i).Text Then
                                'Una vez localizado el objeto en la estructura auxiliar, añadir sus permisos
                                salida = salida & vbCrLf & UsersGroupsListView.Items(i).Text
                                For k = 0 To 19
                                    If TodosPermisos(j).perms(k).allow Then
                                        Try
                                            MailClass.AddAceToDaclComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text, "Allow")
                                        Catch ex As Exception
                                            MsgBox("Error al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                                            HayError = True
                                            SecurityPanel.Visible = True
                                            SecurityPanel.Dock = DockStyle.Fill
                                            ManagedByPanel.Visible = False
                                            OSPanel.Visible = False
                                            GeneralPanel.Visible = False
                                            MemberOfPanel.Visible = False
                                            ObjectPanel.Visible = False
                                        End Try
                                    ElseIf TodosPermisos(j).perms(k).deny Then
                                        Try
                                            MailClass.AddAceToDaclComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text, "deny")
                                        Catch ex As Exception
                                            MsgBox("Error al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                                            HayError = True
                                            SecurityPanel.Visible = True
                                            SecurityPanel.Dock = DockStyle.Fill
                                            ManagedByPanel.Visible = False
                                            OSPanel.Visible = False
                                            GeneralPanel.Visible = False
                                            MemberOfPanel.Visible = False
                                            ObjectPanel.Visible = False
                                        End Try
                                    End If
                                Next
                                nuevo = TodosPermisos(j).usuario
                            End If
                        Next
                    End If
                Next
            End If

            '-------------------------------------------Cambio de permisos a un usuario que ya tiene-------------------------------
            If permisChange Then
                'Si ha cambiado algún permisos
                salida = salida & vbCrLf & "Modificar permisos de:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = MailClass.GetDaclNamesNT(Equipo)
                Dim esta As Boolean = False
                Dim allow(1) As Boolean
                'Para cada objeto no nuevo
                For i = 0 To UsersGroupsListView.Items.Count - 1
                    For l = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(l) = UsersGroupsListView.Items(i).Text Then
                            esta = True
                        End If
                    Next
                    If esta Then
                        'Actualizar todos sus permisos
                        For j = 0 To TodosPermisos.Count - 1
                            If Not nuevo = UsersGroupsListView.Items(i).Text Then

                                If TodosPermisos(j).usuario = UsersGroupsListView.Items(i).Text And TodosPermisos(j).modificado Then
                                    'Añadir o borrar los permisos para ajustarse a los que están marcados en la estructura auxiliar
                                    For k = 0 To 19
                                        allow = MailClass.GetAcePermissionComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text)
                                        If TodosPermisos(j).perms(k).allow Then
                                            If Not allow(0) Then
                                                salida = salida & vbCrLf & "Añadir permisos a:" & UsersGroupsListView.Items(i).Text
                                                Try
                                                    MailClass.AddAceToDaclComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text, "Allow")
                                                Catch ex As Exception
                                                    MsgBox("Error al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                    SecurityPanel.Visible = True
                                                    SecurityPanel.Dock = DockStyle.Fill
                                                    ManagedByPanel.Visible = False
                                                    OSPanel.Visible = False
                                                    GeneralPanel.Visible = False
                                                    MemberOfPanel.Visible = False
                                                    ObjectPanel.Visible = False
                                                End Try
                                            End If
                                        End If
                                        If Not TodosPermisos(j).perms(k).allow Then
                                            If allow(0) Then
                                                salida = salida & vbCrLf & "Quitar permisos a:" & UsersGroupsListView.Items(i).Text
                                                Try
                                                    MailClass.RemoveAceFromDaclComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text, "Allow")
                                                Catch ex As Exception
                                                    MsgBox("Error al quitar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al quitar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                    SecurityPanel.Visible = True
                                                    SecurityPanel.Dock = DockStyle.Fill
                                                    ManagedByPanel.Visible = False
                                                    OSPanel.Visible = False
                                                    GeneralPanel.Visible = False
                                                    MemberOfPanel.Visible = False
                                                    ObjectPanel.Visible = False
                                                End Try
                                            End If
                                        End If
                                        If TodosPermisos(j).perms(k).deny Then
                                            If Not allow(1) Then
                                                salida = salida & vbCrLf & "Añadir permisos a:" & UsersGroupsListView.Items(i).Text
                                                Try
                                                    MailClass.AddAceToDaclComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text, "deny")
                                                Catch ex As Exception
                                                    MsgBox("Error al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                    SecurityPanel.Visible = True
                                                    SecurityPanel.Dock = DockStyle.Fill
                                                    ManagedByPanel.Visible = False
                                                    OSPanel.Visible = False
                                                    GeneralPanel.Visible = False
                                                    MemberOfPanel.Visible = False
                                                    ObjectPanel.Visible = False
                                                End Try
                                            End If
                                        End If
                                        If Not TodosPermisos(j).perms(k).deny Then
                                            If allow(1) Then
                                                salida = salida & vbCrLf & "Quitar permisos a:" & UsersGroupsListView.Items(i).Text
                                                Try
                                                    MailClass.RemoveAceFromDaclComputerNT(UsersGroupsListView.Items(i).Text, equipodn, PermisListView.Items(k).SubItems(0).Text, "deny")
                                                Catch ex As Exception
                                                    MsgBox("Error al quitar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al quitar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                    SecurityPanel.Visible = True
                                                    SecurityPanel.Dock = DockStyle.Fill
                                                    ManagedByPanel.Visible = False
                                                    OSPanel.Visible = False
                                                    GeneralPanel.Visible = False
                                                    MemberOfPanel.Visible = False
                                                    ObjectPanel.Visible = False
                                                End Try
                                            End If
                                        End If
                                    Next

                                End If
                            End If
                        Next
                    End If
                Next
            End If

            '------------------------------------------------Borrado de todos los permisos de un usuario-----------------------------
            If usersremove Then
                'Si hay objetos a los que quitarles todos sus permisos
                salida = salida & vbCrLf & "Quitar todos los permisos a:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = MailClass.GetDaclNamesNT(Equipo)
                'Buscar los objetos entre los que tienen permisos
                For i = 0 To UsersToRemove.Count - 1
                    Dim esta As Boolean = False
                    For j = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(j).Contains(UsersToRemove(i)) Then
                            esta = True
                        End If
                    Next
                    If esta Then
                        'Una vez encontrados, recorrer todos los permisos que tienen concedidos eliminándolos
                        'Si existe el objeto
                        Dim ind As Integer
                        For j = 0 To TodosPermisos.Count - 1
                            If TodosPermisos(j).usuario = UsersToRemove(i) Then
                                ind = j
                            End If
                        Next
                        salida = salida & vbCrLf & UsersToRemove(i)
                        Try
                            MailClass.RemoveAces(UsersToRemove(i), Equipo)
                        Catch ex As Exception
                            MsgBox("Error al quitar todos los permisos para el equipo a " & UsersToRemove(i) & ex.Message)
                            salida = salida & vbCrLf & "Error: al quitar todos los permisos para el equipo a " & UsersToRemove(i) & ex.Message
                            HayError = True
                            SecurityPanel.Visible = True
                            SecurityPanel.Dock = DockStyle.Fill
                            ManagedByPanel.Visible = False
                            OSPanel.Visible = False
                            GeneralPanel.Visible = False
                            MemberOfPanel.Visible = False
                            ObjectPanel.Visible = False
                        End Try
                        TodosPermisos.RemoveAt(ind)
                    End If
                Next
            End If

            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
            Me.Cursor = Cursors.Default
            '------------------------------------Cerrar Ventana---------------------------
            If Not HayError Then
                Me.Close()
            End If

        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub CancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        '==========================================================================
        ' Name:     CancelButton_Click
        ' Purpose:  Cerrar la ventana sin realizar cambios
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Me.Close()

    End Sub

    Private Sub UsersGroupsListView_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles UsersGroupsListView.KeyDown
        '==========================================================================
        ' Name:     UsersGroupsListView_KeyDown
        ' Purpose:  Actualizar el listview de los permisos con los del objeto seleccionado
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   1 Mycell: La Celda
        ' Calls:    None
        '==========================================================================
        Me.Cursor = Cursors.WaitCursor
        Dim item As ListViewItem
        Dim seleccionados As ListView.SelectedListViewItemCollection = UsersGroupsListView.SelectedItems
        Dim equipodn As String = GenericClass.GetDN(Equipo)
        'Buscar el objeto seleccionado en la estructura auxiliar y cargar sus datos
        For Each item In seleccionados
            seleccionado = item.Index
            UGNameLabel.Text = item.Text

            Dim esta As Boolean = False
            Dim ind As Integer = 0
            For i = 0 To TodosPermisos.Count - 1
                If TodosPermisos(i).usuario = item.Text Then
                    esta = True
                    ind = i
                    Exit For
                End If
            Next

            If Not esta Then
                'Cargar los datos del seleccionado por primera vez
                Dim j As Integer = item.Index
                Dim permisos(19) As allowDeny
                For i = 0 To 19
                    Try
                        Dim allow() As Boolean = MailClass.GetAcePermissionComputerNT(UsersGroupsListView.Items(j).Text, equipodn, PermisListView.Items(i).SubItems(0).Text)
                        permisos(i).fijoA = allow(2)
                        permisos(i).fijoD = allow(3)
                        If allow(0) Then
                            permisos(i).allow = True
                        Else
                            permisos(i).allow = False
                        End If
                        If allow(1) Then
                            permisos(i).deny = True
                        Else
                            permisos(i).deny = False
                        End If
                    Catch ex As Exception
                        MsgBox("Error al asignar el permiso" & PermisListView.Items(i).SubItems(0).Text & "para el equipo" & Equipo & " a " & UsersGroupsListView.Items(j).Text & ex.Message)
                        'salida = salida & vbCrLf & "Error: al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                        'HayError = True
                        SecurityPanel.Visible = True
                        SecurityPanel.Dock = DockStyle.Fill
                        ManagedByPanel.Visible = False
                        OSPanel.Visible = False
                        GeneralPanel.Visible = False
                        MemberOfPanel.Visible = False
                        ObjectPanel.Visible = False
                    End Try
                Next
                Dim Tperms As Permissions
                Tperms.perms = permisos
                Tperms.modificado = False
                Tperms.usuario = UsersGroupsListView.Items(j).Text
                TodosPermisos.Add(Tperms)

                'Se cargan en el listView los permisos del objeto
                ind = TodosPermisos.Count - 1
                UGNameLabel.Text = TodosPermisos(ind).usuario
                For i = 0 To 19
                    If TodosPermisos(ind).perms(i).allow Then
                        PermisListView.Items(i).SubItems(1).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(1).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                    End If
                    If TodosPermisos(ind).perms(i).deny Then
                        PermisListView.Items(i).SubItems(2).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(2).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                    End If
                Next
            Else
                'Actualizar el listview con los permisos del seleccionado
                For i = 0 To 19
                    If TodosPermisos(ind).perms(i).allow Then
                        PermisListView.Items(i).SubItems(1).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(1).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                    End If
                    If TodosPermisos(ind).perms(i).deny Then
                        PermisListView.Items(i).SubItems(2).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(2).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                    End If
                Next
            End If

        Next
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub UsersGroupsListView_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles UsersGroupsListView.KeyUp
        '==========================================================================
        ' Name:     UsersGroupsListView_KeyUp
        ' Purpose:  Actualizar el listview de los permisos con los del objeto seleccionado
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   1 Mycell: La Celda
        ' Calls:    None
        '==========================================================================
        Me.Cursor = Cursors.WaitCursor
        Dim item As ListViewItem
        Dim seleccionados As ListView.SelectedListViewItemCollection = UsersGroupsListView.SelectedItems
        Dim equipodn As String = GenericClass.GetDN(Equipo)
        'Buscar el objeto seleccionado en la estructura auxiliar y cargar sus datos
        For Each item In seleccionados
            seleccionado = item.Index
            UGNameLabel.Text = item.Text

            Dim esta As Boolean = False
            Dim ind As Integer = 0
            For i = 0 To TodosPermisos.Count - 1
                If TodosPermisos(i).usuario = item.Text Then
                    esta = True
                    ind = i
                    Exit For
                End If
            Next

            If Not esta Then
                'Cargar los datos del seleccionado por primera vez
                Dim j As Integer = item.Index
                Dim permisos(19) As allowDeny
                For i = 0 To 19
                    Try
                        Dim allow() As Boolean = MailClass.GetAcePermissionComputerNT(UsersGroupsListView.Items(j).Text, equipodn, PermisListView.Items(i).SubItems(0).Text)
                        permisos(i).fijoA = allow(2)
                        permisos(i).fijoD = allow(3)
                        If allow(0) Then
                            permisos(i).allow = True
                        Else
                            permisos(i).allow = False
                        End If
                        If allow(1) Then
                            permisos(i).deny = True
                        Else
                            permisos(i).deny = False
                        End If
                    Catch ex As Exception
                        MsgBox("Error al asignar el permiso" & PermisListView.Items(i).SubItems(0).Text & "para el equipo" & Equipo & " a " & UsersGroupsListView.Items(j).Text & ex.Message)
                        'salida = salida & vbCrLf & "Error: al asignar permisos para el equipo a " & UsersGroupsListView.Items(i).Text & ex.Message
                        'HayError = True
                        SecurityPanel.Visible = True
                        SecurityPanel.Dock = DockStyle.Fill
                        ManagedByPanel.Visible = False
                        OSPanel.Visible = False
                        GeneralPanel.Visible = False
                        MemberOfPanel.Visible = False
                        ObjectPanel.Visible = False
                    End Try
                Next
                Dim Tperms As Permissions
                Tperms.perms = permisos
                Tperms.modificado = False
                Tperms.usuario = UsersGroupsListView.Items(j).Text
                TodosPermisos.Add(Tperms)

                'Se cargan en el listView los permisos del objeto
                ind = TodosPermisos.Count - 1
                UGNameLabel.Text = TodosPermisos(ind).usuario
                For i = 0 To 19
                    If TodosPermisos(ind).perms(i).allow Then
                        PermisListView.Items(i).SubItems(1).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(1).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                    End If
                    If TodosPermisos(ind).perms(i).deny Then
                        PermisListView.Items(i).SubItems(2).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(2).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                    End If
                Next
            Else
                'Actualizar el listview con los permisos del seleccionado
                For i = 0 To 19
                    If TodosPermisos(ind).perms(i).allow Then
                        PermisListView.Items(i).SubItems(1).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(1).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(1).ForeColor = Color.Black
                    End If
                    If TodosPermisos(ind).perms(i).deny Then
                        PermisListView.Items(i).SubItems(2).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                        Else
                            PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If
                    Else
                        PermisListView.Items(i).SubItems(2).Text = (Chr(168))
                        PermisListView.Items(i).SubItems(2).ForeColor = Color.Black
                    End If
                Next
            End If

        Next
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub NameTextBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles NameTextBox.TextChanged
        '==========================================================================
        ' Name:     NameTextBox_TextChanged
        ' Purpose:  Controlar los cambios que se producen al cambiar el texto del textbox
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Si no es la primera carga de datos 
        If Not primera Then
            'Marcar el cambio del textbox
            Namechanged = True
            'Habilitar los botones aceptar y aplicar
            AcceptButton.Enabled = True
            CancelButton.Enabled = True
            ApplyButton.Enabled = True
        End If
    End Sub

    Private Function checkRejexCName(ByVal strFindin As String) As Boolean
        Dim myRegex As New Regex("^([0-9a-zA-Z]|-)+$")
        If myRegex.IsMatch(strFindin) Then
            Return True
        Else
            Return False
        End If
    End Function
End Class