﻿Public Class ResetPassword
    Dim usuario As String
    Friend Sub loadU(ByVal user As String)
        '==========================================================================
        ' Name:     loadU
        ' Purpose:  Obtener el usuario que manipular
        ' Input:    1 string: el nombre de usuario 'user'
        ' Return:   1 string: el nombre de usuario 
        ' Calls:    None
        '==========================================================================
        usuario = user
    End Sub

    Private Sub AcceptButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Resetear el password del usuario
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    ComprobarPasswords
        '==========================================================================
        Try
            Me.Cursor = Cursors.WaitCursor
            Dim HayError As Boolean = False
            Dim salida As String = "-------Cambiar contraseña-------"
            'Llamara a la función que comprueba que los passwords de los dos campos son iguales
            If PassTextBox.Text = "" Then
                MsgBox("No se puede asignar una contraseña vacía")
            Else
                If Not ComprobarPasswords() Then
                    MsgBox("no has confirmado correctamente la contraseña")
                Else
                    salida = salida & vbCrLf & "Usuario al que se cambia:" & usuario
                    salida = salida & vbCrLf & "Nueva contraseña:" & PassTextBox.Text
                    salida = salida & vbCrLf & "reseteo de contraseña..."
                    'Llamar a la función que restea el password y establece el de sus parámetros como el nuevo
                    Try
                        UserClass.ChangePassword(usuario, PassTextBox.Text)
                    Catch ex As Exception When usuario = ""
                        MsgBox("Error al cambiar el password del usuario, el usuario no puede ser vacío " & ex.Message)
                        salida = salida & vbCrLf & "Error: al cambiar el password del usuario, el usuario no puede ser vacío " & ex.Message
                        HayError = True
                    Catch ex As Exception When PassTextBox.Text = ""
                        MsgBox("Error al cambiar el password del usuario, el nuevo password no puede ser vacío " & ex.Message)
                        salida = salida & vbCrLf & "Error: al cambiar el password del usuario, el nuevo password no puede ser vacío " & ex.Message
                        HayError = True
                    Catch ex As Exception
                        MsgBox("Error al cambiar el password del usuario " & ex.Message)
                        salida = salida & vbCrLf & "Error: al cambiar el password del usuario " & ex.Message
                        HayError = True
                    End Try
                    salida = salida & vbCrLf & "Cambio realizado"
                    Me.Cursor = Cursors.Default
                    'Log
                    GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
                    If Not HayError Then
                        Me.Close()
                    End If
                End If
            End If

        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Function ComprobarPasswords() As Boolean
        '==========================================================================
        ' Name:     ComprobarPasswords
        ' Purpose:  Comprobar que el texto de los dos campos es igual
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   1 boolean: True si los dos textbox tienen el mismo texto, false en caso contrario
        ' Calls:    None
        '==========================================================================
        If PassTextBox.Text = ConfPassTextBox.Text Then
            Return True
        Else
            Return False
        End If
    End Function

    Private Sub CancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        '==========================================================================
        ' Name:     CancelButton_Click
        ' Purpose:  Cerrar la ventana sin realizar ningún cambio
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Me.Close()

    End Sub

    Private Sub ResetPassword_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     ResetPassword_Load
        ' Purpose:  Cargar la ventana por primera vez
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    ComprobarPasswords
        '==========================================================================

        PassTextBox.Text = ""
        ConfPassTextBox.Text = ""

    End Sub
End Class