﻿Imports WindowsApplication1.MailClass
Imports WindowsApplication1.UserClass

Public Class RestriccionesEnvio
    Dim Usuario As String
    Dim Primero As Boolean = True
    Dim Usuañadir As String
    '------------Variables de control de excepciones--------
    Dim RecieveRes As Boolean = False
    Dim SendRes As Boolean = False
    Dim AuthOnly As Boolean = False
    Dim from As Boolean = False
    Dim UsersToRemove As Boolean = False
    Dim removeUsers As New List(Of String)

    Friend Sub LoadUser(ByVal User As String)
        '==========================================================================
        ' Name:     LoadUser
        ' Purpose:  Obtener el usuario del que se van a obtener los datos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Usuario = User
    End Sub
    Friend Sub LoadU(ByVal User As String)
        '==========================================================================
        ' Name:     LoadU
        ' Purpose:  Obtener el usuario para añadirlo a los restringidos o permitidos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Usuañadir = User
    End Sub

    '------------------------------------------------------------------------------
    '-------------------------Carga Datos------------------------------------------
    Private Sub RestriccionesEnvio_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '==========================================================================
        ' Name:     RestriccionesEnvio_Load
        ' Purpose:  Carga de los datos del usuario en la ventana
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim salida As String
        Dim HayError As Boolean = False
        '-----------------------------------
        'Obtener tamaño mail salida
        Try
            Dim sendrestriction As Integer = UserClass.GetUserPropertyInteger(Usuario, "submissionContLength")
            If sendrestriction = 0 Then
                senddefaultRadioButton.Checked = True
                sendKBtextbox.Enabled = False
            Else
                sendKBRadioButton.Checked = True
                sendKBtextbox.Text = sendrestriction.ToString
            End If
        Catch ex As Exception
            'HayError = True
            MsgBox("Error al obtener el límite de envío del usuario " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el límite de envío del usuario " & Usuario & ex.Message
            HayError = True
        End Try

        '--------------------------------------
        'Obtener tamaño mail entrada
        Try
            Dim recvrestriction As Integer = UserClass.GetUserPropertyInteger(Usuario, "delivContLength")
            If recvrestriction = 0 Then
                ReciveDefaultRadioButton.Checked = True
                ReciveKBTextBox.Enabled = False
            Else
                ReciveKBRadioButton.Checked = True
                ReciveKBTextBox.Text = recvrestriction.ToString
            End If
        Catch ex As Exception
            'HayError = True
            MsgBox("Error al obtener el límite de recepción del usuario " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el límite de recepción del usuario " & Usuario & ex.Message
            HayError = True
        End Try
        '----------------------------------------
        'Establecer el checkbox que define si solo los usuarios pueden enviar mensajes al usuario autentificados
        Try
            AuthentifiedOnlyCheckBox.Checked = UserClass.GetUserPropertyBool(Usuario, "msExchRequireAuthToSendTo")
        Catch ex As Exception
            'HayError = True
            MsgBox("Error al conocer si solo los usuarios autenticados pueden enviar mensajes al usuario " & ex.Message)
            salida = salida & vbCrLf & "Error al conocer si solo los usuarios autenticados pueden enviar mensajes al usuario " & Usuario & ex.Message
            HayError = True
        End Try
        '-----------------------------------------
        'lista usuarios permitidos/negados
        UsersListView.ShowItemToolTips = True
        ' Establecer modo columnas
        UsersListView.View = View.Details
        ' Establecer la cabecera de columna
        UsersListView.Clear()
        UsersListView.Columns.Add("Name", 150)
        Dim TempNode As ListViewItem

        Try
            'Establecer que no hay ningun objeto permitido/denegado
            If UserClass.GetUserPropertyObject(Usuario, "authOrig") Is Nothing And UserClass.GetUserPropertyObject(Usuario, "unauthOrig") Is Nothing Then
                FromEveryoneRadioButton.Checked = True
                AddButton.Enabled = False
                RemoveButton.Enabled = False
                'Solo un objeto denegado, el atributo como string
            ElseIf (Not UserClass.GetUserPropertyObject(Usuario, "unauthOrig") Is Nothing) And UserClass.isUserPropertyString(Usuario, "unauthOrig") Then
                'Dim parte() As String = UserClass.GetUserPropertyObject(Usuario, "unauthOrig").ToString.ToString.Split(",")
                'Dim nombre As String = parte(0).Substring(3)
                'TempNode = New ListViewItem(nombre)
                TempNode = New ListViewItem(GenericClass.GetlogonN(UserClass.GetUserPropertyObject(Usuario, "unauthOrig").ToString))
                UsersListView.Items.Add(TempNode)
                ExceptfromRadioButton.Checked = True
                OnlyFromRadioButton.Checked = False
                AddButton.Enabled = True
                RemoveButton.Enabled = False
                'Solo un objeto permitido, el atributo como string
            ElseIf (Not UserClass.GetUserPropertyObject(Usuario, "authOrig") Is Nothing) And UserClass.isUserPropertyString(Usuario, "authOrig") Then
                'Dim parte() As String = UserClass.GetUserPropertyObject(Usuario, "authOrig").ToString.ToString.Split(",")
                'Dim nombre As String = parte(0).Substring(3)
                'TempNode = New ListViewItem(nombre)
                TempNode = New ListViewItem(GenericClass.GetlogonN(UserClass.GetUserPropertyObject(Usuario, "authOrig").ToString))
                UsersListView.Items.Add(TempNode)
                ExceptfromRadioButton.Checked = False
                OnlyFromRadioButton.Checked = True
                AddButton.Enabled = True
                RemoveButton.Enabled = False
            Else
                'Mas de un usuario permitido o denegado, establecer la lista de objetos

                'Obtener los objetos denegados o permitidos
                Dim authomails() As Object = UserClass.GetUserPropertyObject(Usuario, "authOrig")
                Dim unauthmails() As Object = UserClass.GetUserPropertyObject(Usuario, "unauthOrig")
                'Insertar esos objetos en el listview
                If Not authomails Is Nothing Then
                    For i = 0 To authomails.Length - 1
                        'Dim parte() As String = authomails(i).ToString.Split(",")
                        'Dim nombre As String = parte(0).Substring(3)
                        'TempNode = New ListViewItem(nombre)
                        TempNode = New ListViewItem(GenericClass.GetlogonN(authomails(i)))
                        UsersListView.Items.Add(TempNode)
                    Next
                    OnlyFromRadioButton.Checked = True
                    AddButton.Enabled = True
                    RemoveButton.Enabled = False
                End If
                If Not unauthmails Is Nothing Then
                    For i = 0 To unauthmails.Length - 1
                        'Dim parte() As String = unauthmails(i).ToString.Split(",")
                        'Dim nombre As String = parte(0).Substring(3)
                        'TempNode = New ListViewItem(nombre)
                        TempNode = New ListViewItem(GenericClass.GetlogonN(unauthmails(i)))
                        UsersListView.Items.Add(TempNode)
                    Next
                    ExceptfromRadioButton.Checked = True
                    AddButton.Enabled = True
                    RemoveButton.Enabled = False
                End If
            End If
        Catch ex As Exception
            'HayError = True
            MsgBox("Error al obtener los usuarios de los que puede recibir mensajes el usuario " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener los usuarios de los que puede recibir mensajes el usuario " & Usuario & ex.Message
            HayError = True
        End Try

        If HayError Then
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        End If
        Primero = False
        AcceptButton.Enabled = False

    End Sub
    '---------------------------------------------------------------------------------------
    '-----------------------Control de excepciones------------------------------------------
    Private Sub ReciveDefaultRadioButton_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReciveDefaultRadioButton.CheckedChanged
        '==========================================================================
        ' Name:     ReciveDefaultRadioButton_CheckedChanged
        ' Purpose:  Al haberse producido un cambio, habilitar los botones aceptar y aplicar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not Primero Then
            If ReciveDefaultRadioButton.Checked Then
                ReciveKBTextBox.Text = ""
                ReciveKBTextBox.Enabled = False
            Else
                ReciveKBTextBox.Enabled = True
            End If
            AcceptButton.Enabled = True
            cancelButton.Enabled = True
            RecieveRes = True
        End If

    End Sub

    Private Sub ReciveKBRadioButton_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReciveKBRadioButton.CheckedChanged
        '==========================================================================
        ' Name:     ReciveKBRadioButton_CheckedChanged
        ' Purpose:  Al haberse producido un cambio, habilitar los botones aceptar y aplicar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not Primero Then
            AcceptButton.Enabled = True
            cancelButton.Enabled = True
            RecieveRes = True
        End If
 
    End Sub

    Private Sub senddefaultRadioButton_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles senddefaultRadioButton.CheckedChanged
        '==========================================================================
        ' Name:     senddefaultRadioButton_CheckedChanged
        ' Purpose:  Al haberse producido un cambio, habilitar los botones aceptar y aplicar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not Primero Then
            If senddefaultRadioButton.Checked Then
                sendKBtextbox.Text = ""
                sendKBtextbox.Enabled = False
            Else
                sendKBtextbox.Enabled = True
            End If
            AcceptButton.Enabled = True
            cancelButton.Enabled = True
            SendRes = True
        End If
 
    End Sub

    Private Sub sendKBRadioButton_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles sendKBRadioButton.CheckedChanged
        '==========================================================================
        ' Name:     sendKBRadioButton_CheckedChanged
        ' Purpose:  Al haberse producido un cambio, habilitar los botones aceptar y aplicar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not Primero Then
            AcceptButton.Enabled = True
            cancelButton.Enabled = True
            SendRes = True
        End If

    End Sub

    Private Sub AuthentifiedOnlyCheckBox_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles AuthentifiedOnlyCheckBox.CheckedChanged
        '==========================================================================
        ' Name:     AuthentifiedOnlyCheckBox_CheckedChanged
        ' Purpose:  Al haberse producido un cambio, habilitar los botones aceptar y aplicar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not Primero Then
            AcceptButton.Enabled = True
            cancelButton.Enabled = True
            AuthOnly = True
        End If

    End Sub

    Private Sub FromEveryoneRadioButton_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles FromEveryoneRadioButton.CheckedChanged
        '==========================================================================
        ' Name:     FromEveryoneRadioButton_CheckedChanged
        ' Purpose:  Al haberse producido un cambio, habilitar los botones aceptar y aplicar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If FromEveryoneRadioButton.Checked = True Then
            If Not Primero Then
                UsersListView.Items.Clear()
                AddButton.Enabled = False
                RemoveButton.Enabled = False
                AcceptButton.Enabled = True
                cancelButton.Enabled = True
                from = True
            End If
        End If

    End Sub

    Private Sub ExceptfromRadioButton_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ExceptfromRadioButton.CheckedChanged
        '==========================================================================
        ' Name:     ExceptfromRadioButton_CheckedChanged
        ' Purpose:  Al haberse producido un cambio, habilitar los botones aceptar y aplicar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If ExceptfromRadioButton.Checked = True Then
            If Not Primero Then
                AddButton.Enabled = True
                RemoveButton.Enabled = False
                AcceptButton.Enabled = True
                cancelButton.Enabled = True
                from = True
            End If
        End If

    End Sub

    Private Sub OnlyFromRadioButton_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles OnlyFromRadioButton.CheckedChanged
        '==========================================================================
        ' Name:     OnlyFromRadioButton_CheckedChanged
        ' Purpose:  Al haberse producido un cambio, habilitar los botones aceptar y aplicar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If OnlyFromRadioButton.Checked = True Then
            If Not Primero Then
                AddButton.Enabled = True
                RemoveButton.Enabled = False
                AcceptButton.Enabled = True
                cancelButton.Enabled = True
                from = True
            End If
        End If

    End Sub

    Private Sub sendKBtextbox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles sendKBtextbox.KeyPress
        '==========================================================================
        ' Name:     sendKBtextbox_KeyPress
        ' Purpose:  Controlar que en el textbox solo se insertan integers
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Not (Char.IsNumber(e.KeyChar) Or Char.IsControl(e.KeyChar)) Then e.Handled = True
    End Sub

    Private Sub ReciveKBTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles ReciveKBTextBox.KeyPress
        '==========================================================================
        ' Name:     ReciveKBTextBox_KeyPress
        ' Purpose:  Controlar que en el textbox solo se insertan integers
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Not (Char.IsNumber(e.KeyChar) Or Char.IsControl(e.KeyChar)) Then e.Handled = True
    End Sub

    '-----------------------------------------------------------------------------------------
    '-----------------------------------Control Botones---------------------------------------

    Private Sub cancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cancelButton.Click
        '==========================================================================
        ' Name:     cancelButton_Click
        ' Purpose:  Cerrar la ventana sin efectuar cambios al hacer click en el botón cancelar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Me.Close()
   
    End Sub

    Private Sub AcceptButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     cancelButton_Click
        ' Purpose:  Efectuar cambios y cerrar la ventana al hacer click en el botón aceptar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    SetSendingMessageSize, SetReceptionMessageSize, SetMailRequireAuthToSendTo,RemoveOrigAuth,
        '           RemoveOrigUnauth, IsInOrigUnauth, ChangeOrigAuth, IsInOrigAuth, AddOrigAuth, AddOrigUnauth de MailClass
        '           GetUserPropertyObject de UserClass
        '==========================================================================
        Try
            Me.Cursor = Cursors.WaitCursor
            Dim HayError As Boolean = False
            Dim salida As String = "-------Restricciones envío-------" & vbCrLf & "Dentro de Propiedades Usuario"
            'Establecer cambios en límites del tamaño del mensaje
            If SendRes Then
                If senddefaultRadioButton.Checked = True Then
                    salida = salida & vbCrLf & "Establecer el tamaño máximo del mensaje como el tamaño por defecto"
                    Try
                        MailClass.SetSendingMessageSize(Usuario, -1)
                    Catch ex As Exception
                        MsgBox("Error al establecer el tamaño de los mensajes de salida como tamaño de los mensajes de salida por defecto " & ex.Message)
                        salida = salida & vbCrLf & "Error: al establecer el tamaño de los mensajes de salida como tamaño de los mensajes de salida por defecto " & ex.Message
                        HayError = True
                    End Try
                Else


                    If sendKBtextbox.Text = "" Then
                        MsgBox("falta el tamaño para el mensaje de salida")
                        HayError = True
                    Else
                        Dim size As Integer = sendKBtextbox.Text
                        salida = salida & vbCrLf & "Establecer el tamaño máximo del mensaje en KB como: " & vbCrLf & size
                        Try
                            MailClass.SetSendingMessageSize(Usuario, size)
                        Catch ex As Exception When size = ""
                            MsgBox("Error al establecer el tamaño de los mensajes de salida, el tamaño no puede ser vacio " & ex.Message)
                            salida = salida & vbCrLf & "Error: al establecer el tamaño de los mensajes de salida, el tamaño no puede ser vacio " & ex.Message
                            HayError = True
                        Catch ex As Exception
                            MsgBox("Error al establecer el tamaño de los mensajes de salida " & ex.Message)
                            salida = salida & vbCrLf & "Error: al establecer el tamaño de los mensajes de salida " & ex.Message
                            HayError = True
                        End Try
                    End If

                End If
            End If
            '-----------------------------------------------------------------------
            If RecieveRes Then
                If ReciveDefaultRadioButton.Checked = True Then
                    salida = salida & vbCrLf & "Establecer el tamaño máximo del mensaje que se puede recibir como el tamaño por defecto"
                    Try
                        MailClass.SetReceptionMessageSize(Usuario, -1)
                    Catch ex As Exception
                        MsgBox("Error al establecer el tamaño de los mensajes de entrada como tamaño de los mensajes de salida por defecto " & ex.Message)
                        salida = salida & vbCrLf & "Error: al establecer el tamaño de los mensajes de entrada como tamaño de los mensajes de salida por defecto " & ex.Message
                        HayError = True
                    End Try
                Else

                    If ReciveKBTextBox.Text = "" Then
                        MsgBox("falta el tamaño del mensaje de entrada")
                        HayError = True
                    Else
                        salida = salida & vbCrLf & "Establecer el tamaño máximo del mensaje que se puede recibir en KB como: " & vbCrLf & ReciveKBTextBox.Text
                        Try
                            MailClass.SetReceptionMessageSize(Usuario, ReciveKBTextBox.Text)
                        Catch ex As Exception When ReciveKBTextBox.Text = ""
                            MsgBox("Error al establecer el tamaño de los mensajes de entrada, el tamaño no puede ser vacio " & ex.Message)
                            salida = salida & vbCrLf & "Error: al establecer el tamaño de los mensajes de entrada, el tamaño no puede ser vacio " & ex.Message
                            HayError = True
                        Catch ex As Exception
                            MsgBox("Error al establecer el tamaño de los mensajes de entrada " & ex.Message)
                            salida = salida & vbCrLf & "Error: al establecer el tamaño de los mensajes de entrada " & ex.Message
                            HayError = True
                        End Try
                    End If

                End If
            End If
            '------------------------------------------------------------------------
            'Establecer que solo puedan enviar mensajes al usuario los objetos autenticados
            If AuthOnly Then
                salida = salida & vbCrLf & "Solo pueden enviar mensajes al usuario los objetos autenticados"
                Try
                    MailClass.SetMailRequireAuthToSendTo(Usuario, AuthentifiedOnlyCheckBox.Checked)
                Catch ex As Exception
                    MsgBox("Error al establecer que solo pueda recibir mensajes de usuarios autentificados " & ex.Message)
                    salida = salida & vbCrLf & "Error: al establecer que solo pueda recibir mensajes de usuarios autentificados " & ex.Message
                    HayError = True
                End Try
            End If
            '------------------------------------------------------------------------
            'Actualizar los usuarios permitidos o denegados
            If from Then
                'Eliminar los objetos permitidos, denegados si está marcado el checkbox de permitir mensajes de todo el mundo
                If FromEveryoneRadioButton.Checked Then
                    salida = salida & vbCrLf & "El usuario puede recibir mensajes de cualquiera"
                    If Not UserClass.GetUserPropertyObject(Usuario, "authOrig") Is Nothing Then
                        'For i = 0 To UsersListView.Items.Count - 1
                        Try
                            UserClass.ClearUserProperty(Usuario, "authOrig")
                            'MailClass.RemoveOrigAuth(Usuario, UsersListView.Items(i).Text)
                            'Catch ex As Exception When UsersListView.Items(i).Text = ""
                            '    MsgBox("Error al eliminar usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, el usuario no puede ser vacio " & ex.Message)
                            '    salida = salida & vbCrLf & "Error: al eliminar usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, el usuario no puede ser vacio " & ex.Message
                            '    HayError = True
                        Catch ex As Exception
                            MsgBox("Error al eliminar usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, con el usuario " & ex.Message) ' & UsersListView.Items(i).Text & ex.Message)
                            salida = salida & vbCrLf & "Error: al eliminar usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, con el usuario " & ex.Message ' & UsersListView.Items(i).Text & ex.Message
                            HayError = True
                        End Try
                        'Next
                    ElseIf Not UserClass.GetUserPropertyObject(Usuario, "unauthOrig") Is Nothing Then
                        'For i = 0 To UsersListView.Items.Count - 1
                        Try
                            UserClass.ClearUserProperty(Usuario, "unauthOrig")
                            'MailClass.RemoveOrigUnauth(Usuario, UsersListView.Items(i).Text)
                            'Catch ex As Exception When UsersListView.Items(i).Text = ""
                            '    MsgBox("Error al eliminar usuarios no  autorizados para recibir de ellos mensajes al permitir recibir de cualquiera, el usuario no puede ser vacio " & ex.Message)
                            '    salida = salida & vbCrLf & "Error: al eliminar usuarios no  autorizados para recibir de ellos mensajes al permitir recibir de cualquiera, el usuario no puede ser vacio " & ex.Message
                            '    HayError = True
                        Catch ex As Exception
                            MsgBox("Error al eliminar usuarios no autorizados para recibir de ellos mensajes al permitir recibir de cualquiera, con el usuario " & ex.Message) ' & UsersListView.Items(i).Text & ex.Message)
                            salida = salida & vbCrLf & "Error: al eliminar usuarios no autorizados para recibir de ellos mensajes al permitir recibir de cualquiera, con el usuario " & ex.Message ' & UsersListView.Items(i).Text & ex.Message
                            HayError = True
                        End Try
                        'Next
                    End If
                Else
                    If UsersToRemove Then

                        salida = salida & vbCrLf & "Eliminar usuarios de los que solo se pueden recibir o de los que nno se pueden recibir mensajes: "
                        'Eliminar los objetos que se han dejado de permitir o denegar
                        For i = 0 To removeUsers.Count - 1
                            salida = salida & vbCrLf & removeUsers(i)
                            If MailClass.IsInOrigUnauth(Usuario, removeUsers(i)) Then
                                Try
                                    MailClass.RemoveOrigUnauth(Usuario, removeUsers(i))
                                Catch ex As Exception When removeUsers(i) = ""
                                    MsgBox("Error al eliminar usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, el usuario no puede ser vacio " & ex.Message)
                                    salida = salida & vbCrLf & "Error: al eliminar usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, el usuario no puede ser vacio " & ex.Message
                                    HayError = True
                                Catch ex As Exception
                                    MsgBox("Error al eliminar usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, con el usuario " & removeUsers(i) & ex.Message)
                                    salida = salida & vbCrLf & "Error: al eliminar usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, con el usuario " & removeUsers(i) & ex.Message
                                    HayError = True
                                End Try
                            Else
                                Try
                                    MailClass.RemoveOrigAuth(Usuario, removeUsers(i))
                                Catch ex As Exception When removeUsers(i) = ""
                                    MsgBox("Error al eliminar usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, el usuario no puede ser vacio " & ex.Message)
                                    salida = salida & vbCrLf & "Error: al eliminar usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, el usuario no puede ser vacio " & ex.Message
                                    HayError = True
                                Catch ex As Exception
                                    MsgBox("Error al eliminar usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, con el usuario " & removeUsers(i) & ex.Message)
                                    salida = salida & vbCrLf & "Error: al eliminar usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, con el usuario " & removeUsers(i) & ex.Message
                                    HayError = True
                                End Try
                            End If
                        Next
                    End If

                    If OnlyFromRadioButton.Checked Then
                        salida = salida & vbCrLf & "El usuario solo puede recibir mensajes de: "
                        'Cambiar los que están al revés
                        Dim cambio As Boolean = False
                        For i = 0 To UsersListView.Items.Count - 1
                            If MailClass.IsInOrigUnauth(Usuario, UsersListView.Items(i).Text) Then
                                cambio = True
                            End If
                        Next
                        If cambio Then
                            Try
                                MailClass.ChangeOrigAuth(Usuario)
                            Catch ex As Exception When Usuario = ""
                                MsgBox("Error al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, el usuario no puede ser vacio  " & ex.Message)
                                salida = salida & vbCrLf & "Error: al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, el usuario no puede ser vacio  " & ex.Message
                                HayError = True
                            Catch ex As Exception
                                MsgBox("Error al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, con el usuario " & Usuario & ex.Message)
                                salida = salida & vbCrLf & "Error: al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, con el usuario " & Usuario & ex.Message
                                HayError = True
                            End Try
                        End If
                        'Añadir a permitidos/denegados los objetos que se han añadido y pasar a permitir o denegar los que ya estuviesen
                        For i = 0 To UsersListView.Items.Count - 1
                            salida = salida & vbCrLf & UsersListView.Items(i).Text
                            'If MailClass.IsInOrigUnauth(Usuario, UsersListView.Items(i).Text) Then
                            '    Try
                            '        MailClass.ChangeOrigAuth(UsersListView.Items(i).Text)
                            '    Catch ex As Exception When UsersListView.Items(i).Text = ""
                            '        MsgBox("Error al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, el usuario no puede ser vacio  " & ex.Message)
                            '        salida = salida & vbCrLf & "Error: al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, el usuario no puede ser vacio  " & ex.Message
                            '        HayError = True
                            '    Catch ex As Exception
                            '        MsgBox("Error al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, con el usuario " & UsersListView.Items(i).Text & ex.Message)
                            '        salida = salida & vbCrLf & "Error: al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, con el usuario " & UsersListView.Items(i).Text & ex.Message
                            '        HayError = True
                            '    End Try
                            'Else
                            If Not MailClass.IsInOrigAuth(Usuario, UsersListView.Items(i).Text) Then
                                Try
                                    MailClass.AddOrigAuth(Usuario, UsersListView.Items(i).Text)
                                Catch ex As Exception When UsersListView.Items(i).Text = ""
                                    MsgBox("Error al añadir usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, el usuario no puede ser vacio " & ex.Message)
                                    salida = salida & vbCrLf & "Error: al añadir usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, el usuario no puede ser vacio " & ex.Message
                                    HayError = True
                                Catch ex As Exception
                                    MsgBox("Error al añadir usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, con el usuario " & UsersListView.Items(i).Text & ex.Message)
                                    salida = salida & vbCrLf & "Error: al añadir usuarios autorizados para recibir solo de ellos mensajes al permitir recibir de cualquiera, con el usuario " & UsersListView.Items(i).Text & ex.Message
                                    HayError = True
                                End Try
                            End If
                        Next
                    ElseIf ExceptfromRadioButton.Checked Then
                        salida = salida & vbCrLf & "El usuario puede recibir mensajes de cualquiera menos de: "
                        Dim cambio As Boolean = False
                        For i = 0 To UsersListView.Items.Count - 1
                            If MailClass.IsInOrigAuth(Usuario, UsersListView.Items(i).Text) Then
                                cambio = True
                            End If
                        Next
                        If cambio Then
                            Try
                                MailClass.ChangeOrigAuth(Usuario)
                            Catch ex As Exception When Usuario = ""
                                MsgBox("Error al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, el usuario no puede ser vacio  " & ex.Message)
                                salida = salida & vbCrLf & "Error: al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, el usuario no puede ser vacio  " & ex.Message
                                HayError = True
                            Catch ex As Exception
                                MsgBox("Error al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, con el usuario " & Usuario & ex.Message)
                                salida = salida & vbCrLf & "Error: al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, con el usuario " & Usuario & ex.Message
                            End Try
                        End If
                        For i = 0 To UsersListView.Items.Count - 1
                            salida = salida & vbCrLf & UsersListView.Items(i).Text
                            'If MailClass.IsInOrigAuth(Usuario, UsersListView.Items(i).Text) Then
                            '    Try
                            '        MailClass.ChangeOrigAuth(UsersListView.Items(i).Text)
                            '    Catch ex As Exception When UsersListView.Items(i).Text = ""
                            '        MsgBox("Error al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, el usuario no puede ser vacio  " & ex.Message)
                            '        salida = salida & vbCrLf & "Error: al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, el usuario no puede ser vacio  " & ex.Message
                            '        HayError = True
                            '    Catch ex As Exception
                            '        MsgBox("Error al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, con el usuario " & UsersListView.Items(i).Text & ex.Message)
                            '        salida = salida & vbCrLf & "Error: al cambiar usuarios no autorizados para recibir de ellos a permitidos a recibir solo de ellos o viceversa, con el usuario " & UsersListView.Items(i).Text & ex.Message
                            '    End Try
                            'Else
                            If Not MailClass.IsInOrigUnauth(Usuario, UsersListView.Items(i).Text) Then
                                Try
                                    MailClass.AddOrigUnauth(Usuario, UsersListView.Items(i).Text)
                                Catch ex As Exception When UsersListView.Items(i).Text = ""
                                    MsgBox("Error al añadir usuarios no  autorizados para recibir de ellos mensajes al permitir recibir de cualquiera, el usuario no puede ser vacio " & ex.Message)
                                    salida = salida & vbCrLf & "Error: al añadir usuarios no  autorizados para recibir de ellos mensajes al permitir recibir de cualquiera, el usuario no puede ser vacio " & ex.Message
                                    HayError = True
                                Catch ex As Exception
                                    MsgBox("Error al añadir usuarios no autorizados para recibir de ellos mensajes al permitir recibir de cualquiera, con el usuario " & UsersListView.Items(i).Text & ex.Message)
                                    salida = salida & vbCrLf & "Error: al añadir usuarios no autorizados para recibir de ellos mensajes al permitir recibir de cualquiera, con el usuario " & UsersListView.Items(i).Text & ex.Message
                                    HayError = True
                                End Try
                            End If
                        Next
                    End If
                End If

                UsersToRemove = False
            End If
            Me.Cursor = Cursors.Default
            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
            If Not HayError Then
                Me.Close()
            End If

        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub AddButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddButton.Click
        '==========================================================================
        ' Name:     AddButton_Click
        ' Purpose:  Añadir un nuevo objeto al listview permitidos/denegados
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================


        'Llamar a la ventana de obtener usuario
        Añadir.Solo("userGroupExch")
        Añadir.ShowDialog()
        If Usuañadir = "" Then
            MsgBox("No se ha seleccionado ningún usuario a añadir")
        Else
            Dim puede As Boolean = True
            For i = 0 To UsersListView.Items.Count - 1
                If UsersListView.Items(i).Text = Usuañadir Then
                    puede = False
                End If
            Next
            If puede Then
                from = True
                Dim nuevo As ListViewItem
                nuevo = New ListViewItem(Usuañadir)
                UsersListView.Items.Add(nuevo)
                'Habilitar botones aceptar y cancelar
                AcceptButton.Enabled = True
                cancelButton.Enabled = True
            Else
                MsgBox("El usuario ya pertenece a la lista")
            End If
        End If
    End Sub

    Private Sub RemoveButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RemoveButton.Click
        '==========================================================================
        ' Name:     RemoveButton_Click
        ' Purpose:  Eliminar un nuevo objeto al listview permitidos/denegados
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not UsersListView.SelectedItems.Count = 0 Then
            'UsersListView.Items.Remove(UsersListView.SelectedItems(0))

            from = True
            Dim seleccionados As ListView.SelectedListViewItemCollection = Me.UsersListView.SelectedItems
            Dim item As ListViewItem
            Dim i As Integer = 0

            Dim UsuAEliminar(seleccionados.Count - 1) As String
            'Eliminar el objeto de el listview permitidos/denegados 
            For Each item In seleccionados
                'UsuAEliminar(i) = item.SubItems(0).Text
                'i = i + 1
                removeUsers.Add(item.SubItems(0).Text)
                item.Remove()
            Next
            If UsersListView.Items.Count = 0 Then
                FromEveryoneRadioButton.Checked = True
                ExceptfromRadioButton.Checked = False
                OnlyFromRadioButton.Checked = False
            End If
            ''Añadir objeto al array de los objetos a eliminar, teniendo en cuenta que puede que en el array ya tengamos elemntos de antes
            'If UsersToRemove Then
            '    i = removeUsers.Length
            '    For j = 0 To UsuAEliminar.Length - 1
            '        removeUsers(i) = UsuAEliminar(j)
            '    Next
            'Else
            '    removeUsers = UsuAEliminar
            'End If
            'Habilitar botones aceptar y cancelar
            If Not Primero Then
                AcceptButton.Enabled = True
                cancelButton.Enabled = True
            End If
            UsersToRemove = True
        Else
            MsgBox("selecciona algún usuario")
        End If
 
    End Sub

    Private Sub UsersListView_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles UsersListView.SelectedIndexChanged
        '==========================================================================
        ' Name:     UsersListView_SelectedIndexChanged
        ' Purpose:  Habilitar o deshabilitar botones en función del elemento seleccionado
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If UsersListView.SelectedItems.Count = 0 Then
            RemoveButton.Enabled = False
        Else
            RemoveButton.Enabled = True
        End If
    End Sub
End Class
