﻿Public Class SeguridadCarpeta
    Dim carpeta As String
    Dim Objeto As String
    Dim UsuarioToGrant As String
    Dim UsersToRemove As New List(Of String)
    Dim primero As Boolean
    Dim conheredados As Boolean

    Private Structure MyCell
        Dim Row As Integer
        Dim Col As Integer
    End Structure
    Private bOWCheck() As Boolean
    '--------------------------Estructura auxiliar donde guardar los permisos--------------------
    Private Structure allowDeny
        Dim allow As Boolean
        Dim deny As Boolean
        Dim fijoA As Boolean
        Dim fijoD As Boolean
    End Structure
    Private Structure Permissions
        Dim perms() As allowDeny
        Dim usuario As String
        Dim modificado As Boolean
    End Structure
    Dim TodosPermisos As New List(Of Permissions)

    'Dim TodosPermisos() As Permissions
    '------------------------------------------------------------------------------------------------

    Dim seleccionado As Integer = 0
    Dim usersremove As Boolean = False
    Dim usersadd As Boolean = False
    Dim permisChange As Boolean = False

    Friend Sub LoadCarpeta(ByVal folder As String)
        '==========================================================================
        ' Name:     LoadUser
        ' Purpose:  Obtener el usuario del que se van a obtener los datos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        carpeta = folder
    End Sub

    Friend Sub LoadObjeto(ByVal obje As String)
        '==========================================================================
        ' Name:     LoadU
        ' Purpose:  Establecer el objeto al que aqsignar permisos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Objeto = obje
    End Sub

    Private Sub SeguridadCarpeta_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        '==========================================================================
        ' Name:     SeguridadCarpeta_FormClosing
        ' Purpose:  Cerrar la ventana sin realizar cambios
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        UsersListView.Clear()
        UsersView.Clear()
        TodosPermisos.Clear()

    End Sub

    Private Sub SeguridadCarpeta_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     SeguridadCarpeta_Load
        ' Purpose:  Carga de los datos del usuario en la ventana
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    GetDaclNames, GetAcePermission de MailClass
        '==========================================================================
        Dim HayError As Boolean = False
        Dim salida As String
        primero = True
        HeredadosCheckBox.Checked = True
        '-------------------------------------Listview Usuarios-----------------------------------------
        'Crear lista de usuarios con permisos
        'UsersListView.Sorting = SortOrder.Ascending
        UsersListView.ShowItemToolTips = True
        UsersListView.View = View.Details
        UsersListView.Columns.Add("", 290, HorizontalAlignment.Left)

        Dim parts() As String = carpeta.Split("\")
        Me.Text = "Seguridad carpeta " & parts(parts.Count - 1)
        'Obtener usuarios con permisos sobre el buzón e insertarlos en el listview
        Dim GrantedUsers As System.Collections.Generic.IList(Of String)

        Try
            'GrantedUsers = MailClass.GetDaclNames(Usuario)
            GrantedUsers = WMIClass.getElementsP(carpeta)

        Catch ex As Exception
            MsgBox("Error al obtener los objetos que poseen permisos sobre la carpeta " & ex.Message)

            HayError = True
        End Try

        For i = 0 To GrantedUsers.Count - 1
            Dim item As ListViewItem
            Dim partes() As String = GrantedUsers(i).Split("\")
            If partes.Count > 1 Then
                item = New ListViewItem(partes(1))
            Else
                item = New ListViewItem(partes(0))
            End If

            UsersListView.Items.Add(item)
        Next
        UsersListView.Sorting = SortOrder.Ascending
        UsersListView.Sort()

        '-------------------------------------Listview Permisos-----------------------------------------
        'Crear listview para los permisos
        Dim myCheckFont As New System.Drawing.Font("Wingdings", 12, FontStyle.Regular)
        ' Columnas
        UsersView.Columns.Add("Permiso", 190, HorizontalAlignment.Left)
        UsersView.Columns.Add("Allow", 50, HorizontalAlignment.Center)
        UsersView.Columns.Add("Deny", 50, HorizontalAlignment.Center)
        'Nombres para las Filas
        Dim opcion(5) As String
        opcion(0) = "Control total"
        opcion(1) = "Modificar"
        opcion(2) = "Lectura y ejecución"
        opcion(3) = "Mostrar el contenido de la carpeta"
        opcion(4) = "Leer"
        opcion(5) = "Escribir"

        'Crear filas
        With UsersView
            For I As Integer = 0 To 5
                .Items.Add(opcion(I))
                .Items(I).UseItemStyleForSubItems = False
                'Los caracters son especiales y tienen la forma de un checkbox con un tick y un chesckbox vacío
                .Items(I).SubItems.Add(Chr(168))
                .Items(I).SubItems.Add(Chr(168))
                .Items(I).SubItems.Item(1).ForeColor = Color.Black
                .Items(I).SubItems.Item(1).Font = myCheckFont
                .Items(I).SubItems.Item(2).ForeColor = Color.Black
                .Items(I).SubItems.Item(2).Font = myCheckFont
                ReDim bOWCheck(I)
            Next I
        End With

        'TodosPermisos = New List(Of Permissions)
        ' TodosPermisos.Clear()
        '-------------------------------Carga de la tabla-------------------------------
        'Cargar la tabla auxiliar para los permisos
       
        Dim permisos(5) As allowDeny
        For i = 0 To 5
            Try

                Dim allow() As Boolean = WMIClass.GetPermission(carpeta, UsersListView.Items(0).Text, UsersView.Items(i).SubItems(0).Text)
                permisos(i).fijoA = allow(2)
                permisos(i).fijoD = allow(3)
                If allow(0) Then
                    permisos(i).allow = True
                Else
                    permisos(i).allow = False
                End If
                If allow(1) Then
                    permisos(i).deny = True
                Else
                    permisos(i).deny = False
                End If
            Catch ex As Exception
                MsgBox("Error al obtener el permiso " & UsersView.Items(i).SubItems(0).Text & " para el objeto " & UsersListView.Items(0).Text & " sobre la carpeta " & ex.Message)
                salida = salida & vbCrLf & "Error al obtener el permiso " & UsersView.Items(i).SubItems(0).Text & " para el objeto " & UsersListView.Items(0).Text & " sobre la carpeta " & carpeta & ex.Message
                HayError = True
            End Try
        Next
        Dim Tperms As Permissions
        Tperms.perms = permisos
        Tperms.usuario = UsersListView.Items(0).Text
        Tperms.modificado = False
        TodosPermisos.Add(Tperms)
        'TodosPermisos(j) = Tperms
        'Next

        'Actualizar el listview de los permisos con los datos del primer objeto
        If Not TodosPermisos.Count = 0 Then

            UGNameLabel.Text = TodosPermisos(0).usuario
            For i = 0 To 5
                If TodosPermisos(0).perms(i).allow Then
                    UsersView.Items(i).SubItems(1).Text = (Chr(254))
                    If TodosPermisos(0).perms(i).fijoA Then
                        UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                        conheredados = True
                    Else
                        UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                    End If
                Else
                    UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                    UsersView.Items(i).SubItems(1).Text = (Chr(168))
                End If
                If TodosPermisos(0).perms(i).deny Then
                    UsersView.Items(i).SubItems(2).Text = (Chr(254))
                    If TodosPermisos(0).perms(i).fijoD Then
                        UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                        conheredados = True
                    Else
                        UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                    End If
                Else
                    UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                    UsersView.Items(i).SubItems(2).Text = (Chr(168))
                End If
            Next
        End If
        If conheredados Then
            HeredadosCheckBox.Checked = True
        End If
        primero = False
        usersremove = False
        usersadd = False
        permisChange = False

        If HayError Then
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        End If
        'Deshabilitar los botones adeptar y aplicar 
        AcceptButton.Enabled = False
        ApplyButton.Enabled = False
        CancelButton.Enabled = True
    End Sub

    Private Sub UsersListView_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles UsersListView.SelectedIndexChanged
        '==========================================================================
        ' Name:     UsersListView_SelectedIndexChanged
        ' Purpose:  Actualizar el listview de los permisos con los datos del objeto seleccionado
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Not primero Then
            Me.Cursor = Cursors.WaitCursor
            Dim item As ListViewItem
            Dim seleccionados As ListView.SelectedListViewItemCollection = UsersListView.SelectedItems
            'buscar el objeto seleccionado en la tabla auxiliar y actualizar el listview de los permisos
            For Each item In seleccionados
                seleccionado = item.Index
                UGNameLabel.Text = item.Text

                Dim esta As Boolean = False
                Dim ind As Integer = 0
                For i = 0 To TodosPermisos.Count - 1
                    If TodosPermisos(i).usuario = item.Text Then
                        esta = True
                        ind = i
                        Exit For
                    End If
                Next

                If Not esta Then
                    'Cargar los permisos del objeto por primera vez
                    Dim j As Integer = item.Index

                    Dim permisos(5) As allowDeny
                    For i = 0 To 5
                        Try
                            Dim allow() As Boolean = WMIClass.GetPermission(carpeta, UsersListView.Items(j).Text, UsersView.Items(i).SubItems(0).Text) 'MailClass.GetAcePermission(UsersListView.Items(j).Text, Usuario, UsersView.Items(i).SubItems(0).Text)
                            permisos(i).fijoA = allow(2)
                            permisos(i).fijoD = allow(3)
                            If allow(0) Then
                                permisos(i).allow = True
                            Else
                                permisos(i).allow = False
                            End If
                            If allow(1) Then
                                permisos(i).deny = True
                            Else
                                permisos(i).deny = False
                            End If
                        Catch ex As Exception
                            MsgBox("Error al obtener el permiso " & UsersView.Items(i).SubItems(0).Text & " para el objeto " & UsersListView.Items(j).Text & " sobre el buzón del usuario " & ex.Message)

                        End Try
                    Next
                    Dim Tperms As Permissions
                    Tperms.perms = permisos
                    Tperms.usuario = UsersListView.Items(j).Text
                    Tperms.modificado = False
                    TodosPermisos.Add(Tperms)

                    'Se cargan en el listView los permisos del objeto
                    ind = TodosPermisos.Count - 1
                    UGNameLabel.Text = TodosPermisos(ind).usuario
                    For i = 0 To 5

                        If TodosPermisos(ind).perms(i).allow Then
                            UsersView.Items(i).SubItems(1).Text = (Chr(254))
                            If TodosPermisos(ind).perms(i).fijoA Then
                                UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                            Else
                                UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                            End If
                        Else
                            UsersView.Items(i).SubItems(1).Text = (Chr(168))
                            UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                        If TodosPermisos(ind).perms(i).deny Then
                            UsersView.Items(i).SubItems(2).Text = (Chr(254))
                            If TodosPermisos(ind).perms(i).fijoD Then
                                UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                            Else
                                UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                            End If
                        Else
                            UsersView.Items(i).SubItems(2).Text = (Chr(168))
                            UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If

                    Next

                Else
                    For i = 0 To 5

                        If TodosPermisos(ind).perms(i).allow Then
                            UsersView.Items(i).SubItems(1).Text = (Chr(254))
                            If TodosPermisos(ind).perms(i).fijoA Then
                                UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                            Else
                                UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                            End If
                        Else
                            UsersView.Items(i).SubItems(1).Text = (Chr(168))
                            UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                        If TodosPermisos(ind).perms(i).deny Then
                            UsersView.Items(i).SubItems(2).Text = (Chr(254))
                            If TodosPermisos(ind).perms(i).fijoD Then
                                UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                            Else
                                UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                            End If
                        Else
                            UsersView.Items(i).SubItems(2).Text = (Chr(168))
                            UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If

                    Next
                End If
            Next
            Me.Cursor = Cursors.Default
        End If
    End Sub

    Private Function WhichCell(ByVal lvw As ListView, ByVal X As Integer, ByVal Y As Integer) As MyCell
        '==========================================================================
        ' Name:     WhichCell
        ' Purpose:  Obtener la celda a cambiar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   1 Mycell: La celda
        ' Calls:    None
        '==========================================================================
        Dim colstart As Integer = 0
        Dim colend As Integer = 0
        Dim xCol As Integer
        'Obtener la columna
        For xCol = 0 To (UsersView.Columns.Count - 1)
            colend = colend + UsersView.Columns(xCol).Width
            If colstart <= X And X <= colend Then
                WhichCell.Col = xCol + 1
                Exit For
            End If
            colstart = colstart + UsersView.Columns(xCol).Width
        Next
        'Obtener la celda
        WhichCell.Row = UsersView.FocusedItem.Index
        Return WhichCell
    End Function

    Private Sub UsersView_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles UsersView.MouseUp
        '==========================================================================
        ' Name:     UsersView_MouseUp
        ' Purpose:  Controlar los cambios que se producen al hacer click en el listview de los permisos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    WhichCell
        '==========================================================================

        If Not primero Then
            permisChange = True

            Dim indice As Integer = 0
            'Obtener el índice del objeto actual
            For i = 0 To TodosPermisos.Count - 1
                If TodosPermisos(i).usuario = UGNameLabel.Text Then
                    indice = i
                End If
            Next
            'Cambiar el checkbox que aparece en el listview de permisos y actualizar la tabla auxiliar de los permisos 
            Dim cellLoc As MyCell
            'obtener la celda que se ha de cambiar
            cellLoc = WhichCell(UsersView, e.X, e.Y)
            'MsgBox(TodosPermisos(indice).usuario & " " & cellLoc.Row & " " & cellLoc.Col)
            If Not UsersView.Items(cellLoc.Row).SubItems(cellLoc.Col - 1).ForeColor = Color.DarkGray Then
                

                If cellLoc.Col = 2 Or cellLoc.Col = 3 Then

                    If bOWCheck(cellLoc.Row) Then

                        'Actualizar checkbox
                        UsersView.Items(cellLoc.Row).SubItems(cellLoc.Col - 1).Text = Chr(168)
                        UsersView.Items(0).SubItems(cellLoc.Col - 1).Text = Chr(168)
                        If cellLoc.Col = 2 Then
                            TodosPermisos(0).perms(cellLoc.Row).allow = False
                            TodosPermisos(indice).perms(cellLoc.Row).allow = False
                        Else
                            TodosPermisos(0).perms(cellLoc.Row).deny = False
                            TodosPermisos(indice).perms(cellLoc.Row).deny = False
                        End If

                        If cellLoc.Row = 1 Or cellLoc.Row = 2 Or cellLoc.Row = 3 Then

                            For i = 1 To cellLoc.Row
                                UsersView.Items(i).SubItems(cellLoc.Col - 1).Text = Chr(168)
                                If cellLoc.Col = 2 Then
                                    TodosPermisos(indice).perms(i).allow = False
                                Else
                                    TodosPermisos(indice).perms(i).deny = False
                                End If
                            Next

                        ElseIf cellLoc.Row = 4 Then
                            For i = 1 To 2
                                UsersView.Items(i).SubItems(cellLoc.Col - 1).Text = Chr(168)
                                If cellLoc.Col = 2 Then
                                    TodosPermisos(indice).perms(i).allow = False
                                Else
                                    TodosPermisos(indice).perms(i).deny = False
                                End If
                            Next
                        ElseIf cellLoc.Row = 5 Then

                            UsersView.Items(1).SubItems(cellLoc.Col - 1).Text = Chr(168)
                            If cellLoc.Col = 2 Then
                                TodosPermisos(indice).perms(1).allow = False
                            Else
                                TodosPermisos(indice).perms(1).deny = False
                            End If

                        End If
                        bOWCheck(cellLoc.Row) = False
                    Else

                        'Actualizar checkbox
                        UsersView.Items(cellLoc.Row).SubItems(cellLoc.Col - 1).Text = Chr(254)
                        If cellLoc.Col = 2 Then

                            If Not UsersView.Items(cellLoc.Row).SubItems(2).ForeColor = Color.DarkGray Then
                                UsersView.Items(cellLoc.Row).SubItems(2).Text = Chr(168)
                                TodosPermisos(indice).perms(cellLoc.Row).deny = False
                                UsersView.Items(0).SubItems(2).Text = Chr(168)
                                TodosPermisos(indice).perms(0).deny = False
                            End If
                            'actualizar tabla
                            TodosPermisos(indice).perms(cellLoc.Row).allow = True
                            If cellLoc.Row = 0 Then
                                For i = 1 To 5
                                    If Not UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(1).Text = Chr(254)
                                        TodosPermisos(indice).perms(i).allow = True
                                    End If
                                    If Not UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(2).Text = Chr(168)
                                        TodosPermisos(indice).perms(i).deny = False
                                    End If
                                Next

                            ElseIf cellLoc.Row = 1 Then

                                For i = 2 To 5
                                    If Not UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(1).Text = Chr(254)
                                        TodosPermisos(indice).perms(i).allow = True
                                    End If
                                    If Not UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(2).Text = Chr(168)
                                        TodosPermisos(indice).perms(i).deny = False
                                    End If
                                Next

                            ElseIf cellLoc.Row = 2 Then

                                For i = 2 To 4
                                    If Not UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(1).Text = Chr(254)
                                        TodosPermisos(indice).perms(i).allow = True
                                    End If
                                Next
                                For i = 0 To 4
                                    If Not UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(2).Text = Chr(168)
                                        TodosPermisos(indice).perms(i).deny = False
                                    End If
                                Next

                            ElseIf cellLoc.Row = 3 Or cellLoc.Row = 4 Then
                                For i = 0 To 4
                                    If Not UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(2).Text = Chr(168)
                                        TodosPermisos(indice).perms(i).deny = False
                                    End If
                                Next

                            ElseIf cellLoc.Row = 5 Then
                                For i = 0 To 1
                                    If Not UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(2).Text = Chr(168)
                                        TodosPermisos(indice).perms(i).deny = False
                                    End If
                                Next
                            End If
                            bOWCheck(cellLoc.Row) = True
                        Else
                            If Not UsersView.Items(cellLoc.Row).SubItems(1).ForeColor = Color.DarkGray Then
                                UsersView.Items(cellLoc.Row).SubItems(1).Text = Chr(168)
                                TodosPermisos(indice).perms(cellLoc.Row).allow = False
                                UsersView.Items(0).SubItems(1).Text = Chr(168)
                                TodosPermisos(indice).perms(0).allow = False
                            End If
                            'actializar tabla
                            TodosPermisos(indice).perms(cellLoc.Row).deny = True
                            If cellLoc.Row = 0 Then
                                For i = 1 To 5
                                    If Not UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(2).Text = Chr(254)
                                        TodosPermisos(indice).perms(2).deny = True
                                    End If
                                    If Not UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(1).Text = Chr(168)
                                        TodosPermisos(indice).perms(i).allow = False
                                    End If
                                Next

                            ElseIf cellLoc.Row = 1 Then

                                For i = 2 To 5
                                    If Not UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(2).Text = Chr(254)
                                        TodosPermisos(indice).perms(i).deny = True
                                    End If
                                    If Not UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(1).Text = Chr(168)
                                        TodosPermisos(indice).perms(i).allow = False
                                    End If
                                Next

                            ElseIf cellLoc.Row = 2 Then

                                For i = 2 To 4
                                    If Not UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(2).Text = Chr(254)
                                        TodosPermisos(indice).perms(i).deny = True
                                    End If
                                Next
                                For i = 0 To 4
                                    If Not UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(1).Text = Chr(168)
                                        TodosPermisos(indice).perms(i).allow = False
                                    End If
                                Next

                            ElseIf cellLoc.Row = 3 Or cellLoc.Row = 4 Then
                                For i = 0 To 4
                                    If Not UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(1).Text = Chr(168)
                                        TodosPermisos(indice).perms(i).allow = False
                                    End If
                                Next

                            ElseIf cellLoc.Row = 5 Then
                                For i = 0 To 1
                                    If Not UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray Then
                                        UsersView.Items(i).SubItems(1).Text = Chr(168)
                                        TodosPermisos(indice).perms(i).allow = False
                                    End If
                                Next
                            End If
                            bOWCheck(cellLoc.Row) = True
                        End If
                    End If


                End If

                If Not TodosPermisos(indice).modificado Then
                    Dim tperms As Permissions
                    tperms.usuario = TodosPermisos(indice).usuario
                    tperms.modificado = True
                    tperms.perms = TodosPermisos(indice).perms
                    TodosPermisos.RemoveAt(indice)
                    TodosPermisos.Add(tperms)
                End If

                AcceptButton.Enabled = True
                ApplyButton.Enabled = True
                CancelButton.Enabled = True
            End If
        End If
    End Sub

    Private Sub AddPButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddPButton.Click
        '==========================================================================
        ' Name:     AddPButton_Click
        ' Purpose:  Añadir un objeto al listview de los objetos con permisos y cargar éstos en el listview de los permisos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        usersadd = True

        Añadir.Solo("usergroup")
        Añadir.ShowDialog()

        If Not Objeto = "" Then
            Dim puede As Boolean = True
            For i = 0 To UsersListView.Items.Count - 1
                If UsersListView.Items(i).Text = Objeto Then
                    puede = False
                End If
            Next
            If puede Then
                'insertar en el listbox de los nombres
                Dim item As ListViewItem
                item = New ListViewItem(Objeto)
                UsersListView.Items.Add(item)

                'cargar sus datos en la estructura provisional
                Dim permisos(5) As allowDeny
                For i = 0 To 5
                    permisos(i).allow = False
                    permisos(i).deny = False
                Next
                For i = 2 To 4
                    permisos(i).allow = True
                    permisos(i).deny = False
                Next
                Dim Tperms As Permissions
                Tperms.perms = permisos
                Tperms.usuario = Objeto
                TodosPermisos.Add(Tperms)

                seleccionado = TodosPermisos.Count - 1
                'sacar datos en el listview de los permisos
                UGNameLabel.Text = Objeto
                For i = 0 To 5
                    UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                    UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                    UsersView.Items(i).SubItems(1).Text = (Chr(168))
                    UsersView.Items(i).SubItems(2).Text = (Chr(168))
                Next
                For i = 2 To 4
                    UsersView.Items(i).SubItems(1).Text = (Chr(254))
                    UsersView.Items(i).SubItems(2).Text = (Chr(168))
                Next
                AcceptButton.Enabled = True
                ApplyButton.Enabled = True
                CancelButton.Enabled = True
            Else
                MsgBox(Objeto & " ya tiene permisos")
            End If
        Else
            MsgBox("No se ha seleccionado ningún objeto que añadir")
        End If
    End Sub

    Private Sub RemovePButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RemovePButton.Click
        '==========================================================================
        ' Name:     RemoveButton_Click
        ' Purpose:  Eliminar un objeto del listview de los objetos con permisos 
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================


        Dim seleccionados As ListView.SelectedListViewItemCollection = UsersListView.SelectedItems
        If seleccionados.Count > 0 Then
            usersremove = True
            'Eliminar el usuario del listview y añadirlo al array de usuarios a eliminar
            For Each item In seleccionados
                UsersToRemove.Add(item.text)
                For i = 0 To TodosPermisos.Count - 1
                    If TodosPermisos(i).usuario = item.text Then
                        TodosPermisos.RemoveAt(i)
                        item.Remove()
                        Exit For
                    End If
                Next
            Next

            Dim esta As Boolean = False
            'Establecer actual como el primero
            For i = 0 To TodosPermisos.Count - 1
                If TodosPermisos(i).usuario = UsersListView.Items(0).Text Then
                    seleccionado = i
                    esta = True
                    Exit For
                End If
            Next

            If esta Then
                'seleccionado = 0
                UGNameLabel.Text = TodosPermisos(seleccionado).usuario
                For i = 0 To 5
                    If TodosPermisos(seleccionado).perms(i).allow Then
                        UsersView.Items(i).SubItems(1).Text = (Chr(254))
                        If TodosPermisos(seleccionado).perms(i).fijoA Then
                            UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                        Else
                            UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                    Else
                        UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                        UsersView.Items(i).SubItems(1).Text = (Chr(168))
                    End If
                    If TodosPermisos(seleccionado).perms(i).deny Then
                        UsersView.Items(i).SubItems(2).Text = (Chr(254))
                        If TodosPermisos(seleccionado).perms(i).fijoD Then
                            UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                        Else
                            UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If
                    Else
                        UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                        UsersView.Items(i).SubItems(2).Text = (Chr(168))
                    End If
                Next

            Else

                'Cargar los permisos del objeto por primera vez
                Dim j As Integer = 0

                Dim permisos(5) As allowDeny
                For i = 0 To 5
                    Try
                        Dim allow() As Boolean = WMIClass.GetPermission(carpeta, UsersListView.Items(j).Text, UsersView.Items(i).SubItems(0).Text) 'MailClass.GetAcePermission(UsersListView.Items(j).Text, Usuario, UsersView.Items(i).SubItems(0).Text)
                        permisos(i).fijoA = allow(2)
                        permisos(i).fijoD = allow(3)
                        If allow(0) Then
                            permisos(i).allow = True
                        Else
                            permisos(i).allow = False
                        End If
                        If allow(1) Then
                            permisos(i).deny = True
                        Else
                            permisos(i).deny = False
                        End If
                    Catch ex As Exception
                        MsgBox("Error al obtener el permiso " & UsersView.Items(i).SubItems(0).Text & " para el objeto " & UsersListView.Items(j).Text & " sobre el buzón del usuario " & ex.Message)

                    End Try
                Next
                Dim Tperms As Permissions
                Tperms.perms = permisos
                Tperms.usuario = UsersListView.Items(j).Text
                Tperms.modificado = False
                TodosPermisos.Add(Tperms)

                'Se cargan en el listView los permisos del objeto
                Dim ind As Integer = TodosPermisos.Count - 1

                UGNameLabel.Text = TodosPermisos(ind).usuario
                For i = 0 To 5

                    If TodosPermisos(ind).perms(i).allow Then
                        UsersView.Items(i).SubItems(1).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoA Then
                            UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                        Else
                            UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                        End If
                    Else
                        UsersView.Items(i).SubItems(1).Text = (Chr(168))
                        UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                    End If
                    If TodosPermisos(ind).perms(i).deny Then
                        UsersView.Items(i).SubItems(2).Text = (Chr(254))
                        If TodosPermisos(ind).perms(i).fijoD Then
                            UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                        Else
                            UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                        End If
                    Else
                        UsersView.Items(i).SubItems(2).Text = (Chr(168))
                        UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                    End If

                Next

            End If


            'Habilitar aceptar y aplicar
            AcceptButton.Enabled = True
            ApplyButton.Enabled = True
            CancelButton.Enabled = True
        End If
    End Sub

    Private Sub CancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        '==========================================================================
        ' Name:     ApplyButton_Click
        ' Purpose:  Cerrar la ventana sin realizar cambios
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        UsersListView.Clear()
        UsersView.Clear()
        TodosPermisos.Clear()
        Me.Close()
    End Sub

    Private Sub ApplyButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ApplyButton.Click
        '==========================================================================
        ' Name:     ApplyButton_Click
        ' Purpose:  Establecer los cambios efectuados en la ventana y deshabilitar los botones aceptar y aplicar 
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    RemoveAceFromDacl, GetAcePermission, GetDaclNames, AddAceToDacl de MailClass
        '==========================================================================
        Try
            Me.Cursor = Cursors.WaitCursor
            Dim salida As String = "---------Permisos Buzón---------" & vbCrLf & "Cambios al hacer click en el botón aplicar (Propiedades Usuario)"
            Dim nuevo As String = ""
            salida = salida & vbCrLf & "Dirección de la carpeta:" & carpeta
            If usersadd Then
                salida = salida & vbCrLf & "Añadir permisos a:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = WMIClass.getElementsP(carpeta)
                For i = 0 To UsersListView.Items.Count - 1
                    Dim esta As Boolean = False
                    For j = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(j) = UsersListView.Items(i).Text Then
                            esta = True
                        End If
                    Next
                    If Not esta Then
                        For j = 0 To TodosPermisos.Count - 1
                            If TodosPermisos(j).usuario = UsersListView.Items(i).Text Then
                                salida = salida & vbCrLf & UsersListView.Items(i).Text
                                For k = 0 To 5
                                    If TodosPermisos(j).perms(k).allow Then
                                        'MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                        Try
                                            WMIClass.AddPermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text, "allow")
                                        Catch ex As Exception
                                            MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                        End Try
                                    ElseIf TodosPermisos(j).perms(k).deny Then
                                        'MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                        Try
                                            WMIClass.AddPermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text, "deny")
                                        Catch ex As Exception
                                            MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                        End Try
                                    End If
                                Next
                                nuevo = TodosPermisos(j).usuario
                            End If
                        Next
                    End If
                Next
            End If

        '-------------------------------------------Cambio de permisos a un usuario que ya tiene-------------------------------
        If permisChange Then
            salida = salida & vbCrLf & "Modificar permisos:"
            Dim GrantedUsers As System.Collections.Generic.IList(Of String)
            GrantedUsers = WMIClass.getElementsP(carpeta)
            Dim esta As Boolean = False
            For i = 0 To UsersListView.Items.Count - 1
                For j = 0 To GrantedUsers.Count - 1
                    If GrantedUsers(j) = UsersListView.Items(i).Text Then
                        esta = True
                    End If
                Next
                If esta Then
                    For j = 0 To TodosPermisos.Count - 1
                        If Not nuevo = UsersListView.Items(i).Text Then
                            If TodosPermisos(j).usuario = UsersListView.Items(i).Text And TodosPermisos(j).modificado Then
                                For k = 0 To 5
                                    Dim allow() As Boolean = WMIClass.GetPermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text) 'MailClass.GetAcePermission(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text)
                                    If TodosPermisos(j).perms(k).allow Then
                                        If Not allow(0) Then
                                            salida = salida & vbCrLf & "Añadir permiso a:" & UsersListView.Items(i).Text
                                            'MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                            Try
                                                WMIClass.AddPermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text, "allow")
                                            Catch ex As Exception
                                                MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                                salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                            End Try
                                        End If
                                    End If
                                    If Not TodosPermisos(j).perms(k).allow Then
                                        If allow(0) Then
                                            salida = salida & vbCrLf & "Quitar permiso a:" & UsersListView.Items(i).Text
                                            'MailClass.RemoveAceFromDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                            Try
                                                WMIClass.RemovePermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text, "allow")
                                            Catch ex As Exception
                                                MsgBox("Error al quitar un permiso a la carpeta para " & UsersListView.Items(i).Text & ex.Message)
                                                salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message

                                            End Try
                                        End If
                                    End If
                                    If TodosPermisos(j).perms(k).deny Then
                                        If Not allow(1) Then
                                            salida = salida & vbCrLf & "Añadir permiso a:" & UsersListView.Items(i).Text
                                            'MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                            Try
                                                WMIClass.AddPermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text, "deny")
                                            Catch ex As Exception
                                                MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                                salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                            End Try
                                        End If
                                    End If
                                    If Not TodosPermisos(j).perms(k).deny Then
                                        If allow(1) Then
                                            salida = salida & vbCrLf & "Quitar permiso a:" & UsersListView.Items(i).Text
                                            Try
                                                WMIClass.RemovePermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text, "deny")
                                            Catch ex As Exception
                                                MsgBox("Error al quitar un permiso a la carpeta para " & UsersListView.Items(i).Text & ex.Message)
                                                salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message

                                            End Try
                                            'MailClass.RemoveAceFromDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                        End If
                                    End If
                                    Next
                                    Dim tperms As Permissions
                                    tperms.usuario = TodosPermisos(j).usuario
                                    tperms.modificado = False
                                    tperms.perms = TodosPermisos(j).perms
                                    TodosPermisos.RemoveAt(j)
                                    TodosPermisos.Add(tperms)
                            End If
                        End If
                    Next
                End If
            Next
        End If

        '------------------------------------------------Borrado de todos los permisos de un usuario-----------------------------
        If usersremove Then
            salida = salida & vbCrLf & "Quitar todos los permisos a:"
            Dim GrantedUsers As System.Collections.Generic.IList(Of String)
            'MsgBox(UsersToRemove(0))
            For i = 0 To UsersToRemove.Count - 1

                salida = salida & vbCrLf & UsersToRemove(i)
                'MailClass.RemoveAcesMailbox(UsersToRemove(i), Usuario)
                Try
                    WMIClass.RemoveAllPermissions(carpeta, UsersToRemove(i))
                Catch ex As Exception
                    MsgBox("Error al quitar todos los permisos sobre la carpeta para " & UsersListView.Items(i).Text & ex.Message)
                    salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message

                End Try
            Next
        End If

        'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)

        '----------------------------------Variables de control y botones------------------------------------------------------
        permisChange = False
        usersremove = False
        usersadd = False
        'Deshabilitar aceptar y aplicar
            AcceptButton.Enabled = True
        ApplyButton.Enabled = False
        CancelButton.Enabled = True
        Me.Cursor = Cursors.Default
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub AcceptButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Establecer los cambios efectuados en la ventana y cerrarla 
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    RemoveAceFromDacl, GetAcePermission, GetDaclNames, AddAceToDacl de MailClass
        '==========================================================================
        Try
            Me.Cursor = Cursors.WaitCursor
            Dim HayError As Boolean = False
            Dim salida As String = "---------Permisos Buzón---------" & vbCrLf & "Cambios al hacer click en el botón aplicar (Propiedades Usuario)"
            Dim nuevo As String = ""
            salida = salida & vbCrLf & "Dirección de la carpeta:" & carpeta
            If usersadd Then
                salida = salida & vbCrLf & "Añadir permisos a:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = WMIClass.getElementsP(carpeta)
                For i = 0 To UsersListView.Items.Count - 1
                    Dim esta As Boolean = False
                    For j = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(j) = UsersListView.Items(i).Text Then
                            esta = True
                        End If
                    Next
                    If Not esta Then
                        For j = 0 To TodosPermisos.Count - 1
                            If TodosPermisos(j).usuario = UsersListView.Items(i).Text Then
                                salida = salida & vbCrLf & UsersListView.Items(i).Text
                                For k = 0 To 5
                                    If TodosPermisos(j).perms(k).allow Then
                                        'MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                        Try
                                            WMIClass.AddPermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text, "allow")
                                        Catch ex As Exception
                                            MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                            HayError = True
                                        End Try
                                    ElseIf TodosPermisos(j).perms(k).deny Then
                                        'MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                        Try
                                            WMIClass.AddPermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text, "deny")
                                        Catch ex As Exception
                                            MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                            salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                            HayError = True
                                        End Try
                                    End If
                                Next
                                nuevo = TodosPermisos(j).usuario
                            End If
                        Next
                    End If
                Next
            End If

            '-------------------------------------------Cambio de permisos a un usuario que ya tiene-------------------------------
            If permisChange Then
                salida = salida & vbCrLf & "Modificar permisos:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                GrantedUsers = WMIClass.getElementsP(carpeta)
                Dim esta As Boolean = False
                For i = 0 To UsersListView.Items.Count - 1
                    For j = 0 To GrantedUsers.Count - 1
                        If GrantedUsers(j) = UsersListView.Items(i).Text Then
                            esta = True
                        End If
                    Next
                    If esta Then
                        For j = 0 To TodosPermisos.Count - 1
                            If Not nuevo = UsersListView.Items(i).Text Then
                                If TodosPermisos(j).usuario = UsersListView.Items(i).Text And TodosPermisos(j).modificado Then
                                    For k = 0 To 5
                                        Dim allow() As Boolean = WMIClass.GetPermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text) 'MailClass.GetAcePermission(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text)
                                        If TodosPermisos(j).perms(k).allow Then
                                            If Not allow(0) Then
                                                salida = salida & vbCrLf & "Añadir permiso a:" & UsersListView.Items(i).Text
                                                'MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                                Try
                                                    WMIClass.AddPermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text, "allow")
                                                Catch ex As Exception
                                                    MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                End Try
                                            End If
                                        End If
                                        If Not TodosPermisos(j).perms(k).allow Then
                                            If allow(0) Then
                                                salida = salida & vbCrLf & "Quitar permiso a:" & UsersListView.Items(i).Text
                                                'MailClass.RemoveAceFromDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "Allow")
                                                Try
                                                    WMIClass.RemovePermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text, "allow")
                                                Catch ex As Exception
                                                    MsgBox("Error al quitar un permiso a la carpeta para " & UsersListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                End Try
                                            End If
                                        End If
                                        If TodosPermisos(j).perms(k).deny Then
                                            If Not allow(1) Then
                                                salida = salida & vbCrLf & "Añadir permiso a:" & UsersListView.Items(i).Text
                                                'MailClass.AddAceToDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                                Try
                                                    WMIClass.AddPermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text, "deny")
                                                Catch ex As Exception
                                                    MsgBox("Error al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al añadir un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                End Try
                                            End If
                                        End If
                                        If Not TodosPermisos(j).perms(k).deny Then
                                            If allow(1) Then
                                                salida = salida & vbCrLf & "Quitar permiso a:" & UsersListView.Items(i).Text
                                                Try
                                                    WMIClass.RemovePermission(carpeta, UsersListView.Items(i).Text, UsersView.Items(k).SubItems(0).Text, "deny")
                                                Catch ex As Exception
                                                    MsgBox("Error al quitar un permiso a la carpeta para " & UsersListView.Items(i).Text & ex.Message)
                                                    salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                                                    HayError = True
                                                End Try
                                                'MailClass.RemoveAceFromDacl(UsersListView.Items(i).Text, Usuario, UsersView.Items(k).SubItems(0).Text, "deny")
                                            End If
                                        End If
                                    Next
                                End If
                            End If
                        Next
                    End If
                Next
            End If

            '------------------------------------------------Borrado de todos los permisos de un usuario-----------------------------
            If usersremove Then
                salida = salida & vbCrLf & "Quitar todos los permisos a:"
                Dim GrantedUsers As System.Collections.Generic.IList(Of String)
                'MsgBox(UsersToRemove(0))
                For i = 0 To UsersToRemove.Count - 1

                    salida = salida & vbCrLf & UsersToRemove(i)
                    'MailClass.RemoveAcesMailbox(UsersToRemove(i), Usuario)
                    Try
                        WMIClass.RemoveAllPermissions(carpeta, UsersToRemove(i))
                    Catch ex As Exception
                        MsgBox("Error al quitar todos los permisos sobre la carpeta para " & UsersListView.Items(i).Text & ex.Message)
                        salida = salida & vbCrLf & "Error: al quitar un permiso al buzón para " & UsersListView.Items(i).Text & ex.Message
                        HayError = True
                    End Try
                Next
            End If

            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)

            '--------------------------------------------------------------------------------------------------------------
            UsersListView.Items.Clear()
            UsersView.Items.Clear()
            Me.Cursor = Cursors.Default
            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
            If Not HayError Then
                UsersView.Clear()
                UsersListView.Clear()
                TodosPermisos.Clear()
                Me.Close()
            End If
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub HeredadosCheckBox_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles HeredadosCheckBox.CheckedChanged
        '==========================================================================
        ' Name:     HeredadosCheckBox_CheckedChanged
        ' Purpose:  Incluir o quitar los permisos heredados de la carpeta
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    GetPermission, getElementsPH de WMIClass
        '==========================================================================
        If Not primero Then

            If HeredadosCheckBox.Checked = False Then
                conheredados = False
                'Obtener usuarios con permisos heredados sobre el buzón 
                Dim HUsers As System.Collections.Generic.IList(Of String)
                Try
                    HUsers = WMIClass.getElementsPH(carpeta)

                Catch ex As Exception
                    MsgBox("Error al obtener los objetos que poseen permisos heredados sobre la carpeta " & ex.Message)

                End Try

                If HUsers.Count > 0 Then
                    Dim Seleccionados As New List(Of String)

                    For i = 0 To HUsers.Count - 1
                        Dim item As String
                        Dim partes() As String = HUsers(i).Split("\")
                        If partes.Count > 1 Then
                            item = partes(1)
                        Else
                            item = HUsers(i)
                        End If

                        Seleccionados.Add(item)
                    Next

                    If Seleccionados.Count > 0 Then
                        usersremove = True
                        'Eliminar el usuario del listview y añadirlo al array de usuarios a eliminar
                        For item = 0 To Seleccionados.Count - 1

                            For Each perm In UsersListView.Items
                                If perm.text = Seleccionados(item) Then
                                    perm.remove()
                                End If
                            Next
                            For i = 0 To TodosPermisos.Count - 1
                                If TodosPermisos(i).usuario = Seleccionados(item) Then
                                    TodosPermisos.RemoveAt(i)
                                End If
                            Next
                        Next

                        Dim esta As Boolean = False
                        'Establecer actual como el primero
                        For i = 0 To TodosPermisos.Count - 1
                            If TodosPermisos(i).usuario = UsersListView.Items(0).Text Then
                                seleccionado = i
                                esta = True
                                Exit For
                            End If
                        Next

                        If esta Then
                            'seleccionado = 0
                            UGNameLabel.Text = TodosPermisos(seleccionado).usuario
                            For i = 0 To 5
                                If TodosPermisos(seleccionado).perms(i).allow Then
                                    UsersView.Items(i).SubItems(1).Text = (Chr(254))
                                    If TodosPermisos(seleccionado).perms(i).fijoA Then
                                        UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                                    Else
                                        UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                                    End If
                                Else
                                    UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                                    UsersView.Items(i).SubItems(1).Text = (Chr(168))
                                End If
                                If TodosPermisos(seleccionado).perms(i).deny Then
                                    UsersView.Items(i).SubItems(2).Text = (Chr(254))
                                    If TodosPermisos(seleccionado).perms(i).fijoD Then
                                        UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                                    Else
                                        UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                                    End If
                                Else
                                    UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                                    UsersView.Items(i).SubItems(2).Text = (Chr(168))
                                End If
                            Next

                        Else

                            'Cargar los permisos del objeto por primera vez
                            Dim j As Integer = 0

                            Dim permisos(5) As allowDeny
                            For i = 0 To 5
                                Try
                                    Dim allow() As Boolean = WMIClass.GetPermission(carpeta, UsersListView.Items(j).Text, UsersView.Items(i).SubItems(0).Text) 'MailClass.GetAcePermission(UsersListView.Items(j).Text, Usuario, UsersView.Items(i).SubItems(0).Text)
                                    permisos(i).fijoA = allow(2)
                                    permisos(i).fijoD = allow(3)
                                    If allow(0) Then
                                        permisos(i).allow = True
                                    Else
                                        permisos(i).allow = False
                                    End If
                                    If allow(1) Then
                                        permisos(i).deny = True
                                    Else
                                        permisos(i).deny = False
                                    End If
                                Catch ex As Exception
                                    MsgBox("Error al obtener el permiso " & UsersView.Items(i).SubItems(0).Text & " para el objeto " & UsersListView.Items(j).Text & " sobre el buzón del usuario " & ex.Message)

                                End Try
                            Next
                            Dim Tperms As Permissions
                            Tperms.perms = permisos
                            Tperms.usuario = UsersListView.Items(j).Text
                            Tperms.modificado = False
                            TodosPermisos.Add(Tperms)

                            'Se cargan en el listView los permisos del objeto
                            Dim ind As Integer = TodosPermisos.Count - 1

                            UGNameLabel.Text = TodosPermisos(ind).usuario
                            For i = 0 To 5

                                If TodosPermisos(ind).perms(i).allow Then
                                    UsersView.Items(i).SubItems(1).Text = (Chr(254))
                                    If TodosPermisos(ind).perms(i).fijoA Then
                                        UsersView.Items(i).SubItems(1).ForeColor = Color.DarkGray
                                    Else
                                        UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                                    End If
                                Else
                                    UsersView.Items(i).SubItems(1).Text = (Chr(168))
                                    UsersView.Items(i).SubItems(1).ForeColor = Color.Black
                                End If
                                If TodosPermisos(ind).perms(i).deny Then
                                    UsersView.Items(i).SubItems(2).Text = (Chr(254))
                                    If TodosPermisos(ind).perms(i).fijoD Then
                                        UsersView.Items(i).SubItems(2).ForeColor = Color.DarkGray
                                    Else
                                        UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                                    End If
                                Else
                                    UsersView.Items(i).SubItems(2).Text = (Chr(168))
                                    UsersView.Items(i).SubItems(2).ForeColor = Color.Black
                                End If

                            Next

                        End If


                        'Habilitar aceptar y aplicar
                        AcceptButton.Enabled = True
                        ApplyButton.Enabled = True
                        CancelButton.Enabled = True

                    End If
                End If

            End If
        End If

    End Sub
End Class