﻿Public Class TareasExchange
    Dim Usuario As String
    Dim tipo As String
    Dim TempNode As ListViewItem
    Dim HayError As Boolean = False
    Friend Sub LoadUser(ByVal User As String, ByVal tipe As String)
        '==========================================================================
        ' Name:     LoadUser
        ' Purpose:  Establecer el usuario del que manipular los datos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Usuario = User
        tipo = tipe
    End Sub

    Private Sub TareasExchange_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     TareasExchange_Load
        ' Purpose:  Visualizar el panel inicial
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        MsgBox("2")
        GeneralPanel.Visible = True
        GeneralPanel.Dock = DockStyle.Fill
        NuevoBuzónPanel.Visible = False
        MoverPanel.Visible = False
        DeletePanel.Visible = False
        EndPanel.Visible = False
        MovingPanel.Visible = False

        NextButton.Text = "Siguiente>"
        CancelButton.Enabled = True
        DeleteGroupMailPanel.Visible = False
        MailPanel.Visible = False


        'Cargar panel general
        BackButton.Enabled = False
        TareasListView.ShowItemToolTips = True
        TareasListView.View = View.Details
        TareasListView.Columns.Clear()
        TareasListView.Columns.Add("Tarea", 300)
        Label1.Text = "Selecciona una de las tareas para ver su descripción"
        Dim homeMDB As String
        If Not tipo = "GROUP" Then
            homeMDB = UserClass.GetUserProperty(Usuario, "homeMDB")
        End If

        'Si homeMDB significa que el usuario tiene buzón y email exchange
        If homeMDB = "" Then
            If Not tipo = "GROUP" Then
                TareasListView.Items.Clear()
                Dim Tarea As String
                Tarea = "Crear Buzón"
                TempNode = New ListViewItem(Tarea)
                TareasListView.Items.Add(TempNode)
            Else
                Dim legacy As String = groupClass.GetGroupProperty(Usuario, "legacyExchangeDN")
                If legacy = "" Then
                    TareasListView.Items.Clear()
                    Dim Tarea As String
                    Tarea = "Establecer correo"
                    TempNode = New ListViewItem(Tarea)
                    TareasListView.Items.Add(TempNode)
                Else
                    TareasListView.Items.Clear()
                    Dim Tarea As String
                    Tarea = "Eliminar correo"
                    TempNode = New ListViewItem(Tarea)
                    TareasListView.Items.Add(TempNode)
                End If
            End If
        Else

            TareasListView.Items.Clear()
            Dim Tarea As String
            Tarea = "Mover Buzón"
            TempNode = New ListViewItem(Tarea)
            TareasListView.Items.Add(TempNode)

            Tarea = "Eliminar Buzón"
            TempNode = New ListViewItem(Tarea)
            TareasListView.Items.Add(TempNode)
        End If

    End Sub

    Private Sub NextButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NextButton.Click
        '==========================================================================
        ' Name:     NextButton_Click
        ' Purpose:  Cada vez que se hace click en next se avanza para visualizar el siguiente panel y en el úlltimo se llama a la función que crea el usuario
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CrearUsuario, ComprobarContraseñas, Comprobar Panel correo
        '           UserExists de UserClass
        '==========================================================================

        If GeneralPanel.Visible = True Then

            If TareasListView.SelectedItems.Count = 0 Then
                MsgBox("No se ha seleccionado ninguna Tarea")
            Else
                If TareasListView.SelectedItems.Item(0).Text = "Crear Buzón" Then
                    GeneralPanel.Visible = False
                    NuevoBuzónPanel.Visible = True
                    NuevoBuzónPanel.Dock = DockStyle.Fill
                    MoverPanel.Visible = False
                    DeletePanel.Visible = False
                    EndPanel.Visible = False
                    MovingPanel.Visible = False

                    BackButton.Enabled = True
                ElseIf TareasListView.SelectedItems.Item(0).Text = "Mover Buzón" Then
                    GeneralPanel.Visible = False
                    NuevoBuzónPanel.Visible = False
                    MoverPanel.Dock = DockStyle.Fill
                    MoverPanel.Visible = True
                    DeletePanel.Visible = False
                    EndPanel.Visible = False
                    MovingPanel.Visible = False

                    BackButton.Enabled = True
                ElseIf TareasListView.SelectedItems.Item(0).Text = "Eliminar Buzón" Then
                    GeneralPanel.Visible = False
                    NuevoBuzónPanel.Visible = False
                    DeletePanel.Dock = DockStyle.Fill
                    MoverPanel.Visible = False
                    DeletePanel.Visible = True
                    EndPanel.Visible = False
                    MovingPanel.Visible = False

                    BackButton.Enabled = True
                ElseIf TareasListView.SelectedItems.Item(0).Text = "Establecer correo" Then
                    GeneralPanel.Visible = False
                    MailPanel.Visible = True
                    MailPanel.Dock = DockStyle.Fill
                    MoverPanel.Visible = False
                    DeletePanel.Visible = False
                    EndPanel.Visible = False
                    MovingPanel.Visible = False

                    BackButton.Enabled = True
                ElseIf TareasListView.SelectedItems.Item(0).Text = "Eliminar correo" Then
                    GeneralPanel.Visible = False
                    NuevoBuzónPanel.Visible = False
                    DeleteGroupMailPanel.Dock = DockStyle.Fill
                    MoverPanel.Visible = False
                    DeleteGroupMailPanel.Visible = True
                    EndPanel.Visible = False
                    MovingPanel.Visible = False

                    BackButton.Enabled = True
                Else
                    MsgBox("No se ha seleccionado ninguna Tarea")
                End If
            End If
            
        ElseIf NuevoBuzónPanel.Visible = True Then
            Dim parts() As String = MailboxStoreComboBox.SelectedItem.ToString.Split("/")
            Me.Cursor = Cursors.WaitCursor
            MailClass.User_MailEnable(Usuario, parts(1), ServerComboBox.SelectedItem.ToString)

            If Not AliasTextBox.Text = "" Then
                Try
                    UserClass.SetUserProperty(Usuario, "mailNickName", AliasTextBox.Text)
                Catch ex As Exception
                    HayError = True
                    MsgBox("Error al asignar el nick del mail " & ex.Message)

                End Try
            Else
                UserClass.ClearUserProperty(Usuario, "mailNickName")
            End If
            Me.Cursor = Cursors.Default
            GeneralPanel.Visible = False
            NuevoBuzónPanel.Visible = False
            EndPanel.Dock = DockStyle.Fill
            MoverPanel.Visible = False
            DeletePanel.Visible = False
            EndPanel.Visible = True
            MovingPanel.Visible = False

            NextButton.Text = "Finalizar"
            CancelButton.Enabled = False

        ElseIf MoverPanel.Visible = True Then
            If MailboxMComboBox.SelectedItem = "" Or ServerMComboBox.SelectedItem = "" Then
                MsgBox("Se han de seleccionar el MailboxStore y Servidor al que mover el buzón")
            Else

                BackButton.Enabled = False
                CancelButton.Enabled = False
                NextButton.Enabled = False
                Dim parts() As String = MailboxMComboBox.SelectedItem.ToString.Split("/")
                Me.Cursor = Cursors.WaitCursor
                MailClass.MoveMailbox(Usuario, parts(1), ServerMComboBox.SelectedItem.ToString)
                Me.Cursor = Cursors.Default
                NextButton.Enabled = True

                GeneralPanel.Visible = False
                MovingPanel.Visible = True
                NuevoBuzónPanel.Visible = False
                MovingPanel.Dock = DockStyle.Fill
                MoverPanel.Visible = False
                DeletePanel.Visible = False
                EndPanel.Visible = False


            End If

            'ElseIf MoverPanel.Visible = True Then
            '    GeneralPanel.Visible = False
            '    PreMovePanel.Visible = True
            '    NuevoBuzónPanel.Visible = False
            '    PreMovePanel.Dock = DockStyle.Fill
            '    MoverPanel.Visible = False
            '    DeletePanel.Visible = False
            '    EndPanel.Visible = False
            '    MovingPanel.Visible = False

            '    BackButton.Enabled = False
            '    CancelButton.Enabled = False
            '    NextButton.Enabled = False
            '    Dim parts() As String = MailboxMComboBox.SelectedItem.ToString.Split("/")
            '    Me.Cursor = Cursors.WaitCursor
            '    MailClass.MoveMailbox(Usuario, parts(1), ServerMComboBox.SelectedItem.ToString)
            '    Me.Cursor = Cursors.Default
            '    NextButton.Enabled = True

            '    GeneralPanel.Visible = False
            '    MovingPanel.Visible = True
            '    NuevoBuzónPanel.Visible = False
            '    MovingPanel.Dock = DockStyle.Fill
            '    MoverPanel.Visible = False
            '    DeletePanel.Visible = False
            '    EndPanel.Visible = False
            '    PreMovePanel.Visible = False
                

        ElseIf DeletePanel.Visible = True Then
            Me.Cursor = Cursors.WaitCursor
            MailClass.DeleteMailbox(Usuario)
            Me.Cursor = Cursors.Default
            GeneralPanel.Visible = False
            NuevoBuzónPanel.Visible = False
            EndPanel.Dock = DockStyle.Fill
            MoverPanel.Visible = False
            DeletePanel.Visible = False

            EndPanel.Visible = True
            MovingPanel.Visible = False
            NextButton.Text = "Finalizar"
            BackButton.Enabled = False
            CancelButton.Enabled = False

        ElseIf MovingPanel.Visible = True Then
            GeneralPanel.Visible = False
            NuevoBuzónPanel.Visible = False
            EndPanel.Dock = DockStyle.Fill
            MoverPanel.Visible = False
            DeletePanel.Visible = False

            EndPanel.Visible = True
            MovingPanel.Visible = False
            NextButton.Text = "Finalizar"
            BackButton.Enabled = False
            CancelButton.Enabled = False

        ElseIf MailPanel.Visible = True Then
            If ComprobarPanelCorreo() Then
                Me.Cursor = Cursors.WaitCursor
                MailClass.Group_MailEnable(Usuario, AdminGroupComboBox.SelectedItem.ToString, AliasSinBuzonTextBox.Text)
                Me.Cursor = Cursors.Default
                GeneralPanel.Visible = False
                NuevoBuzónPanel.Visible = False
                MailPanel.Visible = False
                EndPanel.Dock = DockStyle.Fill
                MoverPanel.Visible = False
                DeletePanel.Visible = False

                EndPanel.Visible = True
                MovingPanel.Visible = False
                NextButton.Text = "Finalizar"
                BackButton.Enabled = False
                CancelButton.Enabled = False
            Else
                MsgBox("Para crear el correo para el grupo se necesita el Alias y el Grupo Administrativo")
            End If

        ElseIf DeleteGroupMailPanel.Visible = True Then
            Me.Cursor = Cursors.WaitCursor
            MailClass.Group_MailDisable(Usuario)
            Me.Cursor = Cursors.Default
            GeneralPanel.Visible = False
            NuevoBuzónPanel.Visible = False
            DeleteGroupMailPanel.Visible = False
            EndPanel.Dock = DockStyle.Fill
            MoverPanel.Visible = False
            DeletePanel.Visible = False

            EndPanel.Visible = True
            MovingPanel.Visible = False
            NextButton.Text = "Finalizar"
            BackButton.Enabled = False
            CancelButton.Enabled = False

        ElseIf EndPanel.Visible = True Then
            If Not HayError Then
                Me.Close()
            End If
        End If
    End Sub

    Private Sub NuevoBuzónPanel_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles NuevoBuzónPanel.VisibleChanged
        '==========================================================================
        ' Name:     NuevoBuzónPanel_VisibleChanged
        ' Purpose:  Carga de servidores en el combobox al visualizar el panel
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CargarServidoresExch de GenericClass
        '==========================================================================
        If NuevoBuzónPanel.Visible = True Then
            Me.Cursor = Cursors.WaitCursor
            'Carga Servidores
            Dim servidores As New List(Of String)
            'Obtener los servidores del dominio
            servidores = GenericClass.CargarServidoresExch
            'Añadir sus nombres al combobox
            ServerComboBox.Items.Clear()
            For i = 0 To servidores.Count - 1
                ServerComboBox.Items.Add(servidores(i))
            Next
            Me.Cursor = Cursors.Default
        End If
    End Sub

    Private Sub ServerComboBox_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ServerComboBox.SelectedIndexChanged
        '==========================================================================
        ' Name:     ServerComboBox_SelectedIndexChanged
        ' Purpose:  Carga de mailboxStores al seleccionar el servidor en el panel nuevo buzón panel.
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CargarMailBoxes de GenericClass
        '==========================================================================
        Me.Cursor = Cursors.WaitCursor
        'Cargar Mailboxes del servidor
        Dim salida As New List(Of String)
        'Se obtienen los mailboxStores del servidor seleccionado en el combobox anterior
        salida = GenericClass.CargarMailBoxes(ServerComboBox.SelectedItem.ToString)
        'Se añaden sus nombres al combobox
        MailboxStoreComboBox.Items.Clear()
        For i = 0 To salida.Count - 1
            MailboxStoreComboBox.Items.Add(salida(i))
        Next
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub MoverPanel_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles MoverPanel.VisibleChanged
        '==========================================================================
        ' Name:     MoverPanel_VisibleChanged
        ' Purpose:  Carga de servidores en el combobox al visualizar el panel
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CargarServidoresExch de GenericClass
        '==========================================================================
        If MoverPanel.Visible = True Then
            Me.Cursor = Cursors.WaitCursor
            'Mailbox Actual
            Dim Servidor As String
            Dim homeMDB As String = UserClass.GetUserProperty(Usuario, "homeMDB")
            Dim legacy As String = UserClass.GetUserProperty(Usuario, "legacyExchangeDN")

            'Si homeMDB significa que el usuario tiene buzón y email exchange
            If Not homeMDB = "" Then

                Dim parte() As String = homeMDB.Split(",")
                Dim mailbox As String = parte(0).Replace("CN=", "")
                Dim StorageGroup As String = parte(1).Replace("CN=", "")
                For i = 2 To parte.Length - 1
                    If parte(i) = "CN=Servers" Then
                        Servidor = parte(i - 1).Replace("CN=", "")
                    End If
                Next
                'Datos generales
                ActualMailboxTextBox.Text = Servidor & "/" & StorageGroup & "/" & mailbox

                'Carga Servidores
                Dim servidores As New List(Of String)

                'Saber el grupo Administrativo del buzón
                Dim parts() As String = legacy.Split("/")
                Dim AdminGroup As String = parts(1).Replace("ou=", "")

                'Obtener los servidores del dominio
                servidores = GenericClass.CargarServidoresExchMove(AdminGroup)

                'Añadir nombres de los servidores exchange que no son el actual al combobox
                ServerMComboBox.Items.Clear()
                For i = 0 To servidores.Count - 1
                    If Not servidores(i).Contains(Servidor) Then
                        ServerMComboBox.Items.Add(servidores(i))
                    ElseIf GenericClass.NumeroMailBoxes(servidores(i)) > 1 Then
                        ServerMComboBox.Items.Add(servidores(i))
                    End If
                Next
                If Not ServerMComboBox.Items.Count > 0 Then

                    MsgBox("No se puede mover el buzón porque solo hay un Almacén de buzones")
                    GeneralPanel.Visible = True
                    GeneralPanel.Dock = DockStyle.Fill
                    NuevoBuzónPanel.Visible = False
                    MoverPanel.Visible = False
                    DeletePanel.Visible = False
                    EndPanel.Visible = False
                    BackButton.Enabled = False
                End If
            End If
            Me.Cursor = Cursors.Default
        End If
    End Sub

    Private Sub ServerMComboBox_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ServerMComboBox.SelectedIndexChanged
        '==========================================================================
        ' Name:     ServerMComboBox_SelectedIndexChanged
        ' Purpose:  Carga de mailboxStores al seleccionar el servidor en el panel nuevo buzón panel.
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CargarMailBoxes de GenericClass
        '==========================================================================
        Me.Cursor = Cursors.WaitCursor
        'Cargar Mailboxes del servidor
        Dim salida As New List(Of String)
        'Se obtienen los mailboxStores del servidor seleccionado en el combobox anterior
        salida = GenericClass.CargarMailBoxes(ServerMComboBox.SelectedItem.ToString)
        Dim homeMDB As String = UserClass.GetUserProperty(Usuario, "homeMDB")
        'Si homeMDB significa que el usuario tiene buzón y email exchange

        Dim parte() As String = homeMDB.Split(",")
        Dim mailbox As String = parte(0).Replace("CN=", "")

        'Se añaden sus nombres al combobox
        MailboxMComboBox.Items.Clear()
        For i = 0 To salida.Count - 1
            If Not salida(i).Contains(mailbox) Then
                MailboxMComboBox.Items.Add(salida(i))
            End If

        Next
        If Not MailboxMComboBox.Items.Count > 0 Then

            MsgBox("No se puede mover el buzón porque solo hay un Almacén de buzones")
            GeneralPanel.Visible = True
            GeneralPanel.Dock = DockStyle.Fill
            NuevoBuzónPanel.Visible = False
            MoverPanel.Visible = False
            DeletePanel.Visible = False
            EndPanel.Visible = False
            BackButton.Enabled = False
        End If
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub CancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        Me.Close()
    End Sub

    Private Sub BackButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles BackButton.Click
        '==========================================================================
        ' Name:     BackButton_Click
        ' Purpose:  Cada vez que se hace click en back se retrocede para visualizar el anterior panel
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If NuevoBuzónPanel.Visible = True Then
            GeneralPanel.Visible = True
            GeneralPanel.Dock = DockStyle.Fill
            NuevoBuzónPanel.Visible = False
            MoverPanel.Visible = False
            DeletePanel.Visible = False
            EndPanel.Visible = False
            BackButton.Enabled = False
        ElseIf MoverPanel.Visible = True Then
            GeneralPanel.Visible = True
            GeneralPanel.Dock = DockStyle.Fill
            NuevoBuzónPanel.Visible = False
            MoverPanel.Visible = False
            DeletePanel.Visible = False
            EndPanel.Visible = False
            BackButton.Enabled = False
        ElseIf DeletePanel.Visible = True Then
            GeneralPanel.Visible = True
            GeneralPanel.Dock = DockStyle.Fill
            NuevoBuzónPanel.Visible = False
            MoverPanel.Visible = False
            DeletePanel.Visible = False
            EndPanel.Visible = False
            BackButton.Enabled = False
        ElseIf MailPanel.Visible = True Then
            GeneralPanel.Visible = True
            GeneralPanel.Dock = DockStyle.Fill
            NuevoBuzónPanel.Visible = False
            MoverPanel.Visible = False
            DeletePanel.Visible = False
            EndPanel.Visible = False
            BackButton.Enabled = False
            MailPanel.Visible = False
        ElseIf DeleteGroupMailPanel.Visible = True Then
            GeneralPanel.Visible = True
            GeneralPanel.Dock = DockStyle.Fill
            NuevoBuzónPanel.Visible = False
            MoverPanel.Visible = False
            DeletePanel.Visible = False
            EndPanel.Visible = False
            BackButton.Enabled = False
            DeleteGroupMailPanel.Visible = False
        End If
    End Sub

    'Private Sub GeneralPanel_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles GeneralPanel.VisibleChanged
    '    '==========================================================================
    '    ' Name:     GeneralPanel_VisibleChanged
    '    ' Purpose:  Carga de datos para el panel inicial, carga los elementos del listview y ocultar los demás
    '    ' Input:    1 Evento: 'e', 
    '    '           1 Objeto: 'sender'
    '    ' Return:   None
    '    ' Calls:    CargarServidoresExch de GenericClass
    '    '==========================================================================
    '    If GeneralPanel.Visible = True Then
    '        BackButton.Enabled = False
    '        TareasListView.ShowItemToolTips = True
    '        TareasListView.View = View.Details
    '        TareasListView.Columns.Clear()
    '        TareasListView.Columns.Add("Tarea", 300)
    '        Label1.Text = "Selecciona una de las tareas para ver su descripción"
    '        Dim homeMDB As String
    '        If Not tipo = "GROUP" Then
    '            homeMDB = UserClass.GetUserProperty(Usuario, "homeMDB")
    '        End If

    '        'Si homeMDB significa que el usuario tiene buzón y email exchange
    '        If homeMDB = "" Then
    '            If Not tipo = "GROUP" Then
    '                TareasListView.Items.Clear()
    '                Dim Tarea As String
    '                Tarea = "Crear Buzón"
    '                TempNode = New ListViewItem(Tarea)
    '                TareasListView.Items.Add(TempNode)
    '            Else
    '                Dim legacy As String = groupClass.GetGroupProperty(Usuario, "legacyExchangeDN")
    '                If legacy = "" Then
    '                    TareasListView.Items.Clear()
    '                    Dim Tarea As String
    '                    Tarea = "Establecer correo"
    '                    TempNode = New ListViewItem(Tarea)
    '                    TareasListView.Items.Add(TempNode)
    '                Else
    '                    TareasListView.Items.Clear()
    '                    Dim Tarea As String
    '                    Tarea = "Eliminar correo"
    '                    TempNode = New ListViewItem(Tarea)
    '                    TareasListView.Items.Add(TempNode)
    '                End If
    '            End If
    '        Else
    '                TareasListView.Items.Clear()
    '                Dim Tarea As String
    '                Tarea = "Mover Buzón"
    '                TempNode = New ListViewItem(Tarea)
    '                TareasListView.Items.Add(TempNode)
    '                Tarea = "Eliminar Buzón"
    '                TempNode = New ListViewItem(Tarea)
    '                TareasListView.Items.Add(TempNode)
    '        End If

    '    End If

    'End Sub

    Private Sub TareasListView_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TareasListView.SelectedIndexChanged
        '==========================================================================
        ' Name:     TareasListView_SelectedIndexChanged
        ' Purpose:  Escribir la descripción de la tarea cada vez que se seleccione una de ellas
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim seleccionados As ListView.SelectedListViewItemCollection = TareasListView.SelectedItems
        If TareasListView.Items.Count > 1 Then
            If TareasListView.Items(0).Selected And TareasListView.Items(0).SubItems(0).Text = "Mover Buzón" Then
                Label1.Text = "Mover el buzón seleccionado a otro almacén"
            ElseIf TareasListView.Items(1).Selected And TareasListView.Items(1).SubItems(0).Text = "Eliminar Buzón" Then
                Label1.Text = "Eliminar el buzón del usuario seleccionado"
            Else
                Label1.Text = "Selecciona una de las tareas para ver su descripción"
            End If
        Else
            If TareasListView.Items(0).Selected And TareasListView.Items(0).SubItems(0).Text = "Crear Buzón" Then
                Label1.Text = "Crear un buzón para el usuario seleccionado"
            ElseIf TareasListView.Items(0).Selected And TareasListView.Items(0).SubItems(0).Text = "Establecer correo" Then
                Label1.Text = "Crear una dirección de correo para el grupo"
            ElseIf TareasListView.Items(0).Selected And TareasListView.Items(0).SubItems(0).Text = "Eliminar correo" Then
                Label1.Text = "Elimina la dirección de correo de el grupo"
            Else
                Label1.Text = "Selecciona una de las tareas para ver su descripción"
            End If
        End If
    End Sub

    Private Sub MailPanel_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles MailPanel.VisibleChanged
        If MailPanel.Visible = True Then
            Me.Cursor = Cursors.WaitCursor
            LimpiarComboBox()
            CargarServidores()
            Me.Cursor = Cursors.Default
        End If

    End Sub

    Private Sub LimpiarComboBox()
        '==========================================================================
        ' Name:     LimpiarComboBox
        ' Purpose:  Quitar los elementos de ServerCombobox
        ' Input:    None
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        AdminGroupComboBox.Items.Clear()
        AdminGroupComboBox.Text = ""

    End Sub

    Private Sub CargarServidores()
        '==========================================================================
        ' Name:     CargarServidores
        ' Purpose:  Añadir elementos a ServerCombobox
        ' Input:    none
        ' Return:   None
        ' Calls:    CargarServidoresGeneral de GenericClass
        '==========================================================================

        Dim servidores As New List(Of String)
        'Obtener los servidores del dominio
        'servidores = GenericClass.CargarServidoresGeneral()
        servidores = GenericClass.CargarGruposAdmin
        'Añadir sus nombres al combobox
        For i = 0 To servidores.Count - 1
            AdminGroupComboBox.Items.Add(servidores(i))
        Next

    End Sub

    Private Function ComprobarPanelCorreo() As Boolean
        '==========================================================================
        ' Name:     ComprobarPanelCorreo
        ' Purpose:  Si ninguno de los campos del panel de mail es vacio, devuleve true
        ' Input:    None
        ' Return:   Si no hay campos vacios en el panel se devuelve true, sino false
        ' Calls:    None
        '==========================================================================


        If AliasSinBuzonTextBox.Text <> "" And AdminGroupComboBox.Text <> "" Then
            Return True
        Else
            MsgBox("Es necesario rellenar todos los campos")
            Return False
        End If


    End Function

End Class