﻿Imports System
Imports System.DirectoryServices
Imports Microsoft.VisualBasic
Imports System.Object
Imports System.Net.Mail
Imports System.Security.AccessControl
Imports System.Security.Principal
Imports CDOEXM
Imports System.Runtime.InteropServices
Imports ActiveDs
Imports System.Reflection


Public Class UserClass

    '------------------------------------------------------------------------------------------------------------------------
    '----------------------------------------Get Atributos----------------------------------------------------------------
    Public Shared Function GetUName(ByVal DirectoryE As DirectoryEntry) As String
        '==========================================================================
        ' Name:     GetUName
        ' Purpose:  Obtener el atributo username de un usuario
        ' Input:    1 DirectoryEntry: El directoryEntry de un usuario 'DirectoryE' 
        ' Return:   String: El atributo Username del DirectoryEntry
        ' Calls:    None
        '==========================================================================
        Return DirectoryE.Username
    End Function

    Public Shared Function GetUserlogonN(ByVal UserDN As String) As String
        '==========================================================================
        ' Name:     GetUserlogonN
        ' Purpose:  Devolver el atributo sAMAccountName de un usuario
        ' Input:    1 String: El atributo distinguishedName de un usuario 'UserDN' 
        ' Return:   String: El atributo sAMAccountName del DirectoryEntry
        ' Calls:    None
        '==========================================================================

        Try
            'Obtener el directoryEntry del usuario y devolver el atributo sAMAccountName
            Dim de As DirectoryEntry = New DirectoryEntry()
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            de.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
            deSearch.Filter = "(&(objectClass=user) (distinguishedName=" & UserDN & "))"
            deSearch.SearchScope = SearchScope.Subtree
            Dim results As SearchResultCollection = deSearch.FindAll()
            Dim oresult As SearchResult
            If results.Count = 0 Then
                Return "No hay Datos"
            Else
                oresult = results.Item(0)
                If Not oresult.GetDirectoryEntry.Properties("sAMAccountName").Value Is Nothing Then
                    Return oresult.GetDirectoryEntry.Properties("sAMAccountName").Value.ToString
                Else
                    Return "No hay Datos"
                End If
            End If
        Catch e As AccessViolationException
            MsgBox("Error al acceder al nombre de login del usuario, No tienes permisos para obtener el nombre de login del usuario " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al acceder al nombre de login del usuario, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al acceder al nombre de login del usuario, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al acceder al nombre de login del usuario, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al acceder al nombre de login del usuario, Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al acceder al nombre de login del usuario, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al acceder al nombre de login del usuario, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
    End Function

    Public Shared Function GetUserlogonNCN(ByVal UserDN As String) As String
        '==========================================================================
        ' Name:     GetUserlogonNCN
        ' Purpose:  Devolver el atributo sAMAccountName de un usuario
        ' Input:    1 String: El atributo cn de un usuario 'UserDN' 
        ' Return:   String: El atributo sAMAccountName del DirectoryEntry
        ' Calls:    None
        '==========================================================================

        Try
            'Obtener el directoryEntry del usuario y devolver el atributo sAMAccountName
            Dim de As DirectoryEntry = New DirectoryEntry()
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            de.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
            deSearch.Filter = "(&(objectClass=user) (cn=" & UserDN & "))"
            deSearch.SearchScope = SearchScope.Subtree
            Dim results As SearchResultCollection = deSearch.FindAll()
            Dim oresult As SearchResult
            If results.Count = 0 Then
                Return "No hay Datos"
            Else
                oresult = results.Item(0)
                If Not oresult.GetDirectoryEntry.Properties("sAMAccountName").Value Is Nothing Then
                    Return oresult.GetDirectoryEntry.Properties("sAMAccountName").Value.ToString
                Else
                    Return "No hay Datos"
                End If
            End If
        Catch e As AccessViolationException
            MsgBox("Error al acceder al nombre canónico del usuario, No tienes permisos para obtener el nombre canónico del usuario " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al acceder al nombre canónico del usuario, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al acceder al nombre canónico del usuario, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al acceder al nombre canónico del usuario, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al acceder al nombre canónico del usuario, Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al acceder al nombre canónico del usuario, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al acceder al nombre canónico del usuario, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try

    End Function

    Public Shared Function GetDirectoryEntry() As DirectoryEntry
        '==========================================================================
        ' Name:     GetDirectoryEntry
        ' Purpose:  Devolver el DirectoryEntry de la raíz del servidor
        ' Input:    None 
        ' Return:   DirectoryEntry: El DirectoryEntry de la raíz del servidor
        ' Calls:    None
        '==========================================================================

        Try
            Dim de As DirectoryEntry = New DirectoryEntry()
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            de.AuthenticationType = AuthenticationTypes.Delegation
            de.Path = "LDAP://" & Settings.ldapServerName & "/" & Settings.ADRoot
            'Se le asigna el controlador de dominio para que tenga todos los permisos
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            de.AuthenticationType = AuthenticationTypes.Delegation
            Return de
        Catch e As AccessViolationException
            MsgBox("Error al acceder al directorio activo, No tienes permisos para obtener la entrada genérica de directorio activo " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al acceder al directorio activo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al acceder al directorio activo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al acceder al directorio activo, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al acceder al directorio activo, Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al acceder al directorio activo, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al acceder al directorio activo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
    End Function

    Public Shared Function getUserDirectoryEntry(ByVal UserName As String) As DirectoryEntry
        '==========================================================================
        ' Name:     getUserDirectoryEntry
        ' Purpose:  Devolver el DirectoryEntry de un usuario
        ' Input:    1 String: El nombre de Login del usuario 'UserName'
        ' Return:   DirectoryEntry: El DirectoryEntry del usuario
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry y devolverlo
        Try
            Dim de As New DirectoryEntry()
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            de.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch As DirectorySearcher = New DirectorySearcher()
            deSearch.SearchRoot = de
            deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
            Dim results As SearchResultCollection = deSearch.FindAll()
            Dim oUser As New DirectoryEntry(results(0).Path)
            Return oUser
        Catch e As AccessViolationException
            MsgBox("Error al acceder al directorio activo, No tienes permisos para obtener la entrada de directorio activo " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al acceder al directorio activo, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al acceder al directorio activo, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al acceder al directorio activo, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al acceder al directorio activo, Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al acceder al directorio activo, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al acceder al directorio activo, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try

    End Function

    Public Shared Function GetUserDN(ByVal UserName As String) As String
        '==========================================================================
        ' Name:     getUserDirectoryEntry
        ' Purpose:  Devolver el atributo distinguishedName de un objeto 
        ' Input:    1 String: El nombre de Login del objeto 'UserName'
        ' Return:   String: El atributo distinguishedName del objeto
        ' Calls:    None
        '==========================================================================

        'Obtener el atributo del objeto y devolverlo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult

        If results.Count = 0 Then
            Return ""
        Else
            oresult = results.Item(0)
            'El atributo distinguishedName lo poseen todos los objetos del directorio activo
            Try
                Return oresult.GetDirectoryEntry.Properties("distinguishedName").Value.ToString
            Catch e As AccessViolationException
                MsgBox("Error al acceder a la dirección del usuario, No tienes permisos para acceder a la información que dice la dirección del usuario " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al acceder a la dirección del usuario, Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al acceder a la dirección del usuario, Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al acceder a la dirección del usuario, La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al acceder a la dirección del usuario, Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al acceder a la dirección del usuario, La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al acceder a la dirección del usuario, Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetUserProperty(ByVal UserName As String, ByVal UserProperty As String) As String
        '==========================================================================
        ' Name:     getUserProperty
        ' Purpose:  Devolver el valor de un atributo de tipo string de un usuario
        ' Input:    2 String: El nombre de Login del usuario 'UserName', 
        '           El nombre del atributo del que se quiere obtener el valor 'UserProperty'
        ' Return:   String: El atributo del usuario
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        If results.Count = 0 Then
            Return ""
        Else
            oresult = results.Item(0)
            'Devolvel el valor del atributo o el string "No hay Datos" si ese atributo no tiene un valor asignado
            If Not oresult.GetDirectoryEntry.Properties(UserProperty).Value Is Nothing Then
                Try
                    Return oresult.GetDirectoryEntry.Properties(UserProperty).Value.ToString
                Catch e As FormatException
                    MsgBox("Error al acceder al atributo del usuario, Error de formato del dato a obtener en  " & UserProperty & e.Message)
                Catch e As AccessViolationException
                    MsgBox("Error al acceder al atributo del usuario, No tienes permisos para acceder a este dato de " & UserProperty & e.Message)
                Catch e As ArgumentOutOfRangeException
                    MsgBox("Error al acceder al atributo del usuario, Se ha intentado obtener un dato con un índice fuera de rango " & UserProperty & e.Message)
                Catch e As OperationCanceledException
                    MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación cancelada " & UserProperty & e.Message)
                Catch e As OperationAbortedException
                    MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación abortada " & UserProperty & e.Message)
                Catch e As OutOfMemoryException
                    MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
                Catch e As FieldAccessException
                    MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato " & UserProperty & e.Message)
                Catch e As InsufficientMemoryException
                    MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
                Catch e As MissingFieldException
                    MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato, no existe " & UserProperty & e.Message)
                End Try
            Else
                Return ""
            End If
        End If
    End Function

    Public Shared Function GetUserPropertyGN(ByVal UserName As String, ByVal UserProperty As String) As String
        '==========================================================================
        ' Name:     getUserPropertyGN
        ' Purpose:  Devolver el valor de un atributo de tipo string de un usuario
        ' Input:    2 String: El atributo givenName del usuario 'UserName', 
        '           El nombre del atributo del que se quiere obtener el valor 'UserProperty'
        ' Return:   String: El atributo del usuario
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (givenName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        If results.Count = 0 Then
            Return ""
        Else
            oresult = results.Item(0)
            'Devolvel el valor del atributo o el string "No hay Datos" si ese atributo no tiene un valor asignado
            If Not oresult.GetDirectoryEntry.Properties(UserProperty).Value Is Nothing Then
                Try
                    Return oresult.GetDirectoryEntry.Properties(UserProperty).Value.ToString
                Catch e As FormatException
                    MsgBox("Error al acceder al atributo del usuario, Error de formato del dato a obtener en  " & UserProperty & e.Message)
                Catch e As AccessViolationException
                    MsgBox("Error al acceder al atributo del usuario, No tienes permisos para acceder a este dato de " & UserProperty & e.Message)
                Catch e As ArgumentOutOfRangeException
                    MsgBox("Error al acceder al atributo del usuario, Se ha intentado obtener un dato con un índice fuera de rango " & UserProperty & e.Message)
                Catch e As OperationCanceledException
                    MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación cancelada " & UserProperty & e.Message)
                Catch e As OperationAbortedException
                    MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación abortada " & UserProperty & e.Message)
                Catch e As OutOfMemoryException
                    MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
                Catch e As FieldAccessException
                    MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato " & UserProperty & e.Message)
                Catch e As InsufficientMemoryException
                    MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
                Catch e As MissingFieldException
                    MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato, no existe " & UserProperty & e.Message)
                End Try
            Else
                Return ""
            End If
        End If
    End Function

    Public Shared Function GetUserPropertyBool(ByVal UserName As String, ByVal UserProperty As String) As Boolean
        '==========================================================================
        ' Name:     getUserPropertyBool
        ' Purpose:  Devolver el valor de un atributo de tipo booleano de un usuario
        ' Input:    2 String: El nombre de Login del usuario 'UserName', 
        '           El nombre del atributo del que se quiere obtener el valor 'UserProperty'
        ' Return:   Boolean: El valor que devuelva el atributo del usuario
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        If results.Count = 0 Then
            MsgBox("")
        Else
            'Devolver el resultado del valor del atributo
            oresult = results.Item(0)
            Try
                Return oresult.GetDirectoryEntry.Properties(UserProperty).Value
            Catch e As FormatException
                MsgBox("Error al acceder al atributo del usuario, Error de formato del dato a obtener en  " & UserProperty & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al acceder al atributo del usuario, No tienes permisos para acceder a este dato de " & UserProperty & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al acceder al atributo del usuario, Se ha intentado obtener un dato con un índice fuera de rango " & UserProperty & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación cancelada " & UserProperty & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación abortada " & UserProperty & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato " & UserProperty & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato, no existe " & UserProperty & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetUserPropertyRefresh(ByVal UserName As String, ByVal UserProperty As String) As String
        '==========================================================================
        ' Name:     getUserPropertyRefresh
        ' Purpose:  Devolver el valor de un atributo de tipo string de un usuario después de 
        '           realizar un refresco de la parte de la memoria en la que se encuentra el objeto usuario
        ' Input:    2 String: El nombre de Login del usuario 'UserName', 
        '           El nombre del atributo del que se quiere obtener el valor 'UserProperty'
        ' Return:   String: El valor que devuelva el atributo del usuario
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            Return ""
        Else
            'Refrescar la memoria
            Dim res As New DirectoryEntry(results(0).Path)
            res.RefreshCache(New String() {UserProperty})

            'Devolver el valor del atributo
            If Not res.Properties(UserProperty).Value Is Nothing Then
                Try
                    Return res.Properties(UserProperty).Value.ToString
                Catch e As FormatException
                    MsgBox("Error al acceder al atributo del usuario, Error de formato del dato a obtener en  " & UserProperty & e.Message)
                Catch e As AccessViolationException
                    MsgBox("Error al acceder al atributo del usuario, No tienes permisos para acceder a este dato de " & UserProperty & e.Message)
                Catch e As ArgumentOutOfRangeException
                    MsgBox("Error al acceder al atributo del usuario, Se ha intentado obtener un dato con un índice fuera de rango " & UserProperty & e.Message)
                Catch e As OperationCanceledException
                    MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación cancelada " & UserProperty & e.Message)
                Catch e As OperationAbortedException
                    MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación abortada " & UserProperty & e.Message)
                Catch e As OutOfMemoryException
                    MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
                Catch e As FieldAccessException
                    MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato " & UserProperty & e.Message)
                Catch e As InsufficientMemoryException
                    MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
                Catch e As MissingFieldException
                    MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato, no existe " & UserProperty & e.Message)
                End Try
            Else
                Return ""
            End If
        End If
    End Function

    Public Shared Function GetUserPropertyOIdentifier(ByVal UserName As String, ByVal UserProperty As String) As String
        '==========================================================================
        ' Name:     getUserPropertyOIdentifier
        ' Purpose:  Devolver el valor de un atributo de tipo OIdentifier de un usuario 
        ' Input:    2 String: El nombre de Login del usuario 'UserName', 
        '           El nombre del atributo del que se quiere obtener el valor 'UserProperty'
        ' Return:   String: El valor que devuelva la parte del valor del atributo del usuario que se necesita
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            Return ""
        Else

            Dim res As New DirectoryEntry(results(0).Path)
            Try
                If Not res.Properties(UserProperty).Value Is Nothing Then
                    'Se utiliza para obtener el tipo de objeto en el atributo objectClass
                    'Aquí se manipula
                    Dim sal() As Object = res.Properties(UserProperty).Value
                    Return sal(sal.Length - 1).ToString
                Else
                    Return ""
                End If
            Catch e As FormatException
                MsgBox("Error al acceder al atributo del usuario, Error de formato del dato a obtener en  " & UserProperty & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al acceder al atributo del usuario, No tienes permisos para acceder a este dato de " & UserProperty & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al acceder al atributo del usuario, Se ha intentado obtener un dato con un índice fuera de rango " & UserProperty & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación cancelada " & UserProperty & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación abortada " & UserProperty & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato " & UserProperty & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato, no existe " & UserProperty & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetUserPropertyLargeInterval(ByVal UserName As String, ByVal UserProperty As String) As String
        '==========================================================================
        ' Name:     getUserPropertyLargeInterval
        ' Purpose:  Devolver el valor de un atributo de tipo LargeInterval de un usuario 
        ' Input:    2 String: El nombre de Login del usuario 'UserName', 
        '           El nombre del atributo del que se quiere obtener el valor 'UserProperty'
        ' Return:   String: El valor que devuelva el atributo del usuario pasado a string
        ' Calls:    GetBytes de la clase BitConverter
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            Return ""
        Else
            Dim res As New DirectoryEntry(results(0).Path)
            res.Username = Settings.adminLogon
            res.Password = Settings.adminPassword
            res.AuthenticationType = AuthenticationTypes.Delegation
            Dim low As Int32
            Dim high As Int32
            Dim valBytes(7) As Byte
            Try
                'Obtener el valor del atributo mediante la interfaz IADsLargeInteger
                Dim longInt As IADsLargeInteger = CType(res.Properties(UserProperty).Value, IADsLargeInteger)

                'Unir las dos partes de la interfaz en una y pasarlo a una variable del tipo int64
                low = longInt.LowPart
                high = longInt.HighPart
                BitConverter.GetBytes(low).CopyTo(valBytes, 0)
                BitConverter.GetBytes(high).CopyTo(valBytes, 4)
                Dim salida As Int64 = BitConverter.ToInt64(valBytes, 0)

                If Not res.Properties(UserProperty).Value Is Nothing Then
                    'Se devuelve la variable pasando a tipo string
                    Return salida
                Else
                    Return ""
                End If
            Catch e As FormatException
                MsgBox("Error al acceder al atributo del usuario, Error de formato del dato a obtener en  " & UserProperty & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al acceder al atributo del usuario, No tienes permisos para acceder a este dato de " & UserProperty & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al acceder al atributo del usuario, Se ha intentado obtener un dato con un índice fuera de rango " & UserProperty & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación cancelada " & UserProperty & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación abortada " & UserProperty & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al acceder a al ubicación física del dato " & UserProperty & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato, no existe " & UserProperty & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetUserPropertyObject(ByVal UserName As String, ByVal UserProperty As String) As Object
        '==========================================================================
        ' Name:     getUserPropertyObject
        ' Purpose:  Devolver el valor de un atributo de tipo COM Object de un usuario 
        ' Input:    2 String: El nombre de Login del usuario 'UserName', 
        '           El nombre del atributo del que se quiere obtener el valor 'UserProperty'
        ' Return:   Object: El objeto que devuelva el atributo del usuario 
        ' Calls:    None
        '==========================================================================

        'Obtener DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        If results.Count = 0 Then
            Return 0
        Else
            oresult = results.Item(0)
            'Devolver el objeto del atributo
            Try
                Return oresult.GetDirectoryEntry.Properties(UserProperty).Value
            Catch e As FormatException
                MsgBox("Error al acceder al atributo del usuario, Error de formato del dato a obtener en  " & UserProperty & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al acceder al atributo del usuario, No tienes permisos para acceder a este dato de " & UserProperty & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al acceder al atributo del usuario, Se ha intentado obtener un dato con un índice fuera de rango " & UserProperty & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación cancelada " & UserProperty & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación abortada " & UserProperty & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato " & UserProperty & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato, no existe " & UserProperty & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetUserPropertyInt(ByVal UserName As String, ByVal UserProperty As String) As Int64
        '==========================================================================
        ' Name:     getUserPropertyInt
        ' Purpose:  Devolver el valor de un atributo de un usuario pasado a Int64
        ' Input:    2 String: El nombre de Login del usuario 'UserName', 
        '           El nombre del atributo del que se quiere obtener el valor 'UserProperty'
        ' Return:   Int64: El valor del atributo pasado al tipo int64
        ' Calls:    GetInt64FromLargeInteger de la clase UserClass
        '==========================================================================

        'Obtener DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        'Dim oresult As SearchResult
        If results.Count = 0 Then
            Return 0
        Else
            Dim res As New DirectoryEntry(results(0).Path)
            res.Username = Settings.adminLogon
            res.Password = Settings.adminPassword
            res.AuthenticationType = AuthenticationTypes.Delegation
            'refrescar memoria
            Try
                res.RefreshCache(New String() {UserProperty})
                'obtner el objeto del atributo 
                Dim pwd As Object = res.Properties(UserProperty).Value
                'devolver el objeto pasado a int64
                Return GetInt64FromLargeInteger(pwd)
            Catch e As FormatException
                MsgBox("Error al acceder al atributo del usuario, Error de formato del dato a obtener en  " & UserProperty & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al acceder al atributo del usuario, No tienes permisos para acceder a este dato de " & UserProperty & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al acceder al atributo del usuario, Se ha intentado obtener un dato con un índice fuera de rango " & UserProperty & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación cancelada " & UserProperty & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación abortada " & UserProperty & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato " & UserProperty & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato, no existe " & UserProperty & e.Message)
            End Try
        End If
    End Function

    Public Shared Function GetUserPropertyInteger(ByVal UserName As String, ByVal UserProperty As String) As Integer
        '==========================================================================
        ' Name:     getUserPropertyInteger
        ' Purpose:  Devolver el valor de un atributo de tipo integer de un usuario 
        ' Input:    2 String: El nombre de Login del usuario 'UserName', 
        '           El nombre del atributo del que se quiere obtener el valor 'UserProperty'
        ' Return:   Integer: El valor del atributo 
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        If results.Count = 0 Then
            MsgBox("No hay Datos obteniendo dato")
            Return -1
        Else
            Dim res As New DirectoryEntry(results(0).Path)
            'Devolver el valor del atributo
            Try
                Return res.Properties(UserProperty).Value
            Catch e As FormatException
                MsgBox("Error al acceder al atributo del usuario, Error de formato del dato a obtener en  " & UserProperty & e.Message)
            Catch e As AccessViolationException
                MsgBox("Error al acceder al atributo del usuario, No tienes permisos para acceder a este dato de " & UserProperty & e.Message)
            Catch e As ArgumentOutOfRangeException
                MsgBox("Error al acceder al atributo del usuario, Se ha intentado obtener un dato con un índice fuera de rango " & UserProperty & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación cancelada " & UserProperty & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Error al acceder al atributo del usuario, Se está intentando obtener un dato involucrado en una operación abortada " & UserProperty & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al acceder al atributo del usuario, Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato " & UserProperty & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("Error al acceder al atributo del usuario, La memoria está totalmente ocupada " & UserProperty & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al acceder al atributo del usuario, Error al acceder a al ubicación física del dato, no existe " & UserProperty & e.Message)
            End Try

        End If
    End Function

    Public Shared Function GetUserGroups(ByVal UserName As String) As String()
        '==========================================================================
        ' Name:     getUserGroups
        ' Purpose:  Devolver us array de strings que contenga los grupos de los que
        '           que es miembro el usuario
        ' Input:    1 String: El nombre de Login del usuario 'UserName', 
        ' Return:   Array de String: Los nombres de los grupos de los que usuario es miembro 
        ' Calls:    GetPrimaryGroup de la clase UserClass
        '==========================================================================

        'Obtener el directoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim result As SearchResultCollection = deSearch.FindAll()
        Dim User As New DirectoryEntry(result(0).Path)
        'Obtener el distinguishedName del usuario
        Dim CNUSer As String = User.Properties("distinguishedName").Value.ToString

        '------------------------------------------grupos---------------------
        'Obtener los DirectoryEntrys de los grupos de los que usuario es miembro
        Try
            Dim dire As DirectoryEntry = New DirectoryEntry()
            dire.Username = Settings.adminLogon
            dire.Password = Settings.adminPassword
            dire.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch2 As DirectorySearcher = New DirectorySearcher(dire)
            deSearch2.Filter = "(&(objectClass=group) (member=" & CNUSer & "))"
            deSearch2.SearchScope = SearchScope.Subtree
            Dim results As SearchResultCollection = deSearch2.FindAll()
            Dim resultado As SearchResult

            'Insertar el grupo primario del usuario al array en primer lugar
            Dim grupos(results.Count) As String
            grupos(0) = GetPrimaryGroup(User.Properties("primaryGroupID").Value.ToString, CNUSer)
            Dim i As Integer = 1
            'Para cada grupo encontrado antes, añadir su nombre al array
            For Each resultado In results
                Dim Grupo As New DirectoryEntry(resultado.Path)
                grupos(i) = Grupo.Properties("sAMAccountName").Value.ToString
                i = i + 1
            Next

            'Devolver el array de grupos
            Return grupos
        Catch e As FormatException
            MsgBox("Error al acceder a los grupos de los que es miembro el usuario, Error de formato del dato al obtener los grupos de  " & UserName & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al acceder a los grupos de los que es miembro el usuario, No tienes permisos para acceder a los grupos de " & UserName & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al acceder a los grupos de los que es miembro el usuario, Se ha intentado obtener un dato con un índice fuera de rango " & UserName & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al acceder a los grupos de los que es miembro el usuario, Se está intentando obtener datos involucrado en una operación cancelada " & UserName & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al acceder a los grupos de los que es miembro el usuario, Se está intentando obtener datos involucrado en una operación abortada " & UserName & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al acceder a los grupos de los que es miembro el usuario, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al acceder a los grupos de los que es miembro el usuario, Error al acceder a al ubicación física de los grupos de " & UserName & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al acceder a los grupos de los que es miembro el usuario, Error al acceder a los grupos de los que es miembro el usuario, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al acceder a los grupos de los que es miembro el usuario, Error al acceder a al ubicación física de los grupos de " & UserName & ", no existe " & e.Message)
        End Try
    End Function

    Public Shared Function GetPrimaryGroup(ByVal token As String, ByVal Miembro As String) As String
        '==========================================================================
        ' Name:     getUserPrimaryGroup
        ' Purpose:  Devolver us string con el nombre del grupo primario del usuario
        ' Input:    1 String: El token del grupo  
        ' Return:   String: el nombres del grupo 
        ' Calls:    None
        '==========================================================================
        Try
            'Obtener el DirectoryEntry del equipo
            Dim de2 As DirectoryEntry = New DirectoryEntry()
            de2.Username = Settings.adminLogon
            de2.Password = Settings.adminPassword
            de2.AuthenticationType = AuthenticationTypes.Delegation
            'Dim deSearch2 As DirectorySearcher = New DirectorySearcher(de2)
            'deSearch2.Filter = "(&(sAMAccountName=" & Miembro & "))"
            'deSearch2.SearchScope = SearchScope.Subtree
            'Dim result As SearchResultCollection = deSearch2.FindAll()
            'Dim User As New DirectoryEntry(result(0).Path)
            'Dim miembrodn As String = User.Properties("distinguishedName").Value.ToString
            'MsgBox(token)
            Using Domain As DirectoryEntry = ActiveDirectory.Domain.GetCurrentDomain.GetDirectoryEntry
                Dim GroupSID As New Security.Principal.SecurityIdentifier(New Security.Principal.SecurityIdentifier(DirectCast(Domain.Properties("objectSid").Value, Byte()), 0).ToString & "-" & token)
                Dim GroupSIDString As New System.Text.StringBuilder
                Dim GroupSIDBytes(GroupSID.BinaryLength - 1) As Byte
                GroupSID.GetBinaryForm(GroupSIDBytes, 0)
                For i As Integer = 0 To GroupSIDBytes.Length - 1
                    GroupSIDString.Append("\" & Hex(GroupSIDBytes(i)).PadLeft(2, "0"c))
                Next
                Dim SearcherObject As DirectorySearcher = New DirectorySearcher(de2)
                SearcherObject.Filter = "(objectSid=" & GroupSIDString.ToString & ")"
                Dim GroupSearchResult As SearchResult = SearcherObject.FindOne
                If Not GroupSearchResult Is Nothing Then
                    Dim PGrupo As New DirectoryEntry(GroupSearchResult.Path)
                    Return PGrupo.Properties("sAMAccountName").Value.ToString
                Else
                    MsgBox("No encuentro grupo primario")
                    Return ""
                End If
            End Using



            ''Obtener todos los grupos del directorio Activo
            'Dim de As DirectoryEntry = New DirectoryEntry()
            'de.Username = Settings.adminLogon
            'de.Password = Settings.adminPassword
            'de.AuthenticationType = AuthenticationTypes.Delegation
            'Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
            'Dim PG As String = token
            'deSearch.Filter = "(&(objectCategory=group)(objectClass=group)(primaryGroupToken=" & token & "))"
            'deSearch.SearchScope = SearchScope.Subtree
            'Dim resC As SearchResultCollection = deSearch.FindAll()
            'Dim res As SearchResult
            'If resC.Count = 0 Then
            '    MsgBox("No encuentro grupo primario")

            'Else
            '    'Buscar el grupo cuyo token es igual a token y devolver su nombre 
            '    For Each res In resC
            '        Dim PGrupo As New DirectoryEntry(res.Path)
            '        'Refrescar la memoria
            '        Try
            '            PGrupo.RefreshCache(New String() {"primaryGroupToken"})
            '            If PGrupo.Properties("primaryGroupToken").Value.ToString = token Then
            '                'Devolver el nombre del grupo encontrado
            '                Return PGrupo.Properties("cn").Value.ToString
            '            End If
        Catch e As FormatException
            MsgBox("Error al acceder a los gruposprimario del usuario, Error de formato del dato a obtener en primaryGroupToken " & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al acceder a los gruposprimario del usuario, No tienes permisos para acceder a este dato de primaryGroupToken " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al acceder a los gruposprimario del usuario, Se ha intentado obtener un dato con un índice fuera de rango en primaryGroupToken " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al acceder a los gruposprimario del usuario, Se está intentando obtener un dato involucrado en una operación cancelada primaryGroupToken " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al acceder a los gruposprimario del usuario, Se está intentando obtener un dato involucrado en una operación abortada primaryGroupToken " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al acceder a los gruposprimario del usuario, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al acceder a los gruposprimario del usuario, Error al acceder a al ubicación física del dato primaryGroupToken " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al acceder a los gruposprimario del usuario, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al acceder a los gruposprimario del usuario, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
        'Next
        'End If

    End Function

    Public Shared Function GetInt64FromLargeInteger(ByVal largeInteger As Object) As Int64
        '==========================================================================
        ' Name:     GetInt64FromLargeInteger
        ' Purpose:  Devolver un int64 obtenido a partir de un com object
        ' Input:    1 Object: Del que sacar el int64 'ladrgeInteger'  
        ' Return:   Int64: el obtenido a partir del object 
        ' Calls:    2: ToInt64 y GetBytes de la clase BitConverter
        '==========================================================================

        Dim low As Int32
        Dim high As Int32
        Dim valBytes(7) As Byte

        'Utilizar la interfaz IADsLargeInteger para obtener los dos int32 que se uniran para crear un int64
        Dim longInt As IADsLargeInteger = CType(largeInteger, IADsLargeInteger)
        low = longInt.LowPart
        high = longInt.HighPart
        Try
            'Unir los bytes de los dos int32
            BitConverter.GetBytes(low).CopyTo(valBytes, 0)
            BitConverter.GetBytes(high).CopyTo(valBytes, 4)

            'Devolver el int64 formado con los bytes
            Return BitConverter.ToInt64(valBytes, 0)
        Catch e As FormatException
            MsgBox("Error al acceder al dato large integer para pasarlo a int64, Error de formato del dato a obtener en el large integer " & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al acceder al dato large integer para pasarlo a int64, No tienes permisos para acceder a este dato en el large integer " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al acceder al dato large integer para pasarlo a int64, Se ha intentado obtener un dato con un índice fuera de rango en el large integer " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al acceder al dato large integer para pasarlo a int64, Se está intentando obtener un dato involucrado en una operación cancelada en el large integer " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al acceder al dato large integer para pasarlo a int64, Se está intentando obtener un dato involucrado en una operación abortada en el large integer " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al acceder al dato large integer para pasarlo a int64, La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al acceder al dato large integer para pasarlo a int64, Error al acceder a al ubicación física del dato en el large integer " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al acceder al dato large integer para pasarlo a int64, La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al acceder al dato large integer para pasarlo a int64, Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
    End Function

    '-----------------------------------------------------------------------------------------------------------------------------
    '------------------------------------------------------Set Atributos----------------------------------------------------------

    Private Sub SetPassword(ByVal dEntry As DirectoryEntry, ByVal sPassword As String)
        '==========================================================================
        ' Name:     SetPassword
        ' Purpose:  Establecer un nuevo password a un usuario
        ' Input:    1 DirectoryEntry: DirectoryEntry del usuario 'dEntry'
        '           1 String: El password a establecer 'sPassword' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Crea el objeto password
        Dim oPassword As Object() = New Object() {sPassword}
        'Invoca al método que establece el password
        Dim ret As Object = dEntry.Invoke("SetPassword", oPassword)
        'Actualiza el DirectoryEntry
        dEntry.CommitChanges()
    End Sub

    Public Shared Sub SetUserProperty(ByVal UserName As String, ByVal UserProperty As String, ByVal Datos As String)
        '==========================================================================
        ' Name:     SetUserProperty
        ' Purpose:  Establecer el valor del atributo de tipo string de un usuario
        ' Input:    3 string: El nombre de Login de un usuaio 'UserName', El atributo a modificar 'UserProperty',
        '           El string con el que modificar el atributo 'Datos' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener dirección del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            MsgBox("Error cargando " & UserProperty)
        Else
            'Obtener DirectoryEntry del usuario con su dirección y darle los permisos del Administrador de dominio 
            Dim oresult As New DirectoryEntry(results(0).Path)
            oresult.Username = Settings.adminLogon
            oresult.Password = Settings.adminPassword
            oresult.AuthenticationType = AuthenticationTypes.Delegation

            'Modificar el atributo y actualizar el DirectoryEntry del usuario
            oresult.Properties(UserProperty).Value = Datos
            Try
                oresult.CommitChanges()
            Catch e As NullReferenceException
                MsgBox("Los datos han de tener algún valor para poder asignarlos a " & UserProperty & e.Message)
            Catch e As FormatException
                MsgBox("Error de formato del dato a introducir en  " & UserProperty & e.Message)
            Catch e As AccessViolationException
                MsgBox("No tienes permisos para asignar este dato a " & UserProperty & e.Message)
            End Try
        End If

    End Sub

    Public Shared Sub SetUserPropertyRefresh(ByVal UserName As String, ByVal UserProperty As String, ByVal Datos As String)
        '==========================================================================
        ' Name:     SetUserPropertyRefresh
        ' Purpose:  Establecer el valor del atributo de tipo string de un usuario refrescaqndo previamente la memoria 
        ' Input:    3 string: El nombre de Login de un usuaio 'UserName', El atributo a modificar 'UserProperty',
        '           El string con el que modificar el atributo 'Datos' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener dirección del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            MsgBox("Error cargando" & UserProperty)
        Else
            'Obtener DirectoryEntry del usuario con su dirección y darle los permisos del Administrador de dominio 
            Dim oresult As New DirectoryEntry(results(0).Path)
            oresult.Username = Settings.adminLogon
            oresult.Password = Settings.adminPassword
            oresult.AuthenticationType = AuthenticationTypes.Delegation

            'Modificar el atributo, refrescar la memoria y actualizar el DirectoryEntry del usuario
            oresult.Properties(UserProperty).Value = Datos
            oresult.RefreshCache(New String() {UserProperty})
            oresult.CommitChanges()
        End If

    End Sub

    Public Shared Sub SetUserPropertyBool(ByVal UserName As String, ByVal UserProperty As String, ByVal Datos As Boolean)
        '==========================================================================
        ' Name:     SetUserPropertyBool
        ' Purpose:  Establecer el valor del atributo de tipo boolean de un usuario
        ' Input:    2 string: El nombre de Login de un usuaio 'UserName', El atributo a modificar 'UserProperty',
        '           1 Boolean: El booleano con el que modificar el atributo 'Datos' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener dirección del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            MsgBox("Error cargando" & UserProperty)
        Else
            'Obtener DirectoryEntry del usuario con su dirección y darle los permisos del Administrador de dominio 
            Dim oresult As New DirectoryEntry(results(0).Path)
            oresult.Username = Settings.adminLogon
            oresult.Password = Settings.adminPassword
            oresult.AuthenticationType = AuthenticationTypes.Delegation

            'Modificar el atributo y actualizar el DirectoryEntry del usuario
            oresult.Properties(UserProperty).Value = Datos
            Try
                oresult.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error, No tienes permisos para asignar un booleano a " & UserProperty & e.Message)
            Catch e As ArgumentException
                MsgBox("Error, El argumento no es un booleano no se puede asignar a " & UserProperty & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error, El argumento no es un booleano, es nulo , no se puede asignar a " & UserProperty & e.Message)
            Catch e As FormatException
                MsgBox("Error, El argumento no es un booleano no se puede asignar a " & UserProperty & e.Message)
            End Try
        End If
    End Sub

    Public Shared Sub SetUserPropertyBoolR(ByVal UserName As String, ByVal UserProperty As String, ByVal Datos As Boolean)
        '==========================================================================
        ' Name:     SetUserPropertyBoolR
        ' Purpose:  Establecer el valor del atributo de tipo boolean de un usuario, refrescando previamente la memoria
        ' Input:    2 string: El nombre de Login de un usuaio 'UserName', El atributo a modificar 'UserProperty',
        '           1 Boolean: El booleano con el que modificar el atributo 'Datos' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        'Obtener dirección del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            MsgBox("Error cargando" & UserProperty)
        Else
            'Obtener DirectoryEntry del usuario con su dirección y darle los permisos del Administrador de dominio 
            Dim oresult As New DirectoryEntry(results(0).Path)
            oresult.Username = Settings.adminLogon
            oresult.Password = Settings.adminPassword
            oresult.AuthenticationType = AuthenticationTypes.Delegation

            'Refrescar la memoria, modificar el atributo  y actualizar el DirectoryEntry del usuario
            oresult.RefreshCache(New String() {UserProperty})
            oresult.Properties(UserProperty).Value = Datos
            Try
                oresult.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error, No tienes permisos para asignar un booleano a " & UserProperty & e.Message)
            Catch e As ArgumentException
                MsgBox("Error, El argumento no es un booleano no se puede asignar a " & UserProperty & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error, El argumento no es un booleano, es nulo , no se puede asignar a " & UserProperty & e.Message)
            Catch e As FormatException
                MsgBox("Error, El argumento no es un booleano no se puede asignar a " & UserProperty & e.Message)
            End Try
        End If
    End Sub

    Public Shared Sub SetUserPropertyInt(ByVal UserName As String, ByVal UserProperty As String, ByVal datos As Integer)
        '==========================================================================
        ' Name:     SetUserPropertyInt
        ' Purpose:  Establecer el valor del atributo de tipo integer de un usuario
        ' Input:    2 string: El nombre de Login de un usuaio 'UserName', El atributo a modificar 'UserProperty',
        '           1 Integer: El integer con el que modificar el atributo 'Datos' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener dirección del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        'Dim oresult As SearchResult
        If results.Count = 0 Then
            MsgBox("Error obteniendo dato")
        Else
            'Obtener DirectoryEntry del usuario con su dirección y darle los permisos del Administrador de dominio 
            Dim res As New DirectoryEntry(results(0).Path)
            res.Username = Settings.adminLogon
            res.Password = Settings.adminPassword
            res.AuthenticationType = AuthenticationTypes.Delegation

            'Refrescar la memoria, modificar el atributo  y actualizar el DirectoryEntry del usuario
            res.RefreshCache(New String() {UserProperty})
            res.Properties(UserProperty).Value = datos
            Try
                res.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tienes permisos para asignar este dato a " & UserProperty & e.Message)
            Catch e As ArgumentException
                MsgBox("El dato no tiene el formato requerido para poder asignarlo a " & UserProperty & e.Message)
            Catch e As ArgumentNullException
                MsgBox("El dato no puede ser Null para poder asignarse a " & UserProperty & e.Message)
            Catch e As FormatException
                MsgBox("El dato no tiene el formato requerido para poder asignarse a " & UserProperty & e.Message)
            End Try
        End If
    End Sub

    Public Shared Sub SetUserPropertyInsert(ByVal UserName As String, ByVal UserProperty As String, ByVal datos As String, ByVal indice As String)
        '==========================================================================
        ' Name:     SetUserPropertyInsert
        ' Purpose:  Añadir un elemento a un atributo del tipo "lista de elementos" de un usuario
        ' Input:    3 string: El nombre de Login de un usuaio 'UserName', El atributo a modificar 'UserProperty',
        '           El elemento de tipo string a insertar 'datos'
        '           1 Integer: El índice que indica donde insertar el elmento 'Datos' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener dirección del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        If results.Count = 0 Then
            MsgBox("Error obteniendo dato")
        Else
            'Obtener DirectoryEntry del usuario con su dirección y darle los permisos del Administrador de dominio 
            Dim res As New DirectoryEntry(results(0).Path)
            res.Username = Settings.adminLogon
            res.Password = Settings.adminPassword
            res.AuthenticationType = AuthenticationTypes.Delegation

            'Añadir el elemento y actualizar el directoryEntry del usuario
            res.Properties(UserProperty).Add(datos)
            Try
                res.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tienes permisos para insertar objetos en " & UserProperty & e.Message)
            Catch e As ArgumentException
                MsgBox("El argumento no tiene el formato adecuado para insertarlo en " & UserProperty & e.Message)
            Catch e As ArgumentNullException
                MsgBox("No se puede insertar un objeto de tipo Null en " & UserProperty & e.Message)
            Catch e As DuplicateNameException
                MsgBox("El objeto a insertar ya existe en " & UserProperty & e.Message)
            Catch e As FormatException
                MsgBox("El objeto a insertar posee un formato no valido para " & UserProperty & e.Message)
            Catch e As IndexOutOfRangeException
                MsgBox("El objeto a insertar no entra en el rango de " & UserProperty & e.Message)
            End Try
            res.Close()
        End If
    End Sub

    Public Shared Sub SetUserPropertyRemove(ByVal UserName As String, ByVal UserProperty As String)
        '==========================================================================
        ' Name:     SetUserPropertyRemove
        ' Purpose:  Eliminar los datos del atributo de un usuario
        ' Input:    2 string: El nombre de Login de un usuaio 'UserName', El atributo a modificar 'UserProperty'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener dirección del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        If results.Count = 0 Then
            MsgBox("Error obteniendo dato")
        Else
            'Obtener DirectoryEntry del usuario con su dirección 
            Dim res As New DirectoryEntry(results(0).Path)
            res.Username = Settings.adminLogon
            res.Password = Settings.adminPassword
            res.AuthenticationType = AuthenticationTypes.Delegation
            'Eliminar los datos del atributo y actualizar el directoryEntry del usuario
            Dim cuenta As Integer = res.Properties(UserProperty).Count
            'If cuenta = 0 Then
            '    MsgBox("Error obteniendo protocolos")
            'Else
            '    For i = 1 To cuenta
            res.RefreshCache(New String() {UserProperty})
            res.Properties(UserProperty).Clear()
            'Next
            Try
                res.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para eliminar los elementos de " & UserProperty & e.Message)
            Catch e As ArgumentNullException
                MsgBox("No tiene permisos para eliminar los elementos de una propiedad que es nula " & e.Message)
            End Try
            res.Close()
            'End If
        End If
    End Sub

    Public Shared Sub setUserPropertyObject(ByVal UserName As String, ByVal UserProperty As String, ByVal dat As Object)
        '==========================================================================
        ' Name:     SetUserPropertyObject
        ' Purpose:  Establecer un objeto como valor del atributo de un usuario
        ' Input:    2 string: El nombre de Login de un usuaio 'UserName', El atributo a modificar 'UserProperty'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener dirección del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        'Obtener DirectoryEntry del usuario con su dirección 
        Dim result As New DirectoryEntry(results(0).Path)
        'Modificar el valor del atributo y actualizar el DirectoryEntry
        result.Properties(UserProperty).Value = dat
        Try
            result.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("No tienes permisos para asignar este dato a " & UserProperty & e.Message)
        Catch e As ArgumentException
            MsgBox("El dato no tiene el formato requerido para poder asignarse a " & UserProperty & e.Message)
        Catch e As ArgumentNullException
            MsgBox("El dato no puede ser Null para poder asignarse a" & UserProperty & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("El dato se ha de introducir dentro del rango de elementos de " & UserProperty & e.Message)
        Catch e As FormatException
            MsgBox("El dato no tiene el formato requerido para poder asignarse a" & UserProperty & e.Message)
        End Try
    End Sub

    Public Shared Sub ClearUserProperty(ByVal UserName As String, ByVal UserProperty As String)
        '==========================================================================
        ' Name:     ClearUserProperty
        ' Purpose:  Eliminar los datos del atributo de un usuario
        ' Input:    2 string: El nombre de Login de un usuaio 'UserName', El atributo a modificar 'UserProperty'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener dirección del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        If results.Count = 0 Then
            MsgBox("Error obteniendo datos")
        Else
            'Obtener DirectoryEntry del usuario con su dirección 
            Dim res As New DirectoryEntry(results(0).Path)
            res.Username = Settings.adminLogon
            res.Password = Settings.adminPassword
            res.AuthenticationType = AuthenticationTypes.Delegation
            'Eliminar los datos del atributo y actualizar el directoryEntry del usuario
            res.Properties(UserProperty).Clear()
            Try
                Try
                    res.CommitChanges()
                Catch e As AccessViolationException
                    MsgBox("No tiene permisos para eliminar los elementos de " & UserProperty & e.Message)
                Catch e As ArgumentNullException
                    MsgBox("No tiene permisos para eliminar los elementos de una propiedad que es nula " & e.Message)
                End Try
            Catch e As AccessViolationException
                MsgBox("No tienes permisos para realizar un borrado para " & UserProperty & e.Message)
            End Try
            res.Close()
        End If
    End Sub

    Public Shared Sub setPrimaryGroup(ByVal Usuario As String, ByVal grupo As String)
        '==========================================================================
        ' Name:     setPrimaryGroup
        ' Purpose:  Establecer el grupo primario del usuario de entre los que es miembro
        ' Input:    2 string: El nombre de Login de un usuaio 'Usuario', El nombre de Login del grupo 'grupo'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        Dim PG As Integer

        'Obtener el DirectoryEntry del grupo
        deSearch.Filter = "(&(objectClass=group) (cn=" & grupo & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim res As SearchResult = deSearch.FindOne()
        Dim PGrupo As New DirectoryEntry(res.Path)
        PGrupo.RefreshCache(New String() {"primaryGroupToken"})
        'Obtener su PrimaryToken
        PG = PGrupo.Properties("primaryGroupToken").Value

        'Obtener el DirectoryEntry del usuario y asignarle a su atributo primaryGroupID el token del grupo
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & Usuario & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim resC As SearchResult = deSearch.FindOne()
        Dim PUsuario As New DirectoryEntry(resC.Path)
        PUsuario.Username = Settings.adminLogon
        PUsuario.Password = Settings.adminPassword
        PUsuario.AuthenticationType = AuthenticationTypes.Delegation
        'PUsuario.RefreshCache(New String() {"primaryGroupID"})
        PUsuario.Properties("primaryGroupID").Value = PG
        PUsuario.RefreshCache(New String() {"primaryGroupID"})
        MsgBox(PUsuario.Properties("primaryGroupID").Value & " tiene que ser " & PG)
        Try
            PUsuario.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("Error, no tiene permisos para establecer el grupo primario del usuario " & e.Message)
        Catch e As ArgumentNullException
            MsgBox("Error, no se puede asignar un null como grupo primario del usuario " & e.Message)
        Catch e As FormatException
            MsgBox("Error, el formato del grupo que se quiere asignar al usuario no es aceptable " & e.Message)
        End Try

    End Sub

    '---------------------------------------------------------------------------------------------------------------------------------
    '-------------------------------------------------------User Actions--------------------------------------------------------------

    Public Shared Function UserExists(ByVal UserName As String) As Boolean
        '==========================================================================
        ' Name:     UserExists
        ' Purpose:  Saber si un usuario forma parte del dominio
        ' Input:    1 string: El nombre de Login de un usuaio 'Usuario'
        ' Return:   1 boolean: True si existe dentro del dominio, false en caso contrario
        ' Calls:    None
        '==========================================================================

        'Buscar el DirectoryEntry del usuario
        Dim de As New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher()
        deSearch.SearchRoot = de
        deSearch.Filter = "(&(objectClass=user)(sAMAccountName=" & UserName & "))"
        Dim results As SearchResultCollection = deSearch.FindAll()

        'Si se ha encontrado se devuelve true sino false
        If results.Count = 0 Then
            Return False
        Else
            Return True
        End If
    End Function

    Public Shared Function UserNameExists(ByVal UserName As String) As Boolean
        '==========================================================================
        ' Name:     UserNameExists
        ' Purpose:  Saber si el nombre de un usuario forma parte del dominio
        ' Input:    1 string: El nombre de Login de un usuaio 'Usuario'
        ' Return:   1 boolean: True si existe dentro del dominio, false en caso contrario
        ' Calls:    None
        '==========================================================================

        'Buscar el DirectoryEntry del usuario
        Dim de As New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher()
        deSearch.SearchRoot = de
        deSearch.Filter = "(&(objectClass=user) (|(sAMAccountName=" & UserName & ")(cn=" & UserName & ")))"
        Dim results As SearchResultCollection = deSearch.FindAll()

        'Si se ha encontrado se devuelve true sino false
        If results.Count = 0 Then
            Return False
        Else
            Return True
        End If
    End Function

    Public Shared Sub DisableAccount(ByVal sUserName As String)
        '==========================================================================
        ' Name:     DisableAccount
        ' Purpose:  Deshabilitar la cuenta de un usuario
        ' Input:    1 string: El nombre de Login de un usuaio 'Usuario'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim dirEntry As DirectoryEntry = GetDirectoryEntry()
        Dim dirSearcher As DirectorySearcher = New DirectorySearcher(dirEntry)
        dirSearcher.Filter = "(&(objectClass=user)(SAMAccountName=" & sUserName & "))"
        dirSearcher.SearchScope = SearchScope.Subtree
        Dim results As SearchResult = dirSearcher.FindOne()

        If Not results Is Nothing Then
            'Dar permisos de Administrador de dominio y obtener el atributo userAccountControl
            Dim dirEntryResults As New DirectoryEntry(results.Path)
            dirEntryResults.Username = Settings.adminLogon
            dirEntryResults.Password = Settings.adminPassword
            dirEntryResults.AuthenticationType = AuthenticationTypes.Delegation
            Dim iVal As Integer = CInt(dirEntryResults.Properties("userAccountControl").Value)

            'Modificar el atributo para que se deshabilite la cuenta
            dirEntryResults.Properties("userAccountControl").Value = iVal Or &H2
            Try
                dirEntryResults.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error al deshabilitar la cuenta de usuario, no tiene permisos para deshabilitar una cuenta de usuario " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al deshabilitar la cuenta de usuario, no se ha encontrado el usuario que se quiere deshabilitar " & e.Message)
            Catch e As ConstraintException
                MsgBox("Error al deshabilitar la cuenta de usuario, se producen incompatibilidades con las reglas preexistentes " & e.Message)
            End Try
            dirEntryResults.Close()
        Else
            MsgBox("Usuario no existe")
        End If
        dirEntry.Close()
    End Sub

    Public Shared Sub RemoveUser(ByVal UserName As String)
        '==========================================================================
        ' Name:     RemoveUser
        ' Purpose:  Eliminar una cuenta de usuario
        ' Input:    1 string: El nombre de Login de un usuaio 'UserName'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim de As New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        'Obtener el DirectoryEntry del usuario
        Dim deSearch As DirectorySearcher = New DirectorySearcher()
        deSearch.SearchRoot = de
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        Dim results As SearchResultCollection = deSearch.FindAll()
        If results.Count = 0 Then
            Console.WriteLine("usuario no existe")
        Else
            'Eliminar el usuario
            Dim oUser As New DirectoryEntry(results(0).Path)
            de.Children.Remove(oUser)
        End If

    End Sub

    Public Shared Sub UnlockUser(ByVal UserName As String)
        '==========================================================================
        ' Name:     UnlockUser
        ' Purpose:  Desbloquear una cuenta de usuario bloqueada
        ' Input:    1 string: El nombre de Login de un usuaio 'UserName'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        Dim deSearch As DirectorySearcher = New DirectorySearcher()
        deSearch.SearchRoot = de
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        Dim results As SearchResultCollection = deSearch.FindAll()
        If results.Count = 0 Then
            Console.WriteLine("usuario no existe")
        Else
            'Invocar el método que establece el valor del bloqueo
            Dim oUser As New DirectoryEntry(results(0).Path)
            oUser.InvokeSet("IsAccountLocked", False)
            Try
                oUser.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error al desbloquear el usuario, No tienes permisos para desbloquear al usuario " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al desbloquear el usuario, No se ha encontrado el usuario " & e.Message)
            End Try
        End If

    End Sub

    Public Shared Sub SetExpirationTime(ByVal UserName As String, ByVal Dat As Object)
        '==========================================================================
        ' Name:     UnlockUser
        ' Purpose:  Desbloquear una cuenta de usuario bloqueada
        ' Input:    1 string: El nombre de Login de un usuaio 'UserName'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        Dim deSearch As DirectorySearcher = New DirectorySearcher()
        deSearch.SearchRoot = de
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        Dim results As SearchResultCollection = deSearch.FindAll()
        If results.Count = 0 Then
            Console.WriteLine("usuario no existe")
        Else
            'Invocar el método que establece el valor del bloqueo
            Dim oUser As New DirectoryEntry(results(0).Path)
            oUser.Username = Settings.adminLogon
            oUser.Password = Settings.adminPassword
            oUser.AuthenticationType = AuthenticationTypes.Delegation
            Dim dato As Date = Dat

            Dim localZone As TimeZone = TimeZone.CurrentTimeZone
            Dim UTCDat As DateTime = _
            localZone.ToUniversalTime(dato)

            Dim d As Date = UTCDat.Day & "/" & UTCDat.Month & "/" & UTCDat.Year & " " & "00:00:00"
            d = d.AddDays(1)
            oUser.NativeObject.AccountExpirationDate = d

            Try
                oUser.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error al desbloquear el usuario, No tienes permisos para desbloquear al usuario " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al desbloquear el usuario, No se ha encontrado el usuario " & e.Message)
            End Try
        End If

    End Sub

    Public Shared Sub RemoveExpirationTime(ByVal UserName As String)
        '==========================================================================
        ' Name:     UnlockUser
        ' Purpose:  Desbloquear una cuenta de usuario bloqueada
        ' Input:    1 string: El nombre de Login de un usuaio 'UserName'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        Dim deSearch As DirectorySearcher = New DirectorySearcher()
        deSearch.SearchRoot = de
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        Dim results As SearchResultCollection = deSearch.FindAll()
        If results.Count = 0 Then
            Console.WriteLine("usuario no existe")
        Else
            'Invocar el método que establece el valor del bloqueo
            Dim oUser As New DirectoryEntry(results(0).Path)
            oUser.Username = Settings.adminLogon
            oUser.Password = Settings.adminPassword
            oUser.AuthenticationType = AuthenticationTypes.Delegation
            Dim dato As Int64 = 0

            oUser.Properties("AccountExpires").Value = 0

            Try
                oUser.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error al desbloquear el usuario, No tienes permisos para desbloquear al usuario " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al desbloquear el usuario, No se ha encontrado el usuario " & e.Message)
            End Try
        End If

    End Sub

    Public Shared Function GetExpirationTime(ByVal UserName As String) As Date
        '==========================================================================
        ' Name:     UnlockUser
        ' Purpose:  Desbloquear una cuenta de usuario bloqueada
        ' Input:    1 string: El nombre de Login de un usuaio 'UserName'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        Dim deSearch As DirectorySearcher = New DirectorySearcher()
        deSearch.SearchRoot = de
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        Dim results As SearchResultCollection = deSearch.FindAll()
        If results.Count = 0 Then
            Return ""
        Else
            'Invocar el método que establece el valor del bloqueo
            Dim oUser As New DirectoryEntry(results(0).Path)
            oUser.Username = Settings.adminLogon
            oUser.Password = Settings.adminPassword
            oUser.AuthenticationType = AuthenticationTypes.Delegation
            'Return oUser.NativeObject.AccountExpirationDate()
            Try
                Dim d As Date = oUser.NativeObject.AccountExpirationDate()
                d = d.AddHours(-2)
                Return d
            Catch e As AccessViolationException
                MsgBox("No tienes permisos para acceder a la información que dice la fecha en la que expira la cuenta de usuario " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try

            Try
                oUser.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error al desbloquear el usuario, No tienes permisos para desbloquear al usuario " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al desbloquear el usuario, No se ha encontrado el usuario " & e.Message)
            End Try
        End If

    End Function

    Public Shared Function isUserlocked(ByVal UserName As String) As Boolean
        '==========================================================================
        ' Name:     isUserlocked
        ' Purpose:  Determinar si la cuenta usuario está bloqueada
        ' Input:    1 string: El nombre de Login de un usuaio 'UserName'
        ' Return:   1 boolean: True si está bloqueada, false si no lo está
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher()
        deSearch.SearchRoot = de
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        Dim results As SearchResultCollection = deSearch.FindAll()
        If results.Count = 0 Then
            MsgBox("usuario no existe")
            Return False
        Else
            'Mirar la propiedad que dice cuanto tiempo lleva la cuenta bloqueada
            Dim oUser As New DirectoryEntry(results(0).Path)
            oUser.Username = Settings.adminLogon
            oUser.Password = Settings.adminPassword
            oUser.AuthenticationType = AuthenticationTypes.Delegation
            Try
                Return Convert.ToBoolean(oUser.InvokeGet("IsAccountLocked"))
            Catch e As AccessViolationException
                MsgBox("No tienes permisos para acceder a la información que dice si el usuario está deshabilitado " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If
    End Function

    Private Shared Sub EnableAccount2(ByVal sUserName As String)
        '==========================================================================
        ' Name:     EnableAccount2
        ' Purpose:  Habilitar una cuenta de usuario deshabilitada
        ' Input:    1 string: El nombre de Login de un usuaio 'sUserName'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtenre el DirectoryEntry del usuario
        Dim dirEntry As New DirectoryEntry()
        dirEntry.Username = Settings.adminLogon
        dirEntry.Password = Settings.adminPassword
        Dim dirSearcher As DirectorySearcher = New DirectorySearcher(dirEntry)
        dirSearcher.Filter = "(&(objectClass=user)(SAMAccountName=" & sUserName & "))"
        dirSearcher.SearchScope = SearchScope.Subtree
        Dim results As SearchResult = dirSearcher.FindOne()
        'Si se ha encontrado
        If Not results Is Nothing Then
            Dim dirEntryResults As New DirectoryEntry(results.Path)
            dirEntryResults.Username = Settings.adminLogon
            dirEntryResults.Password = Settings.adminPassword
            Dim iVal As Integer = CInt(dirEntryResults.Properties("userAccountControl").Value)
            'Habilitar el usuario cambiando el atributo userAccountControl
            dirEntryResults.Properties("userAccountControl").Value = iVal Or &H1
            dirEntryResults.CommitChanges()
            dirEntryResults.Properties("userAccountControl").Value = iVal And Not &H2
            dirEntryResults.CommitChanges()
            dirEntryResults.Close()
        Else
            Console.WriteLine("El usuario no existe")
        End If
        dirEntry.Close()

    End Sub

    Public Shared Function isDisabled(ByVal Name As String) As Boolean
        '==========================================================================
        ' Name:     isDisabled
        ' Purpose:  Habilitar una cuenta de usuario deshabilitada
        ' Input:    1 string: El nombre de Login de un usuaio 'sUserName'
        ' Return:   1 Boolean: True si la cuenta está deshabilitada, false si no lo está
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim dirEntry As New DirectoryEntry()
        Dim dirSearcher As DirectorySearcher = New DirectorySearcher(dirEntry)
        dirSearcher.Filter = "(&(objectClass=user)(SAMAccountName=" & Name & "))"
        dirSearcher.SearchScope = SearchScope.Subtree
        Dim results As SearchResult = dirSearcher.FindOne()
        'Si lo encuentra
        If Not results Is Nothing Then
            Dim dirEntryResults As New DirectoryEntry(results.Path)
            'Mediante la interfaz IADsUser se puede saber si la cuenta está habilitada
            Dim User As IADsUser 'MS CDO Exchange Library
            User = CType(dirEntryResults.NativeObject, IADsUser)
            Try
                If User.AccountDisabled Then
                    Return True
                Else
                    Return False
                End If
            Catch e As AccessViolationException
                MsgBox("No tienes permisos para acceder a la información que dice si el usuario está deshabilitado " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try

            dirEntryResults.Close()
        Else
            MsgBox("Usuario no existe")
        End If
        dirEntry.Close()
    End Function

    Public Shared Sub CreateAdAccount2(ByVal sUserName As String, ByVal sPassword As String, ByVal sFirstName As String, ByVal OU_AC As String, ByVal FullName As String)
        '==========================================================================
        ' Name:     CreateAdAccount2
        ' Purpose:  Crear una nueva cuenta de usuario
        ' Input:    4 string: El nombre de Login de usuaio 'sUserName', la contraseña 'sPassword',
        '           el nombre propio del usuario 'sFirstName', la dirección donde se crea 'OU_AC'
        ' Return:   None
        ' Calls:    EnableAccount2
        '==========================================================================

        Try
            'Obtener solo el container de la dirección
            Dim parts() As String = OU_AC.Split(",")
            Dim OU As String = parts(0)
            For i = 1 To parts.Length - 1
                OU = OU & ";" & parts(i)
            Next

            Dim objOU, objUser, strOU

            strOU = "LDAP://" & OU

            'DirectoryEntry del container en el que se creará el usuario
            Dim dirE As New DirectoryEntry()
            Dim dirEntry As DirectoryEntry = dirE.Children.Find(parts(0))
            dirEntry.Username = Settings.adminLogon
            dirEntry.Password = Settings.adminPassword
            dirEntry.AuthenticationType = AuthenticationTypes.Delegation

            Dim newUser As DirectoryEntry
            'Se crea el usuario en ese container
            newUser = dirEntry.Children.Add("CN=" & FullName, "User")
            newUser.Username = Settings.adminLogon
            newUser.Password = Settings.adminPassword
            newUser.AuthenticationType = AuthenticationTypes.Delegation

            'Se le asignan valores
            newUser.Properties("givenname").Value = sFirstName
            newUser.Properties("SAMAccountName").Value = sUserName
            newUser.Properties("userPrincipalName").Value = sUserName & "@" & Settings.userDNSDomain
            Try
                newUser.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para crear el usuario " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al crear el nuevo usuario, los argumentos para crearlo no pueden ser Null " & e.Message)
            Catch e As FormatException
                MsgBox("Error al crear el nuevo usuario, El formato de los datos no es el adecuado " & e.Message)
            Catch e As Exception
                MsgBox("Error al crear el usuario " & e.Message)

            End Try

            'Busco el usuario para comprobar que está creado
            Dim dirEn As New DirectoryEntry()
            Dim dirSearcher As DirectorySearcher = New DirectorySearcher(dirEn)
            dirSearcher.Filter = "(&(objectClass=user)(SAMAccountName=" & sUserName & "))"
            dirSearcher.SearchScope = SearchScope.Subtree
            Dim results As SearchResult = dirSearcher.FindOne()

            If Not results Is Nothing Then
                'Si existe el usuario
                Dim child As New DirectoryEntry(results.Path)
                child.Username = Settings.adminLogon
                child.Password = Settings.adminPassword
                child.AuthenticationType = AuthenticationTypes.Delegation
                'Dim oPassword As Object() = New Object() {sPassword}
                ''Establecer password y habilitar la cuenta de usuario
                'child.Invoke("SetPassword", oPassword)
                Dim oPassword As Object() = New Object() {sPassword}
                Try
                    child.Invoke("SetPassword", oPassword)
                Catch ex As TargetInvocationException
                    GenericClass.RemoveFromOU(sUserName, OU)
                    MsgBox("El usuario no cumple con los requisitos de seguridad para las contraseñas")
                End Try

                Try
                    child.CommitChanges()
                Catch e As AccessViolationException
                    MsgBox("Error al crear usuario, No tiene permisos para establecer el password del nuevo usuario " & e.Message)
                Catch e As ArgumentNullException
                    MsgBox("Error al crear usuario, El password para el nuevo usuario no puede ser nulo " & e.Message)
                Catch e As FormatException
                    MsgBox("Error al crear usuario, el formato del password no es válido " & e.Message)
                End Try
                EnableAccount2(sUserName)
                'newUser.CommitChanges()
                'Else
                '    MsgBox("El usuario no se ha creado correctamente")
            End If
        Catch e As Exception
            Console.WriteLine(e)
        End Try

    End Sub

    Public Shared Sub CopyUser(ByVal Usuario As String, ByVal OU_AC As String)
        '==========================================================================
        ' Name:     CopyUser
        ' Purpose:  Copiar un usuario
        ' Input:    1 string: El nombre de Login de un usuaio 'sUserName'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim salida As String
        salida = "-------Copiar Usuario-------"
        Dim Nnombre As String = "Copia de " & Usuario
        If Nnombre.Length > 20 Then
            MsgBox("No se puede copiar el usuario porque su nombre de Login no puede pasar de once caracteres")
        Else
            If Not UserExists("Copia de " & Usuario) Then
                CreateAdAccount2("Copia de " & Usuario, "123456", "Copia de " & Usuario, OU_AC, "Copia de " & UserClass.GetUserProperty(Usuario, "cn"))

                Try
                    UserClass.SetUserProperty("Copia de " & Usuario, "DisplayName", "Copia de" & UserClass.GetUserProperty(Usuario, "DisplayName"))


                Catch ex As Exception

                    MsgBox("Error al intentar asignar el nombre de display a la copia del usuario " & ex.Message)

                End Try

                Dim descrp As String = UserClass.GetUserProperty(Usuario, "description")
                If Not descrp = "" Then
                    Try
                        UserClass.SetUserProperty("Copia de " & Usuario, "description", descrp)

                    Catch ex As Exception
                        MsgBox("Error al intentar asignar la descripción a la copia del usuario " & ex.Message)
                    End Try
                End If
                Dim office As String = UserClass.GetUserProperty(Usuario, "physicalDeliveryOfficeName")
                If Not office = "" Then
                    Try
                        UserClass.SetUserProperty("Copia de " & Usuario, "physicalDeliveryOfficeName", office)

                    Catch ex As Exception
                        MsgBox("Error al intentar asignar la oficina a la copia del usuario " & ex.Message)
                    End Try
                End If
                Dim telephone As String = UserClass.GetUserProperty(Usuario, "telephoneNumber")
                If Not telephone = "" Then
                    Try
                        UserClass.SetUserProperty("Copia de " & Usuario, "telephoneNumber", telephone)

                    Catch ex As Exception
                        MsgBox("Error al intentar asignar el teléfono a la copia del usuario " & ex.Message)
                    End Try
                End If
                Dim web As String = UserClass.GetUserProperty(Usuario, "wWWHomePage")
                If Not web = "" Then
                    Try
                        UserClass.SetUserProperty("Copia de " & Usuario, "wWWHomePage", web)

                    Catch ex As Exception
                        MsgBox("Error al intentar asignar la web a la copia del usuario " & ex.Message)
                    End Try
                End If
                ''-------------------------------Account----------------------------------

                'Cuenta expira?
                Try
                    If UserClass.ExpirePassword(UserClass.getUserDirectoryEntry(Usuario)) Then
                        Dim dat As Date = UserClass.GetExpirationTime(Usuario)
                        UserClass.SetExpirationTime("Copia de " & Usuario, dat)
                    End If
                Catch ex As Exception

                    MsgBox("Error al establecer la fecha de expiración de la cuenta del usuario " & ex.Message)
                    salida = salida & vbCrLf & "Error al establecer la fecha de expiración de la cuenta del usuario " & ex.Message
                End Try


                ' deshabilitada
                If UserClass.isDisabled(UserClass.GetUserProperty(Usuario, "sAMAccountName")) Then
                    Try
                        GenericClass.DisableAccount("Copia de " & Usuario)
                        'UserClass.setUserPropertyObject(Usuario, "userAccountControl", &H2)
                    Catch ex As Exception

                        MsgBox("Error al deshabilitar el usuario " & ex.Message)
                        salida = salida & vbCrLf & "Error: al deshabilitar el usuario " & ex.Message

                    End Try
                End If

                ''Change password denied
                'If ChangePasswordDenied(UserClass.getUserDirectoryEntry(Usuario)) Then
                '    Try

                '        UserClass.DenyChangePassword(UserClass.getUserDirectoryEntry("Copia de " & Usuario))
                '    Catch ex As Exception

                '        MsgBox("Se ha producido un error al denegar el cambio de password al usuario " & ex.Message)
                '        salida = salida & vbCrLf & "Error: Se ha producido un error al denegar el cambio de password al usuario " & ex.Message

                '    End Try

                'Else
                '    Try

                '        UserClass.AllowPasswordDenied(UserClass.getUserDirectoryEntry("Copia de " & Usuario))
                '    Catch ex As Exception

                '        MsgBox("Se ha producido un error al permitir el cambio de password al usuario " & ex.Message)
                '        salida = salida & vbCrLf & "Error: Se ha producido un error al permitir el cambio de password al usuario " & ex.Message

                '    End Try

                'End If


                'change pass at next logon?

                Dim dato As Int64 = 0
                salida = salida & vbCrLf & "El usuario tiene que cambiar el password en el siguiente acceso"
                Try

                    UserClass.SetUserPropertyInt("Copia de " & Usuario, "pwdLastSet", dato)
                Catch ex As Exception

                    MsgBox("Error al establecer que el usuario tenga que cambiar el password en el siguiente acceso " & ex.Message)
                    salida = salida & vbCrLf & "Error: al establecer que el usuario tenga que cambiar el password en el siguiente acceso " & ex.Message

                End Try



                '---------------------------------Profile-----------------------------------
                Dim profile As String = UserClass.GetUserProperty(Usuario, "profilePath")
                Try
                    If Not profile = "" Then
                        UserClass.SetUserProperty("Copia de " & Usuario, "profilePath", profile)
                    End If

                Catch ex As Exception
                    MsgBox("Error al asignar la dirección del perfíl " & ex.Message)
                    salida = salida & vbCrLf & "Error: al asignar la dirección del perfíl " & ex.Message

                End Try

                Dim script As String = UserClass.GetUserProperty(Usuario, "scriptPath")
                Try
                    If Not script = "" Then
                        UserClass.SetUserProperty("Copia de " & Usuario, "scriptPath", script)
                    End If

                Catch ex As Exception

                    MsgBox("Error al asignar la dirección del script " & ex.Message)
                    salida = salida & vbCrLf & "Error al asignar la dirección del script " & ex.Message

                End Try

                Dim homedir As String = UserClass.GetUserProperty(Usuario, "homeDirectory")
                Dim homedri As String = UserClass.GetUserProperty(Usuario, "homeDrive")
                Try
                    If Not homedir = "" Then
                        UserClass.SetUserProperty("Copia de " & Usuario, "homeDirectory", homedir)
                    End If
                    If Not homedri = "" Then
                        UserClass.SetUserProperty("Copia de " & Usuario, "homeDrive", homedri)
                    End If

                Catch ex As Exception
                    MsgBox("Error al asignar la dirección de la home " & ex.Message)
                    salida = salida & vbCrLf & "Error: al asignar la dirección de la home " & ex.Message

                End Try




                '--------------------------------------------------MemberOf------------------------------------------------------------------

                Try
                    'Obtener el grupo primario
                    Dim token As String = UserClass.GetUserPropertyRefresh(Usuario, "primaryGroupID")
                    Dim Prim As String = UserClass.GetPrimaryGroup(token, Usuario)
                    'SetUserPropertyRefresh("Copia de " & Usuario, "primaryGroupID", token)
                    'setUserPropertyObject("Copia de " & Usuario, "memberOf", GetUserPropertyObject(Usuario, "memberOf"))

                    'Obtener los demás grupos del usuario
                    Dim grupos() As String = UserClass.GetUserGroups(Usuario)

                    If grupos.Count > 0 Then
                        For i = 0 To grupos.Count - 1

                            If Not grupos(i) = Prim Then
                                Dim DN As String = GenericClass.GetDN(grupos(i))

                                Dim logN As String = grupos(i)
                                Dim lnewlist As New List(Of String)
                                lnewlist = groupClass.GetGroupMembers(logN)
                                Try
                                    groupClass.SetGroupPropertyInsert(logN, "member", GenericClass.GetDN("Copia de " & Usuario), lnewlist.Count)
                                Catch ex As AccessViolationException
                                    MsgBox("Error, por falta de permisos, al añadir el usuario al grupo " & logN & " " & ex.Message)
                                    salida = salida & vbCrLf & "Error, por falta de permisos, al añadir el usuario al grupo " & logN & " " & ex.Message

                                Catch ex As FieldAccessException
                                    MsgBox("Error, por falta de permisos, al añadir el usuario al grupo " & logN & " " & ex.Message)
                                    salida = salida & vbCrLf & "Error, por falta de permisos, al añadir el usuario al grupo " & logN & " " & ex.Message

                                Catch ex As MemberAccessException
                                    MsgBox("Error, por falta de permisos, al eliminar los grupos de los que es miembro el usuario para posteriormente insertar los nuevos" & ex.Message)
                                    salida = salida & vbCrLf & "Error por falta de permisos: al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos" & ex.Message

                                Catch ex As UnauthorizedAccessException
                                    MsgBox("Error, por falta de permisos, al eliminar los grupos de los que es miembro el usuario para posteriormente insertar los nuevos" & ex.Message)
                                    salida = salida & vbCrLf & "Error por falta de permisos: al eliminar los grupos de los que es miembro el equipo para posteriormente insertar los nuevos" & ex.Message

                                Catch ex As Exception When DN = ""
                                    MsgBox("Error el Grupo al que se quiere añadir el usuario no pude ser vacío " & ex.Message)
                                    salida = salida & vbCrLf & "Error: el Grupo al que se quiere añadir el usuario no pude ser vacío " & ex.Message

                                Catch ex As FieldAccessException
                                    MsgBox("No tiene permisos para añadir el usuario a uno de los grupos " & ex.Message)
                                    salida = salida & vbCrLf & "Error: el Grupo al que se quiere añadir el usuario no pude ser vacío " & ex.Message

                                Catch ex As Exception
                                    MsgBox("Error al añadir el usuario al grupo " & logN)
                                    salida = salida & vbCrLf & "Error: al añadir el usuario al grupo " & grupos(i) & ex.Message
                                End Try
                            End If

                        Next
                    End If

                Catch ex As Exception
                    MsgBox("Error al compiar los grupos de los que es miembro " & ex.Message)
                End Try
                '---------------------------------------------------------------------------------

                '-----------------------------------Security---------------------------------------------------------------------
                '--------------------------------------------------------------------------------------------------------------------

                MailClass.CopyAces(Usuario, "Copia de " & Usuario)
            Else
                MsgBox("El usuario Copia de " & Usuario & "ya existe")
            End If
        End If
        salida = salida & vbCrLf & "usuario copiado"
        GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
    End Sub

    Public Shared Sub ChangePassword(ByVal sUserName As String, ByVal sPassword As String)
        '==========================================================================
        ' Name:     ChangePassword
        ' Purpose:  Asignar un nuevo password a un usuario
        ' Input:    2 string: El nombre de Login de usuaio 'sUserName', la nueva contraseña 'sPassword',
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Try
            'Obtener el DirectoryEntry del usuario
            Dim de As New DirectoryEntry()
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            Dim deSearch As DirectorySearcher = New DirectorySearcher()
            deSearch.SearchRoot = de
            deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & sUserName & "))"
            Dim results As SearchResultCollection = deSearch.FindAll()

            If results.Count = 0 Then
                MsgBox("usuario no existe")
            Else
                'Establecer el nuevo password invcando el método SetPassword
                Dim deuser As New DirectoryEntry(results(0).Path)
                deuser.Username = Settings.adminLogon
                deuser.Password = Settings.adminPassword
                deuser.AuthenticationType = AuthenticationTypes.Delegation
                Dim oPassword As Object() = New Object() {sPassword}
                Try
                    deuser.Invoke("SetPassword", oPassword)
                Catch ex As TargetInvocationException
                    MsgBox("La contraseña no cumple con los requisitos de seguridad")
                End Try
                Try
                    deuser.CommitChanges()
                Catch e As AccessViolationException
                    MsgBox("Error actualizando el password del usuario, no tiene permisos para actulizar el password " & e.Message)
                Catch e As ArgumentNullException
                    MsgBox("Error actualizando el password del usuario, no se ha encontrado el usuario o no se ha introducido el nuevo password " & e.Message)
                Catch e As FormatException
                    MsgBox("Error actualizando el password del usuario " & e.Message)
                End Try
            End If
        Catch e As Exception
            Console.WriteLine(e)
        End Try

    End Sub

    Public Shared Function isUserPropertyString(ByVal UserName As String, ByVal UserProperty As String) As Boolean
        '==========================================================================
        ' Name:     isUserPropertyString
        ' Purpose:  Determinar si un atributo del usuario es de tipo string
        ' Input:    2 string: El nombre de Login de usuaio 'UserName', El atributo 'UserProperty',
        ' Return:   1 boolean: True si el atributo es de tipo string, false en caso contratio
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UserName & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        Dim oresult As New DirectoryEntry(results(0).Path)
        If oresult.Properties(UserProperty).Value Is Nothing Then
            Return False
        Else
            Try
                'Si existen usuario y atributo devolver true si el valor del mismo es un string
                Return oresult.Properties(UserProperty).Value.GetType() = GetType(String)
            Catch e As AccessViolationException
                MsgBox("No tienes permisos para acceder a la información que dice si el dato es un string " & e.Message)
            Catch e As OperationCanceledException
                MsgBox("Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
            Catch e As OperationAbortedException
                MsgBox("Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
            Catch e As OutOfMemoryException
                MsgBox("La memoria está totalmente ocupada " & e.Message)
            Catch e As FieldAccessException
                MsgBox("Error al acceder a al ubicación física del dato " & e.Message)
            Catch e As InsufficientMemoryException
                MsgBox("La memoria está totalmente ocupada " & e.Message)
            Catch e As MissingFieldException
                MsgBox("Error al acceder a al ubicación física del dato, no existe " & e.Message)
            End Try
        End If

    End Function

    Public Shared Function x400downgraded(ByVal User As String) As Boolean
        '==========================================================================
        ' Name:     x400downgraded
        ' Purpose:  Determinar si el usuario tiene correo del tipo X400 con la alta prioridad eliminada
        ' Input:    1 string: El nombre de Login de usuaio 'UserName'
        ' Return:   1 boolean: True si el correo X400 no tiene alta prioridad, false en caso contratio
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & User & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oUser As Object = GetObject(results(0).Path)

        'Comprobar si X400 tiene prioridad mediante el securityProtocol del usuario
        If Not oUser.securityProtocol(3) Is Nothing Then
            Dim varReports As Object
            varReports = oUser.securityProtocol

            If varReports(0) = 0 And varReports(1) = 0 And varReports(2) = 0 And varReports(3) = 128 Then
                Return True
            Else
                Return False
            End If
        End If
    End Function

    Public Shared Sub x400downgrad(ByVal User As String, ByVal bool As Boolean)
        '==========================================================================
        ' Name:     x400downgrad
        ' Purpose:  Eliminar la alta prioridad del correo del tipo X400 
        ' Input:    1 string: El nombre de Login de usuaio 'UserName'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener el Directoryentry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & User & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        'Asignar el valor a securityProtocol 0 para eliminar la prioridad
        Dim oUser As New DirectoryEntry(results(0).Path)
        'Dim down As Integer = CInt(oUser.securityProtocol(3))
        If Not bool Then

            oUser.Properties("securityProtocol").Value = Nothing
        Else
            Dim by(3) As Byte
            Dim guid As Integer = &H0
            by(0) = CType(guid, Byte)
            by(1) = CType(guid, Byte)
            by(2) = CType(guid, Byte)
            guid = &H80
            by(3) = CType(guid, Byte)
            oUser.Properties("securityProtocol").Value = by

        End If
        Try
            oUser.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("No tienes permisos para establecer la prioridad de X400 " & e.Message)
        End Try

    End Sub

    Public Shared Function GetUserList() As System.Collections.Generic.IList(Of String)
        '==========================================================================
        ' Name:     GetUserList
        ' Purpose:  Obtener la lista de usuarios del directorio activo
        ' Input:    None
        ' Return:   1 array: Array con los nombres de login de los usuarios
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry de todos los objetos de tipo usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim oresult As SearchResult
        Dim lNewList As New List(Of String)
        Dim user As New DirectoryEntry
        Dim logonN As String
        If Not results.Count = 0 Then
            'Para cada uno añadir su nombre de Login al array de strings
            For Each oresult In results
                user = oresult.GetDirectoryEntry
                logonN = user.Properties("sAMAccountName").Value.ToString
                lNewList.Add(logonN)
            Next
        End If
        Return lNewList
    End Function

    '--------------------------------------------------------------------------------------------------------------------------------------
    '--------------------------------------------------------Password----------------------------------------------------------------------

    Public Shared Sub DenyChangePassword(ByVal user As DirectoryEntry)
        '==========================================================================
        ' Name:     DenyChangePassword
        ' Purpose:  Eliminar el permiso de cambiar su password al usuario
        ' Input:    1 DirectoryEntry: El DirectoryEntry del usuario 'user'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Impersonar el usuario actual para que tome el valor del controlador del dominio
        Dim oImp1 As Impersonation
        oImp1 = New Impersonation()
        oImp1.StartImpersonation(Settings.adminLogon, Settings.userDNSDomain, Settings.adminPassword)

        'Darle permisos de controlador de dominio al usuario
        user.Username = Settings.adminLogon
        user.Password = Settings.adminPassword
        user.AuthenticationType = AuthenticationTypes.Delegation

        ' Crear un Guid que identifica el derecho a cambio de contraseña
        Dim changePasswordGuid As New Guid("{AB721A53-1E2F-11D0-9819-00AA0040529B}")

        ' Obtener el ActiveDirectorySecurity del usuario.
        Dim userSecurity As ActiveDirectorySecurity = user.ObjectSecurity

        ' Crear un objecto SecurityIdentifier para "everyone".
        Dim everyoneSid As New SecurityIdentifier(WellKnownSidType.WorldSid, Nothing)

        ' Crear un objecto SecurityIdentifier para "self".
        Dim selfSid As New SecurityIdentifier(WellKnownSidType.SelfSid, Nothing)

        ' Crear una access rule para permitir cambiar el password a cualquiera
        ' Eliminará todas las demás access rules.
        Dim allowEveryone As New ActiveDirectoryAccessRule(everyoneSid, _
            ActiveDirectoryRights.ExtendedRight, _
            AccessControlType.Allow, _
            changePasswordGuid)

        ' Crear una access rule para denegar cambiar el password a todo el mundo
        Dim denyEveryone As New ActiveDirectoryAccessRule(everyoneSid, _
            ActiveDirectoryRights.ExtendedRight, _
            AccessControlType.Deny, _
            changePasswordGuid)

        ' Crear una access rule para permitir cambiar el password a sí mismo
        ' Eliminará todas las demás access rules.
        Dim allowSelf As New ActiveDirectoryAccessRule(selfSid, _
            ActiveDirectoryRights.ExtendedRight, _
            AccessControlType.Allow, _
            changePasswordGuid)

        ' Crear una access rule para denegar cambiar el password a sí mismo
        Dim denySelf As New ActiveDirectoryAccessRule(selfSid, _
            ActiveDirectoryRights.ExtendedRight, _
            AccessControlType.Deny, _
            changePasswordGuid)

        '  Eliminar la access rule para permitir cambiar el password a cualquiera
        userSecurity.RemoveAccessRuleSpecific(allowEveryone)

        ' Añadir una nueva access rule para denegar el cambio de acceso a todo el mundo
        userSecurity.AddAccessRule(denyEveryone)

        'Eliminar la access rule que permite cambiar password a sí mismo
        userSecurity.RemoveAccessRuleSpecific(allowSelf)

        ' Añadir una nueva acces rule para denegar a sí mismo el derecho a cambiar password
        userSecurity.AddAccessRule(denySelf)

        ' Guardar cambios
        Try
            user.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("Error al no permitir que el usuario pueda actualizar el password, No posees permisos para realizar esta acción " & e.Message)
        Catch e As ConstraintException
            MsgBox("Error al no permitir que el usuario pueda actualizar el password, Esta acción infringe una restricción " & e.Message)
        End Try

        'Terminar impersonación
        oImp1.EndImpersonation()
    End Sub

    Public Shared Sub MustChangePasswordNextLogon(ByVal de As DirectoryEntry) 'ok
        '==========================================================================
        ' Name:     MustChangePasswordNextLogon
        ' Purpose:  Obligar al usuario a cambiar el password en el siguiente login
        ' Input:    1 DirectoryEntry: El DirectoryEntry del usuario 'de'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Dar permisos al usuario de controlador de dominio
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        'Cambiar el atributo pwdLastSet para obligarle a cambiar el password en el siguiente login
        de.Properties("pwdLastSet").Value = 0
        Try
            de.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("Error al establecer que el usuario deba actualizar el password al acceder la siguiente vez, no tiene permisos para hacerlo " & e.Message)
        Catch e As FormatException
            MsgBox("Error al establecer que el usuario deba actualizar el password al acceder la siguiente vez, el formato del usuario no es válido " & e.Message)
        Catch e As ArgumentNullException
            MsgBox("Error al establecer que el usuario deba actualizar el password al acceder la siguiente vez, el usuario no puede ser nulo " & e.Message)
        End Try
    End Sub

    Public Shared Sub DontExpirePassword(ByVal de As DirectoryEntry) 'ok
        '==========================================================================
        ' Name:     DontExpirePassword
        ' Purpose:  Hacer que el password no expire
        ' Input:    1 DirectoryEntry: El DirectoryEntry del usuario 'de'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Dar permisos al usuario de controlador de dominio
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        'Cambiar el atributo userAccountControl para que no expire nunca el password
        Dim val As Integer = CInt(de.Properties("userAccountControl").Value)
        de.Properties("userAccountControl").Value = val Or &H10000
        Try
            de.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("Error al establecer que el password del usuario no expire nunca, no tiene permisos para hacerlo " & e.Message)
        Catch e As FormatException
            MsgBox("Error al establecer que el password del usuario no expire nunca, el formato del usuario no es válido " & e.Message)
        Catch e As ArgumentNullException
            MsgBox("Error al establecer que el password del usuario no expire nunca, el usuario no puede ser nulo " & e.Message)
        Catch e As ConstraintException
            MsgBox("Error al establecer que el password del usuario no expire nunca, Esta acción infringe una restricción " & e.Message)
        End Try
    End Sub

    Public Shared Sub PasswordExpires(ByVal de As DirectoryEntry) 'ok
        '==========================================================================
        ' Name:     DontExpirePassword
        ' Purpose:  Hacer que el password no expire
        ' Input:    1 DirectoryEntry: El DirectoryEntry del usuario 'de'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Dar permisos al usuario de controlador de dominio
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        'Cambiar el atributo userAccountControl para que no expire nunca el password
        Dim val As Integer = CInt(de.Properties("userAccountControl").Value)
        de.Properties("userAccountControl").Value = val And (Not &H10000)
        Try
            de.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("Error al establecer que el password del usuario no expire nunca, no tiene permisos para hacerlo " & e.Message)
        Catch e As FormatException
            MsgBox("Error al establecer que el password del usuario no expire nunca, el formato del usuario no es válido " & e.Message)
        Catch e As ArgumentNullException
            MsgBox("Error al establecer que el password del usuario no expire nunca, el usuario no puede ser nulo " & e.Message)
        Catch e As ConstraintException
            MsgBox("Error al establecer que el password del usuario no expire nunca, Esta acción infringe una restricción " & e.Message)
        End Try
    End Sub

    Public Shared Function ExpirePassword(ByVal de As DirectoryEntry) As Boolean 'ok
        '==========================================================================
        ' Name:     DontExpirePassword
        ' Purpose:  Hacer que el password no expire
        ' Input:    1 DirectoryEntry: El DirectoryEntry del usuario 'de'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Dar permisos al usuario de controlador de dominio
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Try
            'Cambiar el atributo userAccountControl para que no expire nunca el password
            Dim val As Integer = CInt(de.Properties("userAccountControl").Value)

            If val And &H10000 Then
                Return True
            Else
                Return False
            End If

        Catch e As AccessViolationException
            MsgBox("No tienes permisos para acceder a la información que dice si el usuario posee una contraseña que va a expirar " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
    End Function

    Public Shared Function ChangePasswordDenied(ByVal user As DirectoryEntry) As Boolean
        '==========================================================================
        ' Name:     ChangePasswordDenied
        ' Purpose:  Devolver si el usuario tiene el derecho a cambiar el password denegado
        ' Input:    1 DirectoryEntry: El DirectoryEntry del usuario 'de'
        ' Return:   1 boolean: true si el usurio no puede cambiar password, false en caso contrario
        ' Calls:    None
        '==========================================================================

        'Dar permisos de controlador de dominio al usuario
        user.Username = Settings.adminLogon
        user.Password = Settings.adminPassword
        user.AuthenticationType = AuthenticationTypes.Delegation
        ' Obtener el ActiveDirectorySecurity del usuario

        Dim changePasswordGuid As New Guid("{AB721A53-1E2F-11D0-9819-00AA0040529B}")

        ' Obtener el ActiveDirectorySecurity del usuario.
        Dim userSecurity As ActiveDirectorySecurity = user.ObjectSecurity

        ' Crear un objecto SecurityIdentifier para "everyone".
        Dim everyoneSid As New SecurityIdentifier(WellKnownSidType.WorldSid, Nothing)

        ' Crear un objecto SecurityIdentifier para "self".
        Dim selfSid As New SecurityIdentifier(WellKnownSidType.SelfSid, Nothing)

        ' Crear una access rule para permitir cambiar el password a cualquiera
        ' Eliminará todas las demás access rules.
        Dim allowEveryone As New ActiveDirectoryAccessRule(everyoneSid, _
            ActiveDirectoryRights.ExtendedRight, _
            AccessControlType.Allow, _
            changePasswordGuid)

        ' Crear una access rule para denegar cambiar el password a todo el mundo
        Dim denyEveryone As New ActiveDirectoryAccessRule(everyoneSid, _
            ActiveDirectoryRights.ExtendedRight, _
            AccessControlType.Deny, _
            changePasswordGuid)

        ' Crear una access rule para denegar cambiar el password a sí mismo
        Dim denySelf As New ActiveDirectoryAccessRule(selfSid, _
        ActiveDirectoryRights.ExtendedRight, _
        AccessControlType.Deny, _
        changePasswordGuid)

        ' Crear una access rule para permitir cambiar el password a sí mismo
        ' Eliminará todas las demás access rules.
        Dim allowSelf As New ActiveDirectoryAccessRule(selfSid, _
            ActiveDirectoryRights.ExtendedRight, _
            AccessControlType.Allow, _
            changePasswordGuid)

        Try
            Dim resul As Boolean = False
            Dim rule As ActiveDirectoryAccessRule
            'De entre las accessRules buscar la que deniega cambiar password y si está devolver true
            For Each rule In userSecurity.GetAccessRules(True, True, GetType(System.Security.Principal.NTAccount))
                'Dim selfSid As New SecurityIdentifier(WellKnownSidType.SelfSid, Nothing)
                If rule.AccessControlType = AccessControlType.Deny And rule.ActiveDirectoryRights = ActiveDirectoryRights.ExtendedRight And rule.ObjectType = denySelf.ObjectType Then
                    'If rule.Equals(denySelf) Then
                    resul = True
                End If
            Next
            Return resul
        Catch e As AccessViolationException
            MsgBox("No tienes permisos para acceder a la información que dice si el usuario puede cambiar el password " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Se está intentando obtener un dato involucrado en una operación cancelada " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Se está intentando obtener un dato involucrado en una operación abortada " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al acceder a al ubicación física del dato " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try

    End Function 'DenyChangePassword

    Public Shared Sub AllowPasswordDenied(ByVal user As DirectoryEntry)
        '==========================================================================
        ' Name:     AllowPasswordDenied
        ' Purpose:  Dar al usuario el derecho a cambiar el password 
        ' Input:    1 DirectoryEntry: El DirectoryEntry del usuario 'user'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Impersonar el usuario actual para que tome el valor del controlador del dominio
        Dim oImp1 As Impersonation
        oImp1 = New Impersonation()
        oImp1.StartImpersonation(Settings.adminLogon, Settings.userDNSDomain, Settings.adminPassword)

        'Darle permisos de controlador de dominio al usuario
        user.Username = Settings.adminLogon
        user.Password = Settings.adminPassword
        user.AuthenticationType = AuthenticationTypes.Delegation

        ' Crear un Guid que identifica el derecho a cambio de contraseña
        Dim changePasswordGuid As New Guid("{AB721A53-1E2F-11D0-9819-00AA0040529B}")

        ' Obtener el ActiveDirectorySecurity del usuario.
        Dim userSecurity As ActiveDirectorySecurity = user.ObjectSecurity

        ' Crear un objecto SecurityIdentifier para "everyone".
        Dim everyoneSid As New SecurityIdentifier(WellKnownSidType.WorldSid, Nothing)

        ' Crear un objecto SecurityIdentifier para "self".
        Dim selfSid As New SecurityIdentifier(WellKnownSidType.SelfSid, Nothing)

        ' Crear una access rule para permitir cambiar el password a cualquiera
        ' Eliminará todas las demás access rules.
        Dim allowEveryone As New ActiveDirectoryAccessRule(everyoneSid, _
            ActiveDirectoryRights.ExtendedRight, _
            AccessControlType.Allow, _
            changePasswordGuid)

        ' Crear una access rule para denegar cambiar el password a todo el mundo
        Dim denyEveryone As New ActiveDirectoryAccessRule(everyoneSid, _
            ActiveDirectoryRights.ExtendedRight, _
            AccessControlType.Deny, _
            changePasswordGuid)

        ' Crear una access rule para denegar cambiar el password a sí mismo
        Dim denySelf As New ActiveDirectoryAccessRule(selfSid, _
        ActiveDirectoryRights.ExtendedRight, _
        AccessControlType.Deny, _
        changePasswordGuid)

        ' Crear una access rule para permitir cambiar el password a sí mismo
        ' Eliminará todas las demás access rules.
        Dim allowSelf As New ActiveDirectoryAccessRule(selfSid, _
            ActiveDirectoryRights.ExtendedRight, _
            AccessControlType.Allow, _
            changePasswordGuid)

        '  Eliminar la access rule para denegar cambiar el password a cualquiera
        userSecurity.RemoveAccessRuleSpecific(denyEveryone)
        ' Añadir una nueva access rule para permitir el cambio de password a todo el mundo
        userSecurity.AddAccessRule(allowEveryone)
        'Eliminar la access rule que deniega cambiar password a sí mismo
        userSecurity.RemoveAccessRuleSpecific(denySelf)
        ' Añadir una nueva acces rule para permitrise a sí mismo el derecho a cambiar password
        userSecurity.AddAccessRule(allowSelf)
        'Gruardar cambios
        user.CommitChanges()
        'Terminar la impersonación
        oImp1.EndImpersonation()
    End Sub 'DenyChangePassword

    '----------------------------------------------------------------------------------------------------------------------------------------------
    '-------------------------------------------------------Interfaces----------------------------------------------------------------------------

    '<ComImport(), Guid("9068270b-0939-11D1-8be1-00c04fd8d503"),
    'InterfaceTypeAttribute(ComInterfaceType.InterfaceI sDual)> _
    <ComImport(), Guid("9068270b-0939-11D1-8be1-00c04fd8d503")> _
    Public Interface IADsLargeInteger
        Property HighPart As Int32
        Property LowPart As Int32
    End Interface

End Class
