﻿Imports System.ComponentModel

Public Class recursosCompartidosArbol
    Dim primero As String
    Dim servidores As List(Of String)
    Dim nombre As String

    Friend Sub loadName(ByVal name As String)
        '==========================================================================
        ' Name:     loadName
        ' Purpose:  Obtener el nombre del objeto a utilizar más adelante
        ' Input:    1 string: el nombre del objeto 'name'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        nombre = name
    End Sub

    Private Sub recursosCompartidosArbol_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        '==========================================================================
        ' Name:     recursosCompartidosArbol_FormClosing
        ' Purpose:  Eliminar elementos del combobox y el árbol
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CargarServidoresGeneral de genericClass
        '==========================================================================
        ServerComboBox.Text = ""
        ServerComboBox.Items.Clear()
        TreeView1.Nodes.Clear()
        Label2.Text = ""
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '==========================================================================
        ' Name:     Form1_Load
        ' Purpose:  Cargar el combobox de los servidores al cargar el formulario
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CargarServidoresGeneral de genericClass
        '==========================================================================

        ServerComboBox.Text = ""
        ServerComboBox.Items.Clear()
        ''obtener Servidores
        'servidores = GenericClass.CargarServidoresGeneral
        ''Cargarlos en el combobox
        'For i = 0 To servidores.Count - 1
        '    ServerComboBox.Items.Add(servidores(i))
        'Next
        'primero = True
    End Sub

    Private Sub ServerComboBox_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles ServerComboBox.DropDown
        '==========================================================================
        ' Name:     ServerComboBox_Enter
        ' Purpose:  Cargar el combobox de los servidores con ombre en el combobox el formulario
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CargarServidoresGeneral de genericClass
        '==========================================================================

        ServerComboBox.Items.Clear()
        'obtener Servidores
        Me.Cursor = Cursors.WaitCursor
        servidores = GenericClass.BuscarServidoresGeneral(ServerComboBox.Text)
        'Cargarlos en el combobox
        For i = 0 To servidores.Count - 1
            ServerComboBox.Items.Add(servidores(i))
        Next
        Me.Cursor = Cursors.Default
        'ServerComboBox.Se
        primero = True
    End Sub

    Private Sub ServerComboBox_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ServerComboBox.SelectedIndexChanged
        '==========================================================================
        ' Name:     ServerComboBox_SelectedIndexChanged
        ' Purpose:  Una vez seleccionado un servidor del combobox, crear el árbol con sus recursos compartidos
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    CargarServidoresGeneral de genericClass
        '==========================================================================
        Me.Cursor = Cursors.WaitCursor
        ContextMenuStrip1.Enabled = False
        TreeView1.Nodes.Clear()
        TreeView1.Nodes.Add("server", ServerComboBox.SelectedItem.ToString)
        crearArbolR("server", TreeView1.Nodes("server"))
        Me.Cursor = Cursors.Default
        Label2.Text = "Seleccione una carpeta para ver su dirección"
    End Sub

    Private Sub actualizaArbol()
        '==========================================================================
        ' Name:     ServerComboBox_SelectedIndexChanged
        ' Purpose:  Una vez seleccionado un servidor del combobox, crear el árbol con sus recursos compartidos
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        ContextMenuStrip1.Enabled = False
        Label2.Text = "Seleccione una carpeta para ver su dirección"
        Me.Cursor = Cursors.WaitCursor
        TreeView1.Nodes.Clear()
        TreeView1.Nodes.Add("server", ServerComboBox.SelectedItem.ToString)
        crearArbolR("server", TreeView1.Nodes("server"))
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub crearArbolR(ByVal dn As String, ByRef NodoPadre As TreeNode)
        '==========================================================================
        ' Name:     crearArbolR
        ' Purpose:  Crear el primer nivel del arbol(el de los recursos compartidos) y llamar a la función que sigue construyendo el árbol con las carpetas de estas
        ' Input:    1 string: dirección del servidor 'dn',
        '           1 Objeto: Nodo Padre del servidor 'Nodo Padre'
        ' Return:   None
        ' Calls:    crearArbolF
        '           getSharedElements de WMIClass
        '==========================================================================
        Dim clave As String
        'Obtener recursos compartidos
        Dim elements As New List(Of String)
        elements = WMIClass.getSharedElements(ServerComboBox.SelectedItem.ToString)

        'Crear primer nivel del árbol  y llamar a la función que construye lo demás
        If Not elements.Count = 0 Then
            For i = 0 To elements.Count - 1
                If Not elements(i).Contains("$") Then
                    clave = "\\" & ServerComboBox.SelectedItem.ToString & "\" & elements(i)
                    If WMIClass.isDirectory(clave) Then
                        NodoPadre.Nodes.Add(clave, elements(i), 1)
                        'crearArbolF(clave, NodoPadre.Nodes(clave))
        
                    End If
                End If
            Next
        End If
    End Sub

    Private Sub crearArbolF(ByVal dn As String, ByRef NodoPadre As TreeNode)
        '==========================================================================
        ' Name:     crearArbolF
        ' Purpose:  Crear el resto de niveles del arbol, los que están formadas por las carpetas hijas de los recursos compartidos
        ' Input:    1 string: dirección de la carpeta actual 'dn',
        '           1 Objeto: Nodo Padre de la carpeta 'Nodo Padre'
        ' Return:   None
        ' Calls:    SFolderelements3, isDirectory de WMICLass
        '==========================================================================
        Dim clave As String

        Dim elements As New List(Of String)

        'Evitar recursos compartidos de sistema
        If Not dn.Contains(".LOG") Then

            'Obtener carpetas hijas del directorio actual
            elements = WMIClass.SFolderelements3(dn)

            'Recorrer los elementos y para cada uno, si es una carpeta, llamar recursivamente a la función
            If (Not elements.Count = 0) And (Not elements Is Nothing) Then
                For i = 0 To elements.Count - 1
                    clave = dn & "\" & elements(i)

                    If WMIClass.isDirectory(clave) Then
                        If Not TreeView1.Nodes.ContainsKey(clave) Then
                            NodoPadre.Nodes.Add(clave, elements(i), 1)
                        End If
                        'If Not WMIClass.isDirectory("\\" & ServerComboBox.SelectedItem.ToString & "\" & elements(i)) Then

                        '    NodoPadre.Nodes.Add(clave, elements(i), 1)
                        '    'crearArbolF(clave, NodoPadre.Nodes(clave))
                        'End If

                    End If
                Next
            End If

        End If
    End Sub

    Function GetNode(ByVal dnNode As String, ByVal Tree As TreeNode) As TreeNode
        '==========================================================================
        ' Name:     GetNode
        ' Purpose:  Obtener el Nodo de un árbol
        ' Input:    1 String: dirección del nodo 'dnNode'
        '           1 TreeNode: el árbol 'Tree'
        ' Return:   1 TreeNode: El nodo que tiene como nombre la dirección que se pasa por parámetros
        ' Calls:    None
        '==========================================================================
        Return Tree.Nodes(Tree.Nodes.IndexOfKey(dnNode))
    End Function

    Private Sub TreeView1_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeView1.AfterSelect
        '==========================================================================
        ' Name:     TreeView1_AfterSelect
        ' Purpose:  Obtener la dirección de la carpeta seleccionada
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Me.Cursor = Cursors.WaitCursor

        'Cambios en el desplegable al hacer clic con el botón derecho
        Dim carpeta = TreeView1.SelectedNode.FullPath.ToString
        If e.Node.Nodes.Count = 0 Then

            crearArbolF("\\" & carpeta, TreeView1.SelectedNode)
        End If

        Dim parts() As String = carpeta.Split("\")
        'If Not WMIClass.isDirectory("\\" & carpeta) Then
        '    If Not TreeView1.SelectedNode.Equals(TreeView1.TopNode) Then
        '        ContextMenuStrip1.Enabled = False
        '    Else
        '        ContextMenuStrip1.Items(0).Enabled = False
        '        ContextMenuStrip1.Items(1).Enabled = False
        '        ContextMenuStrip1.Items(2).Enabled = True
        '    End If

        'Else


        ContextMenuStrip1.Enabled = True
        'If Not WMIClass.isDirectory("\\" & parts(0) & "\" & parts(parts.Length - 1)) Then
        If Not parts.Count = 2 Then
            If Not parts.Count = 1 Then

                ContextMenuStrip1.Items(0).Enabled = True
                ContextMenuStrip1.Items(1).Enabled = True
                ContextMenuStrip1.Items(2).Enabled = True
            Else
                ContextMenuStrip1.Items(0).Enabled = False
                ContextMenuStrip1.Items(1).Enabled = False
                ContextMenuStrip1.Items(2).Enabled = True
            End If
        Else
            ContextMenuStrip1.Items(0).Enabled = False
            ContextMenuStrip1.Items(1).Enabled = False
            ContextMenuStrip1.Items(2).Enabled = True
        End If
        'End If

        Dim dn As String
        dn = e.Node.Name
        Label2.Text = "\\" & TreeView1.SelectedNode.FullPath.ToString

        If e.Node.Nodes.Count > 0 Then
            e.Node.Expand()
        End If

        Me.Cursor = Cursors.Default
    End Sub

    Private Sub AddButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddButton.Click
        '==========================================================================
        ' Name:     AddButton_Click
        ' Purpose:  Crear una nueva carpeta como hija en la carpeta seleccionada
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    actualizaArbol
        '           createFolderArbol de WMIClass
        '==========================================================================
        Try

            Dim salida As String = "-------Añadir carpeta en recurso compartido-------"
            If TreeView1.SelectedNode Is Nothing Then
                Me.Cursor = Cursors.Default
                MsgBox("Se debe de seleccionar una carpeta dentro de los recursos compartidos del servidor")
                salida = salida & vbCrLf & "No se ha seleccionado una carpeta dentro de los recursos compartidos del servidor"
            Else
                If TreeView1.SelectedNode.FullPath.ToString.Contains((".LOG")) Or TreeView1.SelectedNode.FullPath.ToString.Contains(("REMOVE")) Then
                    Me.Cursor = Cursors.Default
                    MsgBox("No se pueden modificar las carpertas de sistema")
                Else
                    If Not TreeView1.SelectedNode.Equals(TreeView1.TopNode) Then
                   
                        If Not WMIClass.isDirectory("\\" & TreeView1.SelectedNode.FullPath.ToString) Then
                            MsgBox("Se debe seleccionar una carpeta para poder crear otra dentro de ella")
                            salida = salida & vbCrLf & "Error: al crear la carpeta, se ha intentado crear la carpeta en un archivo"
                        Else
                            'Llamada al formulario de obtener nombre de carpeta
                            NombreNuevaCarpeta.ShowDialog()
                            'Llamar a la función que crea la carpeta
                            salida = salida & vbCrLf & "Nombre de nueva carpeta:" & nombre
                            salida = salida & vbCrLf & "dirección de nueva carpeta:" & "\\" & TreeView1.SelectedNode.FullPath.ToString
                            salida = salida & vbCrLf & "Creando carpeta..."
                            Try
                                Me.Cursor = Cursors.WaitCursor
                                WMIClass.createFolderArbol("\\" & TreeView1.SelectedNode.FullPath.ToString, nombre)
                                Me.Cursor = Cursors.Default
                            Catch ex As Exception When nombre = ""
                                MsgBox("Error al crear la carpeta, el nombre de la nueva carpeta no puede ser vacío " & ex.Message)
                                salida = salida & vbCrLf & "Error: al crear la carpeta, el nombre de la nueva carpeta no puede ser vacío " & ex.Message
                            Catch ex As Exception
                                MsgBox("Error al crear la carpeta " & ex.Message)
                                salida = salida & vbCrLf & "Error: al crear la carpeta " & ex.Message
                            End Try
                            Me.Cursor = Cursors.Default
                            salida = salida & vbCrLf & "Carpeta creada"
                            Dim nuevo As Integer = TreeView1.SelectedNode.Index
                            'Actualizar el árbol
                            actualizaArbol()
                            Me.Cursor = Cursors.Default
                            salida = salida & vbCrLf & "Se ha creado una carpeta dentro de los recursos compartidos del servidor"
                        End If
                        'Log
                    End If
                End If



                End If


            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)

        End Try
    End Sub

    Private Sub TreeView1_NodeMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeNodeMouseClickEventArgs) Handles TreeView1.NodeMouseClick
        '==========================================================================
        ' Name:     TreeView1_NodeMouseClick
        ' Purpose:  Al hacer clic sobre un nodo con el botón derecho, que lo tome como seleccionado
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If e.Button = Windows.Forms.MouseButtons.Right Then
            TreeView1.SelectedNode = e.Node
        End If
    End Sub

    Private Sub TreeView1_NodeMouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeNodeMouseClickEventArgs) Handles TreeView1.NodeMouseDoubleClick
        '==========================================================================
        ' Name:     AddButton_Click
        ' Purpose:  Renombrar la carpeta  seleccionada al hacer doble click sobre ella
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    actualizaArbol
        '           renameFolder de WMIClass
        '==========================================================================
        Try
            Dim salida As String = "-------Renombrar carpeta en recurso compartido-------"
            If Not TreeView1.SelectedNode Is Nothing Then
                If Not TreeView1.SelectedNode.Equals(TreeView1.TopNode) Then
                    If Not WMIClass.isDirectory("\\" & TreeView1.SelectedNode.FullPath.ToString) Then
                        MsgBox("Se debe seleccionar una carpeta para poder renombrarla")
                        salida = salida & vbCrLf & "Error: no se ha seleccionado una carpeta para renombrarla"
                    Else
                        'Llamada al formulario de obtener nombre de carpeta
                        NombreNuevaCarpeta.ShowDialog()
                        'Llmada a la función que renombrará la carpeta
                        salida = salida & vbCrLf & "Nombre nuevo para la carpeta:" & nombre
                        salida = salida & vbCrLf & "dirección de la carpeta:" & "\\" & TreeView1.SelectedNode.FullPath.ToString
                        salida = salida & vbCrLf & "Renombrando carpeta..."
                        Try
                            WMIClass.renameFolder(TreeView1.SelectedNode.FullPath.ToString, nombre)
                        Catch ex As Exception When nombre = ""
                            MsgBox("Error al renombrar la carpeta, el nombre a asignar a la carpeta no puede ser vacío " & ex.Message)
                            salida = salida & vbCrLf & "Error: al renombrar la carpeta, el nombre a asignar a la carpeta no puede ser vacío " & ex.Message
                        Catch ex As Exception
                            MsgBox("Error al renombrar la carpeta " & ex.Message)
                            salida = salida & vbCrLf & "Error: al renombrar la carpeta " & ex.Message
                        End Try
                        salida = salida & vbCrLf & "Nombre de la carpeta cambiado"
                        'Actualizar el árbol
                        actualizaArbol()

                    End If
                    
                Else
                    MsgBox("Se ha de seleccionar una carpeta dentro de los recursos compartidos del servidor")
                    salida = salida & vbCrLf & "No se ha seleccionado una carpeta dentro de los recursos compartidos del servidor"
                End If
            End If

            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub deleteButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles deleteButton.Click
        '==========================================================================
        ' Name:     deleteButton_Click
        ' Purpose:  Eliminar la carpeta  seleccionada 
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    actualizaArbol
        '           deleteFolderArbol, isDirectory de WMIClass
        '==========================================================================
        Try
            Dim salida As String = "-------Eliminar carpeta en recurso compartido-------"

            If Not TreeView1.SelectedNode Is Nothing Then
                Me.Cursor = Cursors.WaitCursor
                If Not TreeView1.SelectedNode.Equals(TreeView1.TopNode) Then
                    If Not WMIClass.isDirectory("\\" & TreeView1.SelectedNode.FullPath.ToString) Then
                        Me.Cursor = Cursors.Default
                        MsgBox("Se debe seleccionar una carpeta para poder eliminarla")
                        salida = salida & vbCrLf & "Error: no se ha seleccionado una carpeta para eliminarla"
                    Else

                        Dim parts() As String = TreeView1.SelectedNode.FullPath.ToString.Split("\")
                        'Establecer si es recurso compartido
                        If WMIClass.isDirectory("\\" & parts(0) & "\" & parts(parts.Length - 1)) Then
                            Me.Cursor = Cursors.Default
                            MsgBox("No se puede eliminar un Recurso Compartido")
                        Else
                            'Llamar a la función que elimina la carpeta
                            salida = salida & vbCrLf & "dirección de la carpeta:" & "\\" & TreeView1.SelectedNode.FullPath.ToString
                            salida = salida & vbCrLf & "Eliminando carpeta..."
                            Try

                                WMIClass.deleteFolderArbol("\\" & TreeView1.SelectedNode.FullPath.ToString)
                                Me.Cursor = Cursors.Default
                            Catch ex As Exception
                                Me.Cursor = Cursors.Default
                                MsgBox("Error al eliminar la carpeta " & ex.Message)
                                salida = salida & vbCrLf & "Error: al eliminar la carpeta " & ex.Message
                            End Try
                            Me.Cursor = Cursors.Default
                            salida = salida & vbCrLf & "Carpeta eliminada"
                            'Actualizar el árbol
                            actualizaArbol()
                        End If

                    End If
                Else
                    Me.Cursor = Cursors.Default
                    MsgBox("Se ha de seleccionar una carpeta dentro de los recursos compartidos del servidor")
                    salida = salida & vbCrLf & "No se ha seleccionado una carpeta dentro de los recursos compartidos del servidor"
                End If

            Else
                Me.Cursor = Cursors.Default
                MsgBox("Se ha de seleccionar una carpeta dentro de los recursos compartidos del servidor")
                salida = salida & vbCrLf & "No se ha seleccionado una carpeta dentro de los recursos compartidos del servidor"
            End If



            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub RenombrarCarpetaToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RenombrarCarpetaToolStripMenuItem.Click
        '==========================================================================
        ' Name:     RenombrarCarpetaToolStripMenuItem_Click
        ' Purpose:  Renombrar la carpeta  de la que se ha desplegado el menú doble click sobre ella
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    actualizaArbol
        '           renameFolder de WMIClass
        '==========================================================================
        Try
            Dim salida As String = "-------Renombrar carpeta en recurso compartido-------"
            If Not TreeView1.SelectedNode Is Nothing Then
                If Not TreeView1.SelectedNode.Equals(TreeView1.TopNode) Then
                    If Not WMIClass.isDirectory("\\" & TreeView1.SelectedNode.FullPath.ToString) Then
                        MsgBox("Se debe seleccionar una carpeta para poder renombrarla")
                        salida = salida & vbCrLf & "Error: no se ha seleccionado una carpeta para renombrarla"
                    Else
                        'Llamada al formulario de obtener nombre de carpeta
                        NombreNuevaCarpeta.ShowDialog()
                        'Llmada a la función que renombrará la carpeta
                        salida = salida & vbCrLf & "Nombre nuevo para la carpeta:" & nombre
                        salida = salida & vbCrLf & "dirección de la carpeta:" & "\\" & TreeView1.SelectedNode.FullPath.ToString
                        salida = salida & vbCrLf & "Renombrando carpeta..."
                        Try

                            WMIClass.renameFolder(TreeView1.SelectedNode.FullPath.ToString, nombre)
                        Catch ex As Exception When nombre = ""
                            MsgBox("Error al renombrar la carpeta, el nombre a asignar a la carpeta no puede ser vacío " & ex.Message)
                            salida = salida & vbCrLf & "Error: al renombrar la carpeta, el nombre a asignar a la carpeta no puede ser vacío " & ex.Message
                        Catch ex As Exception
                            MsgBox("Error al renombrar la carpeta " & ex.Message)
                            salida = salida & vbCrLf & "Error: al renombrar la carpeta " & ex.Message
                        End Try
                        salida = salida & vbCrLf & "Nombre de la carpeta cambiado"
                        'Actualizar el árbol
                        actualizaArbol()

                    End If
                    
                Else
                    MsgBox("Se ha de seleccionar una carpeta dentro de los recursos compartidos del servidor")
                    salida = salida & vbCrLf & "No se ha seleccionado una carpeta dentro de los recursos compartidos del servidor"
                End If
            End If

            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub SeguridadToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SeguridadToolStripMenuItem.Click
        '==========================================================================
        ' Name:     SeguridadToolStripMenuItem_Click
        ' Purpose:  Cargar la ventana con la que controlar la seguridad de la carpeta la carpeta  de la que se ha desplegado el menú doble click sobre ella
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    actualizaArbol
        '           renameFolder de WMIClass
        '==========================================================================

        Dim parts() As String = TreeView1.SelectedNode.FullPath.ToString.Split("\")
        'Establecer si es recurso compartido
        If WMIClass.isDirectory("\\" & parts(0) & "\" & parts(parts.Length - 1)) Then
            MsgBox("Al establecer permisos de forma remota en la carpeta raíz de un recurso compartido quitará todos los permisos heredados de dicha carpeta raíz y de todas sus subcarpetas. Para establecer permisos sin quitar los permisos heredados, cambie los permisos en las carpetas secundarias.")
        End If
        If WMIClass.editableFolder("\\" & TreeView1.SelectedNode.FullPath.ToString) Then
            Me.Cursor = Cursors.WaitCursor
            SeguridadCarpeta.LoadCarpeta("\\" & TreeView1.SelectedNode.FullPath.ToString)
            SeguridadCarpeta.ShowDialog()
            Me.Cursor = Cursors.Default
        Else
            MsgBox("Para esa carpeta no se pueden cambiar los permisos")
        End If


    End Sub

    Private Sub CopiarDirecciónDeLaCarpetaAlPortapapelesToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopiarDirecciónDeLaCarpetaAlPortapapelesToolStripMenuItem.Click
        '==========================================================================
        ' Name:     CopiarDirecciónDeLaCarpetaAlPortapapelesToolStripMenuItem_Click
        ' Purpose:  Copia la direc´ción de la carpeta al portapapeles
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    actualizaArbol
        '           renameFolder de WMIClass
        '==========================================================================
        Clipboard.SetText(Label2.Text)
    End Sub
End Class