﻿Imports System
Imports System.DirectoryServices
Imports Microsoft.VisualBasic
Imports System.Object
Imports System.Net.Mail
Imports System.Security.AccessControl
Imports System.Security.Principal
Imports CDOEXM
Imports System.Runtime.InteropServices
Imports System.Collections
Imports ActiveDs
Imports System.Management
'Imports ImpersonateClass
Imports System.Text.RegularExpressions
Imports System.Net.Sockets
Imports System.Net

Public Class MailClass

    '----------------------------------------------------------------------------------------------------------------------------------------------
    '----------------------------------------------------------Generales--------------------------------------------------------------------------------

    Public Shared Function EmailAddressCheck(ByVal emailAddress As String) As Boolean
        '==========================================================================
        ' Name:     EmailAddressCheck
        ' Purpose:  Comprueba que el formato del mail sea el adecuado 
        ' Input:    1 String: El string a comprobar 'emailAddress'
        ' Return:   1 boolean 'EmailAddressCheck'
        ' Calls:    Match de la clase Regex
        '==========================================================================
        Dim pattern As String = "^[a-zA-Z][\w\.-]*[a-zA-Z0-9]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$"
        Dim emailAddressMatch As Match = Regex.Match(emailAddress, pattern)
        If emailAddressMatch.Success Then
            EmailAddressCheck = True
        Else
            EmailAddressCheck = False
        End If
    End Function

    Public Shared Sub User_MailEnable(ByVal UName As String, ByVal MailboxStoreName As String, ByVal Server As String)
        '==========================================================================
        ' Name:     User_MailEnable
        ' Purpose:  Asigna los valores necesarios a los atributos del objeto usuario para 
        '           que se habilite su correo. 
        ' Input:    3 String: Un nombre de loggin de usuario 'UName', Un nombre de mailboxStore Exchange 'MailboxStoreName'
        '           Un nombre de servidor 'Server'
        ' Return:   Nada
        ' Calls:    GetMailBoxStores de la clase Generic Class 
        '==========================================================================

        Try
            'Busqueda del usuario en el Directorio Activo
            Dim path As String
            Dim de As New DirectoryEntry()
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            de.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch As DirectorySearcher = New DirectorySearcher()
            deSearch.SearchRoot = de
            deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & UName & "))"
            Dim results As SearchResultCollection = deSearch.FindAll()
            If Not results.Count = 0 Then
                path = results(0).Path
            Else
                MsgBox("El usuario no existe")
            End If

            'Busqueda del Servidor Exchange, del servidor cuyo nombre es uno de los parámetros
            Dim pathMailStore As String
            Dim oresults As SearchResultCollection
            Dim ExchangeServer As SearchResult
            Dim RootDSE As New DirectoryEntry("LDAP://RootDSE")
            RootDSE.Username = Settings.adminLogon
            RootDSE.Password = Settings.adminPassword
            RootDSE.AuthenticationType = AuthenticationTypes.Delegation
            Dim RootPath As String = "LDAP://" + RootDSE.Properties("configurationNamingContext").Value
            Dim ConfigContainer As New DirectoryEntry(RootPath)
            Dim ConfigSearcher As New DirectorySearcher(ConfigContainer)
            ConfigSearcher.Filter = "(&(objectCategory=msExchExchangeServer))"
            ConfigSearcher.SearchScope = SearchScope.Subtree
            Dim oResultsBackendServers As SearchResultCollection = ConfigSearcher.FindAll

            If Not oResultsBackendServers.Count = 0 Then

                For i = 0 To oResultsBackendServers.Count - 1
                    If Server = oResultsBackendServers(i).GetDirectoryEntry.Properties("cn").Value.ToString Then
                        Dim ServerDN As String
                        ServerDN = oResultsBackendServers(i).GetDirectoryEntry.Properties("distinguishedName").Value.ToString
                        'Obtener los mailboxes del servidor
                        oresults = GenericClass.GetMailBoxStores(ServerDN)

                        'Buscar el objeto mailbox cuyo nombre es uno de los parámetros
                        For Each MailBoxStore In oresults
                            If MailBoxStore.GetDirectoryEntry.Properties("cn").Value.ToString = MailboxStoreName Then
                                pathMailStore = MailBoxStore.GetDirectoryEntry.path
                            End If
                        Next
                    End If
                Next

            Else
                MsgBox("Error con el Mailbox")
            End If

            'Obtener directoryEntry del usuario encontrado y asignarle los valores correspondientes a sus atributos
            Dim directoryentryuser As New DirectoryEntry(path)
            directoryentryuser.Username = Settings.adminLogon
            directoryentryuser.Password = Settings.adminPassword
            directoryentryuser.AuthenticationType = AuthenticationTypes.Delegation

            Dim userName As String
            userName = directoryentryuser.Properties("sAMAccountname").Value

            If directoryentryuser.Properties("msExchMailboxGuid").Value Is Nothing Then

                If directoryentryuser.Properties("displayName").Value Is Nothing Then

                    directoryentryuser.Properties("displayName").Add(userName)
                End If

                'Obtener directoryEntry del mailboxstore para obtener los valores de sus atributos que necesitamos
                Dim directoryEntryMailStore As New DirectoryEntry(pathMailStore)
                directoryEntryMailStore.Username = Settings.adminLogon
                directoryEntryMailStore.Password = Settings.adminPassword
                directoryEntryMailStore.AuthenticationType = AuthenticationTypes.Delegation
                Dim homeMDB As String

                homeMDB = directoryEntryMailStore.Properties("distinguishedName").Value
                'Crear el buzón
                Try

                    CreateMailbox(directoryentryuser.Properties("distinguishedName").Value, homeMDB)
                Catch e As AccessViolationException
                    MsgBox("Error al crear el buzón del usuario, no tiene permisos para hacerlo " & e.Message)
                Catch e As ArgumentNullException
                    MsgBox("Error al crear el buzón del usuario, la dirección del usuario no puede ser nula " & e.Message)
                Catch e As FormatException
                    MsgBox("Error al crear el buzón del usuario, la dirección del usuario no es válida " & e.Message)
                End Try

            Else
                MsgBox("El usuario ya tiene mail asignado")
            End If
            Try
                directoryentryuser.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error al crear el buzón del usuario, no tiene permisos para hacerlo, No tiene permisos para poder hacerlo " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al crear el buzón del usuario, no tiene permisos para hacerlo, No se pueden introducir argumentos nulos " & e.Message)
            Catch e As FormatException
                MsgBox("Error al crear el buzón del usuario, no tiene permisos para hacerlo, El formato de los datos no es el adecuado " & e.Message)
            End Try

        Catch e As Exception
            Console.WriteLine(e)
        End Try

    End Sub

    Public Shared Sub ModifyNickName(ByVal User As String, ByVal NicKName As String)
        '==========================================================================
        ' Name:     ModifyNickName
        ' Purpose:  Cambiar el nickName del mail de un usuario        
        ' Input:    2 String: Un nombre de loggin de usuario 'User', El nuevo nickname 'NickName'           
        ' Return:   Nada
        ' Calls:    Nada 
        '==========================================================================

        'Buscar el objeto usuario cuyo nombre es el que se obtiene en los parámetros
        Dim dirEntry As DirectoryEntry = UserClass.GetDirectoryEntry()
        dirEntry.Username = Settings.adminLogon
        dirEntry.Password = Settings.adminPassword
        dirEntry.AuthenticationType = AuthenticationTypes.Delegation
        Dim dirSearcher As DirectorySearcher = New DirectorySearcher(dirEntry)
        dirSearcher.Filter = "(&(objectClass=user)(sAMAccountName=" & User & "))"
        dirSearcher.SearchScope = SearchScope.Subtree
        Dim results As SearchResult = dirSearcher.FindOne()

        If Not results Is Nothing Then
            Dim dirEntryResults As New DirectoryEntry(results.Path)
            If Not dirEntryResults.Properties("homemdb").Value Is Nothing Then
                'Asignar el nuevo nickname al usuario
                dirEntryResults.Properties("mailNickName").Value = NicKName
                Try
                    dirEntryResults.CommitChanges()
                Catch e As AccessViolationException
                    MsgBox("Error al habilitar el correo y crear el buxón del nuevo usuario, No tiene permisos para poder hacerlo " & e.Message)
                Catch e As ArgumentNullException
                    MsgBox("Error al habilitar el correo y crear el buxón del nuevo usuario, No se pueden introducir argumentos nulos " & e.Message)
                Catch e As FormatException
                    MsgBox("Error al habilitar el correo y crear el buxón del nuevo usuario, El formato de los datos no es el adecuado " & e.Message)
                End Try
            Else
                Console.WriteLine("El usuario introducido no dispone de cuenta de correo")
            End If
        Else
            Console.WriteLine("El usuario introducido no existe")
        End If
    End Sub

    Public Shared Function CreateMailbox(ByVal userDN As String, ByVal homeMDB As String) As Boolean
        '==========================================================================
        ' Name:     CreateMailbox
        ' Purpose:  Crea el buzón Exchange de un usuario
        ' Input:    2 String: La dirección en el DA del usuario 'userDN', La dirección en la que crear el mailbox Exchange 'homeMDB'
        '           Un nombre de servidor 'Server'
        ' Return:   None
        ' Calls:    GetMailBoxStores de la clase Generic Class 
        '==========================================================================
        Try

            'Busqueda del usuario
            Dim deUser As New DirectoryEntry()
            deUser.Username = Settings.adminLogon
            deUser.Password = Settings.adminPassword
            deUser.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch As DirectorySearcher = New DirectorySearcher()
            deSearch.SearchRoot = deUser
            deSearch.Filter = "(&(objectClass=user) (distinguishedName=" & userDN & "))"
            Dim results As SearchResultCollection = deSearch.FindAll()
            If Not results.Count = 0 Then

                Dim deMail As New DirectoryEntry(results(0).Path)
                deMail.Username = Settings.adminLogon
                deMail.Password = Settings.adminPassword
                deMail.AuthenticationType = AuthenticationTypes.Delegation
                If Not deMail Is Nothing Then
                    'Casting para asignarle al objeto del usuario la interfaz buzón
                    Dim mailboxStore As IMailboxStore
                    mailboxStore = CType(deMail.NativeObject, IMailboxStore)
                    'Crear el buzón
                    mailboxStore.CreateMailbox(homeMDB)
                    Try
                        deMail.CommitChanges()
                    Catch e As AccessViolationException
                        MsgBox("Error al crear el buxón del usuario, No tiene permisos para poder hacerlo " & e.Message)
                    Catch e As ArgumentNullException
                        MsgBox("Error al crear el buxón del usuario, No se pueden introducir argumentos nulos " & e.Message)
                    Catch e As FormatException
                        MsgBox("Error al crear el buxón del usuario, El formato de los datos no es el adecuado " & e.Message)
                    End Try
                    Return True
                Else
                    Return False
                End If
            Else
                MsgBox("El usuario no existe")
            End If
        Catch ex As Exception
            MsgBox(ex.Message & vbNewLine & ex.ToString)
            Return False
            'EventLog.WriteEntry("ADSysService", ex.Message, EventLogEntryType.Error)
        End Try
    End Function

    Public Shared Function DeleteMailbox(ByVal user As String) As Boolean
        '==========================================================================
        ' Name:     DeleteMailbox
        ' Purpose:  Elimina el buzón Exchange de un usuario
        ' Input:    2 String: La dirección en el DA del usuario 'userDN', La dirección en la que crear el mailbox Exchange 'homeMDB'
        '           Un nombre de servidor 'Server'
        ' Return:   None
        ' Calls:    GetMailBoxStores de la clase Generic Class 
        '==========================================================================
        Try
            'Busqueda del usuario
            Dim deUser As New DirectoryEntry()
            deUser.Username = Settings.adminLogon
            deUser.Password = Settings.adminPassword
            deUser.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch As DirectorySearcher = New DirectorySearcher()
            deSearch.SearchRoot = deUser
            deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & user & "))"
            Dim results As SearchResultCollection = deSearch.FindAll()
            If Not results.Count = 0 Then

                Dim deMail As New DirectoryEntry(results(0).Path)
                deMail.Username = Settings.adminLogon
                deMail.Password = Settings.adminPassword
                deMail.AuthenticationType = AuthenticationTypes.Delegation
                If Not deMail Is Nothing Then
                    'Casting para asignarle al objeto del usuario la interfaz buzón
                    Dim mailboxStore As IMailboxStore
                    mailboxStore = CType(deMail.NativeObject, IMailboxStore)
                    'Crear el buzón

                    mailboxStore.DeleteMailbox()
                    Try
                        deMail.CommitChanges()
                    Catch e As AccessViolationException
                        MsgBox("Error al eliminar el buxón del usuario, No tiene permisos para poder hacerlo " & e.Message)
                    Catch e As ArgumentNullException
                        MsgBox("Error al eliminar el buxón del usuario, No se pueden introducir argumentos nulos " & e.Message)
                    Catch e As FormatException
                        MsgBox("Error al eliminar el buxón del usuario, El formato de los datos no es el adecuado " & e.Message)
                    End Try

                    Return True
                Else
                    Return False
                End If
            Else
                MsgBox("El usuario no existe")
            End If
        Catch ex As Exception
            MsgBox(ex.Message & vbNewLine & ex.ToString)
            Return False
            'EventLog.WriteEntry("ADSysService", ex.Message, EventLogEntryType.Error)
        End Try
    End Function

    Public Shared Function MoveMailbox(ByVal user As String, ByVal MailboxStoreName As String, ByVal Server As String) As Boolean
        '==========================================================================
        ' Name:     MoveMailbox
        ' Purpose:  Elimina el buzón Exchange de un usuario
        ' Input:    2 String: La dirección en el DA del usuario 'userDN', La dirección en la que crear el mailbox Exchange 'homeMDB'
        '           Un nombre de servidor 'Server'
        ' Return:   None
        ' Calls:    GetMailBoxStores de la clase Generic Class 
        '==========================================================================
        Try
            'Busqueda del Servidor Exchange, del servidor cuyo nombre es uno de los parámetros
            Dim pathMailStore As String
            Dim oresults As SearchResultCollection
            Dim RootDSE As New DirectoryEntry("LDAP://RootDSE")
            RootDSE.Username = Settings.adminLogon
            RootDSE.Password = Settings.adminPassword
            RootDSE.AuthenticationType = AuthenticationTypes.Delegation

            Dim RootPath As String = "LDAP://" + RootDSE.Properties("configurationNamingContext").Value
            Dim ConfigContainer As New DirectoryEntry(RootPath)
            ConfigContainer.Username = Settings.adminLogon
            ConfigContainer.Password = Settings.adminPassword
            ConfigContainer.AuthenticationType = AuthenticationTypes.Delegation

            Dim ConfigSearcher As New DirectorySearcher(ConfigContainer)
            ConfigSearcher.Filter = "(&(objectCategory=msExchExchangeServer))"
            ConfigSearcher.SearchScope = SearchScope.Subtree
            Dim oResultsBackendServers As Object = ConfigSearcher.FindAll
            If Not oResultsBackendServers.Count = 0 Then
                For Each ExchangeServer In oResultsBackendServers
                    If Server = ExchangeServer.GetDirectoryEntry.Properties("cn").Value.ToString Then
                        Dim ServerDN As String
                        ServerDN = ExchangeServer.GetDirectoryEntry.Properties("distinguishedName").Value.ToString
                        'Obtener los mailboxes del servidor
                        oresults = GenericClass.GetMailBoxStores(ServerDN)

                        'Buscar el objeto mailbox cuyo nombre es uno de los parámetros
                        For Each MailBoxStore In oresults
                            If MailBoxStore.GetDirectoryEntry.Properties("cn").Value.ToString = MailboxStoreName Then
                                pathMailStore = MailBoxStore.GetDirectoryEntry.path
                            End If
                        Next
                    End If
                Next

            Else
                MsgBox("Error con el Mailbox")
            End If
            'Obtener directoryEntry del mailboxstore para obtener los valores de sus atributos que necesitamos
            Dim directoryEntryMailStore As New DirectoryEntry(pathMailStore)
            directoryEntryMailStore.Username = Settings.adminLogon
            directoryEntryMailStore.Password = Settings.adminPassword
            directoryEntryMailStore.AuthenticationType = AuthenticationTypes.Delegation
            Dim homeMDB As String

            'homeMDB = "CN=MS Genericas 2 ,CN=SG Genericos ,CN=InformationStore,CN=IBMBXMAIL03,CN=Servers,CN=DONOSTIA,CN=Administrative Groups,CN=IBERMATICA,CN=Microsoft Exchange,CN=Services,CN=Configuration,DC=intranet,DC=ibermatica"
            homeMDB = directoryEntryMailStore.Properties("distinguishedName").Value
            'homeMDB = pathMailStore

            'homeMDB = "LDAP://" & Settings.ldapServerName & "/CN=MS Genericas 2,CN=SG Genericos,CN=InformationStore,CN=IBMBXMAIL03,CN=Servers,CN=DONOSTIA,CN=Administrative Groups,CN=IBERMATICA,CN=Microsoft Exchange,CN=Services,CN=Configuration,DC=intranet,DC=ibermatica"
            'MsgBox("CN=MS Genericas 2 (IBMBXMAIL03),CN=SG Genericos,CN=InformationStore,CN=IBMBXMAIL03,CN=Servers,CN=DONOSTIA,CN=Administrative Groups,CN=IBERMATICA,CN=Microsoft Exchange,CN=Services,CN=Configuration,DC=intranet,DC=ibermatica" & " - " & homeMDB)

            'Busqueda del usuario
            Dim deUser As New DirectoryEntry()
            deUser.Username = Settings.adminLogon
            deUser.Password = Settings.adminPassword
            deUser.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch As DirectorySearcher = New DirectorySearcher()
            deSearch.SearchRoot = deUser
            deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & user & "))"
            Dim results As SearchResultCollection = deSearch.FindAll()
            If Not results.Count = 0 Then

                Dim deMail As New DirectoryEntry(results(0).Path)
                deMail.Username = Settings.adminLogon
                deMail.Password = Settings.adminPassword
                'deMail.AuthenticationType = AuthenticationTypes.Delegation
                deMail.AuthenticationType = AuthenticationTypes.Delegation

                If Not deMail Is Nothing Then

                    'Casting para asignarle al objeto del usuario la interfaz buzón
                    Dim mailboxStore As IMailboxStore
                    mailboxStore = CType(deMail.NativeObject, IMailboxStore)
                    Try

                        'Mover el buzón
                        mailboxStore.MoveMailbox(homeMDB)


                        deMail.CommitChanges()

                    Catch e As ArgumentNullException
                        MsgBox("Error al mover el buxón del usuario, No se pueden introducir argumentos nulos " & e.Message)
                    Catch e As ArgumentException
                        MsgBox("Error al mover el buxón del usuario, El argumento no está dentro del intervalo esperado " & e.Message)
                    Catch e As AccessViolationException
                        MsgBox("Error al mover el buxón del usuario, No tiene permisos para poder hacerlo " & e.Message)
                    Catch e As FormatException
                        MsgBox("Error al mover el buxón del usuario, El formato de los datos no es el adecuado " & e.Message)
                    End Try
                    Return True
                Else
                    Return False
                End If
            Else
                MsgBox("El usuario no existe")
            End If
        Catch ex As Exception
            MsgBox(ex.Message & vbNewLine & ex.ToString)
            Return False
            'EventLog.WriteEntry("ADSysService", ex.Message, EventLogEntryType.Error)
        End Try
    End Function

    Public Shared Sub Group_MailEnable(ByVal GName As String, ByVal AdminGroup As String, ByVal GroupAlias As String)
        '==========================================================================
        ' Name:     User_MailEnable
        ' Purpose:  Asigna los valores necesarios a los atributos del objeto grupo para 
        '           que se habilite su correo. 
        ' Input:    3 String: Un nombre de loggin de grupo 'GName', Un nombre de grupo administrativo Exchange 'AdminGroup'
        '           Alias para el mail 'GroupAlias'
        ' Return:   Nada
        ' Calls:    Nada
        '==========================================================================

        Try
            'Busqueda del usuario en el Directorio Activo
            Dim path As String
            Dim de As New DirectoryEntry()
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            de.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch As DirectorySearcher = New DirectorySearcher()
            deSearch.SearchRoot = de
            deSearch.Filter = "(&(objectClass=group) (sAMAccountName=" & GName & "))"
            Dim results As SearchResultCollection = deSearch.FindAll()
            If Not results.Count = 0 Then
                path = results(0).Path
            Else
                MsgBox("El grupo no existe")
            End If

            'Busqueda del Servidor Exchange, del servidor cuyo nombre es uno de los parámetros
            Dim pathMailStore As String
            Dim oresults As SearchResultCollection
            Dim ExchangeServer As SearchResult
            Dim RootDSE As New DirectoryEntry("LDAP://RootDSE")
            RootDSE.Username = Settings.adminLogon
            RootDSE.Password = Settings.adminPassword
            RootDSE.AuthenticationType = AuthenticationTypes.Delegation
            Dim RootPath As String = "LDAP://" + RootDSE.Properties("configurationNamingContext").Value
            Dim ConfigContainer As New DirectoryEntry(RootPath)
            Dim ConfigSearcher As New DirectorySearcher(ConfigContainer)
            ConfigSearcher.Filter = "(&(objectCategory=msExchAdminGroup))"
            ConfigSearcher.SearchScope = SearchScope.Subtree
            Dim oAdminGroups As SearchResultCollection = ConfigSearcher.FindAll

            Dim AdminLegacyExchDN As String
            If Not oAdminGroups.Count = 0 Then

                For i = 0 To oAdminGroups.Count - 1
                    If AdminGroup = oAdminGroups(i).GetDirectoryEntry.Properties("cn").Value.ToString Then

                        AdminLegacyExchDN = oAdminGroups(i).GetDirectoryEntry.Properties("legacyExchangeDN").Value.ToString

                    End If
                Next

            Else
                MsgBox("Error con el Grupo Administrativo")
            End If

            'Obtener directoryEntry del grupo encontrado y asignarle los valores correspondientes a sus atributos
            Dim directoryentrygroup As New DirectoryEntry(path)
            directoryentrygroup.Username = Settings.adminLogon
            directoryentrygroup.Password = Settings.adminPassword
            directoryentrygroup.AuthenticationType = AuthenticationTypes.Delegation

            Dim groupName As String
            groupName = directoryentrygroup.Properties("sAMAccountname").Value

            'Obtener directoryEntry del mailboxstore para obtener los valores de sus atributos que necesitamos
            Dim directoryEntryMailStore As New DirectoryEntry(pathMailStore)
            directoryEntryMailStore.Username = Settings.adminLogon
            directoryEntryMailStore.Password = Settings.adminPassword
            directoryEntryMailStore.AuthenticationType = AuthenticationTypes.Delegation

            Dim legacyExchangeDN As String
            legacyExchangeDN = AdminLegacyExchDN & "/cn=Recipients/cn=" & GroupAlias

            directoryentrygroup.Properties("legacyExchangeDN").Value = legacyExchangeDN
            directoryentrygroup.Properties("mailNickName").Value = GroupAlias

            Try
                directoryentrygroup.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error al habilitar el correo del nuevo grupo, No tiene permisos para poder hacerlo " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al habilitar el correo del nuevo grupo, No se pueden introducir argumentos nulos " & e.Message)
            Catch e As FormatException
                MsgBox("Error al habilitar el correo del nuevo grupo, El formato de los datos no es el adecuado " & e.Message)
            End Try

        Catch e As Exception
            Console.WriteLine(e)
        End Try

    End Sub

    Public Shared Sub Group_MailDisable(ByVal GName As String)
        '==========================================================================
        ' Name:     User_MailDisable
        ' Purpose:  Elimina los valores necesarios a los atributos del objeto grupo para 
        '           que se deshabilite su correo. 
        ' Input:    1 String: Un nombre de loggin de grupo 'GName'
        ' Return:   Nada
        ' Calls:    Nada
        '==========================================================================

        Try
            'Busqueda del usuario en el Directorio Activo
            Dim path As String
            Dim de As New DirectoryEntry()
            de.Username = Settings.adminLogon
            de.Password = Settings.adminPassword
            de.AuthenticationType = AuthenticationTypes.Delegation
            Dim deSearch As DirectorySearcher = New DirectorySearcher()
            deSearch.SearchRoot = de
            deSearch.Filter = "(&(objectClass=group) (sAMAccountName=" & GName & "))"
            Dim results As SearchResultCollection = deSearch.FindAll()
            If Not results.Count = 0 Then
                path = results(0).Path
            Else
                MsgBox("El grupo no existe")
            End If

            'Obtener directoryEntry del grupo encontrado y asignarle los valores correspondientes a sus atributos
            Dim directoryentrygroup As New DirectoryEntry(path)
            directoryentrygroup.Username = Settings.adminLogon
            directoryentrygroup.Password = Settings.adminPassword
            directoryentrygroup.AuthenticationType = AuthenticationTypes.Delegation

            Dim groupName As String
            groupName = directoryentrygroup.Properties("sAMAccountname").Value

            directoryentrygroup.Properties("legacyExchangeDN").Clear()
            directoryentrygroup.Properties("mailNickName").Clear()

            Try
                directoryentrygroup.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error al deshabilitar el correo del nuevo grupo, No tiene permisos para poder hacerlo " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("Error al deshabilitar el correo del nuevo grupo, No se pueden introducir argumentos nulos " & e.Message)
            Catch e As FormatException
                MsgBox("Error al deshabilitar el correo del nuevo grupo, El formato de los datos no es el adecuado " & e.Message)
            End Try

        Catch e As Exception
            Console.WriteLine(e)
        End Try

    End Sub

    Public Shared Function EmailAddressExists(ByVal emailAddress As String) As Boolean
        '==========================================================================
        ' Name:     EmailAddressExists
        ' Purpose:  Comprueba si el mail existe en el dominio
        ' Input:    1 String: El string a comprobar 'emailAddress'
        ' Return:   1 boolean 'EmailAddressCheck'
        ' Calls:    Match de la clase Regex
        '==========================================================================

        Dim de As New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher()
        deSearch.SearchRoot = de
        
        deSearch.Filter = "(&(proxyAddresses=smtp:" & emailAddress & "))"
        Dim results As SearchResultCollection = deSearch.FindAll()
        If results.Count > 0 Then
            Return True
        Else
            Return False
        End If

    End Function
    '-------------------------------------------------------------------------------------------------------------------
    '--------------------------------------------------Restricciones Envío----------------------------------------------
    Public Shared Sub SetSendingMessageSize(ByVal userDN As String, ByVal size As Integer)
        '==========================================================================
        ' Name:     SetSendingMessageSize
        ' Purpose:  Asigna el tamaño máximo de los mensajes que puede enviar un usuario
        '          
        ' Input:    2 String: El nombre de login de un usuario 'userDN', Nuevo tamaño a asignar 'size'
        '           
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Busqueda del usuario
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=user) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("submissionContLength")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Si size = -1 quiere decir que no se va a limitar el tamaño de mensaje, sino se asigna size
            'al atributo del usuario que controla el tamaño máximo de mensaje que se puede enviar
            If size = -1 Then
                user.Properties("submissionContLength").Value = Nothing
            Else
                user.Properties("submissionContLength").Value = size
            End If
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para establecer el tamaño máximo de los mensajes de salida " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("El tamaño máximo de los mensajes de salida no puede ser nulo " & e.Message)
            Catch e As FormatException
                MsgBox("El formato del tamaño máximo de los mensajes de salida no es válido" & e.Message)
            Catch e As ArithmeticException
                MsgBox("El tamaño máximo de los mensajes de salida no es válido " & e.Message)
            End Try
        Catch ex As Exception
            MsgBox("Error al modificar el tamaño del mensaje de salida : " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
    End Sub

    Shared Sub SetReceptionMessageSize(ByVal userDN As String, ByVal size As Integer)
        '==========================================================================
        ' Name:     SetReceptionMessageSize
        ' Purpose:  Asigna el tamaño máximo de los mensajes que puede recibir un usuario
        '          
        ' Input:    2 String: El nombre de login de un usuario 'userDN', Nuevo tamaño a asignar 'size'
        '           
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Busqueda del usuario
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=user) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("delivContLength")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Si size = -1 quiere decir que no se va a limitar el tamaño de mensaje, sino se asigna size
            'al atributo del usuario que controla el tamaño máximo de mensaje que se puede recibir
            If size = -1 Then
                user.Properties("delivContLength").Value = Nothing
            Else
                user.Properties("delivContLength").Value = size
            End If
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para establecer el tamaño máximo de los mensajes de entrada " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("El tamaño máximo de los mensajes de entrada no puede ser nulo " & e.Message)
            Catch e As FormatException
                MsgBox("El formato del tamaño máximo de los mensajes de entrada no es válido" & e.Message)
            Catch e As ArithmeticException
                MsgBox("El tamaño máximo de los mensajes de entrada no es válido " & e.Message)
            End Try
        Catch ex As Exception
            MsgBox("Error al modificar el tamaño del mensaje de entrada : " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
    End Sub

    Shared Sub SetReceptionMessageSizeGroup(ByVal userDN As String, ByVal size As Integer)
        '==========================================================================
        ' Name:     SetReceptionMessageSizeGroup
        ' Purpose:  Asigna el tamaño máximo de los mensajes que puede recibir un grupo
        '          
        ' Input:    2 String: El nombre de un grupo 'userDN', Nuevo tamaño a asignar 'size'
        '           
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Busqueda del grupo
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=group) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("delivContLength")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Si size = -1 quiere decir que no se va a limitar el tamaño de mensaje, sino se asigna size
            'al atributo del grupo que controla el tamaño máximo de mensaje que se puede recibir
            If size = -1 Then
                user.Properties("delivContLength").Value = Nothing
            Else
                user.Properties("delivContLength").Value = size
            End If
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para establecer el tamaño máximo de los mensajes de entrada " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("El tamaño máximo de los mensajes de entrada no puede ser nulo " & e.Message)
            Catch e As FormatException
                MsgBox("El formato del tamaño máximo de los mensajes de entrada no es válido" & e.Message)
            Catch e As ArithmeticException
                MsgBox("El tamaño máximo de los mensajes de entrada no es válido " & e.Message)
            End Try
        Catch ex As Exception
            MsgBox("Error al modificar el tamaño del mensaje de entrada : " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
    End Sub

    Shared Sub SetMailRequireAuthToSendTo(ByVal userDN As String, ByVal requireAuth As Boolean)
        '==========================================================================
        ' Name:     SetMailRequireAuthToSendTo
        ' Purpose:  Asignar true o false al atributo que obliga a autenticarse al usuario cuando
        '           se quiere enviar un correo. 
        ' Input:    1 String: Un nombre de loggin de usuario 'UName'. 1 Boolean: Valor a asignarle al atributo 'requireAuth'
        '           
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Buscar el usuario
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("msExchRequireAuthToSendTo")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Asignarle el valor
            user.Properties("msExchRequireAuthToSendTo").Value = requireAuth
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para establecer recibir mensajes solo de Usuarios Autentificados " & e.Message)
            Catch e As ArgumentNullException
                MsgBox("El dato que establece que solo se puedan recibir mensajes de usuarios autentificados no puede ser nulo" & e.Message)
            Catch e As FormatException
                MsgBox("El dato que establece que solo se puedan recibir mensajes de usuarios autentificados debe ser un boolean " & e.Message)
            End Try
        Catch ex As Exception
            MsgBox("Error al establecer recibir mensajes solo de Usuarios Autentificados : " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
    End Sub

    Shared Sub SetMailRequireAuthToSendToGroup(ByVal userDN As String, ByVal requireAuth As Boolean)
        '==========================================================================
        ' Name:     SetMailRequireAuthToSendToGroup
        ' Purpose:  Asignar true o false al atributo que obliga a autenticarse al usuario cuando
        '           se quiere enviar un correo de grupo. 
        ' Input:    1 String: Un nombre de loggin de usuario 'UName'. 1 Boolean: Valor a asignarle al atributo 'requireAuth'
        '           
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Buscar el grupo
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=group) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("msExchRequireAuthToSendTo")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Asignar el valor
            user.Properties("msExchRequireAuthToSendTo").Value = requireAuth
            user.CommitChanges()
        Catch ex As Exception
            MsgBox("Error al establecer recibir mensajes solo de Usuarios Autentificados : " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
    End Sub

    Shared Sub AddOrigAuth(ByVal userDN As String, ByVal userDN2 As String)
        '==========================================================================
        ' Name:     AddOrigAuth
        ' Purpose:  Añadir un usuario de los que se permite recibir mensajes
        ' Input:    2 String: El nombre de login del usuario receptor 'userDN', 
        '           El nombre de login del emisor 'userDN2'          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim user2 As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Busqueda de userDN
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=user) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("authOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Busqueda de userDN2
            oSearcher.Filter = "(&(sAMAccountName=" & userDN2 & "))"
            oSearcher.PropertiesToLoad.Add("distinguishedName")
            oResult = oSearcher.FindOne
            user2 = oResult.GetDirectoryEntry
            user2.Username = Settings.adminLogon
            user2.Password = Settings.adminPassword
            user2.AuthenticationType = AuthenticationTypes.Delegation

            'Obtanción de la lista de usuarios de los que userDN puede recibir mensajes
            Dim lNewList As New List(Of String)
            For Each sAddress As String In user.Properties("authOrig")
                lNewList.Add(sAddress)
            Next
            'Añadir userDN2 a esa lista
            lNewList.Add(user2.Properties("distinguishedName").Value.ToString)
            user.Properties("authOrig").Value = lNewList.ToArray
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para añadir el usuario al conjunto de los que se pueden recibir mensajes " & e.Message)
            Catch e As FormatException
                MsgBox("El usuario que se quiere añadir al conjunto de los que se pueden recibir mensajes, no tiene el formato adecuado " & e.Message)
            Catch e As IndexOutOfRangeException
                MsgBox("El usuario no se puede añadir al conjunto de los que se pueden recibir mensajes, al encontrarse fuera del rango " & e.Message)
            End Try

        Catch ex As Exception
            MsgBox("Error al añadir el usuario con permisos de envio a: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try

    End Sub

    Shared Function IsInOrigAuth(ByVal userDN As String, ByVal userDN2 As String) As Boolean
        '==========================================================================
        ' Name:     IsInOrigAuth
        ' Purpose:  Saber si un usuario forma parte del conjunto de usuarios de los 
        '           que se permite recibir mensajes a otro usuario en concreto
        ' Input:    2 String: El nombre de login del usuario receptor 'userDN', El nombre de login del usuario emisor 'userDN2'          
        ' Return:   1 Boolean
        ' Calls:    GetUserDN de la clase userclass
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Dim sal As Boolean = False
        Try
            'Busqueda del usuario receptor
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=user) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("authOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            If oResult Is Nothing Then
                sal = False
            Else
                'Obtener la lista del los usuarios que pueden enviar mensajes a userDN y 
                'comprobar si userDN2 es uno de ellos
                user = oResult.GetDirectoryEntry
                For Each sAddress As String In user.Properties("authOrig")
                    If sAddress.Contains(UserClass.GetUserDN(userDN2)) Then
                        sal = True
                    End If
                Next
            End If

        Catch ex As Exception
            MsgBox("Error al añadir el usuario con permisos de envio a: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
        Return sal
    End Function

    Shared Sub RemoveOrigAuth(ByVal userDN As String, ByVal userDN2 As String)
        '==========================================================================
        ' Name:     RemoveOrigAuth
        ' Purpose:  Eliminar un usuario de los que se permite recibir mensajes 
        ' Input:    2 String: El nombre de login del usuario receptor 'userDN', 
        '           El nombre de login del usuario emisor 'userDN2'          
        ' Return:   None
        ' Calls:    GetUserDN de la clase userclass
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Busqueda del usuario receptor
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=user) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("authOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Crear una nueva lista con todos los usuarios autorizados excepto userDN2
            Dim lNewList As New List(Of String)
            For Each sUser As String In user.Properties("authOrig")
                If Not sUser.Contains(UserClass.GetUserDN(userDN2)) Then
                    lNewList.Add(sUser)
                End If
            Next
            'Establecer la nueva lista como el conjunto de usuarios de los que se permite recibir mensajes
            user.Properties("authOrig").Value = lNewList.ToArray
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para quitar el usuario al conjunto de los que se pueden recibir mensajes " & e.Message)
            Catch e As FormatException
                MsgBox("El usuario que se quiere quitar al conjunto de los que se pueden recibir mensajes, no tiene el formato adecuado " & e.Message)
            Catch e As IndexOutOfRangeException
                MsgBox("El usuario no se puede quitar al conjunto de los que se pueden recibir mensajes, al encontrarse fuera del rango " & e.Message)
            End Try

        Catch ex As Exception
            MsgBox("Error al añadir el usuario con permisos de envio a: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try

    End Sub

    Shared Sub AddOrigUnauth(ByVal userDN As String, ByVal userDN2 As String)
        '==========================================================================
        ' Name:     AddOrigUnauth
        ' Purpose:  Añadir un usuario de los que no se permite recibir mensajes
        ' Input:    2 String: El nombre de login del usuario receptor 'userDN', 
        '           El nombre de login del emisor 'userDN2'          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim user2 As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Busqueda del usuario receptor
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=user) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("unauthOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Busqueda del emisor
            oSearcher.Filter = "(&(sAMAccountName=" & userDN2 & "))"
            oSearcher.PropertiesToLoad.Add("distinguishedName")
            oResult = oSearcher.FindOne
            user2 = oResult.GetDirectoryEntry
            user2.Username = Settings.adminLogon
            user2.Password = Settings.adminPassword
            user2.AuthenticationType = AuthenticationTypes.Delegation

            'Obtener la lista de los usuarios de los que no está permitido receibri mensajes
            Dim lNewList As New List(Of String)
            For Each sAddress As String In user.Properties("unauthOrig")
                lNewList.Add(sAddress)
            Next

            'Añadir userDN2 a esa lista
            lNewList.Add(user.Properties("distinguishedName").Value.ToString)
            user.Properties("unauthOrig").Value = lNewList.ToArray
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para añadir el usuario al conjunto de los que no se pueden recibir mensajes " & e.Message)
            Catch e As FormatException
                MsgBox("El usuario que se quiere añadir al conjunto de los que no se pueden recibir mensajes, no tiene el formato adecuado " & e.Message)
            Catch e As IndexOutOfRangeException
                MsgBox("El usuario no se puede añadir al conjunto de los que no se pueden recibir mensajes, al encontrarse fuera del rango " & e.Message)
            End Try

        Catch ex As Exception
            MsgBox("Error al añadir el usuario con permisos de envio a: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try

    End Sub

    Shared Function IsInOrigUnauth(ByVal userDN As String, ByVal userDN2 As String) As Boolean
        '==========================================================================
        ' Name:     IsInOrigUnauth
        ' Purpose:  Saber si un usuario forma parte del conjunto de usuarios de los 
        '           que no se permite recibir mensajes a otro usuario en concreto
        ' Input:    2 String: El nombre de login del usuario receptor 'userDN', El nombre de login del usuario emisor 'userDN2'          
        ' Return:   1 Boolean
        ' Calls:    GetUserDN de la clase userclass
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Dim sal As Boolean = False
        Try
            'Busqueda del usuario receptor
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=user) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("unauthOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            If oResult Is Nothing Then
                sal = False
            Else
                'Obtener la lista de usuarios de los que no se permite recibir mensajes 
                'y comprobar si userDN2 está entre ellos
                user = oResult.GetDirectoryEntry
                For Each sAddress As String In user.Properties("unauthOrig")
                    If sAddress.Contains(UserClass.GetUserDN(userDN2)) Then
                        sal = True
                    End If
                Next
            End If

        Catch ex As Exception
            MsgBox("Error al añadir el usuario con permisos de envio a: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
        Return sal
    End Function

    Shared Sub RemoveOrigUnauth(ByVal userDN As String, ByVal userDN2 As String)
        '==========================================================================
        ' Name:     RemoveOrigUnAuth
        ' Purpose:  Eliminar un usuario de los que se no permite recibir mensajes 
        ' Input:    2 String: El nombre de login del usuario receptor 'userDN', 
        '           El nombre de login del usuario emisor 'userDN2'          
        ' Return:   None
        ' Calls:    GetUserDN de la clase userclass
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Busqueda de usuario receptor
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=user) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("unauthOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Crear una nueva lista con todos los usuarios no autorizados excepto userDN2
            Dim lNewList As New List(Of String)
            For Each sUser As String In user.Properties("unauthOrig")
                If UCase(sUser).Contains(UCase(userDN2)) Then
                    lNewList.Add(sUser)
                End If
            Next
            'Establecer la nueva lista como el conjunto de usuarios de los que no se permite recibir mensajes
            user.Properties("unauthOrig").Value = lNewList.ToArray
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para quitar el usuario al conjunto de los que no se pueden recibir mensajes " & e.Message)
            Catch e As FormatException
                MsgBox("El usuario que se quiere quitar al conjunto de los que no se pueden recibir mensajes, no tiene el formato adecuado " & e.Message)
            Catch e As IndexOutOfRangeException
                MsgBox("El usuario no se puede quitar al conjunto de los que no se pueden recibir mensajes, al encontrarse fuera del rango " & e.Message)
            End Try

        Catch ex As Exception
            MsgBox("Error al eliminar el usuario con permisos de envio a: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try

    End Sub

    Shared Sub ChangeOrigAuth(ByVal userDN As String)
        '==========================================================================
        ' Name:     ChangeOrigAuth
        ' Purpose:  Establecer el grupo de usuarios de los que se permite recibir mensajes
        '           como el grupo de usuarios de los que no se permite recibir mensajes y viceversa
        ' Input:    1 String: El nombre de login del usuario receptor 'userDN',          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Busqueda del usuario receptor
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=user) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("authOrig")
            oSearcher.PropertiesToLoad.Add("unauthOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Obtener las listas de usuarios permitidos y no permitidos
            Dim NewListAuth As New List(Of String)
            For Each sUser As String In user.Properties("authOrig")
                NewListAuth.Add(sUser)
            Next
            Dim NewListUnauth As New List(Of String)
            For Each sUser As String In user.Properties("unauthOrig")
                NewListUnauth.Add(sUser)
            Next

            'Establecer cada lista de usuarios como perteniciente al grupo opuesto del que se ha obtenido
            user.Properties("authOrig").Value = NewListUnauth.ToArray
            user.Properties("unauthOrig").Value = NewListAuth.ToArray
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para cambiar el usuario del conjunto de los que no se pueden recibir mensajes al que solo se pueden recibir mensajes y viceversa " & e.Message)
            Catch e As FormatException
                MsgBox("El usuario que se quiere cambiar del conjunto de los que no se pueden recibir mensajes al que solo se pueden recibir mensajes y viceversa, no tiene el formato adecuado " & e.Message)
            Catch e As IndexOutOfRangeException
                MsgBox("El usuario no se puede cambiar del conjunto de los que no se pueden recibir mensajes al que solo se pueden recibir mensajes y viceversa, al encontrarse fuera del rango " & e.Message)
            End Try

        Catch ex As Exception
            MsgBox("Error al añadir el usuario con permisos de envio: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try

    End Sub

    Shared Sub RemoveOrigUnauthGroup(ByVal userDN As String, ByVal userDN2 As String)
        '==========================================================================
        ' Name:     RemoveOrigUnAuthGroup
        ' Purpose:  Eliminar un usuario de los que se no permite recibir mensajes 
        ' Input:    2 String: El nombre de login del grupo receptor 'userDN', 
        '           El nombre de login del grupo emisor 'userDN2'          
        ' Return:   None
        ' Calls:    GetUserDN de la clase userclass
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try

            'Busqueda de grupo receptor
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=group) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("unauthOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Crear una nueva lista con todos los usuarios no autorizados excepto userDN2
            Dim lNewList As New List(Of String)
            For Each sUser As String In user.Properties("unauthOrig")

                If Not UCase(sUser).Contains(UCase(UserClass.GetUserDN(userDN2))) Then
                    lNewList.Add(sUser)
                End If
            Next
            'Establecer la nueva lista como el conjunto de usuarios de los que no se permite recibir mensajes
            user.Properties("unauthOrig").Value = lNewList.ToArray
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para quitar el usuario al conjunto de los que no se pueden recibir mensajes " & e.Message)
            Catch e As FormatException
                MsgBox("El usuario que se quiere quitar al conjunto de los que no se pueden recibir mensajes, no tiene el formato adecuado " & e.Message)
            Catch e As IndexOutOfRangeException
                MsgBox("El usuario no se puede quitar al conjunto de los que no se pueden recibir mensajes, al encontrarse fuera del rango " & e.Message)
            End Try

        Catch ex As Exception
            MsgBox("Error al eliminar el usuario con permisos de envio a: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try

    End Sub

    Shared Sub ChangeOrigAuthGroup(ByVal userDN As String)
        '==========================================================================
        ' Name:     ChangeOrigAuthGroup
        ' Purpose:  Establecer el grupo de usuarios de los que se permite recibir mensajes
        '           como el grupo de usuarios de los que no se permite recibir mensajes y viceversa
        ' Input:    1 String: El nombre de login del grupo receptor 'userDN',          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Busqueda del grupo receptor
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=group) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("authOrig")
            oSearcher.PropertiesToLoad.Add("unauthOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Obtener las listas de usuarios permitidos y no permitidos
            Dim NewListAuth As New List(Of String)
            For Each sUser As String In user.Properties("authOrig")
                NewListAuth.Add(sUser)
            Next
            Dim NewListUnauth As New List(Of String)
            For Each sUser As String In user.Properties("unauthOrig")
                NewListUnauth.Add(sUser)
            Next
            'Establecer cada lista de usuarios como perteniciente al grupo opuesto del que se ha obtenido
            user.Properties("authOrig").Value = NewListUnauth.ToArray
            user.Properties("unauthOrig").Value = NewListAuth.ToArray
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para cambiar el usuario del conjunto de los que no se pueden recibir mensajes al que solo se pueden recibir mensajes y viceversa " & e.Message)
            Catch e As FormatException
                MsgBox("El usuario que se quiere cambiar del conjunto de los que no se pueden recibir mensajes al que solo se pueden recibir mensajes y viceversa, no tiene el formato adecuado " & e.Message)
            Catch e As IndexOutOfRangeException
                MsgBox("El usuario no se puede cambiar del conjunto de los que no se pueden recibir mensajes al que solo se pueden recibir mensajes y viceversa, al encontrarse fuera del rango " & e.Message)
            End Try

        Catch ex As Exception
            MsgBox("Error al añadir el usuario con permisos de envio: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try

    End Sub

    Shared Sub RemoveOrigAuthGroup(ByVal userDN As String, ByVal userDN2 As String)
        '==========================================================================
        ' Name:     RemoveOrigAuthGroup
        ' Purpose:  Eliminar un usuario de los que se permite recibir mensajes 
        ' Input:    2 String: El nombre de login del grupo receptor 'userDN', 
        '           El nombre de login del usuario emisor 'userDN2'          
        ' Return:   None
        ' Calls:    GetUserDN de la clase userclass
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'oRoot = New DirectoryEntry("LDAP://" & userDN)
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            'oSearcher.Filter = "(objectCategory=person)"
            oSearcher.Filter = "(&(objectClass=group) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("authOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Crear una nueva lista con todos los usuarios autorizados excepto userDN2
            Dim lNewList As New List(Of String)
            For Each sUser As String In user.Properties("authOrig")
                If Not sUser.Contains(UserClass.GetUserDN(userDN2)) Then
                    lNewList.Add(sUser)
                End If
            Next

            'Establecer la nueva lista como el conjunto de usuarios de los que se permite recibir mensajes
            user.Properties("authOrig").Value = lNewList.ToArray
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para quitar el usuario al conjunto de los que se pueden recibir mensajes " & e.Message)
            Catch e As FormatException
                MsgBox("El usuario que se quiere quitar al conjunto de los que se pueden recibir mensajes, no tiene el formato adecuado " & e.Message)
            Catch e As IndexOutOfRangeException
                MsgBox("El usuario no se puede quitar al conjunto de los que se pueden recibir mensajes, al encontrarse fuera del rango " & e.Message)
            End Try

        Catch ex As Exception
            MsgBox("Error al añadir el usuario con permisos de envio a: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try

    End Sub

    Shared Sub AddOrigUnauthGroup(ByVal userDN As String, ByVal userDN2 As String)
        '==========================================================================
        ' Name:     AddOrigUnauth
        ' Purpose:  Añadir un usuario de los que no se permite recibir mensajes
        ' Input:    3 String: El nombre de login del grupo receptor 'userDN', 
        '           El nombre de login del objeto emisor 'userDN2', El tipo de objeto emisor 'Tipo'          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim user2 As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Busqueda del grupo receptor
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=group) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("unauthOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Busqueda del objeto receptor
            oSearcher.Filter = "(&(sAMAccountName=" & userDN2 & "))"
            oSearcher.PropertiesToLoad.Add("distinguishedName")
            oResult = oSearcher.FindOne
            user2 = oResult.GetDirectoryEntry
            user2.Username = Settings.adminLogon
            user2.Password = Settings.adminPassword
            user2.AuthenticationType = AuthenticationTypes.Delegation

            'Obtener la lista de los usuarios de los que no está permitido receibri mensajes
            Dim lNewList As New List(Of String)
            For Each sAddress As String In user.Properties("unauthOrig")
                lNewList.Add(sAddress)
            Next

            'Añadir userDN2 a esa lista
            lNewList.Add(user2.Properties("distinguishedName").Value.ToString)
            user.Properties("unauthOrig").Value = lNewList.ToArray
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para añadir el usuario al conjunto de los que no se pueden recibir mensajes " & e.Message)
            Catch e As FormatException
                MsgBox("El usuario que se quiere añadir al conjunto de los que no se pueden recibir mensajes, no tiene el formato adecuado " & e.Message)
            Catch e As IndexOutOfRangeException
                MsgBox("El usuario no se puede añadir al conjunto de los que no se pueden recibir mensajes, al encontrarse fuera del rango " & e.Message)
            End Try

        Catch ex As Exception
            MsgBox("Error al añadir el usuario con permisos de envio a: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
    End Sub

    Shared Sub AddOrigAuthGroup(ByVal userDN As String, ByVal userDN2 As String)
        '==========================================================================
        ' Name:     AddOrigAuthGroup
        ' Purpose:  Añadir un usuario/grupo de los que se permite recibir mensajes
        ' Input:    3 String: El nombre de login del grupo receptor 'userDN', 
        '           El nombre de login del emisor 'userDN2', Tipo del objeto emisor 'Tipo'         
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim user2 As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Busqueda de userDN
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=group) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("authOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Busqueda de userDN2
            oSearcher.Filter = "(&(sAMAccountName=" & userDN2 & "))"
            oSearcher.PropertiesToLoad.Add("distinguishedName")
            oResult = oSearcher.FindOne
            user2 = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Obtanción de la lista de usuarios de los que userDN puede recibir mensajes
            Dim lNewList As New List(Of String)
            For Each sAddress As String In user.Properties("authOrig")
                lNewList.Add(sAddress)
            Next
            'Añadir userDN2 a esa lista
            lNewList.Add(user2.Properties("distinguishedName").Value.ToString)
            user.Properties("authOrig").Value = lNewList.ToArray
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para añadir el usuario al conjunto de los que se pueden recibir mensajes " & e.Message)
            Catch e As FormatException
                MsgBox("El usuario que se quiere añadir al conjunto de los que se pueden recibir mensajes, no tiene el formato adecuado " & e.Message)
            Catch e As IndexOutOfRangeException
                MsgBox("El usuario no se puede añadir al conjunto de los que se pueden recibir mensajes, al encontrarse fuera del rango " & e.Message)
            End Try

        Catch ex As Exception
            MsgBox("Error al añadir el usuario con permisos de envio a: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try

    End Sub

    Shared Function IsInOrigUnauthGroup(ByVal userDN As String, ByVal userDN2 As String) As Boolean
        '==========================================================================
        ' Name:     IsInOrigAuth
        ' Purpose:  Saber si un usuario/grupo forma parte del conjunto de los 
        '           que se permite recibir mensajes a otro grupo en concreto
        ' Input:    2 String: El nombre de login del grupo receptor 'userDN', El nombre de login del emisor 'userDN2'          
        ' Return:   1 Boolean
        ' Calls:    GetUserDN de la clase userclass
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Dim sal As Boolean = False
        Try
            'Busqueda del grupo receptor
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=group) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("unauthOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            If oResult Is Nothing Then
                sal = False
            Else
                'Obtener la lista del los que pueden enviar mensajes a userDN y 
                'comprobar si userDN2 es uno de ellos
                user = oResult.GetDirectoryEntry
                For Each sAddress As String In user.Properties("unauthOrig")
                    If UCase(sAddress).Contains(UCase(UserClass.GetUserDN(userDN2))) Then
                        sal = True
                    End If
                Next
            End If

        Catch ex As Exception
            MsgBox("Error al cambiar el usuario con permisos de envio a: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
        Return sal
    End Function

    Shared Function IsInOrigAuthGroup(ByVal userDN As String, ByVal userDN2 As String) As Boolean
        '==========================================================================
        ' Name:     IsInOrigAuth
        ' Purpose:  Saber si un usuario/grupo forma parte del conjunto de los 
        '           que no se permite recibir mensajes a otro grupo en concreto
        ' Input:    2 String: El nombre de login del grupo receptor 'userDN', El nombre de login del emisor 'userDN2'          
        ' Return:   1 Boolean
        ' Calls:    GetUserDN de la clase userclass
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Dim sal As Boolean = False
        Try
            'Busqueda del grupo receptor
            oRoot = New DirectoryEntry()
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Subtree
            oSearcher.Filter = "(&(objectClass=group) (sAMAccountName=" & userDN & "))"
            oSearcher.PropertiesToLoad.Add("authOrig")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            If oResult Is Nothing Then
                sal = False
            Else
                'Obtener la lista del los que pueden enviar mensajes a userDN y 
                'comprobar si userDN2 es uno de ellos
                user = oResult.GetDirectoryEntry
                For Each sAddress As String In user.Properties("authOrig")
                    If UCase(sAddress).Contains(UCase(UserClass.GetUserDN(userDN2))) Then
                        sal = True
                    End If
                Next
            End If

        Catch ex As Exception
            MsgBox("Error al añadir el usuario con permisos de envio a: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
        Return sal
    End Function

    '------------------------------------------------------------------------------------------------
    '--------------------------------------------------Opciones de envío-----------------------------
    Shared Sub GrantSendAs(ByVal userDN As String, ByVal userDN2 As String)
        '==========================================================================
        ' Name:     GrantSendAs
        ' Purpose:  Permitir a un usuario enviar mensajes adoptando la identidad de otro usuario
        ' Input:    2 String: La dirección del usuario que toma la identidad del otro'userDN',
        '           La dirección del usuario que cede su identidad 'userDN2'          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Obtener DirectoryEntry de userDN
            oRoot = New DirectoryEntry("LDAP://" & userDN)
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Base
            oSearcher.Filter = "(objectCategory=person)"
            oSearcher.PropertiesToLoad.Add("publicDelegates")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation
            Dim esta As Boolean = False

            'Obtener lista de los usuarios que puede suplantar userDN para enviar mensajes
            Dim lNewList As New List(Of String)
            For Each sAddress As String In user.Properties("publicDelegates")
                lNewList.Add(sAddress)
                If sAddress = userDN2 Then
                    esta = True
                End If
            Next
            If Not esta Then
                'Añadir userDN2 a la lista
                lNewList.Add(userDN2)
            End If
            user.Properties("publicDelegates").Value = lNewList.ToArray
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No se tiene permiso para añadir el usuario con permisos de enviar como él (suplantándole) " & e.ToString)
            Catch e As ArgumentNullException
                MsgBox("El usuario que se quiere añadir con permisos de enviar como él (suplantándole) no puede ser nulo " & e.ToString)
            Catch e As FormatException
                MsgBox("El usuario que se quiere añadir con permisos de enviar como él (suplantándole) no tiene un formato válido " & e.ToString)
            End Try

        Catch ex As Exception
            MsgBox("Error al añadir el usuario al grupo de los que es posible enviar como ellos(suplantarlos): " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try

    End Sub

    Shared Sub DenySendAs(ByVal userDN As String, ByVal lNewList As List(Of String))
        '==========================================================================
        ' Name:     GrantSendAs
        ' Purpose:  No permitir a un usuario enviar mensajes adoptando la identidad de otro usuario
        ' Input:    2 String: La dirección del usuario que toma la identidad del otro'userDN',
        '           La dirección del usuario que cede su identidad 'userDN2'          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Obtener DirectoryEntry de userDN
            oRoot = New DirectoryEntry("LDAP://" & userDN)
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Base
            oSearcher.Filter = "(objectCategory=person)"
            oSearcher.PropertiesToLoad.Add("publicDelegates")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation
            Dim lNewList2 As New List(Of String)
            Dim puede As Boolean
            For Each sUser As String In user.Properties("publicDelegates")
                puede = True
                For i = 0 To lNewList.Count - 1
                    Dim UsuDN2 As String = UserClass.GetUserPropertyGN(lNewList(i), "distinguishedName")
                    'Obtener lista de los usuarios que puede suplantar userDN para enviar mensajes sin tener en cuenta a userDN2 si está
                    If UCase(sUser) = UCase(UsuDN2) Then
                        puede = False
                    End If
                Next
                If puede Then
                    lNewList2.Add(sUser)
                End If
            Next
            user.Properties("publicDelegates").Value = vbNull
            'Establecer la nueva lista como la de usuarios que puede suplantar userDN a la hora de enviar mensajes
            user.Properties("publicDelegates").Value = lNewList2.ToArray
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No se tiene permiso para quitar el usuario con permisos de enviar como él (suplantándole) " & e.ToString)
            Catch e As ArgumentNullException
                MsgBox("El usuario que se quiere quitar con permisos de enviar como él (suplantándole) no puede ser nulo " & e.ToString)
            Catch e As FormatException
                MsgBox("El usuario que se quiere quitar con permisos de enviar como él (suplantándole) no tiene un formato válido " & e.ToString)
            End Try
        Catch ex As Exception
            MsgBox("Error al eliminar el usuario con permisos de enviar como: " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try

    End Sub

    Shared Sub SetForwardingAddress(ByVal userDN As String, ByVal userDN2 As String)
        '==========================================================================
        ' Name:     SetForwardingAddress
        ' Purpose:  Establecer el reenvio de los mensajes recibidos por userDN a userDN2
        ' Input:    2 String: La dirección del usuario receptor 'userDN',
        '           La dirección del usuario al que se reenvian los mensajes 'userDN2'          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Obtener DirectoryEntry de userDN
            oRoot = New DirectoryEntry("LDAP://" & userDN)
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Base
            oSearcher.Filter = "(objectCategory=person)"
            oSearcher.PropertiesToLoad.Add("altRecipient")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Si no hay un usuario asignado para que reciba los mensajes de userDN, asignar userDN2
            If userDN2 = "" Then
                user.Properties("altRecipient").Value = Nothing
            Else
                user.Properties("altRecipient").Value = userDN2
            End If
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permisos para modificar la redireccion de mensajes " & e.Message)
            Catch e As FormatException
                MsgBox("El formato de la nueva dirección a establecer para la redirección de mensajes, no es válida " & e.Message)
            End Try
        Catch ex As Exception
            MsgBox("Error al modificar redireccion de mensajes : " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
    End Sub

    Shared Sub SetReceptientLimits(ByVal userDN As String, ByVal size As Integer)
        '==========================================================================
        ' Name:     SetReceptientLimits
        ' Purpose:  Asignar el límite de destinatarios a los que puede realizar un envío userDN, 
        ' Input:    2 String: La dirección del usuario receptor 'userDN',
        '           El número a asignar 'size'          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Obtener el DirectryEntry de userDN
            oRoot = New DirectoryEntry("LDAP://" & userDN)
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Base
            oSearcher.Filter = "(objectCategory=person)"
            oSearcher.PropertiesToLoad.Add("msExchRecipLimit")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Asignar el número de destinatarios. Si el número a asignar es -1 se elimina el límite
            If size = -1 Then
                user.Properties("msExchRecipLimit").Value = Nothing
            Else
                user.Properties("msExchRecipLimit").Value = size
            End If
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("No tiene permiso para establecer el número límite de receptores de los mensajes " & e.Message)
            Catch e As FormatException
                MsgBox("El valor que se quiere asignar al número límite de receptores de los mensajes no tiene el formato adecuado " & e.Message)
            Catch e As ArithmeticException
                MsgBox("El valor que se quiere asignar al número límite de receptores de los mensajes no es válido " & e.Message)
            End Try
        Catch ex As Exception
            MsgBox("Error al modificar el numero de destinatarios : " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
    End Sub

    '----------------------------------------------------------------------------------------------------------------------
    '-----------------------------------------------Límites de almacenamiento-----------------------------------------------
    Shared Sub SetUseMDBDefaults(ByVal userDN As String, ByVal useDefaults As Boolean)
        '==========================================================================
        ' Name:     SetUseMDBDefaults
        ' Purpose:  Asignar los límites de almacenamiento por defecto al buzón de userDN
        ' Input:    1 String: La dirección del usuario receptor 'userDN',
        '           1 Boolean: True o false según se quiera establecer los límites por defecto o no          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Obtener el DirectoryEntry de userDN
            oRoot = New DirectoryEntry("LDAP://" & userDN)
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Base
            oSearcher.Filter = "(objectCategory=person)"
            oSearcher.PropertiesToLoad.Add("mDBUseDefaults")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Estableces si se usan los límites por defecto o no
            user.Properties("mDBUseDefaults").Value = useDefaults
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error, no se tienen permisos para establecer los límites por defecto del buzón " & e.Message)
            Catch e As FormatException
                MsgBox("Error, el formato de los datos es incorrecto para establecer los límites por defecto del buzón " & e.Message)
            End Try
        Catch ex As Exception
            MsgBox("Error al establecer el valor de almacenamiento por defecto : " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
    End Sub

    Shared Sub SetWarningLimit(ByVal userDN As String, ByVal warningLimit As Integer)
        '==========================================================================
        ' Name:     SetWarningLimit
        ' Purpose:  Asignar el límite de almacenamiento del buzón de userDN, el cual, una vez superado, saltará una señal de alarma
        ' Input:    1 String: La dirección del usuario receptor 'userDN',
        '           1 Integer: límite de MB antes de que salte la alarma 'warningLimit'          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Obtener DirectoryEntry de userDN
            oRoot = New DirectoryEntry("LDAP://" & userDN)
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Base
            oSearcher.Filter = "(objectCategory=person)"
            oSearcher.PropertiesToLoad.Add("mDBStorageQuota")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Asignar el límite a userDn
            user.Properties("mDBStorageQuota").Value = warningLimit
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error, no se tienen permisos para establecer el valor de almacenamiento del buzón que una vez sobrepasado hace saltar un aviso " & e.Message)
            Catch e As FormatException
                MsgBox("Error, el formato de los datos es incorrecto para establecer el valor de almacenamiento del buzón que una vez sobrepasado hace saltar un aviso " & e.Message)
            End Try
        Catch ex As Exception
            MsgBox("Error al establecer el valor de almacenamiento que una vez sobrepasado hace saltar un aviso : " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
    End Sub

    Shared Sub SetDeniedSendLimit(ByVal userDN As String, ByVal deniedSendLimit As Integer)
        '==========================================================================
        ' Name:     SetDeniedSendLimit
        ' Purpose:  Asignar el límite de almacenamiento del buzón de userDN, el cual, una vez superado,
        '           no permitirá enviar mas mensajes
        ' Input:    1 String: La dirección del usuario receptor 'userDN',
        '           1 Integer: límite de MB antes de que prohiba el envío 'deniedSendLimit'          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Obtener el DirectoryEntry de userDN
            oRoot = New DirectoryEntry("LDAP://" & userDN)
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Base
            oSearcher.Filter = "(objectCategory=person)"
            oSearcher.PropertiesToLoad.Add("mDBOverQuotaLimit")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Asignar el límite a userDN
            user.Properties("mDBOverQuotaLimit").Value = deniedSendLimit
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error, no se tienen permisos para establecer el valor de almacenamiento máximo, en el envío, del buzón " & e.Message)
            Catch e As FormatException
                MsgBox("Error, el formato de los datos es incorrecto para establecer el valor de almacenamiento máximo, en el envío, del buzón " & e.Message)
            End Try
        Catch ex As Exception
            MsgBox("Error al establecer el valor de almacenamiento máximo, en el envío, del buzón : " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
    End Sub

    Shared Sub SetDeniedSendAndReceiveLimit(ByVal userDN As String, ByVal deniedSendAndReceiveLimit As Integer)
        '==========================================================================
        ' Name:     SetDeniedSendAndReceiveLimit
        ' Purpose:  Asignar el límite de almacenamiento del buzón de userDN, el cual, una vez superado,
        '           no permitirá enviar ni recibir mas mensajes
        ' Input:    1 String: La dirección del usuario receptor 'userDN',
        '           1 Integer: límite de MB antes de que prohiba el envío y la recepción 'deniedSendLimit'          
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Dim user As New DirectoryEntry
        Dim oSearcher As DirectorySearcher = Nothing
        Dim oRoot As DirectoryEntry = Nothing
        Dim oResult As SearchResult
        Try
            'Obtener el DirectoryEntry de userDN
            oRoot = New DirectoryEntry("LDAP://" & userDN)
            oSearcher = New DirectorySearcher(oRoot)
            oSearcher.SearchScope = SearchScope.Base
            oSearcher.Filter = "(objectCategory=person)"
            oSearcher.PropertiesToLoad.Add("mDBOverHardQuotaLimit")
            oResult = oSearcher.FindOne
            user = oResult.GetDirectoryEntry
            user.Username = Settings.adminLogon
            user.Password = Settings.adminPassword
            user.AuthenticationType = AuthenticationTypes.Delegation

            'Asignar el límite a userDN
            user.Properties("mDBOverHardQuotaLimit").Value = deniedSendAndReceiveLimit
            Try
                user.CommitChanges()
            Catch e As AccessViolationException
                MsgBox("Error, no se tienen permisos para establecer el valor de almacenamiento máximo, en el envío y la recepción, del buzón " & e.Message)
            Catch e As FormatException
                MsgBox("Error, el formato de los datos es incorrecto para establecer el valor de almacenamiento máximo, en el envío y la recepción, del buzón " & e.Message)
            End Try
        Catch ex As Exception
            MsgBox("Error al establecer el valor de almacenamiento máximo, en el envío y la recepción, del buzón : " & ex.ToString)
        Finally
            user.Dispose()
            oRoot.Dispose()
            oSearcher.Dispose()
            oResult = Nothing
        End Try
    End Sub

    '-------------------------------------------------------------------------------------------------------------------------
    '------------------------------------------------Permisos-----------------------------------------------------------------

    Shared Function GetDaclNames(ByVal User As String) As System.Collections.Generic.IList(Of String)
        '==========================================================================
        ' Name:     GetDaclNames
        ' Purpose:  Obtener la lista de usuarios/Grupos que poseen permisos sobre el buzón del usuario
        ' Input:    1 String: El nombre de Login del usuario 'user',
        ' Return:   Lista de strings con los nombres de los que poseen permisos sobre el buzón
        ' Calls:    None
        '==========================================================================

        'Obtener DirectoryEntry del usuario dueño del buzón
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & User & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim objUser As Object

        Dim oSecurityDescriptor
        Dim dacl
        Dim ace
        Dim lNewList As New List(Of String)

        'Obtener el objeto usuario
        objUser = GetObject(results(0).Path)
        Try
            ' Obtener el security descriptor del buzón(SD).
            oSecurityDescriptor = objUser.MailboxRights
        Catch e As FormatException
            MsgBox("Error de formato del dato a obtener los objetos con permisos sobre " & User & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al obtener los objetos con permisos sobre, No tienes permisos para acceder a este dato " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al obtener los objetos con permisos sobre,Se ha intentado obtener un dato con un índice fuera de rango en el large integer " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al obtener los objetos con permisos sobre,Se está intentando obtener un dato involucrado en una operación cancelada en el large integer " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al obtener los objetos con permisos sobre,Se está intentando obtener un dato involucrado en una operación abortada en el large integer " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al obtener los objetos con permisos sobre,La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al acceder a al ubicación física del dato en el large integer " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al obtener los objetos con permisos sobre,La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al obtener los objetos con permisos sobre, al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
        ' Obtener el Discretionary Access Control List (DACL) mediante la interfaz IADsSecurityDescriptor.
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        'Recorrer los permisos para añadir a los usuarios/grupos que los poseen a la lista
        For Each ace In dacl
            Dim esta = False
            Dim partes() As String = ace.trustee.split("\")
            For i = 0 To lNewList.Count - 1
                If partes.Count > 1 Then
                    If partes(1) = lNewList(i) Then
                        esta = True
                        Exit For
                    End If
                Else
                    If partes(0) = lNewList(i) Then
                        esta = True
                        Exit For
                    End If
                End If
            Next
            If Not esta Then
                If partes.Count > 1 Then
                    lNewList.Add(partes(1))
                Else
                    lNewList.Add(partes(0))
                End If
            End If
        Next

        Return lNewList
    End Function

    Shared Function GetDaclNamesNT(ByVal User As String) As System.Collections.Generic.IList(Of String)
        '==========================================================================
        ' Name:     GetDaclNamesNT
        ' Purpose:  Obtener la lista de usuarios/Grupos que poseen permisos sobre otro objeto 
        ' Input:    1 String: El nombre de Login del objeto 'user',
        ' Return:   Lista de strings con los nombres de los que poseen permisos sobre el objeto
        ' Calls:    None
        '==========================================================================

        'Obtener DirectoryEntry del objeto
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(sAMAccountName=" & User & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim obj As Object

        Dim oSecurityDescriptor
        Dim dacl
        Dim ace
        Dim lNewList As New List(Of String)

        'Obtener el objeto usuario
        obj = GetObject(results(0).Path)
        Try
            ' Obtener el security descriptor del objeto(SD).
            oSecurityDescriptor = obj.Get("ntSecurityDescriptor")
        Catch e As FormatException
            MsgBox("Error de formato del dato a obtener los objetos con permisos sobre " & User & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al obtener los objetos con permisos sobre, No tienes permisos para acceder a este dato " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al obtener los objetos con permisos sobre,Se ha intentado obtener un dato con un índice fuera de rango en el large integer " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al obtener los objetos con permisos sobre,Se está intentando obtener un dato involucrado en una operación cancelada en el large integer " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al obtener los objetos con permisos sobre,Se está intentando obtener un dato involucrado en una operación abortada en el large integer " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al obtener los objetos con permisos sobre,La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al acceder a al ubicación física del dato en el large integer " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al obtener los objetos con permisos sobre,La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al obtener los objetos con permisos sobre, al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
        ' Obtener el Discretionary Access Control List (DACL) mediante la interfaz IADsSecurityDescriptor.
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        'Recorrer los permisos para añadir a los usuarios/grupos que los poseen a la lista
        For Each ace In dacl
            Dim esta = False
            'MsgBox(ace.trustee.ToString)
            Dim partes() As String = ace.trustee.split("\")
            For i = 0 To lNewList.Count - 1
                If partes.Count > 1 Then
                    If partes(1) = lNewList(i) Then
                        esta = True
                        Exit For
                    End If
                Else
                    If partes(0) = lNewList(i) Then
                        esta = True
                        Exit For
                    End If
                End If
            Next
            If Not esta Then
                If partes.Count > 1 Then
                    lNewList.Add(partes(1))
                Else
                    lNewList.Add(partes(0))
                End If

            End If
        Next

        Return lNewList
    End Function

    Shared Sub RemoveDaclNames(ByVal User As String)
        '==========================================================================
        ' Name:     RemoveDaclNames
        ' Purpose:  Eliminar los permisos que posea un objeto sobre su buzón
        ' Input:    1 String: El nombre de Login del objeto 'user',
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener DirectoryEntry del objeto
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & User & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        Dim oSecurityDescriptor As SecurityDescriptor
        Dim dacl As AccessControlList
        Dim ace
        Dim lNewList As New List(Of String)

        'Dar permisos de administrador de dominio al objeto para darle permisos de escritura
        Dim deMail As New DirectoryEntry(results(0).Path)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener el buzón mediante el objeto usuario y la interfaz IExchangeMailbox
        Dim mailboxStore As IExchangeMailbox
        mailboxStore = CType(deMail.NativeObject, IExchangeMailbox)

        'Recorrer los permisos del buzón y eliminar los que posea el propio objeto
        oSecurityDescriptor = mailboxStore.MailboxRights
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        For Each ace In dacl
            If Not ace.trustee.contains("SELF") Then
                dacl.RemoveAce(ace)
            End If
        Next

        oSecurityDescriptor.DiscretionaryAcl = dacl
        mailboxStore.MailboxRights = oSecurityDescriptor

        Try
            deMail.CommitChanges()
        Catch e As FormatException
            MsgBox("Error de formato al eliminar los permisos sobre " & User & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al eliminar los permisos, No tienes permisos para acceder a este dato " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al eliminar los permisos,Se ha intentado obtener un dato con un índice fuera de rango en el large integer " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al eliminar los permisos,Se está intentando obtener un dato involucrado en una operación cancelada en el large integer " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al eliminar los permisos,Se está intentando obtener un dato involucrado en una operación abortada en el large integer " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al eliminar los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al eliminar los permisos,  acceder a al ubicación física del dato en el large integer " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al eliminar los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al eliminar los permisos, al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
    End Sub

    Shared Sub GetGuarradita(ByVal User As String, ByVal lgUser As String)
        '==========================================================================
        ' Name:     GetAcePermission
        ' Purpose:  Obtener los permisos que tendrá un objeto sobre el buzón de otro
        ' Input:    3 String: El nombre de Login del usuario a pregunar que permiso posee 'user',
        '           El nombre de login del usuario dueño del buzón 'lgUser', El nombre del permiso 'Permission'
        ' Return:   Boolean array: Un array de dos booleanos, el primero marca si el objeto tiene
        '           el permiso permitido y el segundo indica si lo tiene negado
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(sAMAccountName=" & lgUser & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim objUser As Object
        Dim resul(1) As Boolean
        resul(0) = False
        resul(1) = False
        Dim obj As Object
        Dim oSecurityDescriptor
        Dim dacl
        Dim ace
        Dim lNewList As New List(Of String)
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1

        'Obtener el security Descriptor del buzón
        obj = GetObject(results(0).Path)
        oSecurityDescriptor = obj.Get("ntSecurityDescriptor")

        'Recorrer los permisos. Si está asignado Permission a user, se marca true el primer boolean 
        'del array de salida, si está negado se marca a true el segundo.
        dacl = oSecurityDescriptor.DiscretionaryAcl

        'Recorrer los permisos. Si está asignado Permission a user, se marca true el primer boolean 
        'del array de salida, si está negado se marca a true el segundo.
        For Each ace In dacl
            'If ace.trustee.contains(User) Then
            If ace.trustee.contains("Account") Then
                MsgBox(ace.trustee & " type: " & ace.AceType & " objectType: " & ace.objectType & "{4C164200-20C0-11D0-A768-00AA006E0529}" & " mask: " & ace.AccessMask & " ESTE:aceflag:" & ace.AceFlags & " flag:" & ace.Flags & " herencia:" & ace.InheritedObjectType)
            End If

            'End If

        Next

    End Sub

    Shared Function GetAcePermission(ByVal User As String, ByVal lgUser As String, ByVal Permission As String) As Boolean()
        '==========================================================================
        ' Name:     GetAcePermission
        ' Purpose:  Obtener los permisos que tendrá un objeto sobre el buzón de otro
        ' Input:    3 String: El nombre de Login del usuario a pregunar que permiso posee 'user',
        '           El nombre de login del usuario dueño del buzón 'lgUser', El nombre del permiso 'Permission'
        ' Return:   Boolean array: Un array de dos booleanos, el primero marca si el objeto tiene
        '           el permiso permitido y el segundo indica si lo tiene negado
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & lgUser & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim objUser As Object
        Dim resul(3) As Boolean
        resul(0) = False
        resul(1) = False
        resul(2) = False
        resul(3) = False
        Dim oSecurityDescriptor
        Dim dacl
        Dim ace
        Dim lNewList As New List(Of String)
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1

        'Mascaras de los diferentes tipos de permiso
        'Const RIGHT_DS_DELETE = 65536
        'Const RIGHT_DS_READ = 131072
        'Const RIGHT_DS_CHANGE = 262144
        'Const RIGHT_DS_TAKE_OWNERSHIP = 524288
        'Const RIGHT_DS_MAILBOX_OWNER = 1
        'Const RIGHT_DS_SEND_AS = 2
        Const RIGHT_DS_DELETE = &H10000
        Const RIGHT_DS_READ = &H20000
        Const RIGHT_DS_CHANGE = &H40000
        Const RIGHT_DS_TAKE_OWNERSHIP = &H80000
        Const RIGHT_DS_MAILBOX_OWNER = &H1
        Const RIGHT_DS_SEND_AS = &H2
        Const RIGHT_DS_PRIMARY_OWNER = &H4
        Dim opcion

        'Obtener la mascara correspondiente a Permission
        If Permission.Contains("Borrado de la memoria del buzón") Then
            opcion = RIGHT_DS_DELETE
        ElseIf Permission = "Permisos de lectura" Then
            opcion = RIGHT_DS_READ
        ElseIf Permission = "Permisos de modificación" Then
            opcion = RIGHT_DS_CHANGE
        ElseIf Permission = "Tomar posesión" Then
            opcion = RIGHT_DS_TAKE_OWNERSHIP
        ElseIf Permission = "Acceso total al buzón" Then
            opcion = RIGHT_DS_MAILBOX_OWNER
        ElseIf Permission = "Cuenta externa asociada" Then
            opcion = RIGHT_DS_SEND_AS
        End If

        'Obtener el security Descriptor del buzón
        objUser = GetObject(results(0).Path)
        Try
            oSecurityDescriptor = objUser.MailboxRights
        Catch e As FormatException
            MsgBox("Error de formato al obtener los permisos sobre " & User & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al obtener los permisos, No tienes permisos para acceder a este dato " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al obtener los permisos,Se ha intentado obtener un dato con un índice fuera de rango en el large integer " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al obtener los permisos,Se está intentando obtener un dato involucrado en una operación cancelada en el large integer " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al obtener los permisos,Se está intentando obtener un dato involucrado en una operación abortada en el large integer " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al obtener los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al obtener los permisos,  acceder a al ubicación física del dato en el large integer " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al obtener los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al obtener los permisos, al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
        'Obtener la lista de permisos del buzón (dacl)
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        Dim trustee As String = GetTrustee(User)
        'Dim ACE_Header As ACEHeader
        'Recorrer los permisos. Si está asignado Permission a user, se marca true el primer boolean 
        'del array de salida, si está negado se marca a true el segundo.
        For Each ace In dacl
            If Not ace.AceFlags = 26 Then
                If ace.trustee = trustee Then
                    'MsgBox(ace.AceFlags & " afl " & ace.Flags & " fl " & ace.trustee & " mask:" & ace.accessMask)
                    'ACE_Header = Marshal.PtrToStructure(ace, GetType(ACEHeader))

                    If (ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED) Then
                        If (ace.AccessMask And opcion) Then
                            resul(0) = True
                            If ace.AceFlags = 18 Then
                                resul(2) = True
                            End If
                            'Exit For
                        End If
                    ElseIf (ace.AceType = ADS_ACETYPE_ACCESS_DENIED) Then
                        If (ace.AccessMask And opcion) Then
                            resul(1) = True
                            If ace.AceFlags = 18 Then
                                resul(3) = True
                            End If
                            'Exit For
                        End If
                    ElseIf (ace.AceType = 5) Then
                        If (ace.AccessMask And opcion) Then
                            resul(0) = True
                            If ace.AceFlags = 18 Then
                                resul(2) = True
                            End If
                            'Exit For
                        End If
                    ElseIf (ace.AceType = 6) Then
                        If (ace.AccessMask And opcion) Then
                            resul(1) = True
                            If ace.AceFlags = 18 Then
                                resul(3) = True
                            End If
                            'Exit For
                        End If

                    End If
                End If
            End If

        Next
        Return resul
    End Function

    Shared Function GetAcePermissionNT(ByVal User As String, ByVal lgUser As String, ByVal Permission As String) As Boolean()
        '==========================================================================
        ' Name:     GetAcePermissionNT
        ' Purpose:  Obtener los permisos que tendrá un objeto sobre un grupo
        ' Input:    3 String: El nombre de Login del objeto a pregunar que permiso posee 'user',
        '           El nombre de login del grupo 'lgUser', El nombre del permiso 'Permission'
        ' Return:   Boolean array: Un array de dos booleanos, el primero marca si el objeto tiene
        '           el permiso permitido y el segundo indica si lo tiene negado
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del grupo
        'Dim de As DirectoryEntry = New DirectoryEntry()
        'Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        'deSearch.Filter = "(&(sAMAccountName=" & lgUser & "))"
        'deSearch.SearchScope = SearchScope.Subtree
        'Dim results As SearchResultCollection = deSearch.FindAll()
        Dim obj As Object
        Dim resul(3) As Boolean
        resul(0) = False
        resul(1) = False
        resul(2) = False
        resul(3) = False

        Dim oSecurityDescriptor
        Dim dacl
        Dim ace
        Dim lNewList As New List(Of String)
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1

        'Mascaras de los diferentes tipos de permiso
        Const ADS_ACETYPE_SEND_TO = "{AB721A55-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_SEND_AS = "{AB721A54-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_PHONE = "{E45795B2-9455-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_SELF = "{BF9679C0-0DE6-11D0-A285-00AA003049E2}"
        Const ADS_RIGHT_GENERIC_READ = &H80000000
        Const ADS_RIGHT_GENERIC_WRITE = &H40000000
        Const ADS_RIGHT_DS_CREATE_CHILD = &H1
        Const ADS_RIGHT_DS_DELETE_CHILD = &H2
        Const ADS_RIGHT_DS_SELF = &H8

        Dim ConTipo As String = "vacio"
        Dim opcion

        'Obtener la mascara correspondiente a Permission
        If Permission.Contains("Control total") Then
            opcion = 983551
            'opcion = -1
        ElseIf Permission = "Lectura" Then
            opcion = 131092
        ElseIf Permission = "Escritura" Then
            opcion = 40
        ElseIf Permission = "Crear todos los objetos hijo" Then
            opcion = 1
        ElseIf Permission = "Eliminar todos los objetos hijo" Then
            opcion = &H2
        ElseIf Permission = "Añadirse/Eliminarse a sí mismo como miembro" Then
            opcion = &H8
            ConTipo = ADS_ACETYPE_SELF
        ElseIf Permission = "Enviar como" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_SEND_AS
        ElseIf Permission = "Enviar a" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_SEND_TO
        ElseIf Permission = "Leer opciones de teléfono y correo" Then
            opcion = &H10
            ConTipo = ADS_ACETYPE_PHONE
        ElseIf Permission = "Escribir opciones de teléfono y correo" Then
            opcion = &H20
            ConTipo = ADS_ACETYPE_PHONE
        End If

        'Obtener el security Descriptor del grupo
        'obj = GetObject(results(0).Path)
        Try
            obj = GetObject("LDAP://" & Settings.ldapServerName & "/" & lgUser)
            oSecurityDescriptor = obj.Get("ntSecurityDescriptor")
        Catch e As FormatException
            MsgBox("Error de formato al obtener los permisos sobre " & User & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al obtener los permisos, No tienes permisos para acceder a este dato " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al obtener los permisos,Se ha intentado obtener un dato con un índice fuera de rango en el large integer " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al obtener los permisos,Se está intentando obtener un dato involucrado en una operación cancelada en el large integer " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al obtener los permisos,Se está intentando obtener un dato involucrado en una operación abortada en el large integer " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al obtener los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al obtener los permisos,  acceder a al ubicación física del dato en el large integer " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al obtener los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al obtener los permisos, al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
        'Recorrer los permisos. Si está asignado Permission a user, se marca true el primer boolean 
        'del array de salida, si está negado se marca a true el segundo.
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        Dim trustee As String = GetTrustee(User)
        For Each ace In dacl
            If Not ace.AceFlags = 26 Then
                If ace.trustee = trustee Then '"\" & User) Then 'Or ace.trustee = "Everyone" Then
                    'If Permission.Contains("Control total") Then
                    If ace.AccessMask = 983551 Then
                        If (ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED) Then
                            resul(0) = True
                            If ace.AceFlags = 18 Then
                                resul(2) = True
                            End If
                            'Exit For
                        ElseIf (ace.AceType = ADS_ACETYPE_ACCESS_DENIED) Then
                            resul(1) = True
                            If ace.AceFlags = 18 Then
                                resul(3) = True
                            End If
                            'Exit For
                        End If
                        'End If
                    Else
                        If Not ace.AccessMask = 4 Then
                            If ace.AccessMask And opcion Then
                                If ConTipo = "vacio" Then
                                    If Not opcion = 983551 Then
                                        If (ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED) Then
                                            resul(0) = True
                                            If ace.AceFlags = 18 Then
                                                resul(2) = True
                                            End If
                                            'Exit For
                                        ElseIf (ace.AceType = ADS_ACETYPE_ACCESS_DENIED) Then
                                            resul(1) = True
                                            If ace.AceFlags = 18 Then
                                                resul(3) = True
                                            End If
                                            'Exit For
                                        End If
                                    End If
                                Else

                                    If (ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED) Then
                                        resul(0) = True
                                        If ace.AceFlags = 18 Then
                                            resul(2) = True
                                        End If
                                        'Exit For
                                    ElseIf (ace.AceType = ADS_ACETYPE_ACCESS_DENIED) Then
                                        resul(1) = True
                                        If ace.AceFlags = 18 Then
                                            resul(3) = True
                                        End If
                                        'Exit For
                                    ElseIf (ace.AceType = 5 And ace.objectType = ConTipo) Then
                                        resul(0) = True
                                        If ace.AceFlags = 18 Then
                                            resul(2) = True
                                        End If
                                        'Exit For
                                    ElseIf (ace.AceType = 6 And ace.objectType = ConTipo) Then
                                        resul(1) = True
                                        If ace.AceFlags = 18 Then
                                            resul(3) = True
                                        End If
                                        'Exit For
                                    End If

                                End If
                            End If
                        End If

                    End If
                End If
            End If

        Next

        Return resul
    End Function

    Shared Function GetAcePermissionUserNT(ByVal User As String, ByVal lgUser As String, ByVal Permission As String) As Boolean()
        '==========================================================================
        ' Name:     GetAcePermissionUserNT
        ' Purpose:  Obtener los permisos que tendrá un objeto sobre un usuario
        ' Input:    3 String: El nombre de Login del objeto a pregunar que permiso posee 'user',
        '           El nombre de login del usuario 'lgUser', El nombre del permiso 'Permission'
        ' Return:   Boolean array: Un array de dos booleanos, el primero marca si el objeto tiene
        '           el permiso permitido y el segundo indica si lo tiene negado
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        'Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        'deSearch.Filter = "(&(sAMAccountName=" & lgUser & "))"
        'deSearch.SearchScope = SearchScope.Subtree
        'Dim results As SearchResultCollection = deSearch.FindAll()
        Dim obj As Object
        Dim resul(3) As Boolean
        resul(0) = False
        resul(1) = False
        resul(2) = False
        resul(3) = False

        Dim oSecurityDescriptor
        Dim dacl
        Dim ace
        Dim lNewList As New List(Of String)
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1

        'Mascaras de los diferentes tipos de permiso
        Const ADS_ACETYPE_SEND_TO = "{AB721A55-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_SEND_AS = "{AB721A54-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_PHONE = "{E45795B2-9455-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_SELF = "{BF9679C0-0DE6-11D0-A285-00AA003049E2}"
        Const ADS_ACETYPE_AUTHENTICATE = "{68B1D179-0D15-4D4F-AB71-46152E79A7BC}"
        Const ADS_ACETYPE_CHANGE_PASS = "{AB721A53-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_RECIEVE_AS = "{AB721A56-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_RESET_PASS = "{00299570-246D-11D0-A768-00AA006E0529}"
        Const ADS_ACETYPE_ACC_REST = "{4C164200-20C0-11D0-A768-00AA006E0529}"
        Const ADS_ACETYPE_GEN_INFO = "{59BA2F42-79A2-11D0-9020-00C04FC2D3CF}"
        Const ADS_ACETYPE_GROUP_MEMBERSHIP = "{BC0AC240-79A9-11D0-9020-00C04FC2D4CF}"
        Const ADS_ACETYPE_LOGON_INFO = "{5F202010-79A5-11D0-9020-00C04FC2D4CF}"
        Const ADS_ACETYPE_PERSONAL_INFO = "{77B5B886-944A-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_PUBLIC_INFO = "{E48D0154-BCF8-11D1-8702-00C04FB96050}"
        Const ADS_ACETYPE_REMOTE_ACCESS = "{037088F8-0AE1-11D2-B422-00A0C968F939}"
        Const ADS_ACETYPE_WEB_INFO = "{E45795B3-9455-11D1-AEBD-0000F80367C1}"
        Const ADS_RIGHT_GENERIC_READ = &H80000000
        Const ADS_RIGHT_GENERIC_WRITE = &H40000000
        Const ADS_RIGHT_DS_CREATE_CHILD = &H1
        Const ADS_RIGHT_DS_DELETE_CHILD = &H2
        Const ADS_RIGHT_DS_SELF = &H8

        Dim ConTipo As String = "vacio"
        Dim opcion

        'Obtener la mascara correspondiente a Permission
        If Permission.Contains("Control total") Then
            opcion = 983551
        ElseIf Permission = "Lectura" Then
            opcion = 131092
        ElseIf Permission = "Escritura" Then
            opcion = 40
        ElseIf Permission = "Crear todos los objetos hijo" Then
            opcion = 1
        ElseIf Permission = "Eliminar todos los objetos hijo" Then
            opcion = &H2
        ElseIf Permission = "Permiso de autenticarse" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_AUTHENTICATE
        ElseIf Permission = "cambio Password" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_CHANGE_PASS
        ElseIf Permission = "Recibir como" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_RECIEVE_AS
        ElseIf Permission = "Reset password" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_RESET_PASS
        ElseIf Permission = "Enviar como" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_SEND_AS
        ElseIf Permission = "Lectura de restricciones de la cuenta" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_ACC_REST
        ElseIf Permission = "Escritura de restricciones de la cuenta" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_ACC_REST
        ElseIf Permission = "Lectura de información general" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_GEN_INFO
        ElseIf Permission = "Escritura de información general" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_GEN_INFO
        ElseIf Permission = "Lectura de miembros de grupo" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_GROUP_MEMBERSHIP
        ElseIf Permission = "Escritura de miembros de grupo" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_GROUP_MEMBERSHIP
        ElseIf Permission = "Lectura de información  de Logon" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_LOGON_INFO
        ElseIf Permission = "Escritura de información  de Logon" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_LOGON_INFO
        ElseIf Permission = "Lectura de información  personal" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_PERSONAL_INFO
        ElseIf Permission = "Escritura de información  personal" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_PERSONAL_INFO
        ElseIf Permission = "Lectura de opciones de teléfono y correo" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_PHONE
        ElseIf Permission = "Escritura de opciones de teléfono y correo" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_PHONE
        ElseIf Permission = "Lectura de información pública" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_PUBLIC_INFO
        ElseIf Permission = "Escritura de información pública" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_PUBLIC_INFO
        ElseIf Permission = "Lectura de información de acceso remoto" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_REMOTE_ACCESS
        ElseIf Permission = "Escritura de información de acceso remoto" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_REMOTE_ACCESS
        ElseIf Permission = "Lectura de información Web" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_WEB_INFO
        ElseIf Permission = "Escritura de información Web" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_WEB_INFO
        End If

        'Obtener el security Descriptor del usuario
        obj = GetObject("LDAP://" & Settings.ldapServerName & "/" & lgUser)
        Try
            oSecurityDescriptor = obj.Get("ntSecurityDescriptor")
        Catch e As FormatException
            MsgBox("Error de formato al obtener los permisos sobre " & User & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al obtener los permisos, No tienes permisos para acceder a este dato " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al obtener los permisos,Se ha intentado obtener un dato con un índice fuera de rango en el large integer " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al obtener los permisos,Se está intentando obtener un dato involucrado en una operación cancelada en el large integer " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al obtener los permisos,Se está intentando obtener un dato involucrado en una operación abortada en el large integer " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al obtener los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al obtener los permisos,  acceder a al ubicación física del dato en el large integer " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al obtener los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al obtener los permisos, al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
        'Recorrer los permisos. Si está asignado Permission a user, se marca true el primer boolean 
        'del array de salida, si está negado se marca a true el segundo.
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        Dim trustee As String = GetTrustee(User)
        For Each ace In dacl
            If Not ace.AceFlags = 26 Then
                If ace.trustee = trustee Then '"\" & User) Then 'Or ace.trustee = "Everyone" Then
                    'If Permission.Contains("Control total") Then
                    If ace.AccessMask = 983551 Then
                        If (ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED) Then
                            resul(0) = True
                            If ace.AceFlags = 18 Then
                                resul(2) = True
                            End If
                            'Exit For
                        ElseIf (ace.AceType = ADS_ACETYPE_ACCESS_DENIED) Then
                            resul(1) = True
                            If ace.AceFlags = 18 Then
                                resul(3) = True
                            End If
                            'Exit For
                        End If
                        'End If
                    Else
                        If Not ace.AccessMask = 4 Then
                            If ace.AccessMask And opcion Then
                                If ConTipo = "vacio" Then
                                    If Not opcion = 983551 Then
                                        If (ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED) Then
                                            resul(0) = True
                                            If ace.AceFlags = 18 Then
                                                resul(2) = True
                                            End If
                                            'Exit For
                                        ElseIf (ace.AceType = ADS_ACETYPE_ACCESS_DENIED) Then
                                            resul(1) = True
                                            If ace.AceFlags = 18 Then
                                                resul(3) = True
                                            End If
                                            'Exit For
                                        End If
                                    End If
                                Else

                                    If (ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED) Then
                                        resul(0) = True
                                        If ace.AceFlags = 18 Then
                                            resul(2) = True
                                        End If
                                        'Exit For
                                    ElseIf (ace.AceType = ADS_ACETYPE_ACCESS_DENIED) Then
                                        resul(1) = True
                                        If ace.AceFlags = 18 Then
                                            resul(3) = True
                                        End If
                                        'Exit For
                                    ElseIf (ace.AceType = 5 And ace.objectType = ConTipo) Then
                                        resul(0) = True
                                        If ace.AceFlags = 18 Then
                                            resul(2) = True
                                        End If
                                        'Exit For
                                    ElseIf (ace.AceType = 6 And ace.objectType = ConTipo) Then
                                        resul(1) = True
                                        If ace.AceFlags = 18 Then
                                            resul(3) = True
                                        End If
                                        'Exit For
                                    End If

                                End If
                            End If
                        End If

                    End If
                End If
            End If

        Next

        Return resul
    End Function

    Shared Function GetAcePermissionComputerNT(ByVal User As String, ByVal lgUser As String, ByVal Permission As String) As Boolean()
        '==========================================================================
        ' Name:     GetAcePermissionComputerNT
        ' Purpose:  Obtener los permisos que tendrá un objeto sobre un Equipo
        ' Input:    3 String: El nombre de Login del objeto a pregunar que permiso posee 'user',
        '           El nombre de login del equipo 'lgUser', El nombre del permiso 'Permission'
        ' Return:   Boolean array: Un array de dos booleanos, el primero marca si el objeto tiene
        '           el permiso permitido y el segundo indica si lo tiene negado
        ' Calls:    None
        '==========================================================================

        'Obtener el DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        'Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        'deSearch.Filter = "(&(sAMAccountName=" & lgUser & "))"
        'deSearch.SearchScope = SearchScope.Subtree
        'Dim results As SearchResultCollection = deSearch.FindAll()
        Dim obj As Object
        Dim resul(3) As Boolean
        resul(0) = False
        resul(1) = False
        resul(2) = False
        resul(3) = False

        Dim oSecurityDescriptor
        Dim dacl
        Dim ace
        Dim lNewList As New List(Of String)
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1

        'Mascaras de los diferentes tipos de permiso
        Const ADS_ACETYPE_SEND_TO = "{AB721A55-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_SEND_AS = "{AB721A54-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_PHONE = "{E45795B2-9455-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_SELF = "{BF9679C0-0DE6-11D0-A285-00AA003049E2}"
        Const ADS_ACETYPE_AUTHENTICATE = "{68B1D179-0D15-4D4F-AB71-46152E79A7BC}"
        Const ADS_ACETYPE_CHANGE_PASS = "{AB721A53-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_RECIEVE_AS = "{AB721A56-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_RESET_PASS = "{00299570-246D-11D0-A768-00AA006E0529}"
        Const ADS_ACETYPE_ACC_REST = "{4C164200-20C0-11D0-A768-00AA006E0529}"
        Const ADS_ACETYPE_VALIDATE_DNS = "{72E39547-7B18-11D1-ADEF-00C04FD8D5CD}"
        Const ADS_ACETYPE_VALIDATE_SPN = "{F3A64788-5306-11D1-A9C5-0000F80367C1}"
        Const ADS_ACETYPE_LOGON_INFO = "{5F202010-79A5-11D0-9020-00C04FC2D4CF}"
        Const ADS_ACETYPE_PERSONAL_INFO = "{77B5B886-944A-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_PUBLIC_INFO = "{E48D0154-BCF8-11D1-8702-00C04FB96050}"
        Const ADS_ACETYPE_REMOTE_ACCESS = "{037088F8-0AE1-11D2-B422-00A0C968F939}"
        Const ADS_ACETYPE_DNS_ATTRIBUTE = "{72E39547-7B18-11D1-ADEF-00C04FD8D5CD}"
        Const ADS_RIGHT_GENERIC_READ = &H80000000
        Const ADS_RIGHT_GENERIC_WRITE = &H40000000
        Const ADS_RIGHT_DS_CREATE_CHILD = &H1
        Const ADS_RIGHT_DS_DELETE_CHILD = &H2
        Const ADS_RIGHT_DS_SELF = &H8

        Dim ConTipo As String = "vacio"
        Dim opcion

        'Obtener la mascara correspondiente a Permission
        If Permission = "Control total" Then
            opcion = 983551
        ElseIf Permission = "Lectura" Then
            opcion = 131092
        ElseIf Permission = "Escritura" Then
            opcion = 40
        ElseIf Permission = "Crear todos los objetos hijo" Then
            opcion = 1
        ElseIf Permission = "Eliminar todos los objetos hijo" Then
            opcion = &H2
        ElseIf Permission = "Permiso de autenticarse" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_AUTHENTICATE
        ElseIf Permission = "cambio Password" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_CHANGE_PASS
        ElseIf Permission = "Recibir como" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_RECIEVE_AS
        ElseIf Permission = "Reset password" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_RESET_PASS
        ElseIf Permission = "Enviar como" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_SEND_AS
        ElseIf Permission = "Lectura de restricciones de la cuenta" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_ACC_REST
        ElseIf Permission = "Escritura de restricciones de la cuenta" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_ACC_REST
        ElseIf Permission = "Escritura validada del DNS Host name" Then
            opcion = 8
            ConTipo = ADS_ACETYPE_VALIDATE_DNS
        ElseIf Permission = "Escritura validada del nombre del servicio principal" Then
            opcion = 8
            ConTipo = ADS_ACETYPE_VALIDATE_SPN
        ElseIf Permission = "Lectura de atributos del DNS Host name" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_DNS_ATTRIBUTE
        ElseIf Permission = "Escritura de atributos del DNS Host name" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_DNS_ATTRIBUTE
        ElseIf Permission = "Lectura de información  personal" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_PERSONAL_INFO
        ElseIf Permission = "Escritura de información  personal" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_PERSONAL_INFO
        ElseIf Permission = "Lectura de información pública" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_PUBLIC_INFO
        ElseIf Permission = "Escritura de información pública" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_PUBLIC_INFO
        End If

        'Obtener el security Descriptor del equipo
        obj = GetObject("LDAP://" & Settings.ldapServerName & "/" & lgUser)
        Try
            oSecurityDescriptor = obj.Get("ntSecurityDescriptor")
        Catch e As FormatException
            MsgBox("Error de formato al obtener los permisos sobre " & User & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al obtener los permisos, No tienes permisos para acceder a este dato " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al obtener los permisos,Se ha intentado obtener un dato con un índice fuera de rango en el large integer " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al obtener los permisos,Se está intentando obtener un dato involucrado en una operación cancelada en el large integer " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al obtener los permisos,Se está intentando obtener un dato involucrado en una operación abortada en el large integer " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al obtener los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al obtener los permisos,  acceder a al ubicación física del dato en el large integer " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al obtener los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al obtener los permisos, al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
        'Recorrer los permisos. Si está asignado Permission a user, se marca true el primer boolean 
        'del array de salida, si está negado se marca a true el segundo.
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")

        Dim trustee As String = GetTrustee(User)
        For Each ace In dacl
            If Not ace.AceFlags = 26 Then
                If ace.trustee = trustee Then '"\" & User) Then 'Or ace.trustee = "Everyone" Then
                    'If Permission.Contains("Control total") Then
                    If ace.AccessMask = 983551 Then
                        If (ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED) Then
                            resul(0) = True
                            If ace.AceFlags = 18 Then
                                resul(2) = True
                            End If
                            'Exit For
                        ElseIf (ace.AceType = ADS_ACETYPE_ACCESS_DENIED) Then
                            resul(1) = True
                            If ace.AceFlags = 18 Then
                                resul(3) = True
                            End If
                            'Exit For
                        End If
                        'End If
                    Else
                        If Not ace.AccessMask = 4 Then
                            If ace.AccessMask And opcion Then
                                If ConTipo = "vacio" Then
                                    If Not opcion = 983551 Then
                                        If (ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED) Then
                                            resul(0) = True
                                            If ace.AceFlags = 18 Then
                                                resul(2) = True
                                            End If
                                            'Exit For
                                        ElseIf (ace.AceType = ADS_ACETYPE_ACCESS_DENIED) Then
                                            resul(1) = True
                                            If ace.AceFlags = 18 Then
                                                resul(3) = True
                                            End If
                                            'Exit For
                                        End If
                                    End If
                                Else

                                    If (ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED) Then
                                        resul(0) = True
                                        If ace.AceFlags = 18 Then
                                            resul(2) = True
                                        End If
                                        'Exit For
                                    ElseIf (ace.AceType = ADS_ACETYPE_ACCESS_DENIED) Then
                                        resul(1) = True
                                        If ace.AceFlags = 18 Then
                                            resul(3) = True
                                        End If
                                        'Exit For
                                    ElseIf (ace.AceType = 5 And ace.objectType = ConTipo) Then
                                        resul(0) = True
                                        If ace.AceFlags = 18 Then
                                            resul(2) = True
                                        End If
                                        'Exit For
                                    ElseIf (ace.AceType = 6 And ace.objectType = ConTipo) Then
                                        resul(1) = True
                                        If ace.AceFlags = 18 Then
                                            resul(3) = True
                                        End If
                                        'Exit For
                                    End If

                                End If
                            End If
                        End If

                    End If
                End If
            End If

        Next

        Return resul
    End Function

    Shared Sub AddAceToDacl(ByVal User As String, ByVal logonU As String, ByVal Permission As String, ByVal tipo As String)
        '==========================================================================
        ' Name:     AddAceToDacl
        ' Purpose:  Añadir un permiso a un objeto sobre el buzón de un usuario
        ' Input:    3 String: El nombre de Login del objeto a pregunar que permiso posee 'user',
        '           El nombre de login del usuario dueño del buzón 'lgUser', El nombre del permiso 'Permission'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del DirectoryEntry del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & logonU & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        Dim lNewList As New List(Of String)
        Const ADS_ACEFLAG_INHERIT_ACE = 2
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1
        Dim opcion

        'Mascaras de los diferentes tipos de permiso
        Const RIGHT_DS_DELETE = 65536
        Const RIGHT_DS_READ = 131072
        Const RIGHT_DS_CHANGE = 262144
        Const RIGHT_DS_TAKE_OWNERSHIP = 524288
        Const RIGHT_DS_MAILBOX_OWNER = 1
        Const RIGHT_DS_SEND_AS = 2
        Const RIGHT_DS_PRIMARY_OWNER = &H4

        'Obtener la mascara correspondiente a Permission
        If Permission.Contains("Borrado de la memoria del buzón") Then
            opcion = RIGHT_DS_DELETE
        ElseIf Permission = "Permisos de lectura" Then
            opcion = RIGHT_DS_READ
        ElseIf Permission = "Permisos de modificación" Then
            opcion = RIGHT_DS_CHANGE
        ElseIf Permission = "Tomar posesión" Then
            opcion = RIGHT_DS_TAKE_OWNERSHIP
        ElseIf Permission = "Acceso total al buzón" Then
            opcion = RIGHT_DS_MAILBOX_OWNER
        ElseIf Permission = "Cuenta externa asociada" Then
            opcion = RIGHT_DS_SEND_AS
        End If

        Dim oSecurityDescriptor As SecurityDescriptor
        Dim dacl As AccessControlList
        Dim ace

        'Obtener el DirectoryEntry del usuario
        Dim deMail As New DirectoryEntry(results(0).Path)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener el Security Descriptor del buzón mediante la interfaz IExchangeMailbox
        Dim mailboxStore As IExchangeMailbox
        mailboxStore = CType(deMail.NativeObject, IExchangeMailbox)
        oSecurityDescriptor = mailboxStore.MailboxRights

        'Obtener la lista de permisos del buzón
        dacl = oSecurityDescriptor.DiscretionaryAcl

        'Crear el nuevo permiso
        ace = CreateObject("AccessControlEntry")
        Dim trustee As String = GetTrustee(User)

        'Asignarle la máscara correspondiente
        ace.accessMask = opcion
        If tipo = "Allow" Then
            ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED
        Else
            ace.AceType = ADS_ACETYPE_ACCESS_DENIED
        End If
        ace.AceFlags = ADS_ACEFLAG_INHERIT_ACE
        ace.Flags = 1
        ace.Trustee = trustee

        'Añadir el permiso a la lista y ésta insertarla en el SecurityDescriptor
        dacl.AddAce(ace)
        oSecurityDescriptor.DiscretionaryAcl = dacl
        mailboxStore.MailboxRights = oSecurityDescriptor
        Try
            deMail.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("No se poseen permisos para añadir permisos al buzón " & e.Message)
        Catch e As ConstraintException
            MsgBox("Error, Al conceder el permiso al buzón se viola una restricción " & e.Message)
        End Try
    End Sub

    Shared Sub AddAceToDaclNT(ByVal User As String, ByVal logonU As String, ByVal Permission As String, ByVal tipo As String)
        '==========================================================================
        ' Name:     AddAceToDaclNT
        ' Purpose:  Añadir un permiso a un objeto sobre un grupo
        ' Input:    3 String: El nombre de Login del objeto a pregunar que permiso posee 'user',
        '           El nombre de login del grupo 'lgUser', El nombre del permiso 'Permission'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del DirectoryEntry del grupo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        'Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        'deSearch.Filter = "(&(sAMAccountName=" & logonU & "))"
        'deSearch.SearchScope = SearchScope.Subtree
        'Dim results As SearchResultCollection = deSearch.FindAll()


        Dim lNewList As New List(Of String)
        Const ADS_ACEFLAG_INHERIT_ACE = 2
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1

        'Mascaras de los diferentes tipos de permiso
        Const ADS_ACETYPE_SEND_TO = "{AB721A55-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_SEND_AS = "{AB721A54-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_PHONE = "{E45795B2-9455-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_SELF = "{BF9679C0-0DE6-11D0-A285-00AA003049E2}"
        Const ADS_RIGHT_GENERIC_READ = &H80000000
        Const ADS_RIGHT_GENERIC_WRITE = &H40000000
        Const ADS_RIGHT_DS_CREATE_CHILD = &H1
        Const ADS_RIGHT_DS_DELETE_CHILD = &H2
        Const ADS_RIGHT_DS_SELF = &H8

        Dim ConTipo As String = "vacio"
        Dim opcion

        'Obtener la mascara correspondiente a Permission
        If Permission.Contains("Control total") Then
            opcion = 983551
            ConTipo = "total"
        ElseIf Permission = "Lectura" Then
            opcion = 131092
        ElseIf Permission = "Escritura" Then
            opcion = 40
        ElseIf Permission = "Crear todos los objetos hijo" Then
            opcion = 1
        ElseIf Permission = "Eliminar todos los objetos hijo" Then
            opcion = &H2
        ElseIf Permission = "Añadirse/Eliminarse a sí mismo como miembro" Then
            opcion = &H8
            ConTipo = "self"
        ElseIf Permission = "Enviar como" Then
            opcion = 256
            ConTipo = "send as"
        ElseIf Permission = "Enviar a" Then
            opcion = 256
            ConTipo = "send to"
        ElseIf Permission = "Leer opciones de teléfono y correo" Then
            opcion = &H10
            ConTipo = "phone"
        ElseIf Permission = "Escribir opciones de teléfono y correo" Then
            opcion = &H20
            ConTipo = "phone"
        End If


        Dim dacl As AccessControlList
        Dim ace

        'Obtener el DirectoryEntry del grupo
        'Dim trusUser As New DirectoryEntry(otherresults(0).Path)
        Dim deMail As New DirectoryEntry("LDAP://" & Settings.ldapServerName & "/" & logonU)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener la lista de permisos del Securitydescriptor
        Dim oSecurityDescriptor As IADsSecurityDescriptor = CType(deMail.Properties("ntSecurityDescriptor").Value, IADsSecurityDescriptor)
        dacl = oSecurityDescriptor.DiscretionaryAcl
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        Dim trustee As String = GetTrustee(User)

        'Crear el nuevo permiso asignándole la máscara y AceType correspondiente
        ace.accessMask = opcion
        If tipo = "Allow" Then
            ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED
        Else
            ace.AceType = ADS_ACETYPE_ACCESS_DENIED
        End If

        If ConTipo = "send as" Then
            ace.objectType = ADS_ACETYPE_SEND_AS
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6

            End If
        End If
        If ConTipo = "send to" Then
            ace.objectType = ADS_ACETYPE_SEND_TO
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If

        End If
        If ConTipo = "phone" Then
            ace.objectType = ADS_ACETYPE_PHONE
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If

        End If
        If ConTipo = "self" Then
            ace.objectType = ADS_ACETYPE_SELF
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If

        End If

        ace.AceFlags = ADS_ACEFLAG_INHERIT_ACE
        ace.Flags = 1
        ace.Trustee = trustee
        'If ConTipo = "Permission" Then
        '    ace.AceFlags = 0
        '    ace.Flags = 0
        'End If
        'Añadir el permiso a la lista y ésta insertarla en el SecurityDescriptor
        dacl.AddAce(ace)
        oSecurityDescriptor.DiscretionaryAcl = dacl
        deMail.Properties("ntSecurityDescriptor").Value = oSecurityDescriptor

        deMail.CommitChanges()
    End Sub

    Shared Sub AddAceToDaclUserNT(ByVal User As String, ByVal logonU As String, ByVal Permission As String, ByVal tipo As String)
        '==========================================================================
        ' Name:     AddAceToDaclUserNT
        ' Purpose:  Añadir un permiso a un objeto sobre un usuario
        ' Input:    3 String: El nombre de Login del objeto a pregunar que permiso posee 'user',
        '           El nombre de login del usuario 'lgUser', El nombre del permiso 'Permission'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del DirectoryEntry del grupo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        'Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        'deSearch.Filter = "(&(sAMAccountName=" & logonU & "))"
        'deSearch.SearchScope = SearchScope.Subtree
        'Dim results As SearchResultCollection = deSearch.FindAll()


        Dim lNewList As New List(Of String)
        Const ADS_ACEFLAG_INHERIT_ACE = 2
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1

        'Mascaras de los diferentes tipos de permiso
        Const ADS_ACETYPE_SEND_TO = "{AB721A55-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_SEND_AS = "{AB721A54-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_PHONE = "{E45795B2-9455-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_SELF = "{BF9679C0-0DE6-11D0-A285-00AA003049E2}"
        Const ADS_ACETYPE_AUTHENTICATE = "{68B1D179-0D15-4D4F-AB71-46152E79A7BC}"
        Const ADS_ACETYPE_CHANGE_PASS = "{AB721A53-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_RECIEVE_AS = "{AB721A56-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_RESET_PASS = "{00299570-246D-11D0-A768-00AA006E0529}"
        Const ADS_ACETYPE_ACC_REST = "{4C164200-20C0-11D0-A768-00AA006E0529}"
        Const ADS_ACETYPE_GEN_INFO = "{59BA2F42-79A2-11D0-9020-00C04FC2D3CF}"
        Const ADS_ACETYPE_GROUP_MEMBERSHIP = "{BC0AC240-79A9-11D0-9020-00C04FC2D4CF}"
        Const ADS_ACETYPE_LOGON_INFO = "{5F202010-79A5-11D0-9020-00C04FC2D4CF}"
        Const ADS_ACETYPE_PERSONAL_INFO = "{77B5B886-944A-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_PUBLIC_INFO = "{E48C0154-BCF8-11D1-8702-00C04FB96050}"
        Const ADS_ACETYPE_REMOTE_ACCESS = "{037088F8-0AE1-11D2-B422-00A0C968F939}"
        Const ADS_ACETYPE_WEB_INFO = "{E45795B3-9455-11D1-AEBD-0000F80367C1}"
        Const ADS_RIGHT_GENERIC_READ = &H80000000
        Const ADS_RIGHT_GENERIC_WRITE = &H40000000
        Const ADS_RIGHT_DS_CREATE_CHILD = &H1
        Const ADS_RIGHT_DS_DELETE_CHILD = &H2
        Const ADS_RIGHT_DS_SELF = &H8

        Dim ConTipo As String = "vacio"
        Dim opcion

        'Obtener la mascara correspondiente a Permission
        If Permission.Contains("Control total") Then
            opcion = 983551
        ElseIf Permission = "Lectura" Then
            opcion = 131092
        ElseIf Permission = "Escritura" Then
            opcion = 40
        ElseIf Permission = "Crear todos los objetos hijo" Then
            opcion = 1
        ElseIf Permission = "Eliminar todos los objetos hijo" Then
            opcion = &H2
        ElseIf Permission = "Permiso de autenticarse" Then
            opcion = 256
            ConTipo = "auth"
        ElseIf Permission = "cambio Password" Then
            opcion = 256
            ConTipo = "cPass"
        ElseIf Permission = "Recibir como" Then
            opcion = 256
            ConTipo = "recAs"
        ElseIf Permission = "Reset password" Then
            opcion = 256
            ConTipo = "Rpass"
        ElseIf Permission = "Enviar como" Then
            opcion = 256
            ConTipo = "sendAs"
        ElseIf Permission = "Lectura de restricciones de la cuenta" Then
            opcion = 16
            ConTipo = "rest"
        ElseIf Permission = "Escritura de restricciones de la cuenta" Then
            opcion = 32
            ConTipo = "rest"
        ElseIf Permission = "Lectura de información general" Then
            opcion = 16
            ConTipo = "geninfo"
        ElseIf Permission = "Escritura de información general" Then
            opcion = 32
            ConTipo = "geninfo"
        ElseIf Permission = "Lectura de miembros de grupo" Then
            opcion = 16
            ConTipo = "membership"
        ElseIf Permission = "Escritura de miembros de grupo" Then
            opcion = 32
            ConTipo = "membership"
        ElseIf Permission = "Lectura de información  de Logon" Then
            opcion = 16
            ConTipo = "logon"
        ElseIf Permission = "Escritura de información  de Logon" Then
            opcion = 32
            ConTipo = "logon"
        ElseIf Permission = "Lectura de información  personal" Then
            opcion = 16
            ConTipo = "pers"
        ElseIf Permission = "Escritura de información  personal" Then
            opcion = 32
            ConTipo = "pers"
        ElseIf Permission = "Lectura de opciones de teléfono y correo" Then
            opcion = 16
            ConTipo = "phone"
        ElseIf Permission = "Escritura de opciones de teléfono y correo" Then
            opcion = 32
            ConTipo = "phone"
        ElseIf Permission = "Lectura de información pública" Then
            opcion = 16
            ConTipo = "public"
        ElseIf Permission = "Escritura de información pública" Then
            opcion = 32
            ConTipo = "public"
        ElseIf Permission = "Lectura de información de acceso remoto" Then
            opcion = 16
            ConTipo = "remote"
        ElseIf Permission = "Escritura de información de acceso remoto" Then
            opcion = 32
            ConTipo = "remote"
        ElseIf Permission = "Lectura de información Web" Then
            opcion = 16
            ConTipo = "web"
        ElseIf Permission = "Escritura de información Web" Then
            opcion = 32
            ConTipo = "web"
        End If


        Dim dacl As AccessControlList
        Dim ace

        'Obtener el DirectoryEntry del usuario
        'Dim trusUser As New DirectoryEntry(otherresults(0).Path)
        Dim deMail As New DirectoryEntry("LDAP://" & Settings.ldapServerName & "/" & logonU)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener la lista de permisos del Securitydescriptor
        Dim oSecurityDescriptor As IADsSecurityDescriptor = CType(deMail.Properties("ntSecurityDescriptor").Value, IADsSecurityDescriptor)
        dacl = oSecurityDescriptor.DiscretionaryAcl
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        Dim trustee As String = GetTrustee(User)

        'Crear el nuevo permiso asignándole la máscara y AceType correspondiente
        ace.accessMask = opcion
        'ace.AceFlags = 0
        'If ConTipo = "vacio" Then
        '    ace.flags = 0
        'Else
        '    ace.flags = 1
        'End If
        If tipo = "Allow" Then
            ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED
        Else
            ace.AceType = ADS_ACETYPE_ACCESS_DENIED
        End If

        If ConTipo = "auth" Then
            ace.objectType = ADS_ACETYPE_AUTHENTICATE
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "cPass" Then
            ace.objectType = ADS_ACETYPE_CHANGE_PASS
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "recAs" Then
            ace.objectType = ADS_ACETYPE_RECIEVE_AS
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "Rpass" Then
            ace.objectType = ADS_ACETYPE_RESET_PASS
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "sendAs" Then
            ace.objectType = ADS_ACETYPE_SEND_AS
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "rest" Then
            ace.objectType = ADS_ACETYPE_ACC_REST
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "geninfo" Then
            ace.objectType = ADS_ACETYPE_GEN_INFO
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "membership" Then
            ace.objectType = ADS_ACETYPE_GROUP_MEMBERSHIP
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "logon" Then
            ace.objectType = ADS_ACETYPE_LOGON_INFO
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "pers" Then
            ace.objectType = ADS_ACETYPE_PERSONAL_INFO
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "phone" Then
            ace.objectType = ADS_ACETYPE_PHONE
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "public" Then
            ace.objectType = ADS_ACETYPE_PUBLIC_INFO
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "remote" Then
            ace.objectType = ADS_ACETYPE_REMOTE_ACCESS
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        ElseIf ConTipo = "web" Then
            ace.objectType = ADS_ACETYPE_WEB_INFO
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        End If
        ace.AceFlags = ADS_ACEFLAG_INHERIT_ACE
        ace.Flags = 1
        ace.Trustee = trustee
        'Añadir el permiso a la lista y ésta insertarla en el SecurityDescriptor
        dacl.AddAce(ace)
        oSecurityDescriptor.DiscretionaryAcl = dacl
        deMail.Properties("ntSecurityDescriptor").Value = oSecurityDescriptor
        Try
            deMail.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("No se poseen permisos para añadir permisos al usuario " & e.Message)
        Catch e As ConstraintException
            MsgBox("Error, Al conceder el permiso al usuario se viola una restricción " & e.Message)
        End Try
    End Sub

    Shared Sub AddAceToDaclComputerNT(ByVal User As String, ByVal logonU As String, ByVal Permission As String, ByVal tipo As String)
        '==========================================================================
        ' Name:     AddAceToDaclComputerNT
        ' Purpose:  Añadir un permiso a un objeto sobre un equipo
        ' Input:    3 String: El nombre de Login del objeto a pregunar que permiso posee 'user',
        '           El nombre de login del equipo 'lgUser', El nombre del permiso 'Permission'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del DirectoryEntry del grupo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        'Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        'deSearch.Filter = "(&(sAMAccountName=" & logonU & "))"
        'deSearch.SearchScope = SearchScope.Subtree
        'Dim results As SearchResultCollection = deSearch.FindAll()

        Dim lNewList As New List(Of String)
        Const ADS_ACEFLAG_INHERIT_ACE = 2
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1

        'Mascaras de los diferentes tipos de permiso
        Const ADS_ACETYPE_SEND_TO = "{AB721A55-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_SEND_AS = "{AB721A54-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_PHONE = "{E45795B2-9455-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_SELF = "{BF9679C0-0DE6-11D0-A285-00AA003049E2}"
        Const ADS_ACETYPE_AUTHENTICATE = "{68B1D179-0D15-4D4F-AB71-46152E79A7BC}"
        Const ADS_ACETYPE_CHANGE_PASS = "{AB721A53-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_RECIEVE_AS = "{AB721A56-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_RESET_PASS = "{00299570-246D-11D0-A768-00AA006E0529}"
        Const ADS_ACETYPE_ACC_REST = "{4C164200-20C0-11D0-A768-00AA006E0529}"
        Const ADS_ACETYPE_VALIDATE_DNS = "{72E39547-7B18-11D1-ADEF-00C04FD8D5CD}"
        Const ADS_ACETYPE_VALIDATE_SPN = "{F3A64788-5306-11D1-A9C5-0000F80367C1}"
        Const ADS_ACETYPE_LOGON_INFO = "{5F202010-79A5-11D0-9020-00C04FC2D4CF}"
        Const ADS_ACETYPE_PERSONAL_INFO = "{77B5B886-944A-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_PUBLIC_INFO = "{E48D0154-BCF8-11D1-8702-00C04FB96050}"
        Const ADS_ACETYPE_REMOTE_ACCESS = "{037088F8-0AE1-11D2-B422-00A0C968F939}"
        Const ADS_ACETYPE_DNS_ATTRIBUTE = "{72E39547-7B18-11D1-ADEF-00C04FD8D5CD}"
        Const ADS_RIGHT_GENERIC_READ = &H80000000
        Const ADS_RIGHT_GENERIC_WRITE = &H40000000
        Const ADS_RIGHT_DS_CREATE_CHILD = &H1
        Const ADS_RIGHT_DS_DELETE_CHILD = &H2
        Const ADS_RIGHT_DS_SELF = &H8

        Dim ConTipo As String = "vacio"
        Dim opcion

        'Obtener la mascara correspondiente a Permission
        If Permission = "Control total" Then
            opcion = 983551
        ElseIf Permission = "Lectura" Then
            opcion = 131092
        ElseIf Permission = "Escritura" Then
            opcion = 40
        ElseIf Permission = "Crear todos los objetos hijo" Then
            opcion = 1
        ElseIf Permission = "Eliminar todos los objetos hijo" Then
            opcion = &H2
        ElseIf Permission = "Permiso de autenticarse" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_AUTHENTICATE
        ElseIf Permission = "cambio Password" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_CHANGE_PASS
        ElseIf Permission = "Recibir como" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_RECIEVE_AS
        ElseIf Permission = "Reset password" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_RESET_PASS
        ElseIf Permission = "Enviar como" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_SEND_AS
        ElseIf Permission = "Lectura de restricciones de la cuenta" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_ACC_REST
        ElseIf Permission = "Escritura de restricciones de la cuenta" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_ACC_REST
        ElseIf Permission = "Escritura validada del DNS Host name" Then
            opcion = 8
            ConTipo = ADS_ACETYPE_VALIDATE_DNS
        ElseIf Permission = "Escritura validada del nombre del servicio principal" Then
            opcion = 8
            ConTipo = ADS_ACETYPE_VALIDATE_SPN
        ElseIf Permission = "Lectura de atributos del DNS Host name" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_DNS_ATTRIBUTE
        ElseIf Permission = "Escritura de atributos del DNS Host name" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_DNS_ATTRIBUTE
        ElseIf Permission = "Lectura de información  personal" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_PERSONAL_INFO
        ElseIf Permission = "Escritura de información  personal" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_PERSONAL_INFO
        ElseIf Permission = "Lectura de información pública" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_PUBLIC_INFO
        ElseIf Permission = "Escritura de información pública" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_PUBLIC_INFO
        End If


        Dim dacl As AccessControlList
        Dim ace

        'Obtener el DirectoryEntry del equipo
        'Dim trusUser As New DirectoryEntry(otherresults(0).Path)
        Dim deMail As New DirectoryEntry("LDAP://" & Settings.ldapServerName & "/" & logonU)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener la lista de permisos del Securitydescriptor
        Dim oSecurityDescriptor As IADsSecurityDescriptor = CType(deMail.Properties("ntSecurityDescriptor").Value, IADsSecurityDescriptor)
        dacl = oSecurityDescriptor.DiscretionaryAcl
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        Dim trustee As String = GetTrustee(User)

        'Crear el nuevo permiso asignándole la máscara y AceType correspondiente
        ace.accessMask = opcion
        ace.AceFlags = ADS_ACEFLAG_INHERIT_ACE
        ace.Flags = 1
        'If ConTipo = "vacio" Then
        '    ace.flags = 0
        'Else
        '    ace.flags = 1
        'End If
        If ConTipo = "vacio" Then
            If tipo = "Allow" Then
                ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED
            Else
                ace.AceType = ADS_ACETYPE_ACCESS_DENIED
            End If
        Else
            ace.objectType = ConTipo
            If tipo = "Allow" Then
                ace.AceType = 5
            Else
                ace.AceType = 6
            End If
        End If


        'If ConTipo = "auth" Then
        '    ace.objectType = ADS_ACETYPE_AUTHENTICATE
        '    If tipo = "Allow" Then
        '        ace.AceType = 5
        '    Else
        '        ace.AceType = 6
        '    End If
        'ElseIf ConTipo = "cPass" Then
        '    ace.objectType = ADS_ACETYPE_CHANGE_PASS
        '    If tipo = "Allow" Then
        '        ace.AceType = 5
        '    Else
        '        ace.AceType = 6
        '    End If
        'ElseIf ConTipo = "recAs" Then
        '    ace.objectType = ADS_ACETYPE_RECIEVE_AS
        '    If tipo = "Allow" Then
        '        ace.AceType = 5
        '    Else
        '        ace.AceType = 6
        '    End If
        'ElseIf ConTipo = "Rpass" Then
        '    ace.objectType = ADS_ACETYPE_RESET_PASS
        '    If tipo = "Allow" Then
        '        ace.AceType = 5
        '    Else
        '        ace.AceType = 6
        '    End If
        'ElseIf ConTipo = "sendAs" Then
        '    ace.objectType = ADS_ACETYPE_SEND_AS
        '    If tipo = "Allow" Then
        '        ace.AceType = 5
        '    Else
        '        ace.AceType = 6
        '    End If
        'ElseIf ConTipo = "rest" Then
        '    ace.objectType = ADS_ACETYPE_ACC_REST
        '    If tipo = "Allow" Then
        '        ace.AceType = 5
        '    Else
        '        ace.AceType = 6
        '    End If
        'ElseIf ConTipo = "WDHN" Then
        '    ace.objectType = ADS_ACETYPE_VALIDATE_DNS
        '    If tipo = "Allow" Then
        '        ace.AceType = 5
        '    Else
        '        ace.AceType = 6
        '    End If
        'ElseIf ConTipo = "WSPN" Then
        '    ace.objectType = ADS_ACETYPE_VALIDATE_SPN
        '    If tipo = "Allow" Then
        '        ace.AceType = 5
        '    Else
        '        ace.AceType = 6
        '    End If
        'ElseIf ConTipo = "DNS" Then
        '    ace.objectType = ADS_ACETYPE_DNS_ATTRIBUTE
        '    If tipo = "Allow" Then
        '        ace.AceType = 5
        '    Else
        '        ace.AceType = 6
        '    End If
        'ElseIf ConTipo = "pers" Then
        '    ace.objectType = ADS_ACETYPE_PERSONAL_INFO
        '    If tipo = "Allow" Then
        '        ace.AceType = 5
        '    Else
        '        ace.AceType = 6
        '    End If
        'ElseIf ConTipo = "public" Then
        '    ace.objectType = ADS_ACETYPE_PUBLIC_INFO
        '    If tipo = "Allow" Then
        '        ace.AceType = 5
        '    Else
        '        ace.AceType = 6
        '    End If
        'End If

        ace.Trustee = trustee

        'Añadir el permiso a la lista y ésta insertarla en el SecurityDescriptor
        dacl.AddAce(ace)
        oSecurityDescriptor.DiscretionaryAcl = dacl
        deMail.Properties("ntSecurityDescriptor").Value = oSecurityDescriptor

        Try
            deMail.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("No se poseen permisos para añadir permisos al equipo " & e.Message)
        Catch e As ConstraintException
            MsgBox("Error, Al conceder el permiso al usuario se viola una restricción " & e.Message)
        End Try
    End Sub

    Shared Sub SetAcePermission(ByVal User As String, ByVal Permission As String, ByVal Allow As Boolean)
        '==========================================================================
        ' Name:     SetAcePermission
        ' Purpose:  Cambiar el permiso de un objeto sobre el buzón de otro usuario
        ' Input:    3 String: El nombre de Login del usuario dueño del buzón 'lgUser',
        '           El nombre de login del objeto 'user', El nombre del permiso 'Permission'
        '           1 Boolean: indica si el permiso se ha de permitir (true) o negar (false) 'Allow'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del objeto
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & User & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        Dim resul(1) As Boolean
        resul(0) = False
        resul(1) = False

        Dim oSecurityDescriptor As SecurityDescriptor
        Dim dacl As AccessControlList
        Dim ace
        Dim lNewList As New List(Of String)
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1

        'Mascaras para los tipos de permisos
        Const RIGHT_DS_DELETE = 65536
        Const RIGHT_DS_READ = 131072
        Const RIGHT_DS_CHANGE = 262144
        Const RIGHT_DS_TAKE_OWNERSHIP = 524288
        Const RIGHT_DS_MAILBOX_OWNER = 1
        Const RIGHT_DS_SEND_AS = 2
        Const RIGHT_DS_PRIMARY_OWNER = &H4
        Dim opcion

        'Obtener la máscara que corresponde a Permission
        If Permission = "Borrado de la memoria del buzón" Then
            opcion = RIGHT_DS_DELETE
        ElseIf Permission = "Permisos de lectura" Then
            opcion = RIGHT_DS_READ
        ElseIf Permission = "Permisos de modificación" Then
            opcion = RIGHT_DS_CHANGE
        ElseIf Permission = "Tomar posesión" Then
            opcion = RIGHT_DS_TAKE_OWNERSHIP
        ElseIf Permission = "Acceso total al buzón" Then
            opcion = RIGHT_DS_MAILBOX_OWNER
        ElseIf Permission = "Cuenta externa asociada" Then
            opcion = RIGHT_DS_SEND_AS
        End If

        'Obtener el DirectoryEntry del usuario
        Dim deMail As New DirectoryEntry(results(0).Path)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener el SecurityDescriptor del buzón mediante una interfaz IExchangeMailbox
        Dim mailboxStore As IExchangeMailbox
        mailboxStore = CType(deMail.NativeObject, IExchangeMailbox)
        oSecurityDescriptor = mailboxStore.MailboxRights

        'Recorrer la lista de permisos y asignar el valor correspondiente a user
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        For Each ace In dacl
            If ace.trustee.contains(User) Then
                If Allow Then
                    ace.AccessMask = opcion
                    ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED
                Else
                    ace.AccessMask = opcion
                    ace.AceType = ADS_ACETYPE_ACCESS_DENIED
                End If
            End If
        Next

        'Actualizar la lista de permisos
        oSecurityDescriptor.DiscretionaryAcl = dacl
        mailboxStore.MailboxRights = oSecurityDescriptor

        deMail.CommitChanges()
    End Sub

    Shared Sub RemoveAceFromDacl(ByVal User As String, ByVal logonU As String, ByVal Permission As String, ByVal tipo As String)
        '==========================================================================
        ' Name:     RemoveAceFromDacl
        ' Purpose:  Eliminar un permiso dado a un objeto sobre el buzón de un usuario
        ' Input:    4 String: El nombre de Login del usuario dueño del buzón 'logonU',
        '           El nombre de login del objeto 'User', El nombre del permiso 'Permission'
        '           ,indica si el permiso permite (Allow) o niega (Deny) 'Tipo'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener direccion del usuario dueño del buzón
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & logonU & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        Dim lNewList As New List(Of String)
        Const ADS_ACEFLAG_INHERIT_ACE = 2
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1
        Dim opcion

        'Mascaras de tipo de permiso
        Const RIGHT_DS_DELETE = 65536
        Const RIGHT_DS_READ = 131072
        Const RIGHT_DS_CHANGE = 262144
        Const RIGHT_DS_TAKE_OWNERSHIP = 524288
        Const RIGHT_DS_MAILBOX_OWNER = 1
        Const RIGHT_DS_SEND_AS = 2
        Const RIGHT_DS_PRIMARY_OWNER = &H4

        'Obtener la máscara de Permission
        If Permission.Contains("Borrado de la memoria del buzón") Then
            opcion = RIGHT_DS_DELETE
        ElseIf Permission = "Permisos de lectura" Then
            opcion = RIGHT_DS_READ
        ElseIf Permission = "Permisos de modificación" Then
            opcion = RIGHT_DS_CHANGE
        ElseIf Permission = "Tomar posesión" Then
            opcion = RIGHT_DS_TAKE_OWNERSHIP
        ElseIf Permission = "Acceso total al buzón" Then
            opcion = RIGHT_DS_MAILBOX_OWNER
        ElseIf Permission = "Cuenta externa asociada" Then
            opcion = RIGHT_DS_SEND_AS
        End If

        Dim oSecurityDescriptor As SecurityDescriptor
        Dim dacl As AccessControlList
        Dim ace

        'Obtener el DirectoryEntry del usuario dueño del buzón
        Dim deMail As New DirectoryEntry(results(0).Path)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener el SecurityDescriptor del buzón
        Dim mailboxStore As IExchangeMailbox
        mailboxStore = CType(deMail.NativeObject, IExchangeMailbox)
        oSecurityDescriptor = mailboxStore.MailboxRights

        'Obtener la lista de permisos
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")

        'Establecer tipo de permiso
        Dim compara
        If tipo = "Allow" Then
            compara = ADS_ACETYPE_ACCESS_ALLOWED
        Else
            compara = ADS_ACETYPE_ACCESS_DENIED
        End If

        'Buscar permiso y eliminarlo

        Dim trustee As String = GetTrustee(User)

        'Dim trusUser As New DirectoryEntry(otherresults(0).Path)
        'Dim PN As String = trusUser.Properties("userPrincipalName").Value.ToString
        'Dim parts() As String = PN.Split("@")
        'Dim parts2() As String = parts(1).Split(".")
        'Dim trustee As String = UCase(parts2(0)) & "\" & parts(0)
        For Each ace In dacl
            If ace.trustee = trustee Then
                If (ace.accessMask And opcion) Then
                    If ace.AceType = compara Then
                        dacl.RemoveAce(ace)
                    End If
                End If
            End If
        Next

        'actualizar lista de permisos
        oSecurityDescriptor.DiscretionaryAcl = dacl
        mailboxStore.MailboxRights = oSecurityDescriptor

        Try
            deMail.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("No se poseen permisos para quitar permisos al buzón " & e.Message)
        Catch e As ConstraintException
            MsgBox("Error, Al quitar el permiso al usuario se viola una buzón " & e.Message)
        End Try
    End Sub

    Shared Sub RemoveAceFromDaclNT(ByVal User As String, ByVal logonU As String, ByVal Permission As String, ByVal tipo As String)
        '==========================================================================
        ' Name:     RemoveAceFromDaclNT
        ' Purpose:  Eliminar un permiso dado a un objeto sobre un grupo
        ' Input:    4 String: El nombre de Login del grupo 'logonU',
        '           El nombre de login del objeto 'User', El nombre del permiso 'Permission'
        '           ,indica si el permiso permite (Allow) o niega (Deny) 'Tipo'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del grupo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        'Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        'deSearch.Filter = "(&(sAMAccountName=" & logonU & "))"
        'deSearch.SearchScope = SearchScope.Subtree
        'Dim results As SearchResultCollection = deSearch.FindAll()

        Dim lNewList As New List(Of String)
        Const ADS_ACEFLAG_INHERIT_ACE = 2
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1

        'Mascaras de permiso
        Const ADS_ACETYPE_SEND_TO = "{AB721A55-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_SEND_AS = "{AB721A54-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_PHONE = "{E45795B2-9455-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_SELF = "{BF9679C0-0DE6-11D0-A285-00AA003049E2}"
        Const ADS_RIGHT_GENERIC_READ = &H80000000
        Const ADS_RIGHT_GENERIC_WRITE = &H40000000
        Const ADS_RIGHT_DS_CREATE_CHILD = &H1
        Const ADS_RIGHT_DS_DELETE_CHILD = &H2
        Const ADS_RIGHT_DS_SELF = &H8

        Dim ConTipo As String = "vacio"
        Dim opcion

        'Obtener la máscara de Permision
        If Permission.Contains("Control total") Then
            opcion = 983551
        ElseIf Permission = "Lectura" Then
            opcion = 131092
        ElseIf Permission = "Escritura" Then
            opcion = 40
        ElseIf Permission = "Crear todos los objetos hijo" Then
            opcion = 1
        ElseIf Permission = "Eliminar todos los objetos hijo" Then
            opcion = &H2
        ElseIf Permission = "Añadirse/Eliminarse a sí mismo como miembro" Then
            opcion = &H8
            ConTipo = "self"
        ElseIf Permission = "Enviar como" Then
            opcion = 256
            ConTipo = "send as"
        ElseIf Permission = "Enviar a" Then
            opcion = 256
            ConTipo = "send to"
        ElseIf Permission = "Leer opciones de teléfono y correo" Then
            opcion = &H10
            ConTipo = "phone"
        ElseIf Permission = "Escribir opciones de teléfono y correo" Then
            opcion = &H20
            ConTipo = "phone"
        End If

        Dim dacl As AccessControlList
        Dim ace

        'Obtener DirectoryEntry del grupo
        Dim deMail As New DirectoryEntry("LDAP://" & Settings.ldapServerName & "/" & logonU)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener la lista de permisos del grupo
        Dim oSecurityDescriptor As IADsSecurityDescriptor = CType(deMail.Properties("ntSecurityDescriptor").Value, IADsSecurityDescriptor)
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")

        'Establecer tipo de permiso
        Dim compara
        If tipo = "Allow" Then
            compara = ADS_ACETYPE_ACCESS_ALLOWED
        Else
            compara = ADS_ACETYPE_ACCESS_DENIED
        End If
        If ConTipo = "send as" Then
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "send to" Then
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "phone" Then
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "self" Then
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If

        'Buscar Permission en la lista y  eliminarlo
        Dim trustee As String = GetTrustee(User)
        For Each ace In dacl
            If ace.trustee = trustee Then

                If opcion = 983551 Then
                    'MsgBox(ace.accessMask)
                    If ace.accessMask = opcion Then
                        If ace.AceType = compara Then
                            dacl.RemoveAce(ace)
                        End If
                    End If
                Else
                    If (ace.accessMask And opcion) Then
                        If ace.AceType = compara Then
                            dacl.RemoveAce(ace)
                        End If
                    End If
                End If
            End If
        Next

        'Actualizar la lista de permisos
        oSecurityDescriptor.DiscretionaryAcl = dacl
        deMail.Properties("ntSecurityDescriptor").Value = oSecurityDescriptor

        deMail.CommitChanges()
    End Sub

    Shared Sub RemoveAces(ByVal User As String, ByVal logonU As String)
        '==========================================================================
        ' Name:     RemoveAceFromDaclNT
        ' Purpose:  Eliminar todos los permisos dados a un objeto sobre un grupo
        ' Input:    4 String: El nombre de Login del grupo 'logonU',
        '           El nombre de login del objeto 'User', El nombre del permiso 'Permission'
        '           ,indica si el permiso permite (Allow) o niega (Deny) 'Tipo'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del grupo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(sAMAccountName=" & logonU & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        Dim lNewList As New List(Of String)

        Dim dacl As AccessControlList
        Dim ace

        'Obtener DirectoryEntry del grupo
        Dim deMail As New DirectoryEntry(results(0).Path)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener la lista de permisos del grupo
        Dim oSecurityDescriptor As IADsSecurityDescriptor = CType(deMail.Properties("ntSecurityDescriptor").Value, IADsSecurityDescriptor)
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        Dim trustee As String = GetTrustee(User)
        'Borrar los asignados al objeto
        For Each ace In dacl
            If ace.trustee = trustee Then
                dacl.RemoveAce(ace)
            End If
        Next

        'Actualizar la lista de permisos
        oSecurityDescriptor.DiscretionaryAcl = dacl
        deMail.Properties("ntSecurityDescriptor").Value = oSecurityDescriptor
        Try
            deMail.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("No se poseen permisos para quitar permisos al usuario " & User & e.Message)
        Catch e As ConstraintException
            MsgBox("Error, Al quitar los permisos al usuario " & User & " se viola una restricción " & e.Message)
        End Try
    End Sub

    Shared Sub RemoveAcesMailbox(ByVal User As String, ByVal logonU As String)
        '==========================================================================
        ' Name:     RemoveAceFromDaclNT
        ' Purpose:  Eliminar todos los permisos dados a un objeto sobre un grupo
        ' Input:    4 String: El nombre de Login del grupo 'logonU',
        '           El nombre de login del objeto 'User', El nombre del permiso 'Permission'
        '           ,indica si el permiso permite (Allow) o niega (Deny) 'Tipo'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del grupo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(sAMAccountName=" & logonU & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        Dim lNewList As New List(Of String)

        Dim dacl As AccessControlList
        Dim ace

        'Obtener DirectoryEntry del grupo
        Dim deMail As New DirectoryEntry(results(0).Path)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener el SecurityDescriptor del buzón
        Dim mailboxStore As IExchangeMailbox
        mailboxStore = CType(deMail.NativeObject, IExchangeMailbox)

        'Obtener la lista de permisos del grupo
        Dim oSecurityDescriptor As SecurityDescriptor = mailboxStore.MailboxRights
        'Obtener la lista de permisos
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        Dim trustee As String = GetTrustee(User)
        'Borrar los asignados al objeto
        For Each ace In dacl
            If ace.trustee = trustee Then
                dacl.RemoveAce(ace)
            End If
        Next

        'actualizar lista de permisos
        oSecurityDescriptor.DiscretionaryAcl = dacl
        mailboxStore.MailboxRights = oSecurityDescriptor
        Try
            deMail.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("No se poseen permisos para quitar permisos al usuario " & User & e.Message)
        Catch e As ConstraintException
            MsgBox("Error, Al quitar los permisos al usuario " & User & " se viola una restricción " & e.Message)
        End Try
    End Sub

    Shared Sub RemoveAceFromDaclUserNT(ByVal User As String, ByVal logonU As String, ByVal Permission As String, ByVal tipo As String)
        '==========================================================================
        ' Name:     RemoveAceFromDaclUserNT
        ' Purpose:  Eliminar un permiso dado a un objeto sobre un usuario
        ' Input:    4 String: El nombre de Login del usuario 'logonU',
        '           El nombre de login del objeto 'User', El nombre del permiso 'Permission'
        '           ,indica si el permiso permite (Allow) o niega (Deny) 'Tipo'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        'Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        'deSearch.Filter = "(&(sAMAccountName=" & logonU & "))"
        'deSearch.SearchScope = SearchScope.Subtree
        'Dim results As SearchResultCollection = deSearch.FindAll()

        Dim lNewList As New List(Of String)
        Const ADS_ACEFLAG_INHERIT_ACE = 2
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1

        'Máscaras de tipos de permisos
        Const ADS_ACETYPE_SEND_TO = "{AB721A55-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_SEND_AS = "{AB721A54-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_PHONE = "{E45795B2-9455-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_SELF = "{BF9679C0-0DE6-11D0-A285-00AA003049E2}"
        Const ADS_ACETYPE_AUTHENTICATE = "{68B1D179-0D15-4D4F-AB71-46152E79A7BC}"
        Const ADS_ACETYPE_CHANGE_PASS = "{AB721A53-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_RECIEVE_AS = "{AB721A56-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_RESET_PASS = "{00299570-246D-11D0-A768-00AA006E0529}"
        Const ADS_ACETYPE_ACC_REST = "{4C164200-20C0-11D0-A768-00AA006E0529}"
        Const ADS_ACETYPE_GEN_INFO = "{59BA2F42-79A2-11D0-9020-00C04FC2D3CF}"
        Const ADS_ACETYPE_GROUP_MEMBERSHIP = "{BC0AC240-79A9-11D0-9020-00C04FC2D4CF}"
        Const ADS_ACETYPE_LOGON_INFO = "{5F202010-79A5-11D0-9020-00C04FC2D4CF}"
        Const ADS_ACETYPE_PERSONAL_INFO = "{77B5B886-944A-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_PUBLIC_INFO = "{E48C0154-BCF8-11D1-8702-00C04FB96050}"
        Const ADS_ACETYPE_REMOTE_ACCESS = "{037088F8-0AE1-11D2-B422-00A0C968F939}"
        Const ADS_ACETYPE_WEB_INFO = "{E45795B3-9455-11D1-AEBD-0000F80367C1}"
        Const ADS_RIGHT_GENERIC_READ = &H80000000
        Const ADS_RIGHT_GENERIC_WRITE = &H40000000
        Const ADS_RIGHT_DS_CREATE_CHILD = &H1
        Const ADS_RIGHT_DS_DELETE_CHILD = &H2
        Const ADS_RIGHT_DS_SELF = &H8

        Dim ConTipo As String = "vacio"
        Dim opcion

        'Obtener el tipo de permiso de Permission
        If Permission.Contains("Control total") Then
            opcion = 983551
        ElseIf Permission = "Lectura" Then
            opcion = 131092
        ElseIf Permission = "Escritura" Then
            opcion = 40
        ElseIf Permission = "Crear todos los objetos hijo" Then
            opcion = 1
        ElseIf Permission = "Eliminar todos los objetos hijo" Then
            opcion = &H2
        ElseIf Permission = "Permiso de autenticarse" Then
            opcion = 256
            ConTipo = "auth"
        ElseIf Permission = "cambio Password" Then
            opcion = 256
            ConTipo = "cPass"
        ElseIf Permission = "Recibir como" Then
            opcion = 256
            ConTipo = "recAs"
        ElseIf Permission = "Reset password" Then
            opcion = 256
            ConTipo = "Rpass"
        ElseIf Permission = "Enviar como" Then
            opcion = 256
            ConTipo = "sendAs"
        ElseIf Permission = "Lectura de restricciones de la cuenta" Then
            opcion = 16
            ConTipo = "rest"
        ElseIf Permission = "Escritura de restricciones de la cuenta" Then
            opcion = 32
            ConTipo = "rest"
        ElseIf Permission = "Lectura de información general" Then
            opcion = 16
            ConTipo = "geninfo"
        ElseIf Permission = "Escritura de información general" Then
            opcion = 32
            ConTipo = "geninfo"
        ElseIf Permission = "Lectura de miembros de grupo" Then
            opcion = 16
            ConTipo = "membership"
        ElseIf Permission = "Escritura de miembros de grupo" Then
            opcion = 32
            ConTipo = "membership"
        ElseIf Permission = "Lectura de información  de Logon" Then
            opcion = 16
            ConTipo = "logon"
        ElseIf Permission = "Escritura de información  de Logon" Then
            opcion = 32
            ConTipo = "logon"
        ElseIf Permission = "Lectura de información  personal" Then
            opcion = 16
            ConTipo = "pers"
        ElseIf Permission = "Escritura de información  personal" Then
            opcion = 32
            ConTipo = "pers"
        ElseIf Permission = "Lectura de opciones de teléfono y correo" Then
            opcion = 16
            ConTipo = "phone"
        ElseIf Permission = "Escritura de opciones de teléfono y correo" Then
            opcion = 32
            ConTipo = "phone"
        ElseIf Permission = "Lectura de información pública" Then
            opcion = 16
            ConTipo = "public"
        ElseIf Permission = "Escritura de información pública" Then
            opcion = 32
            ConTipo = "public"
        ElseIf Permission = "Lectura de información de acceso remoto" Then
            opcion = 16
            ConTipo = "remote"
        ElseIf Permission = "Escritura de información de acceso remoto" Then
            opcion = 32
            ConTipo = "remote"
        ElseIf Permission = "Lectura de información Web" Then
            opcion = 16
            ConTipo = "web"
        ElseIf Permission = "Escritura de información Web" Then
            opcion = 32
            ConTipo = "web"
        End If

        Dim dacl As AccessControlList
        Dim ace

        'Obtener DirectoryEntry del usuario
        Dim deMail As New DirectoryEntry("LDAP://" & Settings.ldapServerName & "/" & logonU)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener lista de permisos del usuario
        Dim oSecurityDescriptor As IADsSecurityDescriptor = CType(deMail.Properties("ntSecurityDescriptor").Value, IADsSecurityDescriptor)
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")
        Dim objectType As String
        Dim compara

        'Establecer tipo de permiso
        If tipo = "Allow" Then
            compara = ADS_ACETYPE_ACCESS_ALLOWED
        Else
            compara = ADS_ACETYPE_ACCESS_DENIED
        End If

        If ConTipo = "auth" Then
            objectType = ADS_ACETYPE_AUTHENTICATE
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "cPass" Then
            objectType = ADS_ACETYPE_CHANGE_PASS
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "recAs" Then
            objectType = ADS_ACETYPE_RECIEVE_AS
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "Rpass" Then
            objectType = ADS_ACETYPE_RESET_PASS
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "sendAs" Then
            objectType = ADS_ACETYPE_SEND_AS
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "rest" Then
            objectType = ADS_ACETYPE_ACC_REST
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "geninfo" Then
            objectType = ADS_ACETYPE_GEN_INFO
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "membership" Then
            objectType = ADS_ACETYPE_GROUP_MEMBERSHIP
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "logon" Then
            objectType = ADS_ACETYPE_LOGON_INFO
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "pers" Then
            objectType = ADS_ACETYPE_PERSONAL_INFO
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "phone" Then
            objectType = ADS_ACETYPE_PHONE
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "public" Then
            objectType = ADS_ACETYPE_PUBLIC_INFO
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "remote" Then
            objectType = ADS_ACETYPE_REMOTE_ACCESS
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If
        If ConTipo = "web" Then
            objectType = ADS_ACETYPE_WEB_INFO
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If

        'Buscar permiso en la lista de permisos de usuario y eliminarlo
        Dim trustee As String = GetTrustee(User)

        For Each ace In dacl
            If ace.trustee = trustee Then
                If opcion = 983551 Then
                    If ace.accessMask = opcion Then
                        If ace.AceType = compara Then
                            dacl.RemoveAce(ace)
                        End If
                    End If
                ElseIf (ace.accessMask And opcion) Then
                    If ace.AceType = compara Then
                        If Not ConTipo = "vacio" Then
                            If ace.objectType = objectType Then
                                dacl.RemoveAce(ace)
                            End If
                        Else
                            dacl.RemoveAce(ace)
                        End If
                    End If
                End If
            End If
        Next

        'Actualizar lista de permisos
        oSecurityDescriptor.DiscretionaryAcl = dacl
        deMail.Properties("ntSecurityDescriptor").Value = oSecurityDescriptor
        Try
            deMail.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("No se poseen permisos para quitar permisos al usuario " & e.Message)
        Catch e As ConstraintException
            MsgBox("Error, Al quitar el permiso al usuario se viola una restricción " & e.Message)
        End Try
    End Sub

    Shared Sub RemoveAceFromDaclComputerNT(ByVal User As String, ByVal logonU As String, ByVal Permission As String, ByVal tipo As String)
        '==========================================================================
        ' Name:     RemoveAceFromDaclComputerNT
        ' Purpose:  Eliminar un permiso dado a un objeto sobre un usuario
        ' Input:    4 String: El nombre de Login del usuario 'logonU',
        '           El nombre de login del objeto 'User', El nombre del permiso 'Permission'
        '           ,indica si el permiso permite (Allow) o niega (Deny) 'Tipo'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        'Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        'deSearch.Filter = "(&(sAMAccountName=" & logonU & "))"
        'deSearch.SearchScope = SearchScope.Subtree
        'Dim results As SearchResultCollection = deSearch.FindAll()

        Dim lNewList As New List(Of String)
        Const ADS_ACEFLAG_INHERIT_ACE = 2
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1

        'Mascaras de los diferentes tipos de permiso
        Const ADS_ACETYPE_SEND_TO = "{AB721A55-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_SEND_AS = "{AB721A54-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_PHONE = "{E45795B2-9455-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_SELF = "{BF9679C0-0DE6-11D0-A285-00AA003049E2}"
        Const ADS_ACETYPE_AUTHENTICATE = "{68B1D179-0D15-4D4F-AB71-46152E79A7BC}"
        Const ADS_ACETYPE_CHANGE_PASS = "{AB721A53-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_RECIEVE_AS = "{AB721A56-1E2F-11D0-9819-00AA0040529B}"
        Const ADS_ACETYPE_RESET_PASS = "{00299570-246D-11D0-A768-00AA006E0529}"
        Const ADS_ACETYPE_ACC_REST = "{4C164200-20C0-11D0-A768-00AA006E0529}"
        Const ADS_ACETYPE_VALIDATE_DNS = "{72E39547-7B18-11D1-ADEF-00C04FD8D5CD}"
        Const ADS_ACETYPE_VALIDATE_SPN = "{F3A64788-5306-11D1-A9C5-0000F80367C1}"
        Const ADS_ACETYPE_LOGON_INFO = "{5F202010-79A5-11D0-9020-00C04FC2D4CF}"
        Const ADS_ACETYPE_PERSONAL_INFO = "{77B5B886-944A-11D1-AEBD-0000F80367C1}"
        Const ADS_ACETYPE_PUBLIC_INFO = "{E48D0154-BCF8-11D1-8702-00C04FB96050}"
        Const ADS_ACETYPE_REMOTE_ACCESS = "{037088F8-0AE1-11D2-B422-00A0C968F939}"
        Const ADS_ACETYPE_DNS_ATTRIBUTE = "{72E39547-7B18-11D1-ADEF-00C04FD8D5CD}"
        Const ADS_RIGHT_GENERIC_READ = &H80000000
        Const ADS_RIGHT_GENERIC_WRITE = &H40000000
        Const ADS_RIGHT_DS_CREATE_CHILD = &H1
        Const ADS_RIGHT_DS_DELETE_CHILD = &H2
        Const ADS_RIGHT_DS_SELF = &H8

        Dim ConTipo As String = "vacio"
        Dim opcion

        'Obtener la mascara correspondiente a Permission
        If Permission = "Control total" Then
            opcion = 983551
        ElseIf Permission = "Lectura" Then
            opcion = 131092
        ElseIf Permission = "Escritura" Then
            opcion = 40
        ElseIf Permission = "Crear todos los objetos hijo" Then
            opcion = 1
        ElseIf Permission = "Eliminar todos los objetos hijo" Then
            opcion = &H2
        ElseIf Permission = "Permiso de autenticarse" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_AUTHENTICATE
        ElseIf Permission = "cambio Password" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_CHANGE_PASS
        ElseIf Permission = "Recibir como" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_RECIEVE_AS
        ElseIf Permission = "Reset password" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_RESET_PASS
        ElseIf Permission = "Enviar como" Then
            opcion = 256
            ConTipo = ADS_ACETYPE_SEND_AS
        ElseIf Permission = "Lectura de restricciones de la cuenta" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_ACC_REST
        ElseIf Permission = "Escritura de restricciones de la cuenta" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_ACC_REST
        ElseIf Permission = "Escritura validada del DNS Host name" Then
            opcion = 8
            ConTipo = ADS_ACETYPE_VALIDATE_DNS
        ElseIf Permission = "Escritura validada del nombre del servicio principal" Then
            opcion = 8
            ConTipo = ADS_ACETYPE_VALIDATE_SPN
        ElseIf Permission = "Lectura de atributos del DNS Host name" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_DNS_ATTRIBUTE
        ElseIf Permission = "Escritura de atributos del DNS Host name" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_DNS_ATTRIBUTE
        ElseIf Permission = "Lectura de información  personal" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_PERSONAL_INFO
        ElseIf Permission = "Escritura de información  personal" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_PERSONAL_INFO
        ElseIf Permission = "Lectura de información pública" Then
            opcion = 16
            ConTipo = ADS_ACETYPE_PUBLIC_INFO
        ElseIf Permission = "Escritura de información pública" Then
            opcion = 32
            ConTipo = ADS_ACETYPE_PUBLIC_INFO
        End If

        Dim dacl As AccessControlList
        Dim ace '= New AccessControlEntryClass()

        'Obtener DirectoryEntry del Equipo
        Dim deMail As New DirectoryEntry("LDAP://" & Settings.ldapServerName & "/" & logonU)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener lista de permisos del equipo
        Dim oSecurityDescriptor As IADsSecurityDescriptor = CType(deMail.Properties("ntSecurityDescriptor").Value, IADsSecurityDescriptor)
        dacl = oSecurityDescriptor.DiscretionaryAcl
        ace = CreateObject("AccessControlEntry")

        'Establecer el tipo de permiso
        Dim objectType As String
        Dim compara
        If ConTipo = "vacio" Then
            If tipo = "Allow" Then
                compara = ADS_ACETYPE_ACCESS_ALLOWED
            Else
                compara = ADS_ACETYPE_ACCESS_DENIED
            End If
        Else
            objectType = ConTipo
            If tipo = "Allow" Then
                compara = 5
            Else
                compara = 6
            End If
        End If


        'Buscar permiso en la lista de permisos del equipo y eliminarlo
        Dim trustee As String = GetTrustee(User)
        For Each ace In dacl
            If ace.trustee = trustee Then
                If opcion = 983551 Then
                    If ace.accessMask = opcion Then
                        If ace.AceType = compara Then
                            dacl.RemoveAce(ace)
                        End If
                    End If
                ElseIf (ace.accessMask And opcion) Then
                    If ace.AceType = compara Then
                        If Not ConTipo = "vacio" Then
                            If ace.objectType = objectType Then
                                dacl.RemoveAce(ace)
                            End If
                        Else
                            dacl.RemoveAce(ace)
                        End If
                    End If
                End If
            End If
        Next

        'Actualizar la lista de permisos
        oSecurityDescriptor.DiscretionaryAcl = dacl
        deMail.Properties("ntSecurityDescriptor").Value = oSecurityDescriptor

        Try
            deMail.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("No se poseen permisos para quitar permisos al equipo " & e.Message)
        Catch e As ConstraintException
            MsgBox("Error, Al quitar el permiso al usuario se viola una restricción " & e.Message)
        End Try
    End Sub

    Shared Function IsAceinDacl(ByVal User As String, ByVal logonU As String, ByVal Permission As String, ByVal tipo As String) As Boolean
        '==========================================================================
        ' Name:     IsAceinDacl
        ' Purpose:  Saber si un permiso forma parte de la lista de permisos del buzón de un usuario
        ' Input:    4 String: El nombre de Login del usuario 'logonU',
        '           El nombre de login del objeto 'User', El nombre del permiso 'Permission'
        '           ,indica si el permiso permite (Allow) o niega (Deny) 'Tipo'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del usuario
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & logonU & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim salida As Boolean = False

        Dim lNewList As New List(Of String)
        Const ADS_ACEFLAG_INHERIT_ACE = 2
        Const ADS_ACETYPE_ACCESS_ALLOWED = 0
        Const ADS_ACETYPE_ACCESS_DENIED = 1
        Dim opcion

        'Máscaras de permisos
        Const RIGHT_DS_DELETE = &H10000
        Const RIGHT_DS_READ = &H20000
        Const RIGHT_DS_CHANGE = &H40000
        Const RIGHT_DS_TAKE_OWNERSHIP = &H80000
        Const RIGHT_DS_MAILBOX_OWNER = &H1
        Const RIGHT_DS_SEND_AS = &H2
        Const RIGHT_DS_PRIMARY_OWNER = &H4

        'Obtener la máscara de permission
        If Permission.Contains("Borrado de la memoria del buzón") Then
            opcion = RIGHT_DS_DELETE
        ElseIf Permission.Contains("Permisos de lectura") Then
            opcion = RIGHT_DS_READ
        ElseIf Permission.Contains("Permisos de modificación") Then
            opcion = RIGHT_DS_CHANGE
        ElseIf Permission.Contains("Tomar posesión") Then
            opcion = RIGHT_DS_TAKE_OWNERSHIP
        ElseIf Permission.Contains("Acceso total al buzón") Then
            opcion = RIGHT_DS_MAILBOX_OWNER
        ElseIf Permission.Contains("Cuenta externa asociada") Then
            opcion = RIGHT_DS_SEND_AS
        End If

        Dim oSecurityDescriptor As SecurityDescriptor
        Dim dacl As AccessControlList
        Dim ace

        'Obtener DirectoryEntry del usuario
        Dim deMail As New DirectoryEntry(results(0).Path)

        'Obtener la lista de permisos del buzón
        Dim mailboxStore As IExchangeMailbox
        Try
            mailboxStore = CType(deMail.NativeObject, IExchangeMailbox)
            oSecurityDescriptor = mailboxStore.MailboxRights
            dacl = oSecurityDescriptor.DiscretionaryAcl
        Catch e As FormatException
            MsgBox("Error de formato al obtener los permisos sobre " & User & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al obtener los permisos, No tienes permisos para acceder a este dato " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al obtener los permisos,Se ha intentado obtener un dato con un índice fuera de rango en el large integer " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al obtener los permisos,Se está intentando obtener un dato involucrado en una operación cancelada en el large integer " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al obtener los permisos,Se está intentando obtener un dato involucrado en una operación abortada en el large integer " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al obtener los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al obtener los permisos,  acceder a al ubicación física del dato en el large integer " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al obtener los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al obtener los permisos, al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
        'Establecer datos del permiso a buscar
        ace = CreateObject("AccessControlEntry")

        Dim compara
        If tipo = "Allow" Then
            compara = ADS_ACETYPE_ACCESS_ALLOWED
        Else
            compara = ADS_ACETYPE_ACCESS_DENIED
        End If

        'Buscar el permiso en la lista y asignar el valor al booleano salida
        Dim trustee As String = GetTrustee(User)
        For Each ace In dacl
            If ace.trustee = trustee Then
                If (ace.accessMask And opcion) Then
                    If ace.AceType = compara Then
                        salida = True
                    End If
                End If
            End If
        Next

        'Devolver salida
        Return salida
    End Function

    Shared Function managerCanChangeMembershipList(ByVal manager As String, ByVal Group As String) As Boolean
        '==========================================================================
        ' Name:     managerCanChangeMembershipList
        ' Purpose:  Saber si un usuario tiene permiso para cambiar los miembros de un grupo
        ' Input:    2 String: El nombre de Login del usuario 'manager',
        '           El nombre de login del grupo 'Group'
        ' Return:   Boolean: True si lo tiene, false si no lo tiene
        ' Calls:    None
        '==========================================================================

        'Obtener el objeto grupo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=group) (sAMAccountName=" & Group & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim objgroup As Object = GetObject(results(0).Path)
        Dim salida As Boolean = False

        'Máscaras de permisos
        Dim lNewList As New List(Of String)
        Const ADS_ACETYPE_ACCESS_ALLOWED_OBJECT = &H5
        Const ADS_RIGHT_DS_WRITE_PROP = &H20
        Const ADS_ACEFLAG_INHERIT_ACE = &H2
        Const ADS_ACEFLAG_DONT_INHERIT_ACE = &H0

        Const ADS_FLAG_OBJECT_TYPE_PRESENT = &H1
        Const ADS_OBJECT_WRITE_MEMBERS = "{BF9679C0-0DE6-11D0-A285-00AA003049E2}"


        Dim oSecurityDescriptor As SecurityDescriptor
        Dim dacl As AccessControlList
        Dim ace

        'Obtener DirectoryEntry del usuario
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & manager & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim otherresults As SearchResultCollection = deSearch.FindAll()
        Dim trusUser As New DirectoryEntry(otherresults(0).Path)

        Try
            'Obtener la lista de permisos del grupo
            oSecurityDescriptor = objgroup.Get("ntSecurityDescriptor")
            dacl = oSecurityDescriptor.DiscretionaryAcl
            ace = CreateObject("AccessControlEntry")
        Catch e As FormatException
            MsgBox("Error de formato al obtener los permisos sobre " & Group & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al obtener los permisos, No tienes permisos para acceder a este dato " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al obtener los permisos,Se ha intentado obtener un dato con un índice fuera de rango en el large integer " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al obtener los permisos,Se está intentando obtener un dato involucrado en una operación cancelada en el large integer " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al obtener los permisos,Se está intentando obtener un dato involucrado en una operación abortada en el large integer " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al obtener los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al obtener los permisos,  acceder a al ubicación física del dato en el large integer " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al obtener los permisos,La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al obtener los permisos, al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
        'Buscar el permiso en la lista de permisos y si lo tiene asignar al booleno salida el valor true 
        Dim PN As String = trusUser.Properties("userPrincipalName").Value.ToString
        Dim parts() As String = PN.Split("@")
        Dim parts2() As String = parts(1).Split(".")
        Dim trustee As String = UCase(parts2(0)) & "\" & parts(0)
        For Each ace In dacl
            If ace.trustee = trustee Then

                If (ace.accessMask And ADS_RIGHT_DS_WRITE_PROP) Then

                    If ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED_OBJECT Then

                        If ace.objectType = ADS_OBJECT_WRITE_MEMBERS Then

                            salida = True
                        End If
                    End If
                End If
            End If
        Next

        'Devolver salida
        Return salida
    End Function

    Shared Sub SetManagerCanChangeMembershipList(ByVal manager As String, ByVal Group As String, ByVal tipo As Boolean)
        '==========================================================================
        ' Name:     SetManagerCanChangeMembershipList
        ' Purpose:  Dar permiso o denegarlo(si ya lo tiene) a un usuario para cambiar los miembros de un grupo
        ' Input:    2 String: El nombre de Login del usuario 'manager',
        '           El nombre de login del grupo 'Group'
        '           1 Boolean: De ser true el permiso se ha de conceder, si es false se deniega 'tipo' 
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtiene el DirectoryEntry del grupo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(objectClass=group) (sAMAccountName=" & Group & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()
        Dim objgroup As New DirectoryEntry(results(0).Path)
        objgroup.Username = Settings.adminLogon
        objgroup.Password = Settings.adminPassword
        objgroup.AuthenticationType = AuthenticationTypes.Delegation

        'Máscaras de permisos
        Dim lNewList As New List(Of String)
        Const ADS_ACETYPE_ACCESS_ALLOWED_OBJECT = &H5
        Const ADS_RIGHT_DS_WRITE_PROP = &H20
        Const ADS_ACEFLAG_INHERIT_ACE = &H2
        Const ADS_ACEFLAG_DONT_INHERIT_ACE = &H0

        Const ADS_FLAG_OBJECT_TYPE_PRESENT = &H1
        Const ADS_OBJECT_WRITE_MEMBERS = "{BF9679C0-0DE6-11D0-A285-00AA003049E2}"



        Dim dacl As AccessControlList
        Dim ace

        'Obtener el DirectoryEntry del usuario
        deSearch.Filter = "(&(objectClass=user) (sAMAccountName=" & manager & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim otherresults As SearchResultCollection = deSearch.FindAll()
        Dim trusUser As New DirectoryEntry(otherresults(0).Path)
        Try
            'Obtener el SecurityDescriptor del grupo y de ahí su lista de permisos
            Dim oSecurityDescriptor As IADsSecurityDescriptor = CType(objgroup.Properties("ntSecurityDescriptor").Value, IADsSecurityDescriptor)
            dacl = oSecurityDescriptor.DiscretionaryAcl
            ace = CreateObject("AccessControlEntry")


            Dim PN As String = trusUser.Properties("userPrincipalName").Value.ToString
            Dim parts() As String = PN.Split("@")
            Dim parts2() As String = parts(1).Split(".")
            Dim trustee As String = UCase(parts2(0)) & "\" & parts(0)

            If Not tipo Then
                'Buscar y eliminar el permiso una vez encontrado
                For Each ace In dacl
                    If ace.trustee = trustee Then
                        If (ace.accessMask And ADS_RIGHT_DS_WRITE_PROP) Then

                            If ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED_OBJECT Then

                                If ace.objectType = ADS_OBJECT_WRITE_MEMBERS Then

                                    dacl.RemoveAce(ace)
                                End If
                            End If
                        End If
                    End If
                Next
            ElseIf tipo = True Then
                'Crear el permiso y añadirlo
                ace.trustee = trustee
                ace.accessMask = 32
                ace.AceType = 5
                ace.objectType = ADS_OBJECT_WRITE_MEMBERS
                ace.Flags = 1

                dacl.AddAce(ace)

            End If


            'Actualizar la lista de permisos del grupo
            oSecurityDescriptor.DiscretionaryAcl = dacl

            objgroup.Properties("ntSecurityDescriptor").Value = oSecurityDescriptor

            objgroup.CommitChanges()
        Catch e As FormatException
            MsgBox("Error de formato al añadir los permisos al administrador sobre " & Group & e.Message)
        Catch e As AccessViolationException
            MsgBox("Error al añadir los permisos al administrador, No tienes permisos para acceder a este dato " & e.Message)
        Catch e As ArgumentOutOfRangeException
            MsgBox("Error al añadir los permisos al administrador,Se ha intentado obtener un dato con un índice fuera de rango en el large integer " & e.Message)
        Catch e As OperationCanceledException
            MsgBox("Error al añadir los permisos al administrador,Se está intentando obtener un dato involucrado en una operación cancelada en el large integer " & e.Message)
        Catch e As OperationAbortedException
            MsgBox("Error al añadir los permisos al administrador,Se está intentando obtener un dato involucrado en una operación abortada en el large integer " & e.Message)
        Catch e As OutOfMemoryException
            MsgBox("Error al añadir los permisos al administrador,La memoria está totalmente ocupada " & e.Message)
        Catch e As FieldAccessException
            MsgBox("Error al añadir los permisos al administrador,  acceder a al ubicación física del dato en el large integer " & e.Message)
        Catch e As InsufficientMemoryException
            MsgBox("Error al añadir los permisos al administrador,La memoria está totalmente ocupada " & e.Message)
        Catch e As MissingFieldException
            MsgBox("Error al añadir los permisos al administrador, al acceder a al ubicación física del dato, no existe " & e.Message)
        End Try
    End Sub

    Shared Function GetTrustee(ByVal User As String) As String
        '==========================================================================
        ' Name:     GetTrustee
        ' Purpose:  Añadir un permiso a un objeto sobre un usuario
        ' Input:    3 String: El nombre de Login del objeto a pregunar que permiso posee 'user',
        '           El nombre de login del usuario 'lgUser', El nombre del permiso 'Permission'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del DirectoryEntry del grupo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener el DirectoryEntry del objeto
        Dim deSearch2 As DirectorySearcher = New DirectorySearcher(de)
        deSearch2.Filter = "(&(sAMAccountName=" & User & "))"
        deSearch2.SearchScope = SearchScope.Subtree
        Dim otherresults As SearchResultCollection = deSearch2.FindAll()

        Dim trustee As String
        If User = "SELF" Then
            trustee = "NT AUTHORITY\SELF"
        ElseIf User = "Authenticated Users" Then
            trustee = "NT AUTHORITY\Authenticated Users"
        ElseIf User = "SYSTEM" Then
            trustee = "NT AUTHORITY\SYSTEM"
        ElseIf User = "ENTERPRISE DOMAIN CONTROLLERS" Then
            trustee = "NT AUTHORITY\ENTERPRISE DOMAIN CONTROLLERS"
        ElseIf User = "Everyone" Then
            trustee = User
        Else
            If otherresults.Count = 0 Then
                trustee = User
            Else
                Dim trusUser As New DirectoryEntry(otherresults(0).Path)
                trusUser.Username = Settings.adminLogon
                trusUser.Password = Settings.adminPassword
                trusUser.AuthenticationType = AuthenticationTypes.Delegation
                Try
                    If Not trusUser.Properties("distinguishedName").Value.ToString.Contains("Builtin") Then
                        trustee = UCase(Settings.userDomain) & "\" & User
                    Else
                        trustee = "BUILTIN\" & User
                    End If
                Catch e As FormatException
                    MsgBox("Error de formato al obtener la dirección de " & User & e.Message)
                Catch e As AccessViolationException
                    MsgBox("Error al obtener la dirección, No tienes permisos para acceder a este dato " & e.Message)
                Catch e As ArgumentOutOfRangeException
                    MsgBox("Error al obtener la dirección,Se ha intentado obtener un dato con un índice fuera de rango en el large integer " & e.Message)
                Catch e As OperationCanceledException
                    MsgBox("Error al obtener la dirección,Se está intentando obtener un dato involucrado en una operación cancelada en el large integer " & e.Message)
                Catch e As OperationAbortedException
                    MsgBox("Error al obtener la dirección,Se está intentando obtener un dato involucrado en una operación abortada en el large integer " & e.Message)
                Catch e As OutOfMemoryException
                    MsgBox("Error al obtener la dirección,La memoria está totalmente ocupada " & e.Message)
                Catch e As FieldAccessException
                    MsgBox("Error al obtener la dirección,  acceder a al ubicación física del dato en el large integer " & e.Message)
                Catch e As InsufficientMemoryException
                    MsgBox("Error al obtener la dirección,La memoria está totalmente ocupada " & e.Message)
                Catch e As MissingFieldException
                    MsgBox("Error al obtener la dirección, al acceder a al ubicación física del dato, no existe " & e.Message)
                End Try
            End If

        End If

        Return trustee
    End Function

    Shared Sub CopyAces(ByVal User As String, ByVal CopyUser As String)
        '==========================================================================
        ' Name:     RemoveAceFromDaclNT
        ' Purpose:  Eliminar todos los permisos dados a un objeto sobre un grupo
        ' Input:    4 String: El nombre de Login del grupo 'logonU',
        '           El nombre de login del objeto 'User', El nombre del permiso 'Permission'
        '           ,indica si el permiso permite (Allow) o niega (Deny) 'Tipo'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        'Obtener la dirección del grupo
        Dim de As DirectoryEntry = New DirectoryEntry()
        de.Username = Settings.adminLogon
        de.Password = Settings.adminPassword
        de.AuthenticationType = AuthenticationTypes.Delegation
        Dim deSearch As DirectorySearcher = New DirectorySearcher(de)
        deSearch.Filter = "(&(sAMAccountName=" & User & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results As SearchResultCollection = deSearch.FindAll()

        Dim dacl As AccessControlList

        'Obtener DirectoryEntry del grupo
        Dim deMail As New DirectoryEntry(results(0).Path)
        deMail.Username = Settings.adminLogon
        deMail.Password = Settings.adminPassword
        deMail.AuthenticationType = AuthenticationTypes.Delegation

        'Obtener la lista de permisos del grupo
        Dim oSecurityDescriptor As IADsSecurityDescriptor = CType(deMail.Properties("ntSecurityDescriptor").Value, IADsSecurityDescriptor)
        dacl = oSecurityDescriptor.DiscretionaryAcl
        
        deSearch.Filter = "(&(sAMAccountName=" & CopyUser & "))"
        deSearch.SearchScope = SearchScope.Subtree
        Dim results2 As SearchResultCollection = deSearch.FindAll()

        Dim CopydeMail As New DirectoryEntry(results2(0).Path)
        CopydeMail.Username = Settings.adminLogon
        CopydeMail.Password = Settings.adminPassword
        CopydeMail.AuthenticationType = AuthenticationTypes.Delegation

        'Actualizar la lista de permisos
        Dim oSecurityDescriptor2 As IADsSecurityDescriptor = CType(CopydeMail.Properties("ntSecurityDescriptor").Value, IADsSecurityDescriptor)
        oSecurityDescriptor2.DiscretionaryAcl = dacl
        CopydeMail.Properties("ntSecurityDescriptor").Value = oSecurityDescriptor2
        Try
            CopydeMail.CommitChanges()
        Catch e As AccessViolationException
            MsgBox("No se poseen permisos para quitar permisos al usuario " & User & e.Message)
        Catch e As ConstraintException
            MsgBox("Error, Al quitar los permisos al usuario " & User & " se viola una restricción " & e.Message)
        End Try
    End Sub

End Class
